      SUBROUTINE MODOPT(A,B,P,Q,R,G,nx,nu,na,nb)

      INTEGER nx,nu,na,nb
      DOUBLE PRECISION         A(na,na),  B(na,nb)
      DOUBLE PRECISION         P(nb,nb),  Q(na,na)
      DOUBLE PRECISION         R(na,na),  G(nb,na)

C... Local variables 

      INTEGER                  n,m,nm,mm,nd,md
      PARAMETER              ( nm = 50, mm = 50, nd = 100, md = 100 )

      DOUBLE PRECISION         AN(nm,mm), H(nm,mm)
      DOUBLE PRECISION         PI(nm,mm), HS(nm,mm)
      DOUBLE PRECISION         Z(nd,md),  W(nd,md)
      DOUBLE PRECISION         QR(nm,mm), QS(nm,mm)
      DOUBLE PRECISION         RR(nm,mm), RS(nm,mm)
      DOUBLE PRECISION         er(nd),    ei(nd)
      DOUBLE PRECISION         T(nm,mm),  U(nm,mm),  UT(nm,mm)
      DOUBLE PRECISION         wv1(nm),   wv2(nd)
      DOUBLE PRECISION         wm1(nm,mm),wm2(nm,mm),wm3(nm,mm)

      INTEGER                  ind(nd), ix(nm), info, mc
      LOGICAL                  qzer, askq, mov ,stab 

      n = nx
      m = nu

      askq = .FALSE.

50    CALL DINIT(A,AN,B,P,PI,Q,QR,QS,RR,RS,H,G,n,m,nm,mm,qzer,wv1,wm1)

      IF     ( .NOT. qzer ) THEN
        CALL   MATCOP(Q,R,n,n,nm,nm)
        CALL   RICSOL(AN,H,R,Z,W,n,er,ei,wv2,ind,info,nm,nm,nm)
      ELSE
        CALL   DMZER(R,n,n,nm,nm)
        WRITE(*,*) 'Matrix Q is zero.'
      END IF

100   CALL     DCALG(G,PI,B,R,n,m,nm,mm,wm1,wm2,wm3)
c     CALL     MATPRT('Matrise R = R + RR  : ',R,nm,nm,n,n)

      CALL     DCALAN(AN,A,H,R,n,m,nm,mm,wm1)
c     CALL     MATPRT('Matrise R = R + RR  : ',R,nm,nm,n,n)

200   CALL     MATCOP(AN,T,n,n,nm,nm)
      CALL     DCSCHF(U,T,n,nm,mm,er,ei,ind)

300   CALL     DMENU(mc)

      GOTO   ( 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18 )
     $ mc
          WRITE(*,*) 'Ukjent valg.'
          GOTO 19
1         CALL MATPRT('Matrise A : ',A,nm,nm,n,n)
          GOTO 19      
2         CALL MATPRT('Matrise B : ',B,nm,mm,n,m)
          GOTO 19      
3         CALL MATPRT('Matrise P : ',P,mm,mm,m,m)
          GOTO 19      
4         CALL MATPRT('Matrise Q : ',Q,nm,nm,n,n)
          GOTO 19      
5         CALL MATPRT('Matrise G : ',G,mm,nm,m,n)
          GOTO 19      
6         CALL MATPRT('Matrise R : ',R,nm,nm,n,n)
          GOTO 19      
7         CALL MATPRT('Matrise A + BG : ',AN,nm,nm,n,n)
          GOTO 19      

8         CALL DMEIG(AN,RS,QR,QS,T,U,UT,H,HS,n,n,nm,mm,
     +                     er,ei,ind,ix,mov,stab,askq,wm1)
          IF   ( .NOT.mov ) GOTO 100

c         IF   ( n .GE. 2 ) THEN
c              CALL DMTMP(R,U,RS,n,n,nm,nm,wm1)
c         ELSE                   
c              R(1,1) = RS(1,1)
c         END  IF

          CALL DUMPQ(Q,QR,QS,U,n,n,nm,nm,wm1)        
          CALL DUMPQ(R,RR,RS,U,n,n,nm,nm,wm1)

          CALL DCALAN(AN,A,H,R,n,m,nm,mm,wm1)

          CALL MATCOP(AN,T,n,n,nm,nm)
          CALL DCSCHF(U,T,n,nm,mm,er,ei,ind)

          GOTO 8  

9         CALL DRABPQ(A,B,P,Q,n,m,nm,mm,wv1)
          GOTO 50
10        CALL DAIRQV(askq)
          GOTO 19 
11        CALL DPHLP
          GOTO 19

12        GOTO 999

13        CALL MATPRT('Matrise RR : ',RR,nm,nm,n,n)
          GOTO 19      
14        CALL MATPRT('Matrise QR : ',QR,nm,nm,n,n)
          GOTO 19      
15        CALL MATPRT('Matrise inv(P) : ',PI,mm,mm,m,m)
          GOTO 19      
16        CALL MATPRT('Matrise B*inv(P)*tsp(B) : ',H,nm,nm,n,n)
          GOTO 19      
17        CALL MATPRT('Matrise T : ',T,nm,nm,n,n)
          GOTO 19      
18        CALL MATPRT('Matrise U : ',U,nm,nm,n,n)
          GOTO 19      
19    GOTO 300 


999   nx = n
      nu = m

      END
                                                                            


      SUBROUTINE               DRABPQ(A,B,P,Q,n,m,nm,mm,wv1)

      INTEGER                  n,m,nm,mm

      DOUBLE PRECISION         A(nm,mm),  B(nm,mm)
      DOUBLE PRECISION         P(nm,mm),  Q(nm,mm)
      DOUBLE PRECISION         wv1(nm)

      CALL     NREAD('Number of states      nx = ? ',n,1,1,IIII)
               WRITE (*,*)
      CALL     NREAD('Number of inputs      nu = ? ',m,1,1,IIII)
               WRITE (*,*)
      CALL     DREMA(A,wv1,n,nm,n,nm,'A')
               WRITE (*,*)
      CALL     DREMA(B,wv1,n,nm,m,mm,'B')
               WRITE (*,*)
      CALL     DREMA(P,wv1,m,mm,m,mm,'P')
               WRITE (*,*)
      CALL     DREMA(Q,wv1,n,nm,n,nm,'Q')

      RETURN
      END



      SUBROUTINE               DAIRQV(askq)

      LOGICAL                  askq
      INTEGER                  ians,IYESANS

      ians = IYESANS('Do you want to registrate QS(1,2) ? ',2)
      askq = ( ians .EQ. 2 ) 

      RETURN
      END



      SUBROUTINE DINIT(A,AN,B,P,PI,Q,QR,QS,RR,RS,H,G,n,m,nm,mm,ze,v1,m1)

      INTEGER                  n,m,nm,mm
      DOUBLE PRECISION         A(nm,mm),  AN(nm,mm), H(nm,mm)
      DOUBLE PRECISION         Q(nm,mm),  QS(nm,mm), QR(nm,mm)
      DOUBLE PRECISION         B(nm,mm),  G(nm,mm) 
      DOUBLE PRECISION         P(nm,mm),  PI(nm,mm)
      DOUBLE PRECISION         v1(nm),    m1(nm,mm)
      DOUBLE PRECISION         det
      LOGICAL                  sy, ze

      CALL     DTSYM(Q,n,nm,sy)
      IF     ( .NOT. sy ) THEN
        WRITE(*,*) 'Makes matrix Q symmetric.'
        CALL   MATCOP(Q,QR,n,n,nm,nm)
        CALL   DMSYM(Q,QR,n,nm)
      END IF

      CALL     DTZER(Q,n,n,nm,nm,ze)

      CALL     DMZER(QS,n,n,nm,nm)
      CALL     DMZER(RR,n,n,nm,nm)
      CALL     DMZER(RS,n,n,nm,nm)
      CALL     DMZER(G,m,n,mm,nm)

      CALL     MATCOP(P,m1,m,m,mm,mm)
      CALL     INVERS(m1,PI,v1,det,m,mm)
      CALL     DMTMP(H,B,PI,n,m,nm,mm,m1)

      CALL     MATCOP(Q,QR,n,n,nm,nm)
      CALL     MATCOP(A,AN,n,n,nm,nm)

      RETURN
      END





      SUBROUTINE               DCALAN(AN,A,H,R,n,m,nm,mm,wm1)

      INTEGER                  n,m,nm,mm
      DOUBLE PRECISION         AN(nm,mm), A(nm,mm)
      DOUBLE PRECISION         H(nm,mm),  R(nm,mm)
      DOUBLE PRECISION         wm1(nm,mm)

      CALL MATMULT(H,R,wm1,n,n,n,nm)
      CALL DMSUM(AN,A,wm1,n,n,nm,nm,'-')

      RETURN
      END




      SUBROUTINE               DCSCHF(U,T,n,nm,mm,er,ei,ind)
 
      INTEGER                  n,nm,mm,ind(nm)
      DOUBLE PRECISION         U(nm,mm), T(nm,mm)
      DOUBLE PRECISION         er(nm), ei(nm)
 
      DOUBLE PRECISION         eps
 
c     reduces T to real schur form.

c     CALL     DCEPS(eps)
c     WRITE(*,*) 'eps = ',eps

      eps = 1.0D-25

      CALL     ORTHES(nm,n,1,n,T,er)
      CALL     ORTRAN(nm,n,1,n,T,er,U)
      CALL     HQR3(T,U,n,1,n,eps,er,ei,ind,nm,nm)
      CALL     DMZLT(T,n,nm)
 
      RETURN
      END



      SUBROUTINE               DMZLT(T,n,nm)

      INTEGER                  n,nm
      DOUBLE PRECISION         T(nm,nm)

      INTEGER                  i,j

      IF ( n .GE. 3 ) THEN

         DO 10 i = 3,n
            DO 20 j = 1,i-2
               T(i,j) = 0.0
20          CONTINUE
10       CONTINUE

      END IF

      RETURN
      END




      SUBROUTINE DMEIG(AN,RS,QR,QS,T,U,UT,H,HS,n,m,nm,mm,
     +                       er,ei,ind,ix,mov,stab,aq,wm1)

      INTEGER                  n,m,nm,mm

      DOUBLE PRECISION         AN(nm,mm), H(nm,mm),  QR(nm,mm)
      DOUBLE PRECISION         RS(nm,mm), HS(nm,mm), QS(nm,mm)
      DOUBLE PRECISION         T(nm,mm),  U(nm,mm),  UT(nm,mm)
      DOUBLE PRECISION         er(nm),    ei(nm)
      DOUBLE PRECISION         wm1(nm,mm) 

      INTEGER                  ind(nd), ix(nm)
      LOGICAL                  mov, stab, aq

      DOUBLE PRECISION         H2(2,2), Q2(2,2), R2(2,2), T2(2,2)
      DOUBLE PRECISION         Z(4,4) , W(4,4)
      DOUBLE PRECISION         er2(4),  ei2(4),  wv2(4)
      DOUBLE PRECISION         DCSOEZ
      INTEGER                  ind2(4), info

      CALL       DRMOV(QS,T,U,UT,H,HS,n,n,nm,mm,er,ei,ind,ix,mov,aq,wm1)

      IF       ( .NOT.mov ) GOTO 999

      IF ( n.GE.2 ) THEN
         CALL DGMBFD(T,T2,n,2,n-1,nm)
c        CALL MATPRT('Matrise T : ',T,nm,nm,n,n)
c        CALL MATPRT('Matrise T2: ',T2,nm,nm,2,2)
         CALL DGMBFD(HS,H2,n,2,n-1,nm)
c        CALL MATPRT('Matrise HS: ',HS,nm,nm,n,n)
c        CALL MATPRT('Matrise H2: ',H2,nm,nm,2,2)
         CALL DGMBFD(QS,Q2,n,2,n-1,nm)
         CALL MATCOP(Q2,R2,2,2,nm,nm)
c        CALL MATPRT('Matrise QS: ',QS,nm,nm,n,n)
c        CALL MATPRT('Matrise Q2: ',Q2,nm,nm,2,2)

       CALL RICSOL(T2,H2,R2,Z,W,2,er2,ei2,wv2,ind2,info,nm,nm,nm)

c        CALL MATPRT('Matrise R2: ',R2,nm,nm,2,2)
         CALL DSMBTD(RS,R2,n,2,n-1,nm)
c        CALL MATPRT('Matrise RS: ',RS,nm,nm,n,n)
c        CALL DMTMP(R,U,RS,n,n,nm,nm,wm1)
c        CALL MATPRT('Matrise R: ',R,nm,nm,n,n)

         CALL DCHSTA(Q2,R2,H2,stab)

      ELSE IF ((n.EQ.1).AND.(m.EQ.1)) THEN
         RS(1,1) = DCSOEZ(HS(1,1),(-2*AN(1,1)),(-QS(1,1)),'+')
         stab = ( QS(1,1) .GE. 0.0 )
         IF ( .NOT. stab )     
     +      stab = (( QS(1,1) + RS(1,1)*HS(1,1)*RS(1,1) ) .GE. 0.0 )
      ELSE
         GOTO 999
      END IF

      IF ( .NOT. stab ) THEN
         WRITE(*,*)
         WRITE(*,*) 'Closed loop eigenvalues are unstable.'
         WRITE(*,*)
      END IF

999   RETURN
      END






      SUBROUTINE DRMOV(QS,T,U,UT,H,HS,n,m,nm,mm,er,ei,ind,ix,mov,aq,wm1)

      INTEGER                  n,m,nm,mm,ind(nm),ix(nm)
      DOUBLE PRECISION         QS(nm,mm), T(nm,mm), H(nm,mm), HS(nm,mm)
      DOUBLE PRECISION         U(nm,mm), UT(nm,mm)
      DOUBLE PRECISION         er(nm),    ei(nm)
      DOUBLE PRECISION         wm1(nm,mm)
      LOGICAL                  mov, aq

      INTEGER                  nf,tep,aep(2),iah,ial
      DOUBLE PRECISION         nrv,p1,p2

100   CALL   DWEIGV(er,ei,ind,n,nm,tep,aep,ix)

      IF ((aep(1).GE.1).AND.(tep.GE.1)) THEN

         IF ((ix(aep(1)).LT.(n-1)).OR.
     +      ((aep(2).GE.1).AND.(ix(aep(2)).LT.(n-1)))) THEN

            IF (ind(ix(aep(1))).NE.0) THEN

c              CALL DCHEX(U,UT,T,HS,wm1,n,m,nm,mm)
               CALL DCEXCH(T,U,n,m,nm,mm,er,ei,ind,ix(aep(1)))
c              CALL DCHEX(U,UT,T,HS,wm1,n,m,nm,mm)
c              CALL MATPRT('T e/DCEXCH ',T,nm,nm,n,n)
c              READ (*,*)

            ELSE IF (ind(ix(aep(2))).NE.0) THEN

c              CALL DCHEX(U,UT,T,HS,wm1,n,m,nm,mm)
               CALL DCEXCH(T,U,n,m,nm,mm,er,ei,ind,ix(aep(2)))
c              CALL DCHEX(U,UT,T,HS,wm1,n,m,nm,mm)
c              CALL MATPRT('T e/DCEXCH ',T,nm,nm,n,n)
c              READ (*,*)

            ELSE 

               IF  (aep(1).GE.aep(2)) THEN
                   iah = aep(1)
                   ial = aep(2)
               ELSE
                   iah = aep(2)
                   ial = aep(1)
               END IF

c              WRITE(*,*) '         '
c              WRITE(*,*) 'ix(iah) =',ix(iah)
c              WRITE(*,*) 'n       =',n
c              WRITE(*,*) '         '

               IF (ix(iah).LT.n) THEN

c                 WRITE(*,*) 'High slar til'
c                 CALL DCHEX(U,UT,T,HS,wm1,n,m,nm,mm)
                  CALL DCEXCH(T,U,n,m,nm,mm,er,ei,ind,ix(iah))
c                 CALL DCHEX(U,UT,T,HS,wm1,n,m,nm,mm)
c                 CALL MATPRT('T e/DCEXCH ',T,nm,nm,n,n)
c                 READ (*,*)

               END IF

               IF ((ix(ial).LT.(n-1)).AND.(ial.NE.iah).AND.
     +                  (ial.NE.0)) THEN

c                 WRITE(*,*) 'Low  slar til'
c                 CALL DCHEX(U,UT,T,HS,wm1,n,m,nm,mm)
                  CALL DCEXCH(T,U,n,m,nm,mm,er,ei,ind,ix(ial))
c                 CALL DCHEX(U,UT,T,HS,wm1,n,m,nm,mm)
c                 CALL MATPRT('T e/DCEXCH ',T,nm,nm,n,n)
c                 READ (*,*)

               END IF

            END IF

         END IF

         CALL EIGVAL(T,U,n,1,n,er,ei,nm,nm)

c        WRITE(*,*)
c        DO 45 idum = 1,n
c           WRITE(*,35) 'er(n) = ',er(idum),'  ei(n) = ',ei(idum)
c35         FORMAT(A,G16.6,A,G16.6)
c45      CONTINUE

         mov = .TRUE.

         IF (((aep(2).EQ.0).OR.(aep(2).EQ.aep(1))).AND.
     +        (ind(n) .EQ. 0)) THEN

            CALL DMZER(QS,n,n,nm,nm)

            IF (ix(aep(1)).EQ.(n-1))
     +         CALL DCEXCH(T,U,n,m,nm,mm,er,ei,ind,ix(aep(1)))

            CALL DMTSP(UT,U,n,n,nm,nm)
            CALL DMTMP(HS,UT,H,n,n,nm,nm,wm1)

            nrv = T(n,n)
            WRITE (*,*)
            CALL DREAD('New real eigenvalue        : ',nrv,1,1,IIII)
            QS(n,n) = ((nrv**2-T(n,n)**2)/HS(n,n))

         ELSE

            CALL DMTSP(UT,U,n,n,nm,nm)
            CALL DMTMP(HS,UT,H,n,n,nm,nm,wm1)

200         CALL DRNEV(er,ei,n,nm,p1,p2)

c           CALL D1CALQS(QS,T,HS,n,m,nm,mm,p1,p2,nf)
            CALL D2CALQS(QS,T,HS,n,m,nm,mm,p1,p2,aq,nf)

            IF (nf .EQ. 1) THEN
               WRITE (*,*)
               WRITE (*,*) ' Not possible with these eigenvalues.'
               GOTO 200
            END IF

         END IF
      ELSE IF (aep(1) .EQ. 0) THEN
         mov = .FALSE.
      ELSE
         GOTO 100
      END IF

      RETURN
      END




      SUBROUTINE               DCHEX(U,UT,T,HS,wm1,n,m,nm,mm)

      INTEGER                  n,m,nm,mm
      DOUBLE PRECISION         T(nm,mm), HS(nm,mm)
      DOUBLE PRECISION         U(nm,mm), UT(nm,mm)
      DOUBLE PRECISION         wm1(nm,mm)

c     WRITE(*,*)
      CALL MATMULT(U,T,wm1,n,n,n,nm)
      CALL DMTSP(UT,U,n,n,nm,nm)
      CALL MATMULT(wm1,UT,HS,n,n,n,nm)
c     CALL MATPRT('Prod: UTU'' f/DCEXCH ',HS,nm,nm,n,n)

      RETURN
      END




      SUBROUTINE               DWEIGV(er,ei,ind,n,nm,j,k,ix)

      INTEGER                  n, nm
      INTEGER                  j, k(2), ix(nm), ind(nm)
      DOUBLE PRECISION         er(nm), ei(nm) 

      INTEGER                  i,in,ij


100   WRITE(*,*)
      WRITE(*,*) 'Eigenvalues of (A + BG) :'
      WRITE(*,*) '-------------------------'

       i = 0
      
      in = 0
      ij = 0

10    CONTINUE            
         i = i + 1

         IF ( ind(i) .EQ. 0 ) THEN
            in = in + 1
            ij = ij + 1
            ix(ij) = in
            WRITE(*,1) ij,in,er(in)
1           FORMAT (I2,'.   s(',I2,') =',G16.6)
         ELSE IF ((ind(i).EQ.1).OR.(ind(i).EQ.2)) THEN
                  i = i  + 1
                 in = in + 1
                 ij = ij + 1
                 ix(ij) = in
                 WRITE(*,2) ij,in, er(in), ei(in)
                 WRITE(*,3) in+1, er(in+1),ei(in+1)
2                FORMAT (I2,'.   s(',I2,') =',G16.6,4X,G16.6,' i')
3                FORMAT (2X,'    s(',I2,') =',G16.6,4X,G16.6,' i')
                 in = in + 1
         END IF
      IF ( i .LT. n ) GOTO 10

      IF ( ij .EQ. 0 ) THEN
         WRITE(*,*)
         WRITE(*,*) ' Not able to find eigenvalues.'
         k(1) = 0
      ELSE
         j = ij

200      k(1) = 0
         k(2) = 0
         WRITE(*,*)
         CALL NREAD('Eigenvalue numbers (0-Exit) : ',k,2,2,IIII)
         ij = j
         IF ((k(1).LT.0).OR.(k(1).GT.ij).OR.
     +       (k(2).LT.0).OR.(k(2).GT.ij)) THEN
            WRITE(*,*)
            WRITE(*,4) 'Possible numbers is 0 - ',ij,'.'
4           FORMAT(1X,A,I1,A)
            GOTO 200
         ELSE IF ((k(1).NE.0).AND.(k(2).NE.0).AND.
     +           ((ind(ix(k(1))).NE.0).OR.(ind(ix(k(2))).NE.0))) THEN
            WRITE(*,*)
            WRITE(*,*) ' Can only move two eigenvalues a time.'
            GOTO 200
         END IF

c        WRITE(*,*)
c        WRITE(*,*) 'tep    =',j
c        WRITE(*,*) 'aep(1) =',k(1)
c        WRITE(*,*) 'aep(2) =',k(2)
c        WRITE(*,*) 'ix(1)  =',ix(1)
c        WRITE(*,*) 'ix(2)  =',ix(2)
c        WRITE(*,*) 'ix(3)  =',ix(3)

      END IF

      RETURN
      END




                              
      SUBROUTINE               DMTMP(H,M1,M2,n,m,nm,mm,wm1)

      INTEGER                  n,m,nm,mm
      DOUBLE PRECISION         H(nm,mm),  wm1(nm,mm)
      DOUBLE PRECISION         M1(nm,mm), M2(nm,mm)

      CALL     TRANSMULT(M2,M1,wm1,m,m,n,nm,1)
      CALL     MATMULT(M1,wm1,H,n,m,n,nm)

      RETURN
      END




      SUBROUTINE               DRNEV(er,ei,n,nm,p1,p2)

      INTEGER                  n,nm
      DOUBLE PRECISION         er(nm), ei(nm), p1, p2

      DOUBLE PRECISION         dw(3),cv,rv
      PARAMETER              ( cv = 1.0, rv = 2.0 )

100   WRITE(*,*)
      IF (ei(n).EQ.0.0) THEN
         dw(1) = rv 
         dw(3) = er(n)
      ELSE
         dw(1) = cv 
         dw(3) = ei(n-1)
      END IF

      dw(2) = er(n-1)

      CALL DREAD('New type and values :',dw,3,3,IIII)

      IF ( dw(1) .EQ. cv ) THEN
         p1 = (2 * ( dw(2)**2 - dw(3)**2 ))
         p2 = (( dw(2)**2 + dw(3)**2 )**2 )
      ELSE IF ( dw(1) .EQ. rv ) THEN
         p1 = ( dw(2)**2 + dw(3)**2 )
         p2 = ( dw(2)**2 * dw(3)**2 )
      ELSE
         WRITE(*,*)
         WRITE(*,*) ' Possible type is 1 or 2. '
         WRITE(*,*) ' 1 - new complex values.  '
         WRITE(*,*) ' 2 - new real values.     '
         GOTO 100
      END IF

      RETURN
      END



      SUBROUTINE               DUMPQ(M1,M1R,M1S,U,n,m,nm,mm,wm1)

      INTEGER                  n,m,nm,mm
      DOUBLE PRECISION         M1(nm,mm), M1R(nm,mm), M1S(nm,mm)
      DOUBLE PRECISION         U(nm,mm), wm1(nm,mm)

      CALL     TRANSMULT(M1S,U,wm1,n,n,n,nm,1)
      CALL     MATMULT(U,wm1,M1R,n,n,n,nm)
      CALL     DMSUM(M1,M1,M1R,n,n,nm,nm,'+')

      RETURN
      END




      SUBROUTINE               DCALG(G,PI,B,R,n,m,nm,mm,wm1,wm2)

      INTEGER                  n,m,nm,mm
      DOUBLE PRECISION         G(nm,mm),   PI(nm,mm)
      DOUBLE PRECISION         B(nm,mm),   R(nm,mm)
      DOUBLE PRECISION         wm1(nm,mm), wm2(nm,mm)

      CALL     TRANSMULT(B,R,wm1,m,n,n,nm,2)
      CALL     MATMULT(PI,wm1,wm2,m,m,n,nm)

c     CALL     MATPRT('Matrise PI*B''*R:',wm2,mm,nm,m,n)

      CALL     DMZER(wm1,m,n,mm,nm)
      CALL     DMSUM(G,wm1,wm2,m,n,mm,nm,'-')

c     CALL     MATPRT('Matrise G - PI*B''*R:',G,mm,nm,m,n)

      RETURN
      END


      SUBROUTINE               DCEXCH(T,U,n,m,nm,mm,er,ei,ind,i)

      INTEGER                  n, m, nm, mm   
      INTEGER                  ind(nm),  i  
      DOUBLE PRECISION         T(nm,mm), U(nm,mm)
      DOUBLE PRECISION         er(nm),    ei(nm)

      INTEGER                  T1,T2
      DOUBLE PRECISION         eps
      LOGICAL                  fail


c     CALL DCEPS(eps)
      eps = 1.0D-25

c     i = 0
c     j = 0
c
c10   CONTINUE
c        i = i + 1
c        j = j + 1
c        IF ((ind(i).NE.0).AND.(j.LT.aep)) i = i + 1
c     IF (j.LT.aep) GOTO 10
c


c     WRITE(*,*) 'i for lokke :', i
c     WRITE(*,*)          
c     WRITE(*,*) 'Ind(1) = ',ind(1)
c     WRITE(*,*) 'Ind(2) = ',ind(2)
c     WRITE(*,*) 'Ind(3) = ',ind(3)

20    CONTINUE
         IF (ind(i).EQ.0) THEN
            IF (ind(i+1).EQ.0) THEN
               CALL EXCHNG(T,U,n,i,1,1,eps,fail,nm,nm)
               T1 = ind(i)
               ind(i)   = ind(i+1)
               ind(i+1) = T1
               i = i + 1
            ELSE
               CALL EXCHNG(T,U,n,i,1,2,eps,fail,nm,nm)
               T1 = ind(i)
               ind(i)   = ind(i+1)
               ind(i+1) = ind(i+2)
               ind(i+2) = T1
               i = i + 2
            END IF
         ELSE
            IF (ind(i+2).EQ.0) THEN
               CALL EXCHNG(T,U,n,i,2,1,eps,fail,nm,nm)
               T1 = ind(i)
               ind(i)   = ind(i+2)
               ind(i+2) = ind(i+1)
               ind(i+1) = T1
               i = i + 1
            ELSE
               CALL EXCHNG(T,U,n,i,2,2,eps,fail,nm,nm)
               T1 = ind(i)
               T2 = ind(i+1)
               ind(i)   = ind(i+2)
               ind(i+1) = ind(i+3)
               ind(i+2) = T1
               ind(i+3) = T2
               i = i + 2
            END IF
         END IF

      IF (((ind(i).EQ.0).AND.(i.LT.n)).OR.
     +    ((ind(i).NE.0).AND.(i.LT.(n-1)))) GOTO 20

c     WRITE(*,*)          
c     WRITE(*,*) 'Ferdig'
c     WRITE(*,*) 'Ind(1) = ',ind(1)
c     WRITE(*,*) 'Ind(2) = ',ind(2)
c     WRITE(*,*) 'Ind(3) = ',ind(3)
c     READ(*,*)
c
c     IF (ind(i).EQ.0) THEN
c        IF (i.LT.n) THEN
c           GOTO 20
c        END IF
c     ELSE IF (i.LT.(n-1)) THEN   
c        GOTO 20
c     END IF
c
      RETURN
      END




      SUBROUTINE               D2CALQS(QS,T,H,n,m,nm,mm,p1,p2,aq,nf)

      INTEGER                  n,m,nm,mm,nf
      DOUBLE PRECISION         QS(nm,mm), T(nm,mm), H(nm,mm)
      DOUBLE PRECISION         p1, p2
      LOGICAL                  aq

      INTEGER                  x
      DOUBLE PRECISION         a(0:2),b(1:3),c(1:3),d(1:2)
      DOUBLE PRECISION         f(1:4),g(1:2),k(1:2),v(1:2),w(1:2)
      DOUBLE PRECISION         hh,hh2,LL,UL,minval,T1,T2,DCSOEZ
      DOUBLE PRECISION         wrk1,wrk2,wrk3,wrk4
      PARAMETER              ( minval = 0.00000001 )

      x = n-1

      a(0) = H(x,x)*H(n,n) - H(x,n)*H(n,x)
      a(1) = H(x,x)*T(n,n)*T(n,n) - 2.0*H(x,n)*T(x,n)*T(n,n) +
     +       H(n,n)*T(x,n)*T(x,n)
      a(2) = H(x,x)*T(n,x)*T(n,x) - 2.0*H(x,n)*T(x,x)*T(n,x) +
     +       H(n,n)*T(x,x)*T(x,x)
      b(1) = H(x,x)
      b(2) = H(n,n)
      d(1) = 2.0*H(x,n)
      d(2) = T(x,x)*T(x,x) + T(n,n)*T(n,n) + 2.0*T(x,n)*T(n,x)
      k(1) = 2.0*T(x,n)*( H(x,n)*T(n,x) - H(n,n)*T(x,x)) +
     +       2.0*T(n,n)*(-H(x,x)*T(n,x) + H(x,n)*T(x,x))
      wrk1 = T(x,x)*T(n,n) - T(x,n)*T(n,x)
      k(2) = wrk1 * wrk1

      g(1) = -2.0*a(0)*a(0)*d(1)
      wrk1 = a(0)*d(2) - a(1)*b(2) - a(2)*b(1)
      g(2) = a(0)*(4.0*b(1)*b(2)*k(1) + 2.0*d(1)*wrk1)
      f(1) = a(0)*a(0)
      f(2) = -2.0*a(0)*wrk1
      f(3) = wrk1*wrk1 + 4.0*b(1)*b(2)*(a(0)*k(2)-a(1)*a(2))
      f(4) = -4.0*a(0)*b(1)*b(2)

      c(1) = -4.0*a(0)*a(0)*a(0)

CUT   IF ( ABS(c(1)) .GT. minval ) THEN
      IF ( ABS(a(0)) .GT. minval ) THEN
         c(2) = g(1)*p1 + g(2)
         c(3) = f(1)*p1*p1 + f(2)*p1 + f(3) + f(4)*p2

c        WRITE(*,*) 'c(1)   ',c(1)
c        WRITE(*,*) 'c(2)   ',c(2)
c        WRITE(*,*) 'c(3)   ',c(3)

         hh = c(2)*c(2) - 4.0*c(1)*c(3)

         IF ( ABS(hh) .LT. minval ) THEN
            QS(x,n) = -(c(2)/(2.0*c(1)))
            QS(n,x) = QS(x,n)
            IF (aq) THEN
               WRITE(*,*)
               WRITE(*,1) 'QS(1,2) = QS(2,1) must be exact :',QS(x,n)
1              FORMAT(1X,A,G16.6)
            END IF
         ELSE IF ( hh .LT. 0.0 ) THEN
            nf = 1
            GOTO 999
         ELSE
            wrk1 = -(c(2)/(2.0*c(1)))
            IF ( aq ) THEN
               hh2 = c(2)*c(2) - 4.0*c(1)*c(3)
               IF ( hh2 .GE. 0.0 ) THEN
                  T1 = DCSOEZ(c(1),c(2),c(3),'-')
                  T2 = DCSOEZ(c(1),c(2),c(3),'+')
               ELSE
                  nf = 1
                  GOTO 999
               END IF
               IF ( T1 .GT. T2 ) THEN
                  LL = T2
                  UL = T1
               ELSE
                  LL = T1
                  UL = T2
               END IF
               WRITE (*,*)
               WRITE (*,*)' Valid interval for QS(1,2):
     +                      <',LL,',',UL,'  >'
c              WRITE (*,2) 'Min : ',LL,'     Max : ',UL
c2             FORMAT (1X,A,G16.6,A,G16.6)
               WRITE (*,*)
100            wrk2 = wrk1
               CALL DREAD('Registrate value : ',wrk2,1,1,IIII)
               IF ((wrk2.LT.LL).OR.(wrk2.GT.UL)) GOTO 100
               QS(x,n) = wrk2
            ELSE
               QS(x,n) = wrk1
            END IF
            QS(n,x) = QS(x,n)
         END IF

         b(3) = d(1)*QS(x,n) + d(2) - p1
         wrk1 = c(1)*QS(x,n)*QS(x,n) + c(2)*QS(x,n) + c(3)
         wrk2 = -a(0)*b(3)
         wrk3 = a(1)*b(2) - a(2)*b(1)
         wrk4 = 2.0*a(0)*b(1)
         wrk5 = 2.0*a(0)*b(2)

c        WRITE(*,*) 'wrk1 = ', wrk1
c        WRITE(*,*) 'wrk2 = ', wrk2
c        WRITE(*,*) 'wrk3 = ', wrk3
c        WRITE(*,*) 'wrk4 = ', wrk4
c        WRITE(*,*) 'wrk5 = ', wrk5

         IF ((ABS(wrk4).LT.minval).OR.(ABS(wrk5).LT.minval)) THEN
            nf = 1
            GOTO 999
         END IF

         IF ((wrk1.LT.0.0).AND.(ABS(wrk1).LT.minval)) wrk1 = 0.0

         QS(x,x) = ((wrk2+wrk3+SQRT(wrk1))/wrk4)
         QS(n,n) = ((wrk2-wrk3-SQRT(wrk1))/wrk5)

c        CALL MATPRT('Matrise Q  rut 2 : ',QS,nm,nm,n,n)

      ELSE 
         wrk1 = a(1)*b(2) - a(2)*b(1)
         IF ( ABS(wrk1) .LT. minval ) THEN
            WRITE(*,*)
            WRITE(*,*) ' Not possible to control the system
     +                   with this values'
            nf = 1
            GOTO 999
         ELSE
            IF ( aq ) THEN
               WRITE(*,*)
               WRITE(*,*) ' No invalid interval for QS(2,1) = QS(1,2)'
               WRITE(*,*)
               QS(x,n) = 0.0
               CALL DREAD('Registrate value : ',QS(x,n),1,1,IIII)
            ELSE
               QS(x,n) = 0.0
            END IF

            QS(n,x) = QS(x,n)

            v(1) = ((a(2)*d(1) - b(2)*k(1))/wrk1)
            v(2) = ((b(2)*(p2-k(2)) - a(2)*(p1-d(2)))/wrk1)
            w(1) = ((b(1)*k(1) - a(1)*d(1))/wrk1)
            w(2) = ((-b(1)*(p2-k(2)) + a(1)*(p1-d(2)))/wrk1)

            QS(x,x) = v(1) * QS(x,n) + v(2)
            QS(n,n) = w(1) * QS(x,n) + w(2)
         END IF
      END IF

      nf = 0

999   RETURN
      END



      SUBROUTINE               D1CALQS(QS,T,H,n,m,nm,mm,p1,p2,nf)

      INTEGER                  n,m,nm,mm,nf
      DOUBLE PRECISION         QS(nm,mm), T(nm,mm), H(nm,mm)
      DOUBLE PRECISION         p1, p2

      INTEGER                  x
      DOUBLE PRECISION         a(0:5),b(0:5),c(0:2),d(0:2)
      DOUBLE PRECISION         e(0:5),f(0:5),g(0:2)   
      DOUBLE PRECISION         qroot, minval
      DOUBLE PRECISION         T1,T2
      PARAMETER              ( minval = 0.00000001 )


      x = n-1

      a(0) = 0.0d0
      a(1) = H(x,x)
      a(2) = H(n,n)
      a(3) = 0.0d0
      a(4) = 2*H(x,n)
      a(5) = T(n,n)**2 + 2*T(x,n)*T(n,x) + T(x,x)**2

      b(0) = H(x,x)*H(n,n) - H(x,n)**2
      b(1) = H(x,x)*T(n,n)**2 - 2*H(x,n)*T(x,n)*T(n,n)  
     +       + H(n,n)*T(x,n)**2
      b(2) = H(x,x)*T(n,x)**2 - 2*H(x,n)*T(x,x)*T(n,x)  
     +       + H(n,n)*T(x,x)**2
      b(3) = - H(x,x)*H(n,n) + H(x,n)**2
      b(4) = - 2*H(x,x)*T(n,x)*T(n,n) + 2*H(x,n)*T(x,x)*T(n,n)  
     +       + 2*H(x,n)*T(x,n)*T(n,x) - 2*H(n,n)*T(x,x)*T(x,n)
      b(5) = T(x,x)**2*T(n,n)**2 - 2*T(x,x)*T(x,n)*T(n,x)*T(n,n)  
     +       + T(x,n)**2*T(n,x)**2

      e(0) = - a(1)*b(0)
      e(1) = - a(4)*b(0)
      e(2) = - a(1)*b(2) + a(2)*b(1) - b(0)*a(5) + b(0)*p1
      e(3) = a(2)*b(3)
      e(4) = a(2)*b(4) - b(2)*a(4)
      e(5) = a(2)*b(5) - a(5)*b(2) - a(2)*p2 + b(2)*p1

      f(0) = - a(2)*b(0)
      f(1) = - a(4)*b(0)
      f(2) = a(1)*b(2) - a(2)*b(1) - a(5)*b(0) + b(0)*p1
      f(3) = a(1)*b(3)
      f(4) = a(1)*b(4) - b(1)*a(4)
      f(5) = a(1)*b(5) - a(1)*p2 - a(5)*b(1) + b(1)*p1

c     WRITE(*,*) 'e(0) = ',e(0)
c     WRITE(*,*) 'e(1) = ',e(1)
c     WRITE(*,*) 'e(2) = ',e(2)
c     WRITE(*,*) 'e(3) = ',e(3)
c     WRITE(*,*) 'e(4) = ',e(4)
c     WRITE(*,*) 'e(5) = ',e(5)

      g(0) = e(1)**2 - 4*e(0)*e(3)
      g(1) = 2*e(1)*e(2) - 4*e(0)*e(4)
      g(2) = e(2)**2 - 4*e(0)*e(5)

      CALL DCRQND(g(0),g(1),g(2),qroot,minval,nf)
      IF ( nf .EQ. 1 ) GOTO 999

      QS(n,x) = qroot  
      QS(x,n) = qroot

      c(0) = e(0)
      c(1) = e(1)*QS(n,x) + e(2)
      c(2) = e(3)*QS(n,x)**2 + e(4)*QS(n,x) + e(5)

      d(0) = f(0)
      d(1) = f(1)*QS(n,x) + f(2)
      d(2) = f(3)*QS(n,x)**2 + f(4)*QS(n,x) + f(5)

c     WRITE(*,*) 'c(0) = ', c(0)
c     WRITE(*,*) 'c(1) = ', c(1)
c     WRITE(*,*) 'c(2) = ', c(2)

      CALL DCRQOD(c(0),c(1),c(2),qroot,minval,nf,'-')
      IF ( nf .EQ. 1 ) GOTO 999

      QS(x,x) = qroot
c     WRITE(*,*) 'd(0) = ', d(0)
c     WRITE(*,*) 'd(1) = ', d(1)
c     WRITE(*,*) 'd(2) = ', d(2)

      CALL DCRQOD(d(0),d(1),d(2),qroot,minval,nf,'+')
      IF ( nf .EQ. 1 ) GOTO 999

      QS(n,n) = qroot

      T1 = a(0)*QS(x,x)*QS(n,n) + a(1)*QS(x,x) + a(2)*QS(n,n) +     
     +     a(3)*QS(x,n)**2 + a(4)*QS(x,n) + a(5) - p1

      T2 = b(0)*QS(x,x)*QS(n,n) + b(1)*QS(x,x) + b(2)*QS(n,n) +     
     +     b(3)*QS(x,n)**2 + b(4)*QS(x,n) + b(5) - p2

      CALL MATPRT('Matrise Q rut 1  : ',QS,nm,nm,n,n)
c     WRITE(*,*) 'T1 = ', T1
c     WRITE(*,*) 'T2 = ', T2

      nf = 0

999   RETURN
      END



      SUBROUTINE               DCRQND(a,b,c,root,mv,nf)

      DOUBLE PRECISION         a, b, c, root, mv
      INTEGER                  nf

      DOUBLE PRECISION         hh, T1, T2, TR, LL, UL, DCSOEZ

c     WRITE(*,*) 'a      ',a
c     WRITE(*,*) 'b      ',b
c     WRITE(*,*) 'c      ',c

      IF ( ABS(a) .LT. mv ) THEN
         IF ( ABS(b) .LT. mv ) THEN
            IF ( c .LT. 0.0 ) THEN
               WRITE(*,*) 'DCRQND a,b < mv og c < 0'
               nf = 1
               GOTO 999
            ELSE
               root = 0.0d0
               WRITE(*,*) 'QS(1,2) kan ha alle reelle verdier'
            END IF
         ELSE IF ( b .LT. 0.0 ) THEN
            root = -(c/b) - 1.0
         ELSE 
            root = -(c/b) + 1.0
         END IF
      ELSE
         hh = b**2 - 4*a*c
         T1 = - (b/(2*a))           
         WRITE (*,*)

         IF ( hh .LT. 0.0d0 ) THEN
              WRITE(*,*) 'DCRQND hh < 0.0'
              nf = 1
              GOTO 999
         ELSE IF ( hh .LT. mv ) THEN
              T2 = T1 + 10.0
              TR = a*T2**2 + b*T2 + c
              IF ( TR .GT. 0.0d0 ) THEN
                 WRITE(*,*) 'QS(x,n) kan ha alle reelle verdier'
              ELSE
                 WRITE(*,*) 'QS(x,n) = ',T1
              END IF
              root = T1
         ELSE
              LL = DCSOEZ(a,b,c,'-')
              UL = DCSOEZ(a,b,c,'+')
              TR = a*T1**2 + b*T1 + c
              IF ( TR .GT. 0.0d0 ) THEN
                 root = T1
                 WRITE (*,*) 'Lovlig omraade for QS(x,n) :'
                 WRITE (*,*) '---------------------------'
                 WRITE (*,1) 'QS(x,n) max : ', UL
                 WRITE (*,1) 'QS(x,n) min : ', LL
1                FORMAT (A13,G16.6)
              ELSE
                 root = UL + 10.0
                 WRITE (*,*) 'Ulovlig omraade for QS(x,n) :'
                 WRITE (*,*) '----------------------------'
                 WRITE (*,2) 'QS(x,n) max : ', UL
                 WRITE (*,2) 'QS(x,n) min : ', LL
2                FORMAT (A13,G16.6)
              END IF
         END IF

      END IF

      nf = 0

999   RETURN
      END



      SUBROUTINE               DCRQOD(a,b,c,root,mv,nf,sign)

      DOUBLE PRECISION         a, b, c, root, mv
      INTEGER                  nf
      CHARACTER                sign

      DOUBLE PRECISION         hh, T1, DCSOEZ

      IF ( ABS(a) .LT. mv ) THEN
         IF ( ABS(b) .LT. mv ) THEN
            IF ( ABS(c) .LT. mv ) THEN
               root = 0.0d0
               WRITE(*,*) 'QS(n,n) kan ha alle reelle verdier'
            ELSE
               WRITE(*,*) 'DCRQOD a,b < mv og c > mv'
               nf = 1
               GOTO 999
            END IF
         ELSE                          
            root = -(c/b)
         END IF
      ELSE
         hh = b**2 - 4*a*c
         T1 = - (b/(2*a))           
         WRITE (*,*)

         IF ( hh .LT. 0.0d0 ) THEN
              WRITE(*,*) 'DCRQOD hh  < 0.0'
              nf = 1
              GOTO 999
         ELSE IF ( hh .LT. mv ) THEN
              root = T1
         ELSE
              root = DCSOEZ(a,b,c,sign)
         END IF
      END IF

      nf = 0

999   RETURN
      END



      SUBROUTINE               DCHSTA(Q,R,H,stab)               

      DOUBLE PRECISION         Q(2,2),  R(2,2),  H(2,2)
      DOUBLE PRECISION         T1(2,2), T2(2,2), T3(2,2)
      LOGICAL                  stab

      stab = (( Q(1,1)*Q(2,2) - Q(2,1)*Q(1,2) ) .GE. 0.0 )

      IF ( .NOT. stab ) THEN
         CALL MATMULT(H,R,T1,2,2,2,2)
         CALL MATMULT(R,T1,T2,2,2,2,2)
         CALL DMSUM(T3,Q,T2,2,2,2,2,'+')
         stab = (( T3(1,1)*T3(2,2) - T3(2,1)*T3(1,2) ) .GE. 0.0 )
      END IF

      RETURN
      END




 
      DOUBLE PRECISION FUNCTION DCSOEZ(a,b,c,sgn)
 
      DOUBLE PRECISION         a,b,c,root
      CHARACTER                sgn
 
      IF (sgn.EQ.'+') THEN
         root = ((-b+sqrt(b**2-4*a*c))/(2*a))
      ELSE IF (sgn.EQ.'-') THEN
         root = ((-b-sqrt(b**2-4*a*c))/(2*a))
      END IF
 
      DCSOEZ = root

      RETURN
      END
 


      SUBROUTINE               DGMBFD(MS,ML,n,ibst,ipos,nm)
      INTEGER                  n,ibst,ipos,nm
      DOUBLE PRECISION         MS(nm,nm), ML(nm,nm)

      INTEGER                  imax,i,j

      imax = ipos + ibst - 1

      IF (imax.LE.n) THEN 
         DO 10 i = ipos,(ipos+ibst-1)
            DO 20 j = ipos,(ipos+ibst-1)
               ML((i-ipos+1),(j-ipos+1)) = MS(i,j)
20          CONTINUE
10       CONTINUE
      END IF

      RETURN
      END



      SUBROUTINE               DSMBTD(MS,ML,n,ibst,ipos,nm)

      INTEGER                  n,ibst,ipos,nm
      DOUBLE PRECISION         MS(nm,nm), ML(nm,nm)

      INTEGER                  imax,i,j

      imax = ipos + ibst - 1

      IF (imax.LE.n) THEN 
         DO 10 i = ipos,(ipos+ibst-1)
            DO 20 j = ipos,(ipos+ibst-1)
               MS(i,j) = ML((i-ipos+1),(j-ipos+1))
20          CONTINUE
10       CONTINUE
      END IF

      RETURN
      END



      SUBROUTINE               DMENU(ijob)

      INTEGER                  ijob

      INTEGER                  icom,ipos,iflag
      PARAMETER              ( icom=18 )
      CHARACTER                cjob*6, com(1:icom)*(6)

      DATA COM(1)/'A'/,   COM(2)/'B'/, COM(3)/'P'/,    COM(4)/'Q'/,
     +     COM(5)/'G'/,   COM(6)/'R'/, COM(7)/'A+BG'/, COM(8)/'MOV'/,
     +     COM(9)/'RNS'/, COM(10)/'RQV'/, COM(11)/'HELP'/,
     +     COM(12)/'EXIT'/

      WRITE(*,*)
      WRITE(*,*) '-------------                                      '
      WRITE(*,*) 'MODOPT MENU :                                      '
      WRITE(*,*) '-------------------------------------------------- '
      WRITE(*,*) 'Command : A B P Q G R A+BG MOV RNS  RQV HELP EXIT  '
      WRITE(*,*) 'Numeric : 1 2 3 4 5 6  7    8   9   10   11   0    '
      WRITE(*,*) '-------------------------------------------------- '

C... Read command
      cjob = 'MOV'

100   WRITE(*,*)
      CALL RCSTR('Modopt command :',cjob,1,1,1)
      WRITE(*,*)

C...  Test number from 0 - icom
      ipos = ICNUM(cjob)
      IF ((ipos.GE.0).AND.(ipos.LE.icom)) THEN
       ijob = ipos
       GO TO 1000
      ENDIF

C...  Test other commands
      CALL COMCHK(cjob,com,icom,iflag,ipos)
      IF (iflag.EQ.0) THEN
        ijob = ipos
      ELSEIF (iflag.EQ.1) THEN
       CALL COMLIS('Available is :',com,icom)
       cjob = 'MOV'
       GO TO 100
      ENDIF

1000  IF ( ijob .EQ. 0 ) ijob = 12

      RETURN
      END



      SUBROUTINE               DPHLP

      WRITE(*,*)                                                      
      WRITE(*,*)                                                      
      WRITE(*,*)                                                      
      WRITE(*,*)                                                      
      WRITE(*,*)                                                      
      WRITE(*,*)                                                      
      WRITE(*,*)'                         < MODOPT UTILITIES >       '   
      WRITE(*,*)'                   -------------------------------- '  
      WRITE(*,*)'                    1. Print matrix A -------> A    '
      WRITE(*,*)'                    2. Print matrix B -------> B    '
      WRITE(*,*)'                    3. Print matrix P -------> P    '
      WRITE(*,*)'                    4. Print matrix Q -------> Q    '
      WRITE(*,*)'                    5. Print matrix G -------> G    '
      WRITE(*,*)'                    6. Print matrix R -------> R    '
      WRITE(*,*)'                    7. Print matrix A+BG ----> A+BG '
      WRITE(*,*)'                    8. Move eigenvalues -----> MOV  '
      WRITE(*,*)'                    9. Read new system ------> RNS  '
      WRITE(*,*)'                   10. Registrate Q-values --> RQV  '
      WRITE(*,*)'                   11. Print this page ------> HLP  '
      WRITE(*,*)'                    0. Exit program MODOPT --> EXIT '
      WRITE(*,*)'                   ---------------------------------'
      WRITE(*,*)'                                                    '
      WRITE(*,*)'                                                    '
      WRITE(*,*)'                                                    '

      RETURN
      END




      SUBROUTINE               DMSUM(RES,M1,M2,n,m,nm,mm,flg)

      INTEGER                  n,m,nm,mm
      DOUBLE PRECISION         RES(nm,mm), M1(nm,mm), M2(nm,mm)
      CHARACTER*1              flg

      INTEGER                  i,j

      IF ( flg .EQ. '+' ) THEN
           DO 20 i = 1,n
              DO 10 j = 1,m
                 RES(i,j) = M1(i,j) + M2(i,j)
10            CONTINUE
20         CONTINUE
      ELSE IF ( flg .EQ. '-' ) THEN
           DO 40 i = 1,n
              DO 30 j = 1,m
                 RES(i,j) = M1(i,j) - M2(i,j)
30            CONTINUE
40         CONTINUE
      END IF

      RETURN
      END



      SUBROUTINE               DMTSP(RES,MAT,n,m,nn,mm)

      INTEGER                  n,m,nn,mm
      DOUBLE PRECISION         RES(nn,nm), MAT(nn,nm)

      INTEGER                  i,j

      DO 20 i = 1,n
         DO 10 j = 1,m
            RES(j,i) = MAT(i,j)
10       CONTINUE
20    CONTINUE

      RETURN
      END




      SUBROUTINE               DMZER(MAT,n,m,nm,mm)

      INTEGER                  n,m,nm,mm
      DOUBLE PRECISION         MAT(nm,mm)

      INTEGER                  i,j

      DO  20  i=1,n
          DO  10  j=1,m
              MAT(i,j) = 0.0d0
10        CONTINUE
20    CONTINUE

      RETURN
      END




      SUBROUTINE               DTSYM(MAT,n,nm,sym)

      INTEGER                  n,nm
      DOUBLE PRECISION         MAT(nm,nm)
      LOGICAL                  sym
                                                       
      INTEGER                  i,j
      DOUBLE PRECISION         mdiff
      PARAMETER              ( mdiff = 0.00001 )

      sym = .TRUE.

      DO 20 i = 1,n
         DO 10 j = i,n
            IF ( sym ) sym = ( MAT(i,j)-MAT(j,i) .LE. mdiff )
10       CONTINUE
20    CONTINUE

      RETURN
      END



      SUBROUTINE               DMSYM(RES,MAT,n,nm)

      INTEGER                  n,nm
      DOUBLE PRECISION         RES(nm,nm),MAT(nm,nm)

      INTEGER                  i,j

      DO 20 i = 1,n
         DO 10 j = 1,n
            RES(i,j) = 0.5 * ( MAT(i,j) + MAT(j,i) )
10       CONTINUE
20    CONTINUE

      RETURN
      END





      SUBROUTINE               DTZER(MAT,n,m,nm,mm,zer)

      INTEGER                  n,m,nm,mm
      DOUBLE PRECISION         MAT(nm,mm)
      LOGICAL                  zer
                                                       
      INTEGER                  i,j
      DOUBLE PRECISION         mdiff
      PARAMETER              ( mdiff = 0.00001 )

      zer = .TRUE.

      DO 20 i = 1,n
         DO 10 j = 1,m
            IF ( zer ) zer = ( ABS(MAT(i,j)) .LE. mdiff )
10       CONTINUE
20    CONTINUE

      RETURN
      END


      SUBROUTINE               DCEPS(eps)

      DOUBLE PRECISION         eps

      eps = 1.0d0
 100  eps = eps/2.0d0
      if (eps+1.0d0 .gt. 1.0d0) go to 100
      eps = 2.0d0*eps

      RETURN
      END


  





  

