      subroutine balgbk (n,mz,z,m,low,igh,cscale,cperm)
c
c     *****parameters:
      integer igh,low,m,mz,n
      double precision cperm(n),cscale(n),z(mz,n)
c
c     *****local variables:
c     none.
c
c     *****functions:
c     none.
c
c     *****subroutines called:
c     gradbk, scalbk
c
c     ---------------------------------------------------------------
c
c     *****purpose:
c     this subroutine back transforms the eigenvectors of a
c     generalized eigenvalue problem a*x = (lambda)*b*x, that was
c     balanced by subroutine balgen, to those of the original
c     problem.
c     ref.:  ward, r. c., balancing the generalized eigenvalue
c     problem, siam j. sci. stat. comput., vol. 2, no. 2, june 1981,
c     141-152.
c
c     *****parameter description:
c     on input:
c       mz      integer
c               row dimension of the array z as specified in the
c               calling program dimension statement;
c
c       n       integer
c               order of the matrices a and b in the eiggenproblem;
c
c       m       integer
c               specifies the number of eigenvectors to be trans-
c               formed;
c
c       z       real(mz,n)
c               contains the eigenvectors to be transformed;
c
c       low     integer
c               specifies the beginning index of the submatrices of
c               a and b which were balanced;
c
c       igh     integer
c               specifies the ending index of the submatrices of
c               a and b which were balanced;
c
c       cscale  real(n)
c               contains the reducing column permutations and scaling
c               information as returned from balgen;
c
c       cperm   real(n)
c               contains in its low through igh locations the column
c               permutations applied in grading the a and b
c               submatrices as returned from balgen.
c
c     on output:
c       z       real(mz,n)
c               contains the transformed eigenvectors.
c
c     *****algorithm notes:
c     none.
c
c     *****history:
c     written by r. c. ward.......
c
c     ---------------------------------------------------------------
c
      call gradbk (n,mz,z,m,low,igh,cperm)
      call scalbk (n,mz,z,m,low,igh,cscale)
      return
c
c     last line of balgbk
c
      end
