      subroutine cl1nrm (n,z,znorm)
      integer n
      real znorm
      complex z(n)
c
c     *** purpose:
c
c     cl1nrm computes an l1-type norm of a complex n-vector z and
c     scales the vector z by this norm.  specifically, the norm of z
c     is determined as the summation of  abs(re(z(i)))+abs(im(z(i)))
c     for i from 1 to n where re(z(i)) and im(z(i)) are the real and
c     imaginary parts, respectively, of the i-th component of z.
c
c     on entry:
c
c        n     integer
c              the length of the vector z.
c
c        z     complex(n)
c              the vector which is to be scaled by its norm.
c
c     on return:
c
c        znorm real
c              the norm of the vector z.
c
c        z     the vector z scaled by znorm.
c
c     this version dated may 1980.
c     alan j. laub, university of southern california.
c
c     internal variables:
c
      integer i
c
c     fortran functions called:
c
      real abs,aimag,real
      complex cmplx
c
      znorm = 0.0e0
      do 10 i = 1,n
         znorm = znorm+abs(real(z(i)))+abs(aimag(z(i)))
   10 continue
      do 20 i = 1,n
         z(i) = z(i)/cmplx(znorm,0.0e0)
   20 continue
      return
      end
