      subroutine giv (a,b,d,e)
c
c     *****parameters:
      double precision a,b,d,e
c
c     *****local variables:
      double precision c
c
c     *****functions:
      double precision dabs, dmax1
c
c     *****subroutines called:
c     none.
c
c     ----------------------------------------------------------------
c
c     *****purpose:
c     this subroutine computes:
c
c               d = a / sqrt(a*a + b*b)
c
c               e = b / sqrt(a*a + b*b)
c
c     by first normalizing by the largest magnitude of a or b.
c
c     *****parameter description:
c     on input:
c       a       real;
c
c       b       real;
c
c     on outpu:
c       d       real
c               = a / sqrt(a*a + b*b);
c
c       e       real
c               = b / sqrt(a*a + b*b).
c
c     *****history:
c     written by p. van dooren("a generalized eigenvalue approach
c     for solving riccati equations", internal report na-80-02,
c     dept. of computer science, stanford university, 1980).
c     documented by w.f. arnold, 1982.
c
c     ----------------------------------------------------------------
c
      c = dmax1(dabs(a),dabs(b))
      d = a/c
      e = b/c
      c = dsqrt(d*d + e*e)
      d = d/c
      e = e/c
      return
c
c     last line of giv
c
      end
