      subroutine mulwoa (na,nb,n,a,b,work)
c
c     *****parameters:
      integer na,nb,n
      double precision a(na,n),b(nb,n),work(n)
c
c     *****local variables:
      integer i,j,k
c
c     *****subroutines called:
c     none
c
c     ------------------------------------------------------------------
c
c     *****purpose:
c     this subroutine overwrites the array a with the matrix product
c        a*b.  both a and b are n x n arrays and must be distinct.
c
c     *****parameter description:
c     on input:
c        na,nb            row dimensions of the arrays containing a and
c                         b, respectively, as declared in the calling
c                         program dimension statement;
c
c        n                order of the matrices a and b;
c
c        a                an n x n matrix;
c
c        b                an n x n matrix.
c
c     on output:
c
c        a                an n x n array containing a*b;
c
c        work             a real scratch vector of length n.
c
c     *****history:
c     written by alan j. laub (elec. sys. lab., m.i.t., rm. 35-331,
c     cambridge, ma 02139,  ph.: (617)-253-2125), september 1977.
c     most recent version: sep. 21, 1977.
c
c     ------------------------------------------------------------------
c
      do 40 i=1,n
         do 20 j=1,n
            work(j)=0.0d0
            do 10 k=1,n
               work(j)=work(j)+a(i,k)*b(k,j)
10          continue
20       continue
         do 30 j=1,n
            a(i,j)=work(j)
30       continue
40    continue
      return
c
c     last line of mulwoa
c
      end
