      subroutine rotr (h,nmax,n,l1,l2,m1,m2,d,e)
c
c     *****parameters:
      integer l1,l2,m1,m2,n,nmax
      double precision d,e,h(nmax,n)
c
c     *****local variables:
      integer j
      double precision s
c
c     *****functions:
c     none.
c
c     *****subroutines called:
c     none.
c
c     ________________________________________________________________
c
c     *****purpose:
c     this routine performs the givens rotation:
c                       ! d  e !
c                       !-e  d !
c     on rows l1, l2 of h, this from columns m1 to m2.
c
c     *****parameter description:
c     on input:
c       nmax    integer
c               row dimension of the arrays containing a,b,z as
c               declared in the calling program dimension statement;
c
c       n       integer
c               order of the matrices a,b,z;
c
c       h       real(nmax,n)
c               the array upon which the givens rotation is to be
c               performed;
c
c       l1,l2   integer
c               rows involved in the rotation;
c
c       m1,m2   integer
c               columns involved in the rotation;
c
c       d,e     real
c               rotation parameters.
c
c     on output:
c       h       real(nmax,n)
c               the array whose rows have been modified as specified
c               above.
c
c     *****history:
c     written by p. van dooren("a generalized eigenvalue approach
c     for solving riccati equations", internal report na-80-02,
c     dept. of computer science, stanford university, 1980).
c     documented by w.f. arnold, 1982.
c
c     ----------------------------------------------------------------
c
      do 10 j = m1,m2
         s = d*h(l1,j) + e*h(l2,j)
         h(l2,j) = -e*h(l1,j) + d*h(l2,j)
         h(l1,j) = s
   10 continue
      return
c
c     last line of rotr
c
      end
