      subroutine shrslv(a,b,c,m,n,na,nb,nc)
      implicit real*8(a-h,o-z)
c shrslv      h6080 version    july 1975
c subroutines used  -  sysslv
c
c shrslv is a fortran iv subroutine to solve the real matrix
c equation a*x + x*b = c, where a is in lower real schur form 
c and b is in upper real schur form.  shrslv user the auxiliary 
c subroutine sysslv, which it communicates with through the 
c common block slvblk.  the parameters in the argument list are
c           a      a doubly subscripted array containing the
c                  matrix a in lower real schur form.
c           b      a doubly subscripted array containing the
c                  matrix b in upper real schur form.
c           c      a doubly subscripted array containing the
c                  matrix c.
c           m      the order of the matrix a.
c           n      the order of the matrix b.
c           na     the first dimension of the array a.
c           nb     the first dimension of the array b.
c           nc     the first dimension of the array c.
c
      real*8
     1a(na,1),b(nb,1),c(nc,1),t,p
      integer
     1m,n,na,nb,nc,k,km1,dk,kk,l,lm1,dl,ll,i,ib,j,ja,nsys
      common/slvblk/t(5,5),p(5),nsys
      l = 1
   10   lm1 = 1
        if(l .eq. n) go to 15
        if(b(l+1,l) .ne. 0.) dl = 2
   15   ll = l+dl-1
	if(l .eq. 1) go to 30
	do 20 j=l,ll
	  do 20 i=1,m
	    do 20 ib=1,lm1
              c(i,j) = c(i,j) - c(i,ib)*b(ib,j)
   20   continue
   30   k = 1
   40     km1 = k-1
          dk = 1
          if(k .eq. m) go to 45
          if(a(k,k+1) .ne. 0.) dk = 2
   45     kk = k+dk-1
          if(k .eq. 1) go to 60
          do 50 i=k,kk
            do 50 j=l,ll
              do 50 ja=1,km1
                c(i,j) = c(i,j) - a(i,ja)*c(ja,j)
   50     continue
   60     if(dl .eq. 2) go to 80
          if(dk .eq. 2) go to 70
          t(1,1) = a(k,k) + b(l,l)
          if(t(1,1) .eq. 0.0) then
		  if (c(k,l) .ne. 0.0) return 1
	      else
		  c(k,l) = c(k,l)/t(1,1)
	  endif
          go to 100
   70     t(1,1) = a(k,k) + b(l,l)
          t(1,2) = a(k,kk)
          t(2,1) = a(kk,k)
          t(2,2) = a(kk,kk) + b(l,l)
          p(1) = c(k,l)
          p(2) = c(kk,l)
          nsys = 2
          call sysslv
          c(k,l) = p(1)
          c(kk,l) = p(2)
          go to 100
   80     if(dk .eq. 2) go to 90
          t(1,1) = a(k,k) + b(l,l)
          t(1,2) = b(ll,l)
          t(2,1) = b(l,ll)
          t(2,2) = a(k,k) + b(ll,ll)
          p(1) = c(k,l)
          p(2) = c(k,ll)
          nsys = 2
          call sysslv
	  c(k,l) = p(1)
          c(k,ll) = p(2)
          go to 100
   90     t(1,1) = a(k,k) + b(l,l)
          t(1,2) = a(k,kk)
          t(1,3) = b(ll,l)
          t(1,4) = 0.
          t(2,1) = a(kk,k)
          t(2,2) = a(kk,kk) + b(l,l)
          t(2,3) = 0.
          t(2,3) = t(1,3)
          t(3,1) = b(l,ll)
          t(3,2) = 0.
          t(3,3) = a(k,k) + b(ll,ll)
          t(3,4) = t(1,2)
          t(4,1) = 0.
          t(4,2) = t(3,1)
          t(4,3) = t(2,1)
          t(4,4) = a(kk,kk) + b(ll,ll)
          p(1) = c(k,l)
          p(2) = c(kk,l)
          p(3) = c(k,ll)
          p(4) = c(kk,ll)
          nsys = 4
          call sysslv
          c(k,l) = p(1)
          c(kk,l) = p(2)
          c(k,ll) = p(3)
          c(kk,ll) = p(4)
  100   k = k + dk
        if(k .le. m) go to 40
      l = l + dl
      if(l .le. n) go to 10
      return
      end
