	subroutine symslc (a,c,n,na,nc)
c
c   subroutines used  -	 sysslv
c
c   symslc is a fortran subroutine to solve the real matrix
c   equation trans(a)*x + x*a  = c, where c is symmetric, a is
c   in upper real schur form, and trans(a) denotes the trans-
c   pose of a.	symslc uses the auxiliary subroutine sysslv,
c   which it communicates with through the common block
c   slvblk.
c
c   the parameters in the argument list are
c
c	a	a doubly subscripted array containing the
c		matrix a in upper real schur form.
c	c	a doubly subscripted array containing the
c		matrix c.
c	n	the order of the matrix a.
c	na	the first dimension of the array a.
c	nc	the first dimension of the array c.
c
	real*8 a(na,*),c(nc,*),t,p
	integer n,na,nc,k,kk,dk,l,ll,dl,ldl,i,ia,j,nsys
	common /slvblk/ t(5,5),p(5),nsys
	l = 1
   10	continue
	    if (l .eq. n) then
		    dl = 1
		elseif (a(l+1,l) .eq. 0.0) then
		    dl = 1
		else
		    dl = 2
	    endif
	    ll = l + dl - 1
	    k = l
   30	    continue
		if (k .eq. n) then
			dk = 1
		    elseif (a(k+1,k) .eq. 0.0) then
			dk = 1
		    else
			dk = 2
		endif
		kk = k + dk - 1
		if (dl .eq. 1) then
			if (dk .eq. 1 ) then
				do 40 ia=l,k-1
				    c(k,l) = c(k,l) - a(ia,k)*c(ia,l)
   40				continue
				t(1,1) = a(k,k) + a(l,l)
				if (t(1,1) .eq. 0.0) then
					if (c(k,l) .ne. 0.0) return 1
				    else
					c(k,l) = c(k,l)/t(1,1)
				endif
			    else
				p(1) = c(k,l)
				p(2) = c(kk,l)
				do 50 ia=l,k-1
				    p(1) = p(1) - a(ia,k)*c(ia,l)
				    p(2) = p(2) - a(ia,kk)*c(ia,l)
   50				continue
				t(1,1) = a(k,k) + a(l,l)
				t(1,2) = a(kk,k)
				t(2,1) = a(k,kk)
				t(2,2) = a(kk,kk) + a(l,l)
				nsys = 2
				call sysslv
				c(k,l) = p(1)
				c(kk,l) = p(2)
			endif
		    else
			if (dk .eq. 1) then
				p(1) = c(k,l)
				p(2) = c(k,ll)
				do 60 ia=l,k-1
				    p(1) = p(1) - a(ia,k)*c(ia,l)
				    p(2) = p(2) - a(ia,k)*c(ia,ll)
   60				continue
				t(1,1) = a(k,k) + a(l,l)
				t(1,2) = a(ll,l)
				t(2,1) = a(l,ll)
				t(2,2) = a(k,k) + a(ll,ll)
				nsys = 2
				call sysslv
				c(k,l) = p(1)
				c(k,ll) = p(2)
			    elseif (k .eq. l) then
				t(1,1) = a(l,l)
				t(1,2) = a(ll,l)
				t(1,3) = 0.0
				t(2,1) = a(l,ll)
				t(2,2) = a(l,l) + a(ll,ll)
				t(2,3) = a(ll,l)
				t(3,1) = 0.0
				t(3,2) = a(l,ll)
				t(3,3) = a(ll,ll)
				p(1) = c(l,l)*0.5
				p(2) = c(ll,l)
				p(3) = c(ll,ll)*0.5
				nsys = 3
				call sysslv
				c(l,l) = p(1)
				c(ll,l) = p(2)
				c(l,ll) = p(2)
				c(ll,ll) = p(3)
			    else
				p(1) = c(k,l)
				p(2) = c(kk,l)
				p(3) = c(k,ll)
				p(4) = c(kk,ll)
				do 70 ia=l,k-1
				    p(1) = p(1) - a(ia,k)*c(ia,l)
				    p(2) = p(2) - a(ia,kk)*c(ia,l)
				    p(3) = p(3) - a(ia,k)*c(ia,ll)
				    p(4) = p(4) - a(ia,kk)*c(ia,ll)
   70				continue
				t(1,1) = a(k,k) + a(l,l)
				t(1,2) = a(kk,k)
				t(1,3) = a(ll,l)
				t(1,4) = 0.0
				t(2,1) = a(k,kk)
				t(2,2) = a(kk,kk) + a(l,l)
				t(2,3) = 0.0
				t(2,4) = a(ll,l)
				t(3,1) = a(l,ll)
				t(3,2) = 0.0
				t(3,3) = a(k,k) + a(ll,ll)
				t(3,4) = a(kk,k)
				t(4,1) = 0.0
				t(4,2) = a(l,ll)
				t(4,3) = a(k,kk)
				t(4,4) = a(kk,kk) + a(ll,ll)
				nsys = 4
				call sysslv
				c(k,l) = p(1)
				c(kk,l) = p(2)
				c(k,ll) = p(3)
				c(kk,ll) = p(4)
			endif
		endif
		k = k + dk
	    if (k .le. n) goto 30
	    ldl = l + dl
	    do 120 j=ldl,n
		do 100 i=l,ll
		    c(i,j) = c(j,i)
  100		continue
		do 110 i=j,n
		    c(i,j) = c(i,j) - c(i,l)*a(l,j) - a(l,i)*c(j,l)
		    if (dl .eq. 2) then
			c(i,j) = c(i,j) - c(i,ll)*a(ll,j) - a(ll,i)*c(j,ll)
		    endif
		    c(j,i) = c(i,j)
  110		continue
  120	    continue
	    l = ldl
	if (ldl .le. n) goto 10
	return
	end
