	subroutine symsld (a,c,n,na,nc)
c
c   subroutines used  -	 sysslv
c
c   symsld is a fortran subroutine to solve the real matrix
c   equation trans(a)*x*a - x = c, where c is symmetric, a is
c   in upper real schur form, and trans(a) denotes the trans-
c   pose of a.	symsld uses the auxiliary subroutine sysslv,
c   which it communicates with through the common block
c   slvblk.
c
c   the parameters in the argument list are
c
c	a	a doubly subscripted array containing the
c		matrix a in upper real schur form.
c	c	a doubly subscripted array containing the
c		matrix c.
c	n	the order of the matrix a.
c	na	the first dimension of the array a.
c	nc	the first dimension of the array c.
c
	real*8 a(na,*),c(nc,*),t,p
	integer n,na,nc,k,kk,dk,l,ll,dl,ldl,i,ia,j,nsys
	common /slvblk/ t(5,5),p(5),nsys
	l = 1
   10	continue
	    if (l .eq. n) then
		    dl = 1
		elseif (a(l+1,l) .eq. 0.0) then
		    dl = 1
		else
		    dl = 2
	    endif
	    ll = l + dl - 1
	    k = l
   30	    continue
		if (k .eq. n) then
			dk = 1
		    elseif (a(k+1,k) .eq. 0.0) then
			dk = 1
		    else
			dk = 2
		endif
		kk = k + dk - 1
		if (dl .eq. 1) then
			if (dk .eq. 1 ) then
				if (k .ne. l) then
				    t(1,1) = 0.0
				    do 40 ia=l,k-1
					t(1,1) = t(1,1) + a(ia,k)*c(ia,l)
   40				    continue
				    c(l,k) = t(1,1)
				    c(k,l) = c(k,l) - t(1,1)*a(l,l)
				endif
				t(1,1) = a(k,k)*a(l,l) - 1.0
				if (t(1,1) .eq. 0.0) then
					if (c(k,l) .ne. 0.0) return 1
				    else
					c(k,l) = c(k,l)/t(1,1)
				endif
				if (k .ne. l) c(l,k) = c(l,k) + a(k,k)*c(k,l)
			    else
				t(1,1) = 0.0
				t(2,1) = 0.0
				do 50 ia=l,k-1
				    t(1,1) = t(1,1) + a(ia,k)*c(ia,l)
				    t(2,1) = t(2,1) + a(ia,kk)*c(ia,l)
   50				continue
				c(l,k) = t(1,1)
				c(l,kk) = t(2,1)
				p(1) = c(k,l) - t(1,1)*a(l,l)
				p(2) = c(kk,l) - t(2,1)*a(l,l)
				t(1,1) = a(k,k)*a(l,l) - 1.0
				t(1,2) = a(kk,k)*a(l,l)
				t(2,1) = a(k,kk)*a(l,l)
				t(2,2) = a(kk,kk)*a(l,l) - 1.0
				nsys = 2
				call sysslv
				c(k,l) = p(1)
				c(kk,l) = p(2)
				c(l,k) = c(l,k) + a(k,k)*p(1) + a(kk,k)*p(2)
				c(l,kk) = c(l,kk) + a(k,kk)*p(1) + a(kk,kk)*p(2)
			endif
		    else
			if (dk .eq. 1) then
				t(1,1) = 0.0
				t(1,2) = 0.0
				do 60 ia=l,k-1
				    t(1,1) = t(1,1) + a(ia,k)*c(ia,l)
				    t(1,2) = t(1,2) + a(ia,k)*c(ia,ll)
   60				continue
				c(l,k) = t(1,1)
				c(ll,k) = t(1,2)
				p(1) = c(k,l) - t(1,1)*a(l,l) - t(1,2)*a(ll,l)
				p(2) = c(k,ll) - t(1,1)*a(l,ll) - t(1,2)*a(ll,ll)
				t(1,1) = a(k,k)*a(l,l) - 1.0
				t(1,2) = a(k,k)*a(ll,l)
				t(2,1) = a(k,k)*a(l,ll)
				t(2,2) = a(k,k)*a(ll,ll) - 1.0
				nsys = 2
				call sysslv
				c(k,l) = p(1)
				c(k,ll) = p(2)
				c(l,k) = c(l,k) + a(k,k)*p(1)
				c(ll,k) = c(ll,k) + a(k,k)*p(2)
			    elseif (k .eq. l) then
				t(1,1) = a(l,l)**2 - 1.0
				t(1,2) = 2.0*a(ll,l)*a(l,l)
				t(1,3) = a(ll,l)**2
				t(2,1) = a(l,ll)*a(l,l)
				t(2,2) = a(l,l)*a(ll,ll) + a(l,ll)*a(ll,l) - 1.0
				t(2,3) = a(ll,l)*a(ll,ll)
				t(3,1) = a(l,ll)**2
				t(3,2) = 2.0*a(l,ll)*a(ll,ll)
				t(3,3) = a(ll,ll)**2 - 1.0
				p(1) = c(l,l)
				p(2) = c(ll,l)
				p(3) = c(ll,ll)
				nsys = 3
				call sysslv
				c(l,l) = p(1)
				c(ll,l) = p(2)
				c(l,ll) = p(2)
				c(ll,ll) = p(3)
			    else
				t(1,1) = 0.0
				t(1,2) = 0.0
				t(2,1) = 0.0
				t(2,2) = 0.0
				do 70 ia=l,k-1
				    t(1,1) = t(1,1) + a(ia,k)*c(ia,l)
				    t(1,2) = t(1,2) + a(ia,k)*c(ia,ll)
				    t(2,1) = t(2,1) + a(ia,kk)*c(ia,l)
				    t(2,2) = t(2,2) + a(ia,kk)*c(ia,ll)
   70				continue
				c(l,k) = t(1,1)
				c(ll,k) = t(1,2)
				c(l,kk) = t(2,1)
				c(ll,kk) = t(2,2)
				p(1) = c(k,l) - t(1,1)*a(l,l) - t(1,2)*a(ll,l)
				p(2) = c(kk,l) - t(2,1)*a(l,l) - t(2,2)*a(ll,l)
				p(3) = c(k,ll) - t(1,1)*a(l,ll) - t(1,2)*a(ll,ll)
				p(4) = c(kk,ll) - t(2,1)*a(l,ll) - t(2,2)*a(ll,ll)
				t(1,1) = a(k,k)*a(l,l) - 1.0
				t(1,2) = a(kk,k)*a(l,l)
				t(1,3) = a(k,k)*a(ll,l)
				t(1,4) = a(kk,k)*a(ll,l)
				t(2,1) = a(k,kk)*a(l,l)
				t(2,2) = a(kk,kk)*a(l,l) - 1.0
				t(2,3) = a(k,kk)*a(ll,l)
				t(2,4) = a(kk,kk)*a(ll,l)
				t(3,1) = a(k,k)*a(l,ll)
				t(3,2) = a(kk,k)*a(l,ll)
				t(3,3) = a(k,k)*a(ll,ll) - 1.0
				t(3,4) = a(kk,k)*a(ll,ll)
				t(4,1) = a(k,kk)*a(l,ll)
				t(4,2) = a(kk,kk)*a(l,ll)
				t(4,3) = a(k,kk)*a(ll,ll)
				t(4,4) = a(kk,kk)*a(ll,ll) - 1.0
				nsys = 4
				call sysslv
				c(k,l) = p(1)
				c(kk,l) = p(2)
				c(k,ll) = p(3)
				c(kk,ll) = p(4)
				c(l,k) = c(l,k) + a(k,k)*p(1) + a(kk,k)*p(2)
				c(l,kk) = c(l,kk) + a(k,kk)*p(1) + a(kk,kk)*p(2)
				c(ll,k) = c(ll,k) + a(k,k)*p(3) + a(kk,k)*p(4)
				c(ll,kk) = c(ll,kk) + a(k,kk)*p(3) + a(kk,kk)*p(4)
			endif
		endif
		k = k + dk
	    if (k .le. n) goto 30
	    ldl = l + dl
	    do 120 j=ldl,n
		do 100 i=j,n
		    c(i,j) = c(i,j) - c(l,i)*a(l,j) - a(l,i)*c(l,j) 
     .			     + a(l,i)*c(l,l)*a(l,j)
		    if (dl .eq. 2) then
			c(i,j) = c(i,j) - c(ll,i)*a(ll,j) - a(ll,i)*c(ll,j) 
     .				 + a(ll,i)*c(ll,ll)*a(ll,j)
     .				 + (a(l,i)*a(ll,j) + a(ll,i)*a(l,j))*c(l,ll)
		    endif
		    c(j,i) = c(i,j)
  100		continue
		do 110 i=l,ll
		    c(i,j) = c(j,i)
  110		continue
  120	    continue
	    l = ldl
	if (ldl .le. n) goto 10
	return
	end
