      subroutine symslv(a,c,n,na,nc)
      implicit real*8(a-h,o-z)
c symslv      h6080 version    july 1975
c subroutines used  -  sysslv
c
c symslv is a fortran iv subroutine to solve the real matrix
c equation trans(a)*x + x*a = c, where c is symmetric, a is
c in upper real schur form, and trans(a) denotes the trans-
c pose of a.  symslv uses the auxiliary subroutine sysslv,
c which it communicates with through the common block
c slvblk.  the parameters in the argument list are
c           a      a doubly subscripted array containing the
c                  matrix a in upper real schur form.
c           c      a doubly subscripted array containing the
c                  matrix c.
c           n      the order of the matrix a.
c           na     the first dimension of the array a.
c           nc     the first dimension of the array c.
c
      real*8
     1a(na,1),c(nc,1),t,p
      integer
     1n,na,nc,k,kk,dk,km1,l,ll,dl,ldl,i,ia,j,nsys
      common/slvblk/t(5,5),p(5),nsys
      l = 1
   10   dl = 1
        if(l .eq. n) go to 20
        if(a(l+1,l) .ne. 0.) dl = 2
   20   ll = l+dl-1
        k = l
   30     km1 = k-1
          dk = 1
          if(k .eq. n) go to 35
          if(a(k+1,k) .ne. 0.) dk = 2
   35     kk = k+dk-1
          if(k .eq. l) go to 45
          do 40 i=k,kk
            do 40 j=l,ll
              do 40 ia=l,km1
                c(i,j) = c(i,j) - a(ia,i)*c(ia,j)
   40     continue
   45     if(dl .eq. 2) go to 60
          if(dk .eq. 2 ) go to 50
          t(1,1) = a(k,k) + a(l,l)
          if(t(1,1) .eq. 0.) stop 992
          c(k,l) = c(k,l)/t(1,1)
          go to 90
   50     t(1,1) = a(k,k) + a(l,l)
          t(1,2) = a(kk,k)
          t(2,1) = a(k,kk)
          t(2,2) = a(kk,kk) + a(l,l)
          p(1) = c(k,l)
          p(2) = c(kk,l)
          nsys = 2
          call sysslv
          c(k,l) = p(1)
          c(kk,l) = p(2)
          go to 90
   60     if(dk .eq. 2) go to 70
          t(1,1) = a(k,k) + a(l,l)
          t(1,2) = a(ll,l)
          t(2,1) = a(l,ll)
          t(2,2) = a(k,k) + a(ll,ll)
          p(1) = c(k,l)
          p(2) = c(k,ll)
          nsys = 2
          call sysslv
	  c(k,l) = p(1)
          c(k,ll) = p(2)
          go to 90
   70     if(k .ne. l) go to 80
          t(1,1) = a(l,l)
          t(1,2) = a(ll,l)
          t(1,3) = 0.
          t(2,1) = a(l,ll)
          t(2,2) = a(l,l) + a(ll,ll)
          t(2,3) = t(1,2)
          t(3,1) = 0.
          t(3,2) = t(2,1)
          t(3,3) = a(ll,ll)
          p(1) = c(l,l)/2.
          p(2) = c(ll,l)
          p(3) = c(ll,ll)/2.
          nsys = 3
          call sysslv
          c(l,l) = p(1)
          c(ll,l) = p(2)
          c(l,ll) = p(2)
          c(ll,ll) = p(3)
          go to 90
   80     t(1,1) = a(k,k) + a(l,l)
          t(1,2) = a(kk,k)
          t(1,3) = a(ll,l)
          t(1,4) = 0.
          t(2,1) = a(k,kk)
          t(2,2) = a(kk,kk) + a(l,l)
          t(2,3) = 0.
          t(2,4) = t(1,3)
          t(3,1) = a(l,ll)
          t(3,2) = 0.
          t(3,3) = a(k,k) + a(ll,ll)
          t(3,4) = t(1,2)
          t(4,1) = 0.
          t(4,2) = t(3,1)
          t(4,3) = t(2,1)
          t(4,4) = a(kk,kk) + a(ll,ll)
          p(1) = c(k,l)
          p(2) = c(kk,l)
          p(3) = c(k,ll)
          p(4) = c(kk,ll)
          nsys = 4
          call sysslv
          c(k,l) = p(1)
          c(kk,l) = p(2)
          c(k,ll) = p(3)
          c(kk,ll) = p(4)
   90   k = k + dk
        if(k .le. n) go to 30
        ldl = l + dl
        if(ldl .gt. n) return
        do 120 j=ldl,n
          do 100 i=l,ll
            c(i,j) = c(j,i)
  100     continue
          do 120 i=j,n
            do 110 k=l,ll
              c(i,j) = c(i,j) - c(i,k)*a(k,j) - a(k,i)*c(k,j)
  110       continue
            c(j,i) = c(i,j)
  120   continue
      l = ldl
      go to 10
      end
