	subroutine sysslv
c
c   subroutines used  -	 (none)
c
c   sysslv is a fortran subroutine that solves the linear
c   system ax = b of order n (less than 5) by crout reduction
c   followed by back substitution.  the matrix a, the vector
c   b, and the order n are contained in the arrays a,b, and
c   the variable n of the common block slvblk.	the solution
c   is returned in the array b.
c
	common /slvblk/ a(5,5),b(5),n
	real*8 a,b,max,temp
	integer n,nm1,n1,k,km1,i,j,kp1,intr,im1,ii,i1
c
	nm1 = n - 1
	n1 = n + 1
c
c   compute the lu factorization of a
c
	do 80 k=1,n
	    km1 = k - 1
	    do 20 i=k,n
		do 10 j=1,km1
		    a(i,k) = a(i,k) - a(i,j)*a(j,k)
   10		continue
   20	    continue
	    if (k .eq. n) goto 100
	    kp1 = k + 1
	    max = abs(a(k,k))
	    intr = k
	    do 30 i=kp1,n
		temp = abs(a(i,k))
		if (temp .le. max) goto 30
		max = temp
		intr = i
   30	    continue
	    if (max .eq. 0.0) return 1
	    a(n1,k) = intr
	    if (intr .ne. k) then
		do 40 j=1,n
		    temp = a(k,j)
		    a(k,j) = a(intr,j)
		    a(intr,j) = temp
   40		continue
	    endif
	    do 70 j=kp1,n
		do 60 i=1,km1
		    a(k,j) = a(k,j) - a(k,i)*a(i,j)
   60		continue
		a(k,j) = a(k,j)/a(k,k)
   70	    continue
   80	continue
c
c   interchange the components of b
c
  100	continue
	do 110 j=1,nm1
	    intr = a(n1,j)
	    if (intr .ne. j) then
		temp = b(j)
		b(j) = b(intr)
		b(intr) = temp
	    endif
  110	continue
c
c   solve lx = b
c
	b(1) = b(1)/a(1,1)
	do 220 i=2,n
	    im1 = i-1
	    do 210 j=1,im1
		b(i) = b(i) - a(i,j)*b(j)
  210	    continue
	    b(i) = b(i)/a(i,i)
  220	continue
c
c   solve ux = b
c
	do 320 ii=1,nm1
	    i = nm1 - ii + 1
	    i1 = i+1
	    do 310 j=i1,n
		b(i) = b(i) - a(i,j)*b(j)
  310	    continue
  320	continue
	return 0 
	end
