      SUBROUTINE  CSROT (N,CX,INCX,CY,INCY,C,S)                         00000010
C                                                                       00000020
C     APPLIES A PLANE ROTATION, WHERE THE COS AND SIN (C AND S) ARE REAL00000030
C     AND THE VECTORS CX AND CY ARE COMPLEX.                            00000040
C     JACK DONGARRA, LINPACK, 3/11/78.                                  00000050
C                                                                       00000060
      COMPLEX CX(1),CY(1),CTEMP                                         00000070
      REAL C,S                                                          00000080
      INTEGER I,INCX,INCY,IX,IY,N                                       00000090
C                                                                       00000100
      IF(N.LE.0)RETURN                                                  00000110
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               00000120
C                                                                       00000130
C       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL       00000140
C         TO 1                                                          00000150
C                                                                       00000160
      IX = 1                                                            00000170
      IY = 1                                                            00000180
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 00000190
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 00000200
      DO 10 I = 1,N                                                     00000210
        CTEMP = C*CX(IX) + S*CY(IY)                                     00000220
        CY(IY) = C*CY(IY) - S*CX(IX)                                    00000230
        CX(IX) = CTEMP                                                  00000240
        IX = IX + INCX                                                  00000250
        IY = IY + INCY                                                  00000260
   10 CONTINUE                                                          00000270
      RETURN                                                            00000280
C                                                                       00000290
C       CODE FOR BOTH INCREMENTS EQUAL TO 1                             00000300
C                                                                       00000310
   20 DO 30 I = 1,N                                                     00000320
        CTEMP = C*CX(I) + S*CY(I)                                       00000330
        CY(I) = C*CY(I) - S*CX(I)                                       00000340
        CX(I) = CTEMP                                                   00000350
   30 CONTINUE                                                          00000360
      RETURN                                                            00000370
      END                                                               00000380
