      SUBROUTINE  DCOPY(N,DX,INCX,DY,INCY)                              00000010
C                                                                       00000020
C     COPIES A VECTOR, X, TO A VECTOR, Y.                               00000030
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.                  00000040
C     JACK DONGARRA, LINPACK, 3/11/78.                                  00000050
C                                                                       00000060
      DOUBLE PRECISION DX(1),DY(1)                                      00000070
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N                                 00000080
C                                                                       00000090
      IF(N.LE.0)RETURN                                                  00000100
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               00000110
C                                                                       00000120
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS                00000130
C          NOT EQUAL TO 1                                               00000140
C                                                                       00000150
      IX = 1                                                            00000160
      IY = 1                                                            00000170
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 00000180
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 00000190
      DO 10 I = 1,N                                                     00000200
        DY(IY) = DX(IX)                                                 00000210
        IX = IX + INCX                                                  00000220
        IY = IY + INCY                                                  00000230
   10 CONTINUE                                                          00000240
      RETURN                                                            00000250
C                                                                       00000260
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                            00000270
C                                                                       00000280
C                                                                       00000290
C        CLEAN-UP LOOP                                                  00000300
C                                                                       00000310
   20 M = MOD(N,7)                                                      00000320
      IF( M .EQ. 0 ) GO TO 40                                           00000330
      DO 30 I = 1,M                                                     00000340
        DY(I) = DX(I)                                                   00000350
   30 CONTINUE                                                          00000360
      IF( N .LT. 7 ) RETURN                                             00000370
   40 MP1 = M + 1                                                       00000380
      DO 50 I = MP1,N,7                                                 00000390
        DY(I) = DX(I)                                                   00000400
        DY(I + 1) = DX(I + 1)                                           00000410
        DY(I + 2) = DX(I + 2)                                           00000420
        DY(I + 3) = DX(I + 3)                                           00000430
        DY(I + 4) = DX(I + 4)                                           00000440
        DY(I + 5) = DX(I + 5)                                           00000450
        DY(I + 6) = DX(I + 6)                                           00000460
   50 CONTINUE                                                          00000470
      RETURN                                                            00000480
      END                                                               00000490
