      REAL FUNCTION SMACH(JOB)                                          00000010
      INTEGER JOB                                                       00000020
C                                                                       00000030
C     SMACH COMPUTES MACHINE PARAMETERS OF FLOATING POINT               00000040
C     ARITHMETIC FOR USE IN TESTING ONLY.  NOT REQUIRED BY              00000050
C     LINPACK PROPER.                                                   00000060
C                                                                       00000070
C     IF TROUBLE WITH AUTOMATIC COMPUTATION OF THESE QUANTITIES,        00000080
C     THEY CAN BE SET BY DIRECT ASSIGNMENT STATEMENTS.                  00000090
C     ASSUME THE COMPUTER HAS                                           00000100
C                                                                       00000110
C        B = BASE OF ARITHMETIC                                         00000120
C        T = NUMBER OF BASE  B  DIGITS                                  00000130
C        L = SMALLEST POSSIBLE EXPONENT                                 00000140
C        U = LARGEST POSSIBLE EXPONENT                                  00000150
C                                                                       00000160
C     THEN                                                              00000170
C                                                                       00000180
C        EPS = B**(1-T)                                                 00000190
C        TINY = 100.0*B**(-L+T)                                         00000200
C        HUGE = 0.01*B**(U-T)                                           00000210
C                                                                       00000220
C     DMACH SAME AS SMACH EXCEPT T, L, U APPLY TO                       00000230
C     DOUBLE PRECISION.                                                 00000240
C                                                                       00000250
C     CMACH SAME AS SMACH EXCEPT IF COMPLEX DIVISION                    00000260
C     IS DONE BY                                                        00000270
C                                                                       00000280
C        1/(X+I*Y) = (X-I*Y)/(X**2+Y**2)                                00000290
C                                                                       00000300
C     THEN                                                              00000310
C                                                                       00000320
C        TINY = SQRT(TINY)                                              00000330
C        HUGE = SQRT(HUGE)                                              00000340
C                                                                       00000350
C                                                                       00000360
C     JOB IS 1, 2 OR 3 FOR EPSILON, TINY AND HUGE, RESPECTIVELY.        00000370
C                                                                       00000380
C                                                                       00000390
      REAL EPS,TINY,HUGE,S                                              00000400
C                                                                       00000410
      EPS = 1.0                                                         00000420
   10 EPS = EPS/2.0                                                     00000430
      S = 1.0 + EPS                                                     00000440
      IF (S .GT. 1.0) GO TO 10                                          00000450
      EPS = 2.0*EPS                                                     00000460
C                                                                       00000470
      S = 1.0                                                           00000480
   20 TINY = S                                                          00000490
      S = S/16.0                                                        00000500
      IF (S*100. .NE. 0.0) GO TO 20                                     00000510
      TINY = (TINY/EPS)*100.0                                           00000520
      HUGE = 1.0/TINY                                                   00000530
C                                                                       00000540
      IF (JOB .EQ. 1) SMACH = EPS                                       00000550
      IF (JOB .EQ. 2) SMACH = TINY                                      00000560
      IF (JOB .EQ. 3) SMACH = HUGE                                      00000570
      RETURN                                                            00000580
      END                                                               00000590
