      SUBROUTINE SROTG(SA,SB,C,S)                                       00000010
C                                                                       00000020
C     CONSTRUCT GIVENS PLANE ROTATION.                                  00000030
C     JACK DONGARRA, LINPACK, 3/11/78.                                  00000040
C                                                                       00000050
      REAL SA,SB,C,S,ROE,SCALE,R,Z                                      00000060
C                                                                       00000070
      ROE = SB                                                          00000080
      IF( ABS(SA) .GT. ABS(SB) ) ROE = SA                               00000090
      SCALE = ABS(SA) + ABS(SB)                                         00000100
      IF( SCALE .NE. 0.0 ) GO TO 10                                     00000110
         C = 1.0                                                        00000120
         S = 0.0                                                        00000130
         R = 0.0                                                        00000140
         GO TO 20                                                       00000150
   10 R = SCALE*SQRT((SA/SCALE)**2 + (SB/SCALE)**2)                     00000160
      R = SIGN(1.0,ROE)*R                                               00000170
      C = SA/R                                                          00000180
      S = SB/R                                                          00000190
   20 Z = 1.0                                                           00000200
      IF( ABS(SA) .GT. ABS(SB) ) Z = S                                  00000210
      IF( ABS(SB) .GE. ABS(SA) .AND. C .NE. 0.0 ) Z = 1.0/C             00000220
      SA = R                                                            00000230
      SB = Z                                                            00000240
      RETURN                                                            00000250
      END                                                               00000260
