      DOUBLE PRECISION FUNCTION ZMACH(JOB)                              00000010
      INTEGER JOB                                                       00000020
C                                                                       00000030
C     COMPLEX*16 FLOATING POINT ARITHMETIC CONSTANTS.                   00000040
C     FOR THE LINPACK TEST DRIVERS ONLY.                                00000050
C     NOT USED BY ACTUAL LINPACK SUBROUTINES.                           00000060
C                                                                       00000070
C     SMACH COMPUTES MACHINE PARAMETERS OF FLOATING POINT               00000080
C     ARITHMETIC FOR USE IN TESTING ONLY.  NOT REQUIRED BY              00000090
C     LINPACK PROPER.                                                   00000100
C                                                                       00000110
C     IF TROUBLE WITH AUTOMATIC COMPUTATION OF THESE QUANTITIES,        00000120
C     THEY CAN BE SET BY DIRECT ASSIGNMENT STATEMENTS.                  00000130
C     ASSUME THE COMPUTER HAS                                           00000140
C                                                                       00000150
C        B = BASE OF ARITHMETIC                                         00000160
C        T = NUMBER OF BASE  B  DIGITS                                  00000170
C        L = SMALLEST POSSIBLE EXPONENT                                 00000180
C        U = LARGEST POSSIBLE EXPONENT                                  00000190
C                                                                       00000200
C     THEN                                                              00000210
C                                                                       00000220
C        EPS = B**(1-T)                                                 00000230
C        TINY = 100.0*B**(-L+T)                                         00000240
C        HUGE = 0.01*B**(U-T)                                           00000250
C                                                                       00000260
C     DMACH SAME AS SMACH EXCEPT T, L, U APPLY TO                       00000270
C     DOUBLE PRECISION.                                                 00000280
C                                                                       00000290
C     CMACH SAME AS SMACH EXCEPT IF COMPLEX DIVISION                    00000300
C     IS DONE BY                                                        00000310
C                                                                       00000320
C        1/(X+I*Y) = (X-I*Y)/(X**2+Y**2)                                00000330
C                                                                       00000340
C     THEN                                                              00000350
C                                                                       00000360
C        TINY = SQRT(TINY)                                              00000370
C        HUGE = SQRT(HUGE)                                              00000380
C                                                                       00000390
C                                                                       00000400
C     JOB IS 1, 2 OR 3 FOR EPSILON, TINY AND HUGE, RESPECTIVELY.        00000410
C                                                                       00000420
      DOUBLE PRECISION EPS,TINY,HUGE,S                                  00000430
C                                                                       00000440
      EPS = 1.0D0                                                       00000450
   10 EPS = EPS/2.0D0                                                   00000460
      S = 1.0D0 + EPS                                                   00000470
      IF (S .GT. 1.0D0) GO TO 10                                        00000480
      EPS = 2.0D0*EPS                                                   00000490
C                                                                       00000500
      S = 1.0D0                                                         00000510
   20 TINY = S                                                          00000520
      S = S/16.0D0                                                      00000530
      IF (S*1.0D0 .NE. 0.0D0) GO TO 20                                  00000540
      TINY = TINY/EPS                                                   00000550
      S = (1.0D0,0.0D0)/DCMPLX(TINY,0.0D0)                              00000560
      IF (S .NE. 1.0D0/TINY) TINY = DSQRT(TINY)                         00000570
      HUGE = 1.0D0/TINY                                                 00000580
C                                                                       00000590
      IF (JOB .EQ. 1) ZMACH = EPS                                       00000600
      IF (JOB .EQ. 2) ZMACH = TINY                                      00000610
      IF (JOB .EQ. 3) ZMACH = HUGE                                      00000620
      RETURN                                                            00000630
      END                                                               00000640
