       SUBROUTINE CLABG(ABG,A,B,G,NX,NU,NA,NB)
C---------------------------------------------------------------C
C***BEGIN PROLOGUE CLABG                                        C
C                                                               C
C   PURPOSE                                                     C
C   CLABG computes the closed loop matrix A + B*G. A, B, and G  C
C   are unchanged on output.                                    C
C   ON INPUT                                                    C
C   A        DOUBLE PRECISION (NA,NX) system matrix.            C
C   B        DOUBLE PRECISION (NB,NU) control matrix.           C
C   G        DOUBLE PRECISION (NB,NX) feedback matrix.          C
C   NX       INTEGER number of states.                          C
C   NU       INTEGER number of control variable.                C
C   NA,NB    INTEGER leading dimensions on A and B respectively.C
C   ON OUTPUT                                                   C
C   ABG      DOUBLE PRECISION (NA,NX) the result A+B*G.         C
C                                                               C
C   ROUTINES CALLED : MATMULT                                   C
C***END PROLOGUE CLABG                                          C
C---------------------------------------------------------------C
      INTEGER NX,NU,NA,NB
      DOUBLE PRECISION ABG(NA,NX),A(NA,NX),B(NB,NU),G(NB,NX)

C1... Compute the product B*G           .........................
      CALL MATMULT(B,G,ABG,NX,NU,NX,NA)

C2... Compute A + B*G                   .........................
      DO 10 I=1,NX
         DO 20 J=1,NX
            ABG(I,J) = A(I,J) + ABG(I,J)
20       CONTINUE
10    CONTINUE

      RETURN
      END
