        function dfnorm(mat,nm,n)
C------------------------------------------------------------------C
C***BEGIN PROLOGUE DFNORM                                          C
C   AUTHOR : David Di Ruscio                                       C
C                                                                  C
C   PURPOSE                                                        C
C   FNORM computes the Frobenius norm of a squere matrix MAT(N,N). C
C                                                                  C
C   ON INPUT                                                       C
C   MAT      DOUBLE PRECISION (NM,N) matrix to compute Frobenius   C
C            norm of. Unchanged on output.                         C
C   NM       INTEGER leading dimension on MAT in calling program.  C
C   N        INTEGER actual dimension on MAT in calling program.   C
C                                                                  C
C   ROUTINES CALLED : (NONE)                                       C
C***END PROLOGUE DFNORM                                            C
C------------------------------------------------------------------C
        integer nm,n
        double precision mat(nm,nm),fnorm1,fabs
c
        fnorm1=0.0
c
        do 100 i=1,n
           do 100 j=1,n
           fabs = abs(mat(i,j))
           if (fabs.gt.1.e15) fabs=1.e15
           fnorm1 = fnorm1 + fabs*fabs
100     continue
        dfnorm = sqrt(fnorm1)
c
        return
        end
