       SUBROUTINE DMINFNO(A,NA,N,M,DNORM,W1,W2)        
C--------------------------------------------------------------c
C***BEGIN PROLOGUE DMINFNO                                     c
C   Author :   David Di Ruscio                  30/5-89        c
C   DMINFNO computes the infinity norm of a double precision   c
C   matrix A(N,M). The result inf(A) is stored in DNORM on     c
C   output.                                                    c
C   ON INPUT                                                   c
C   A     DOUBLE PRECISION(NA,*) argument.                     c
C   NA    INTEGER leading dimension for A in calling program.  c
C   N     INTEGER actual row dimension A(N,M).                 c
C   M     INTEGER actual col. dimension A(N,M).                c
C   W1 W2 DOUBLE PRECISION (*) used as work space. Must be     c
C         dimensioned at least max(N,M) in calling program.    c
C   ON OUTPUT                                                  c
C   DNORM DOUBLE PRECISION scalar inf. norm of A.              c
C                                                              c
C   ROUTINES CALLED : DINORM                                   c
C***END PROLOGUE DMINFNO                                       c
C--------------------------------------------------------------c
       INTEGER I,II,N,M,NA      
       DOUBLE PRECISION A(NA,NA),W1(NA),W2(NA),DMAX,DNORM 

C....Take column for column and sort these vectors.      ....... 

       DO 10 II=1,M
C... Lagrer spalter i A i vektoren W1
          DO 20 I=1,N
             W1(I) = 0.0
             W1(I) = DABS( A(I,II) )
20        CONTINUE
C... Find largest element in W1 and store this in W2     ........ 
          CALL DINORM(W1,DMAX,N,NA)
          W2(II) = DMAX

10     CONTINUE

C..Sort array W2(II) of largest column elements in A     ........
       CALL DINORM(W2,DMAX,M,NA)
       DNORM = DMAX

       RETURN
       END
        

