      SUBROUTINE MONITD( N, T, HLAST, HNEXT,Y, YDOT, YSAVE, NYH, R,ACOR,
     1       RESWK, NRESWK, WKMON, NWKMON, IMON, INLN, HMIN, HMAX)
C**********************************************************************
C  MONITOR TO TEST OUT DISCTY HANDLING
C
C  SPRINT MODIFIED TO RETURN IMON=-1  IF INTEGRATOR FAILURE WITH
C  ISTEP = -1 OR -2
C**********************************************************************
      INTEGER N, NYH, NRESWK, NWKMON, IMON, INLN, ITRACE, IDEV
      INTEGER  NQ, I,J,NEQN,NIN,NOUT
C             VALUES NEEDED FOR DISCON CALL
      INTEGER ITEST,IDISC,IFLADI
      DOUBLE PRECISION T, HLAST,HNEXT, Y(1), YDOT(1), YSAVE(NYH,1),R(1),
     -       ACOR(NYH,2), RESWK(NRESWK), WKMON(NWKMON), HMIN, HMAX,
C            ARRAYS AND VALUES FOR DISCON CALL (MAX.SIZES ARE NYH)
     -       TDISC,TOUT,GOLD,HMINMN
      EXTERNAL RES,SWITCH
      COMMON /LSTATS/ NQ,NQU,NST,NRE,NJE,NITER
      COMMON/SDEV1/ NIN,NOUT
      COMMON /SDEV2/ ITRACE, IDEV
C COMMON BLOCKS FOR DISCTY HANDLING
      COMMON/MAINMD/TOUT,HMINMN,IDISC
      COMMON/DISRES/GOLD
C
C GOLD IS VALUE OF SWITCH AT CURRENT TIME AND WHEN REFERENCED IN
C RESID GOLD IS THEN LAST TIME VALUE OF SWITCH. GOLD IS UPDATED
C BY DISCON FOR THE CASES IDISC=1 AND 2. HOWEVER WHILE IDISC=0
C IT MUST BE THE TASK OF MONITOR TO KEEP GOLD UPDATED IN
C ANTICIPATION OF A DISCTY
C
C DISCON CALLED WITH IDISC=0   INDICATES INITIAL ENTRY TO OR SUCCESS-
C                              FUL RETURN FROM DISCON
C            OR WITH IDISC=1   RETURN FROM STEP WHILE STEPPING
C                              UP TO THE DISCTY
C            OR WITH IDISC=2   RETURN FROM STEP WHILE STEPPING
C                              AWAY FROM THE DISCTY AFTER EULER STEP
C            OR WITH IDISC=3   RETURN FROM NON-LINEAR EQN SOLVER FOR
C                              EULER STEP BY FUNCTIONAL ITERATION
       WRITE(IDEV,910)T,HLAST,HNEXT,IMON,IDISC,(Y(I),I=1,N)
  910  FORMAT(/' MONITD CALL AT T =',D12.4,
     - '  WITH HLAST AND HNEXT = ',2D12.4,
     -         ' IMON AND IDISC =',2I3,/' Y = ',3D14.6/)
C
C
C        MULTIPLY IMON BY -1 IF ITS MODULUS IS TWO TO BE CONSISTENT
C        WITH MK2 OF SPRINT.
      IF(IMON .EQ. 2 .OR. IMON .EQ. -2)IMON = -IMON
      J = 2 * N
      IF( J .GT. NWKMON)THEN
          CALL SERROR(' MONITD USER PROVIDED WORKSPACE OF
     1                  SIZE (=I1) IS SMALLER THAN REQUIRED (=I2)', 1,
     2                  2, NWKMON, J, 0, 0.0D0, 0.0D0)
         IMON = -1
         RETURN
      END IF
      J = N + 1
      IF(IMON.EQ.2.OR.IDISC.GT.0)THEN
       ITEST=ITRACE
       CALL DISCON (T,Y,N,YSAVE,NYH,NQU,SWITCH,TOUT,ITEST,R,YDOT,
     -              WKMON(J), IMON, INLN, IDISC, HLAST, HNEXT, HMIN,
     -              HMAX,HMINMN,TDISC, WKMON, ACOR(1,1),IFLADI)
C
C DISCON SETS IMON AND IDISC FOR SUBSEQUENT CALLS
           IF(IFLADI.NE.0)THEN
               WRITE(IDEV,999)IFLADI
  999          FORMAT(' MONITD FLAGGED DISCON ERROR ',I3)
               IMON=-2
           ELSE
C           IF IDISC.NE.0 THEN A RETURN FROM DISCON IS JUST A PROMPT TO
C                             DO AN INTEGRATION STEP WITH IDISC =1 OR 2
               IF(IDISC.EQ.0)WRITE(IDEV,900)TDISC,HLAST,HNEXT,IMON
C              AS IFLADI=0 THEN DISCTY SUCCESSFULLY NEGOTIATED
  900          FORMAT(' SUCCESSFUL CALL OF DISCON ROUTINE',/
     -                ' DISCONTINUITY LOCATED AT TIME ',D12.5,/
     -                ' STEP CONTINUES WITH HLAST/NEXT AND IMON =',
     -        2D12.5,I3//)
           ENDIF
      ELSE
C IMON.NE.2 AND IDISC=0 NORMAL (NON-DISCTY) MONITOR PROCESSING
C CHECK TO SEE IF IMON NEGATIVE (INTEGRATOR FAILURE)
        IF(IMON.LT.0)THEN
           IMON=-1
           RETURN
        ENDIF
        IMON=1
C KEEP GOLD UPDATED IN ANTICIPATION OF A DISCTY
        CALL SWITCH(N,T,Y,GOLD)
      ENDIF
      RETURN
      END
C
      SUBROUTINE DISCON (T,YVAL,N,YSAVE,NYH,NQ,SWITCH,TOUT,ITEST,R,
     -                   YDOT, P3,IMON, INLN, IDISC,HLAST,HNEXT,HMIN,
     -                   HMAX,HMINMN,TDISC,YD, EWT, IFLADI)
C
C DISCONTINUITY HANDLING OF JAN SIJBRAND (MSE,KSLA)
C ADAPTED FOR SPRINT BY R.M.FURZELAND (CMT,TRC) JUNE 1984
C THE SYMBOL $$$ DENOTES CHANGES IN THEORY OF SIJBRAND
C ---------------------------------------------------------------------
C
C PARAMETERS:
C T IS CURRENT TIME VALUE
C YVAL = CURRENT Y VALUES AS RETURNED BY STEP INTEGRATOR
C N IS NO. OF UNKNOWNS (<=NYH)
C YSAVE(NYH,NQ) IS NORDSIECK TYPE ARRAY OF Y AND ITS DERIVS FROM
C    LAST SUCCESSFUL INT.STEP (IF STEP HAS FAILED THEN = OLD VALUES)
C NYH IS MAX. 1ST DIMENSION OF YSAVE ARRAY
C NQ IS ODER OF METHOD USED BY STEP INTEGRATOR
C RESID IS NAME OF RESIDUAL ROUTINE CONTAINING O.D.E.S
C SWITCH IS NAME OF DISCTY SWITCH ROUTINE OF THE FORM:
C     SUBROUTINE SWITCH(N,T,Y,G)
C     INTEGER N
C     DOUBLE PRECISION Y(N),T,G
C  E.G. SWITCH IN FIRST COMPONENT AT VALUE 1.0
C     G=Y(1)-1.0D0
C     RETURN
C     END
C TOUT IS FINAL (OR INTERMEDIATE) TIME VALUE AT WHICH INTEGRATION
C    IS TO STOP.
C ITEST - SET NON-ZERO IF REQUIRE INFORMATION PRINT OF DISCTY HANDLING
C R(N)   RESID INFORMATION NO LONGER USED
C
C P3 WORK ARRAY OF LENGTH N
C IMON ON INPUT IS CURRENT VALUE OF IMON IN SPRINT MONITOR ROUTINE
C   AND INDICATES STATUS OF INTEGRATION; ON OUTPUT DISCON SETS IMON
C   APPROPRIATE TO SORT OF INTEGRATION RESTART NEEDED.
C IDISC =0 INDICATES INITIAL ENTRY TO OR SUCCESSFUL RETURN FROM DISCON
C       =1 INDICATES RETURN FROM STEP WHILE STEPPING UP TO DISCTY
C       =2 INDICATES RETURN FROM STEP WHILE STEPPING AWAY
C                    FROM THE DISCTY AFTER EULER STEP
C       =3 INDICATES RETURN FROM NON-LINEAR EQN SOLVER TAKING EULER STEP
C          SIMULATED BY USING FUNCTIONAL ITERATION
C
C HLAST IS LAST SUCCESSFUL INTEGRATION STEP-SIZE USED
C HNEXT IS DISCON ESTIMATE OF NEW STEP-SIZE FOR INT.STEP TO USE
C HMIN, HMAX ON INPUT ARE TYPICAL MIN/MAX STEP-SIZES
C   EFFICIENCY IS AIDED BY SELECTING HMIN SMALL BUT NOT TOO SMALL
C   SET HMAX REALISTIC ENOUGH TO AVOID OVER-STEPPING DISCTY BY TOO MUCH
C   HMIN/HMAX ARE ALTERED BY DISCON ACCORDING TO NEARNESS TO DISCTY
C   BUT RESTORED AFTER DISCTY TO USER VALUES.
C HMINMN IS MINIMUM HMIN ALLOWED ESPECIALLY NEAR A DISCTY
C TDISC IS OUTPUT VALUE OF TIME OF DICTY
C YD IS OUTPUT ARRAY OF LENGTH N OF Y AT TDISC
C
C  EWT(N) ARRAY CONTAINING WEIGHTS USED IN NORM FORMATION.
C
C
C IFLADI - ERROR INDICATOR (EXTRA DIAGNOSTICS ARE PRODUCED IF ITEST SET)
C                                                             CHAPTER
C   = 0   SUCCESSFUL CALL OF DISCON                           -------
C     1   FAILURE TO CONVERGE IN NEWTON ROOT FINDING FOR ALPH.   1
C     2   DISCTY CROSSING ERRORS HAVE FORCED DISCON TO           3
C          DECREASE HMIN BELOW MIN.HMIN (HMINMN).
C     3   NO. OF INTEGRATION STEPS (KSTEP) TAKEN BEFORE          3
C          DISCTY HAS EXCEEDED MAX. ALLOWED (20).
C     4   ROOT FINDING CHOICE HAS FORCED DISCON TO               2
C          DECREASE HMIN BELOW MIN.HMIN (HMINMN).
C     5   INTEGRATION ERRORS HAVE FORCED DISCON TO DECREASE      3
C          HMIN BELOW MIN.HMIN (HMINMN).
C     6   DISCTY ROOT FOUND BUT EULER STEP HTOL2 SUCH THAT       4
C          PRELIMINARY Y VALUE DOES NOT CROSS DISCTY AND FURTHER
C          WHEN HTOL2 CHANGED DISCTY STILL NOT CROSSED
C     7   DISCTY ROOT FOUND BUT EULER STEP DOES NOT              4
C          CROSS DISCTY.
C    10   MORE THAN 10 ATTEMPTS AT CHOOSING EULER STEP (HTOL2).  6
C    11   INVALID IDISC VALUE SUPPLIED BY USER                   0
C    12   NUMERICAL DERIVATIVE IN NEWTON ROOT FINDING IS ZERO    1
C    13   FAILURE IN CALL TO NON-LINEAR EQN SOLVER FOR EULER     4
C         STEP USING FUNCTIONAL ITERATION - HIGHLY NON-LINEAR
C         ALGEBRAIC EQNS OR FULLY IMPLICIT YDOT SYSTEM
C    15   MORE THAN 10 INTEGRATION RESTARTS TRIED IN ATTEMPT     5
C          TO RESTART INTEGRATION AFTER EULER STEP.
C----------------------------------------------------------------------
      INTEGER N,NQ,NYH,IFLADI,ITEST,IMON,IDISC,NIN,NOUT,INLN,
     -        ITRACE,IDEV,IOVFLO,I,KSTEP,K,KOUNTN,INDIC,NORD,J,NOINST
     -        , NQFUDG
      DOUBLE PRECISION YSAVE(NYH,1),R(N),P3(N),YD(N),
     -        GOLD,DUNFLO,UROUND,FT,DYMOD,ALPH1,ALPH2,ALPH,T3,T,
     -        GAPP1,GAPP2,DGAP,TOUT,TDISC,HTOL,HD,ESTER,HTOL2,TD,
     -        GPOST,GPRE,ESTIMA,HMAX,HMSAVE,YVAL(N),HRAT,HMIN,HMINSV,
     -        HMINMN, EPS, EWT(1), FTODYM, VNORM, WNORM, YDOT(1),HSTART,
     -        HLAST,HNEXT,HLSAVE
C
C INTERNAL VARIABLES:
C KSTEP (MAX.20 ) IS NO. INTEGR. STEPS TAKEN DURING IDISC=1 STAGE
C KOUNTN (MAX.20) IS NO. NEWTON ITERATIONS DURING ROOT FINDING
C ALPH=(T-TBASE)/H WHERE TBASE=LAST INTEGR.PT SUCCES. REACHED
C NOINST IS NO. ATTEMPTS AT RESTARTING AFTER DISCTY
C  HMSAVE,HMINSV  SAVE AND RESTORE HMAX, HMIN AFTER DISCTY
C
      LOGICAL CRACK
      EXTERNAL SWITCH
C SAVES CURRENT VALUES WHILE RETURN TO INTEGRATOR (IDISC=1, 2 OR 3)
      SAVE
      COMMON/DISRES/GOLD
C COMMON LINK WITH RESID ROUTINE FOR DIFF.EQNS. AND SWITCH FUNCTION
      COMMON/SDEV1/ NIN,NOUT
      COMMON /SDEV2/ ITRACE,IDEV
      COMMON /SCONS1/ DUNFLO, UROUND, IOVFLO
C
      CRACK=.FALSE.
      IF(IMON.EQ.2)CRACK=.TRUE.
C OUTPUT STATUS INFORMATION  (IF ITEST=1)
      IF (ITEST .NE. 1)   GO TO 8
      WRITE (IDEV,9000) T ,IDISC,IMON
 9000 FORMAT(1X,'SUBROUTINE DISCO ENTERED',
     #/' LAST SUCCESSFUL INTEGRATION AT TIME T = ',D14.6,
     #/' IDISC AND IMON = ',2I3/)
C
      NORD=NQ+1
      DO 6 I = 1,N
         WRITE (IDEV,9010) I,(YSAVE(I,J),J=1,NORD)
 9010 FORMAT(5X,' YSAVE ARRAY FOR NO.',I3,' IS',2(6D12.4/))
    6 CONTINUE
C
    8 IF(IDISC.EQ.3)GO TO 294
C
C $$$ FORMS NORMS AND CRITERIA FOR ERROR TESTING
C THIS IS NOW DONE EVERY TIME Y CHANGED (IDISC=1 OR 2) AND IS ESSENTIAL
C IF Y COMPONENTS (THUS EPS AND DYMOD) CHANGE SIGNIFICANTLY ACROSS DSCTY
      DO 10 I=1,N
   10    P3(I) = 1.0D0
C EPS NOW CORRESPOND TO SIJBRAND THEORY APART FROM USE STINT VNORM
C TO OBTAIND NORM OF ERROR WEIGHTS EWT = 1/( ABS + REL *Y)
C ALSO WE RESTRICT EPS TO UROUND
      EPS = 1.0D0 / VNORM(N,P3,EWT)
      EPS = DMAX1( UROUND, EPS)
      DO 15 I=1,N
   15    P3(I) = DMAX1( 1.0D0, DABS(YSAVE(I,1)))
      FT = EPS *  WNORM( N, P3)
      DYMOD = 1.0D0 + WNORM( N, YSAVE(1,2)) / HLAST
      FTODYM= FT / DYMOD
      IF(ITEST.EQ.1) WRITE(IDEV,7654)FT,DYMOD,FTODYM
7654  FORMAT('0  FT,DYMOD,FTODYM ',3D12.4)
C IDISC=0 ,1 OR 2 HANDLING
      IF(IDISC.EQ.1)GO TO 145
      IF(IDISC.EQ.2)GO TO 375
      IF(IDISC.EQ.0)GO TO 35
C
C INVALID IDISC CALL
      WRITE(NOUT,9999)IDISC
 9999 FORMAT(' DISCON ROUTINE, INVALID IDISC VALUE ',I10)
      IFLADI=11
      RETURN
C
C IDISC=0 : FIRST CALL TO DISCON DOES INITIALISATIONS FOLLOWED BY
C INITIAL ROOT FINDING CALCULATIONS (LABEL 40)
   35 HMSAVE=HMAX
      HMINSV=HMIN
      KSTEP = 0
      IFLADI = 0
C
C ** CHAPTER 1 :DISCONTINUITY ROOT FINDING BY NEWTON RAPHSON ********
C THIS PART OF THE CODE IS REPEATED AFTER EACH IDISC=1 STEP (LABEL 145
C
   40 KOUNTN = 0
      ALPH1 = 1.0D0
      ALPH2 = 0.1D0
C INTERPOLATES TO FIND Y AT T3=T+ALPH1*HLAST
      CALL POLYD ( YSAVE, ALPH1, N, NYH, NQ, P3, T, HLAST)
      T3=T+ALPH1*HLAST
      CALL SWITCH(N,T3,P3,GAPP1)
C
C NEWTON LOOP TO ESTIMATE DISTANCE TO DISCTY = ALPH*H  STARTS WITH
C  ESTIMATES (0.1,1.); DGAP IS DERIVATIVE FOR ROOT FINDING
C INTERPOLATES TO FIND Y AT T3=T+ALPH2*H
   60 CALL POLYD ( YSAVE, ALPH2, N, NYH, NQ, P3, T, HLAST)
      T3=T+ALPH2*HLAST
      CALL SWITCH(N,T3,P3,GAPP2)
C
      DGAP = (GAPP2 - GAPP1) / (ALPH2 - ALPH1)
      IF(DABS(DGAP).GT.DUNFLO*1.0D+2)GO TO 65
      IFLADI=12
      WRITE(IDEV,9015)T,HLAST,ALPH1,GAPP1,ALPH2,GAPP2
 9015 FORMAT(' DISCON ERROR NO. 12: ',
     -/' NEWTON DERIVATIVE FOR ALPH (GAPP2-GAPP1)/(ALPH2-ALPH1) = 0',
     -/' T,HLAST,ALPH1,GAPP1,ALPH2,GAPP2 ARE ',/6D12.5,
     -/' CHECK YSAVE(*,K) VALUES OR REDUCE HMAX')
      RETURN
   65 ALPH = ALPH2 - GAPP2 / DGAP
      KOUNTN = KOUNTN + 1
C CONVERGENCE CRITERIA FOR ROOT FINDING
      IF (DABS(ALPH - ALPH2) .LT. (FTODYM /  HLAST))  GO TO 70
      ALPH1 = ALPH2
      GAPP1 = GAPP2
      ALPH2 = ALPH
      IF (KOUNTN .LT. 20)   GO TO 60
      GO TO 80
C
   70 IF (ALPH .GE. DUNFLO. AND. ALPH .LE. 4.D0)  GO TO 90
C
   80 IFLADI = 1
C
      TDISC = T + ALPH * HLAST
      IF (ITEST .EQ. 1)   WRITE (IDEV,9020) ALPH,TDISC,HLAST,KOUNTN
 9020 FORMAT(1X,'NEWTON FAILED ALPH,TDISC,HLAST,KOUNTN =   ',3D14.5,I4)
      HNEXT = HLAST * .5D0
      RETURN
C
C SUCCESSFUL ROOT FINDING ACCORDING TO STOPPING CRITERIA
   90 HD = ALPH * HLAST
      TDISC = T + HD
      IF (ITEST .EQ. 1)   WRITE (IDEV,9030) ALPH,TDISC,HD,HLAST,KOUNTN
 9030 FORMAT(/1X,'DISCON CH.1 - NEWTON CONVERGED',/
     -' ALP, TDISC, HD, HLAST, KOUNTN = ',4D14.6,I4)
C
C ** CHAPTER 2 ******************************************************
C
C  SEPARATION OF INTEGRATION ACROSS DISCONTINUITY IN TIME STEP AND
C  POLYNOMIAL STEP
C
C HD IS DISTANCE TDISC-TBASE WHERE TDISC=DISCTY TIME
C HTOL IS MAX.LENGTH OF THE INTERVAL FOR WHICH THE POLYNOMIAL
C ROUTINE POLYD ACCURATELY DESCRIBES THE SOLUTION (W.R.T EPS)
C $$$ ERROR ESTIMATE BASED ON YSAVE/POLYD FORM
C $$$ NQ=1 EXTIMATES TOO PESSIMISTIC SO USE MIN OF 2
      NQFUDG=MAX0(2,NQ)
      ESTER = WNORM( N, YSAVE(1,NQFUDG+1) ) * ALPH**NQFUDG
      IF(ITEST.EQ.1)WRITE(IDEV,9035)ESTER
9035  FORMAT('0 POLYD ERROR ESTIMATE ESTER = ',D14.6)
C $$$ NEW TEST TO AVOID PROBLEMS WHEN ESTER SMALL OR ZERO
      IF(ESTER. GT. (FT* (HD/HLAST)**NQFUDG) )THEN
         HTOL = HD * (FT/ESTER ) ** (1.0D0 / DFLOAT(NQFUDG))
         IF (HTOL.GT.HD) GO TO 220
      ELSE
C $$$ IF ESTER SMALL THEN RESTRICTS HTOL=H LAST USED (UNLESS HD > H)
C SO HTOL>HD AND GOES ON TO CH.4 (FOR EULER STEP)
         HTOL = DMAX1(HD,HLAST)
         GO TO 220
      ENDIF
C HTOL<HD SO NEED ANOTHER INTEGRATION STEP:
C $$$   H = DMIN1( .5D0 * H,HD - .7D0 * HTOL,TOUT - T) CHOICE REMOVED
C SINCE H/2 CAN LEAD TO EXCESSIVE REPEATED SUBDIVISION
C MAIN CHOICE IS HD-0.7HTOL WHICH USES CURRENT ESTIMATE HD OF DISCTY
C DISTANCE AND INCLUDES HTOL SO THAT AFTER NEXT STEP NEW HTOL IS
C LIKELY TO BE SUFFICIENT TO REACH DISCTY.
      HNEXT = HD - .7D0*HTOL
C $$$  IF HTOL SMALL RELATIVE TO HD THEN HNEXT=.9*HD
      HNEXT=DMIN1(HNEXT,0.9D0*HD)
      HNEXT = DMIN1(HNEXT, TOUT - T)
      IF (ITEST .EQ. 1)   WRITE (IDEV,9040) HNEXT,HTOL
 9040 FORMAT(/1X,'DISCON CH.2 EXTRA INTEGR. STEP WITH HNEXT =',D14.6,
     -/' NECESSARY SINCE POLYD IS ONLY VALID FOR H(TOL) = ',D14.6)
  100 IF (HNEXT .GT. HMIN)   GO TO 140
      HMIN = .1D0 * HMIN
      IF(ITEST.EQ.1) WRITE (IDEV,9050) HMIN
 9050 FORMAT(1X,'CURRENT HMIN DECREASED TO ',D15.8)
      IF (HMIN.GT.HMINMN)   GO TO 100
C HMIN DECREASED BELOW MININUM HMIN ALLOWED
      IFLADI = 4
      RETURN
C
C CONTINUE TO DO STEP INTEGRATION
C
C ** CHAPTER 3 **************************************************
C IDISC=1:  INTEGRATION STEPS UP TO THE DISCONTINUITY IN CONJUNCTION
C WITH ROOT FINDING. INTEGRATION IS ACCOMPLISHED BY REVERSE COMMUN-
C CATION RETURNS TO STEP ROUTINE VIA MONITD AND SPRINT DRIVER.
C
  140 IDISC=1
C RETURNS TO PERFORM AN INTEGRATION STEP RESTARTING WITH CURRENT
C YSAVE IN Y AND WITH HMAX SET TO HNEXT
C UPDATE GOLD FOR USE IN RESID ROUTINE DURING INTEGRATION STEP
      CALL SWITCH( N, T, YSAVE, GOLD)
  142 IMON=4
      HMAX=HNEXT
C SAVE HNEXT FOR USE AS HLAST IF STEP FAILS
      HLSAVE=HNEXT
      IF (ITEST .EQ. 1)   WRITE (IDEV,9055) HNEXT
 9055 FORMAT(/1X,'DISCON CH.3 - RETURN FOR INTEGR. STEP HNEXT =',D14.6)
      RETURN
C RETURN FROM STEP INTEGRATOR
  145 IF ( .NOT. CRACK) GO TO 160
C
C ATTEMPT TO CROSS DISCTY DURING INTEGRATION STEP (HALF STEP & REPEAT)
C LABEL 150
      IF (ITEST .EQ. 1)   WRITE (IDEV,9060)
 9060 FORMAT(1X,'DISCON CH.3 - INTERMEDIATE  POINT IN INT. STEP BEFORE',
     # ' DISCON CROSSES DISCONTINUITY')
C DISCTY CROSSED PROBABLY BECAUSE OF ERROR IN ALPH (TRY .8 OF ALPH)
      HNEXT = HLSAVE * 0.8D0
      IF (HNEXT.GT.HMIN)   GO TO 142
      HMIN=HMIN*0.1D0
      IF(ITEST.EQ.1) WRITE(IDEV,9050)HMIN
      IF(HMIN.GT.HMINMN)GO TO 142
C HMIN DECREASED BELOW MININUM HMIN ALLOWED
      IFLADI = 2
      RETURN
C
C DISCTY NOT CROSSED CHECKS FOR INT.ERRRORS AND CONTINUES TO FIND ROOT
  160 IF(IMON.GE.0)GO TO 180
C INTEGRATION ERRORS (REDUCES H & REPEATS)
      HNEXT=HLSAVE*0.25D0
      IF(HNEXT.GT.HMIN)GO TO 142
      HMIN=0.1D0*HMIN
      IF(ITEST.EQ.1) WRITE(IDEV,9050)HMIN
      IF(HMIN.GT.HMINMN)GO TO 142
      IFLADI=5
      RETURN
C NO INT. ERRORS SO CONTINUES TO FIND ROOT
C BY RETURNING TO LABEL 40 (KSTEP<=20)
  180 IF (ITEST .NE. 1)   GO TO 200
      WRITE (IDEV,9080) T
 9080 FORMAT(/1X,' DISCON CH.3 - INT. STEP BEFORE DISCONTINUITY ',
     #' SUCCESSFULLY COMPLETED AT TIME ',D14.6)
      DO 190 I = 1,N
         WRITE (IDEV,9090) I,YSAVE(I,1)
 9090 FORMAT(8X,'DEPENDENT VARIABLE NO.',I4,' IS',D14.6)
  190 CONTINUE
  200 IF (T .GT. (1.D0 - UROUND) * TOUT)   GO TO 540
      KSTEP = KSTEP + 1
      IF (KSTEP .LE. 20)   GO TO 40
      IFLADI = 3
      RETURN
C
C
C ** CHAPTER 4 *******************************************************
C  EVALUATES Y(TDISC) AND GOES ON TO TAKE A PRUDENT EULER STEP
C
  220 IF (ITEST .EQ. 1)   WRITE (IDEV,9100)HTOL
C POLYNOMIAL IS SUFFIENTLY ACCURATE TO REACH DISCTY (NO EXTRA INTS.)
 9100 FORMAT(/1X,'DISCON CH.4 - POLYNOMIAL STEP SUFFICES, HTOL=',D14.6/)
      IF (T + HD .GT. TOUT)   GO TO 530
      TD = T + HD
      CALL SWITCH( N, T, YSAVE, GPRE)
C Y(TDISC)
      CALL POLYD ( YSAVE, ALPH, N, NYH, NQ, YD, T, HLAST)
      INDIC = 1
      IF (ITEST .NE. 1)   GO TO 250
C LABEL 230
      WRITE (IDEV,9110) TD
 9110 FORMAT(/1X,'DISCONTINUITY LOCATED AT TIME ',D14.6/,50('-')//)
      DO 240 K = 1,N
         WRITE (IDEV,9120) K,YD(K)
 9120 FORMAT(1X,'DEPENDENT VARIABLE NO.',I4,' IS ',D14.6)
  240 CONTINUE
  250 CONTINUE
C
C  DETERMINATION OF HTOL2=EULER STEP LENGTH WHERE IT IS EXPECTED
C  THAT T+HTOL2 CROSSES THE DISCTY SURFACE. SAMPLE A POINT FROM
C  A QUITE ARBITRARY DIRECTION TRANSVERSE TO DISCTY SURFACE
C      (IN FACT USES YSAVE(I,2) FROM BEFORE DISCTY)
C  AS THE ERROR IN THE POLYNOMIAL WAS ESTIMATED TO BE OF ORDER NQ
C  AND EULER MAKES AN ERROR OF ORDER 2, WE TAKE HTOL2=HTOL**(NQ/2)
C  THE FACTOR 4 IS A SAFETY MEASURE. THE TERM FT* IS FOUR TIMES
C  THE ERROR IN THE NEWTON RAPHSON LOCALIZATION OF XD.
C
C LABEL 260    INITIAL HTOL2
C IF 2ND EXPRESSION (ERROR IN EULER STEP+POLYD) IS SMALL THEN
C USES 1ST EXPRESSION (ERROR IN NEWTON ROOT FINDING)
C $$$$ USES NQFUDG
      HTOL2 = DMAX1(4.D0 * FTODYM , HTOL ** (NQFUDG / 2.D0) / 4.D0)
      NOINST=0
C
C EULER STEP INTEGRATION LOOP (LABELS 270 TO 340)
  270 HTOL2 = DMIN1(HTOL2,TOUT - TD)
         IF(ITEST.EQ.1)WRITE (IDEV,9123) HTOL2
 9123    FORMAT(/1X,'EULER STEP:   HTOL2 = ',D14.6)
C
C  DETERMINATION OF THE RIGHT HAND SIDE JUST ACROSS DISCO
      HRAT=HTOL2/HLAST
      DO 280 I = 1,N
  280   P3(I) = YD(I) + YSAVE(I,2) * HRAT
      T = TD + HTOL2
      CALL SWITCH(N,T,P3,GPOST)
C IF G BEFORE * G AFTER NEGATIVE THEN KNOW DISCTY CROSSED
      IF (GPRE * GPOST .LT. 0.D0)   GO TO 290
      IFLADI = 6
      RETURN
C  $$$
C  EULER STEP  - CALLS NON-LINEAR EQUATION SOLVER TO EVALUATE YDOT
C AT T,Y=P3
C THIS IS DONE BY USING FUNCTIONAL ITERATION TO SIMULATE EULER STEP
C THIS CALL REPLACES SIJBRAND'S CALL TO RESID AND SO IS VALID FOR
C ALGEBRAIC EQNS AND POSSIBLY IMPLICIT YDOT SYSTEMS
C
C SETS GOLD=GPOST READY FOR USE IN RESID (VIA COMMON/DISRES/)
  290 GOLD=GPOST
      DO 293 I=1,N
         YDOT(I) = YVAL(I)
         YVAL(I) = P3(I)
         P3(I)   = YDOT(I)
         YDOT(I) = 0.0D0
         YSAVE(I,1) = YVAL(I)
         YSAVE(I,2) = 0.0D0
  293 CONTINUE
      IMON = 0
      INLN=7
      IDISC = 3
      RETURN
C           TO NONLINEAR EQUATIONS SOLVER FOR A FUNCTION CALL
294   CONTINUE
      IF(INLN. LT. 0)THEN
         IFLADI=13
         WRITE(IDEV,9125)
         RETURN
      END IF
 9125 FORMAT(' FAILURE IN CALL TO NON-LINEAR EQUATION SOLVER FOR EULER',
     - ' STEP USING FUNCTIONAL ITERATION ')
      DO 300 K = 1,N
         YVAL(K) = P3(K)
         YSAVE(K,1) = YD(K) + YDOT(K)* (T - TD)
C                 --- YSAVE(K,1) HAS REGAINED ITS ORIGINAL MEANING
      IF(ITEST.EQ.1)WRITE (IDEV,9128)P3(K),YSAVE(K,2),R(K),YSAVE(K,1)
 9128 FORMAT(1X,'P3 & Y2,YDOT, Y ',4D14.6)
  300 CONTINUE
      IF (T .GE. (1.D0 - UROUND) * TOUT)   GO TO 550
C
C IF G BEFORE * G AFTER NEGATIVE THEN KNOW DISCTY CROSSED
C LABEL 320
      CALL SWITCH ( N, T, YSAVE, GPOST)
      IF (GPRE * GPOST .LT. 0.D0)   GO TO 340
C
      IF (ITEST .EQ. 1)   WRITE (IDEV,9130)T,GPRE,GPOST
 9130 FORMAT(1X,'EULER STEP HAS NOT PASSED DISCONTINUITY AT TIME ',
     -D14.6,'  G BEFORE AND AFTER = ',2D14.6)
      IF (INDIC .EQ. 1)   GO TO 330
      IFLADI = 7
      RETURN
C EULER STEP IS ONLY CHANGED ONCE (STEP-SIZE DOUBLED)
  330 HTOL2 = 2.D0 * HTOL2
      INDIC = INDIC + 1
      GO TO 270
C
  340 CONTINUE
      IF (ITEST .NE. 1)   GO TO 360
      WRITE (IDEV,9140) T
 9140 FORMAT(/1X,'EULER STEP TAKEN AT TIME ',D14.6)
      DO 350 I = 1,N
  350 WRITE (IDEV,9150) I,YSAVE(I,1)
 9150 FORMAT(1X,'DEPENDENT VARIABLE NO ',I4,' IS ',D14.6)
C
C
C ** CHAPTER 5 ********************************************************
C INTEGRATION STEP AFTER DISCONTINUITY AND EULER STEP. SEVERAL DIFFERENT
C STEPS MAY BE NEEDED IN ORDER TO FIND AN ACCEPTABLE EULER STEP.
  360 HNEXT = DMIN1(HTOL2,TOUT - T)
C
C INTEGRATION RESTART LOOP  (IF CROSS DISCTY OR FAIL ON SAY HMIN
C
  370 IDISC=2
C INITIALISE YVAL WITH CURRENT EULER Y VALUES (1ST TIME THROUGH)
C OR FOR SUBSEQUENT RESTARTS REINITIALISE USING SAVED Y VALUES
      DO 372 I=1,N
  372 YVAL(I)= YSAVE(I,1)
C RETURNS TO PERFORM AN INTEGRATION STEP - FULL RESTART(SPRINT WILL
C RECOMPUTE START YDOT)
      NOINST=NOINST+1
      IF(NOINST.LT.10)GO TO 373
      IFLADI=15
      RETURN
  373 IMON=2
C SET HMAX,HMIN
      HMAX=HMSAVE
C INTEGRATION STEP WILL BE SMALL SO USE HMIN=HMINMN
      HMIN=HMINMN
C SAVE HNEW FOR USE AS HLAST IF STEP FAILS
      HLSAVE=HNEXT
C SETS GOLD=GPOST READY FOR USE IN RESID (VIA COMMON/DISRES/)
      GOLD=GPOST
      IF (ITEST .EQ. 1)   WRITE (IDEV,9155) T,HNEXT,HMIN,HMAX,GOLD
 9155 FORMAT(/1X,60('*'),
     -/' DISCON CH.5 - FULL INTEGRATION RESTART AFTER DISCTY ',
     -/'     T     HNEXT(=HTOL2)    HMIN       HMAX         G',
     -/ 5D12.5//)
      RETURN
C RETURN FROM INTEGRATOR FOR IDISC=2
C
  375 IF ( .NOT. CRACK)   GO TO 390
C $$$  DISCTY CROSSED SO INCREASES STEP AND REPEAT INTEGRATION
C                        (SIJBRAND HALVED STEP)
      IF (ITEST .EQ. 1)   WRITE (IDEV,9160)
 9160 FORMAT(1X,'INT.STEP CROSSES DISCTY SETS H=10*H AND TRIES AGAIN')
      HNEXT = HLSAVE*10.0D0
      GO TO 370
C INTEGRATION STEP HAS NOT CROSSED DISCTY SO CONTINUES ON TO
C EVALUATE WHETHER EULER STEP WAS CORRECT  (LABEL 420)
  390 IF(IMON.GE.0)GO TO 410
C FAILURE IN INTEGRATOR TO CONVERGE OR HMIN TOO LARGE
      HNEXT=0.5D0*HLSAVE
      IF(HNEXT.GT.HMIN)GO TO 370
      HMIN=0.01D0*HMIN
      IF(ITEST.EQ.1) WRITE(IDEV,9050)HMIN
C HMIN WILL ONLY BE REDUCED MAX. NOINST TIMES (=10)
      GO TO 370
  410 IF (ITEST .EQ. 1)   WRITE (IDEV,9180) T,HLAST
 9180 FORMAT(1X,'INT. STEP AFTER DISCONTINUITY COMPLETED, T AND H ='
     # ,2D14.6)
C
C
C ** CHAPTER 6 ******************************************************
C  APPRAISAL OF EULER STEP    (AFTER INTEGRATION STEP IDISC=2)
C    ESTIMATES THE ERROR MADE IN THE EULER STEP BY EXTRAP.BACK USING
C    A POLYNOMIAL BASED ON THE FULL (GEAR) INTEGRATION STEP AND CHECKS
C    AGREES WITH  PREVIOUS Y(TD) ESTIMATE. IF NOT DECREASE EULER STEP
C    AND TRY AGAIN (UP TO A LIMIT OF 8 TIMES)
C
C LABEL 420
C BECAUSE INTEGRATOR TAKES STEP H1 (TO FORM YDOT) THEN A STEP H
C THEN BACK EXTRAPOLATION IS OVER DISTANCE H1+H=T-(TD+HTOL2)
      HRAT=(T-TD)/( T-(TD+HTOL2) )
      DO 430 K = 1,N
  430 P3(K) = YSAVE(K,1) - HRAT * YSAVE(K,2) - YD(K)
C $$$ USES SPRINT ODE ERROR NORM (REPLACES SIJBRAND CALL TO POLYD)
      ESTIMA = VNORM( N, P3, EWT)
      IF(ITEST.EQ.1)WRITE(IDEV,9185)(P3(K),K=1,N)
 9185 FORMAT(' DISCON CH.6 - BACK EXTRAPOLATED ERR IN Y COMPARED TO YD',
     -/200(D14.6/))
      IF (ESTIMA .LT. 1.D0)   GO TO 450
      IF (ITEST .EQ. 1)   WRITE (IDEV,9190) ESTIMA
 9190 FORMAT(1X,'EULER STEP TURNS OUT TO BE INACCURATE, ERROR NORM = '
     - ,D14.6)
C
C $$$ SUB-DIVIDE HTOL2 BY 5 ACCORDING TO LOG10(ESTIMA)
      HTOL2 = HTOL2 / (5.0D0*DMAX1(1.0D0,DLOG10(ESTIMA)) )
C REPLACES SIJBRAND    HTOL2 = HTOL2 / DSQRT(ESTIMA) * .7D0
      INDIC = INDIC + 1
      IF (INDIC .LT. 10)   GO TO 270
      IFLADI = 10
      RETURN
C
C EULER STEP CORRECT AND DISCTY SUCCESSFULLY NEGOTIATED AND CONTROL
C IS RETURNED TO REGULAR INTEGRATION PROGRAM
C RETURNS WITH IDISC=0 SO IDISC INITIALISED READY FOR FURTHER DISCTIES
  450 CONTINUE
      IDISC=0
      IF (ITEST .EQ. 1)   WRITE (IDEV,9200) ESTIMA
 9200 FORMAT(1X,'EULER STEP PROVES TO BE ACCURATE, ERROR NORM = '
     - ,D14.6)
      IF (T .GE. TOUT * (1.D0 - UROUND))   GO TO 550
C RETURNS TO PERFORM AN INTEGRATION STEP RESTARTING WITH CURRENT
C YSAVE AND WITH HMIN, HMAX RESTORED TO VALUES BEFORE DISCTY
      IMON=4
      HMAX=HMSAVE
C $$$ USES SPRINT LOCAL ERROR ESTIMATE TO GET IMPROVED H START
C DOESN'T SEEM TO HELP SO REMOVED
C    WHICH IS USED AS LONG AS HSTART > 1.1 * H OLD   (I.E.VNORM < .9)
C     HSTART = H / VNORM(N,EWT,EWT(NYH+1))   NOW NEED HLAST/NEW
C     IF(DABS(HSTART/H).GT.1.1D0) H=DMIN1(100.0D0*H,HSTART,HMAX)
C SETS HMIN TO SMALLER OF HMINSV AND H(START)
      HMIN=DMIN1(HMINSV,HLAST)
C
      CALL SWITCH( N, T, YSAVE, GOLD)
      IF (ITEST .EQ. 1)   WRITE (IDEV,9205) T,HLAST,HNEXT,HMIN,HMAX,GOLD
 9205 FORMAT(/1X,60('*'),
     -/' DISCON CH.7 - CONTINUATION AFTER DISCTY (HMIN,HMAX RESTORED)',
     -/'     T        HLAST       HNEXT       HMIN        HMAX        G'
     -/ 6D12.4)
      RETURN
C
C
CCCC CHAPTER 7 ********************************************************
C   TERMINATION - IF TOUT OCCURS BEFORE DISCTY THEN NO PROBLEM
C
  530 CONTINUE
      ALPH = (TOUT - T) / HLAST
      CALL POLYD ( YSAVE, ALPH, N, NYH, NQ, YVAL, T, HLAST)
      T = TOUT
  540 IF (ITEST .EQ. 1)   WRITE (IDEV,9210)
 9210 FORMAT(1X,'TOUT OCCURS JUST BEFORE DISCO')
      GO TO 560
C
C
  550 CONTINUE
C     WARNING OUTPUT
      WRITE (IDEV,9220) TD,TOUT
 9220 FORMAT(1X,'DISCTY AT TD LOCATED JUST BEFORE TOUT, INTEGRATION',/
     # ' STEP FROM TD TO TOUT MAY BE INACCURATE, TD & TOUT = ',2D16.7)
C
  560 IDISC=0
      RETURN
      END
C
      SUBROUTINE POLYD ( YSAVE, ALPH, N, NYH, NQ, P3, T, H )
C
C INTER/EXTRAPOLATING  POLYNOMIAL BASED ON YSAVE NORDSIECK VECTOR
C NYH IS MAXIMUM 1ST DIMENSION OF YSAVE ARRAY
      INTEGER N,NQ,NORD,I,J,NYH ,ITRACE,IDEV
      DOUBLE PRECISION P3(1),YSAVE(NYH,1),ALPH,T,H, WNORM
      COMMON /SDEV2/ ITRACE, IDEV
      NORD = NQ+1
      DO 10 I=1,N
         P3(I)=0.D0
         DO 10 J=1,NORD
10          P3(I)=P3(I)+YSAVE(I,J)*(ALPH)**(J-1)
C
C $$$ ESTER ESTIMATE IS NOW DONE ON RETURN FROM POLYD (ONLY WHERE NEEDED
C ESTER = WNORM( N, YSAVE(1,NORD)) * ALPH ** NQ
      RETURN
      END
C
      DOUBLE PRECISION FUNCTION WNORM (N, W)
C-----------------------------------------------------------------------
C THIS FUNCTION ROUTINE COMPUTES THE VECTOR NORM USED BY MONITD.
C  INORM = 1        MAXIMUM NORM
C        = 2        EUCLIDEAN OR L2 NORM
C        = 3        AVERAGE L2 NORM
C  THE CHOICE OF NORM IS DEFINED BY THE USER ON ENTRY TO SPRINT AND
C  PASSED TO THIS FUNCTION BY THE COMMON BLOCK /SSNORM/.
C
C ALL THREE NORMS ARE VECTOR NORMS
C OF THE VECTOR OF LENGTH N CONTAINED IN THE ARRAY W.
C   E.G. FOR THE AVERAGED L2 NORM
C        WNORM = SQRT( (1/M) * SUM( W(I) )**2 )  WHERE M = N
C   WHILE FOR THE L2 NORM M = 1.
C   FOR THE MAX NORM
C        WNORM = MAX | W(I) |      .
C                 I
C-----------------------------------------------------------------------
      INTEGER N, M, I, INORM
      DOUBLE PRECISION W, SUM
      DIMENSION W(N)
      COMMON /SSNORM/ INORM
      SAVE   /SSNORM/
      SUM = 0.0D0
      M = N
      GOTO (30, 60, 90), INORM
 30   DO 40 I = 1,N
 40     SUM = DMAX1(SUM, DABS(W(I)))
      WNORM = SUM
      RETURN
 60   M = 1
 90   DO 100 I = 1,N
 100     SUM = SUM + (W(I))**2
      WNORM = DSQRT(SUM/DFLOAT(M))
      RETURN
C----------------------- END OF FUNCTION WNORM -------------------------
      END
