      PARAMETER (NNPTS = 41)
      PARAMETER (NNEQ = NNPTS)
C  workspace required for sparse matrix algebra routines
      PARAMETER (NRWK = 20*NNEQ+93 + 4*NNEQ + 11*NNEQ/2)
C  workspace for res - skeel discretisation
      PARAMETER (NRESWK = NNPTS*6 + 100)
      PARAMETER (NMONWK = 1)
      PARAMETER (NRW    = NRWK + NRESWK + NMONWK)
C  integer workspace
      PARAMETER (NIWK = 2*NNEQ + 14)
C
      INTEGER I, IBAND, IBK, ITRACE, IW(NIWK), M, MAXNPT, NEL, NEQ,
     1           NPDE, NPTS, NT, NV, NXI, NPTL, NIW(3)
      DOUBLE PRECISION DXP, T, TOUT, TINC,
     1           Y(NNEQ), X(NNPTS), RTOL(NNEQ), ATOL(NNEQ), RW(NRW),
     2           XI(1), XBK(11), EXY(31)
      LOGICAL REMESH
      CHARACTER*6  RESULT,SNORM,MATZ,STEP,SPACE
C
      EXTERNAL SKLRES,EZMNTR
C
C  SETUP AND CALL INITIALISATION OF THE SPACE DISCRETISATION
C  ---------------------------------------------------------
C
C actual problem size - may be smaller than parameter statements
      NPDE    = 1
      NPTS    = 31
C M = geometry (0 = planar, 1 = cylindrical, 2 = spherical)
      M = 0
C define the mesh positions in array X(I)
      X(1)=0.0D0
      X(NPTS) = 1.0D0
      DXP = (X(NPTS)-X(1))/DFLOAT(NPTS-1)
      DO 31 I = 2,NPTS-1
31    X(I) = X(I-1) + DXP
C coupled o.d.e. (moving boundary)
      NV      = 1
      NXI     = 1
      XI(1)   = 1.0D0
      REMESH  = .FALSE.
      MAXNPT  = NNPTS
      SPACE   = 'SKEEL'
      STEP    = 'GEAR'
      RESULT = 'BRIEF'
C
C following needed for collocation method only  (space='coll')
C     NEL     = 10
C     NPTL    = 4
C     NPTS    = NEL*(NPTL-1)+1
C     IBK     = 11
C     XBK(1)  =0.0D0
C     XBK(IBK) = 1.0D0
C     DXP = (XBK(IBK)-XBK(1))/DFLOAT(IBK-1)
C     DO 41 I = 2,IBK
C 41  XBK(I) = XBK(I-1) + DXP
C
      T    = 0.1D0
      CALL SETPDE(NEQ,NPDE,NPTS,X,Y,SPACE,STEP,RW,NRESWK,M,T,
     1            IBAND,1,REMESH,MAXNPT,XBK,IBK,NEL,NPTL,NV,NXI,XI)
C
C  SETUP AND CALL SPRINT - VIA EASY INTERFACE SPRITE
C  -------------------------------------------------
C
      DO 52 I = 1,NEQ
      RTOL(I) = 1.D-4
52    ATOL(I) = 1.D-4
      ITRACE  = 1
      SNORM   = 'L2NORM'
      MATZ    = 'SPARSE'
      IW(1)   = 0
      IW(3)   = 0
      NIW(1) = NIWK
      NIW(2) = 0
      NIW(3) = 0
      NT      = 1
      WRITE(8,4999)
      TINC = 0.1D0
      DO 53 I = 1,9
      TOUT = T + TINC
C
      CALL SPRITE(NEQ,T,TOUT,NT,RESULT,Y,RTOL,ATOL,ITRACE,
     -            SNORM,MATZ,STEP,SKLRES,EZMNTR,RW,NRW,IW,NIW)
C
      WRITE(8,5000) T,Y(1),Y(2),Y(30),Y(31),Y(32)
      CALL EXACT( T, NPDE, NPTS, X, EXY)
      WRITE(8,5000) T,EXY(1),EXY(2),EXY(30),EXY(31),T
C test if SPRINT integration successful
      IF (IW(1).NE.2) GO TO 1000
 53   CONTINUE
 1000 CONTINUE
      STOP
C
 4999 FORMAT('     TIME     Y(1)    Y(2)     Y(30)     Y(31)    Y(32) ')
 5000 FORMAT(7F8.3)
      END
C
C ************** USER SUBROUTINES **************************************
C
      SUBROUTINE UINIT( NPDE, NPTS, X, U)
C Routine for p.d.e. initial values (start time is 0.1)
      INTEGER NPDE, NPTS
      DOUBLE PRECISION X(NPTS), U(NPDE,NPTS), TIME
      TIME=0.1D0
      DO 10 I = 1,NPTS
 10      U(1,I) = DEXP( TIME * (1.0D0 - X(I))) - 1.0D0
      RETURN
      END
C
      SUBROUTINE SVINIT( V,NV)
C Routine for initial values of auxiliary o.d.e.s (if any)
      INTEGER NV
      DOUBLE PRECISION V(1)
       V(1) = 0.1D0
      RETURN
      END
C
      SUBROUTINE SODEFN(T, NV, V, VDOT, NPDE, NXI, XI, UI, UXI, RI,
     1                    UTI, UTXI, VRES, IRES)
C DEFINITION OF COUPLED O.D.E. RESIDUALS IN MASTER EQN. (5.3) FORM,
C             .
C     FV ( V, V , XI, UI, UI , RI , UI , UI  , ) = 0,
C     --   -  -   -   -   - X  -    - T  - XT
C
C UI, UI , RI , UI , UI   are of length NPDE*NXI and hold the solution
C -   - X  -    - T  - XT
C flux, and derivatives values at the coupling points XI(NXI).
      INTEGER NPDE, NXI, NV, IRES
      DOUBLE PRECISION T, XI(NXI), UI(NPDE,NXI), UXI(NPDE,NXI),
     1        RI(NPDE,NXI), UTI(NPDE,NXI), UTXI(NPDE,NXI), VRES(NV),
     2        V(NV), VDOT(NV)
       IF(IRES.EQ.-1)THEN
C if IRES=-1 then only part dependent on VDOT required
              VRES(1) = 0.0D0
       ELSE
C the residual VRES(1) from moving boundary condition U=0
C this and the fixed b.c. at X=1 may be interchanged
              VRES(1) = UI(1,1)
       ENDIF
C IRES CAN BE RESET TO COPE WIH ILLEGAL VALUES OF M.B. POSITION V(1).
       IF(V(1) .LT. 0.0D0)IRES = 3
       RETURN
       END
C
       SUBROUTINE SPDEF1( T, X, NPDE,U,DUDX,C,Q,R,NV, V,VD, IRES)
C  Master equation form of the p.d.e. for moving boundary problem
C NPDE                       .   .                        .
C  SUM  C   (X,T, U, U  , V, V ) U  + Q (X,T, U, U  , V , V )
C P =1   J,P      -  - X  -  -    P    J      -  - X  -   -
C
C                               -M     M
C                           =  X   D (X  R (X,T, U, U  , V )),     (5.1)
C                                  DX     J      -  -X   -
C J DENOTES JTH EQUATION, J=1,..,NPDE; M DENOTES SPACE GEOMETRY TYPE;
C the dots denote time derivatives.
C THE USER SUPPLIES C, R AND Q AT THE SINGLE MESH-POINT X
C                      .
C     S * S * U  - S * S  * X * U   =  U     , X IN (0,1).
C              T                 X      XX
       INTEGER NPDE, NV, IRES
       DOUBLE PRECISION T, X, U(NPDE), DUDX(NPDE),
     1         C(NPDE,NPDE), Q(NPDE), R(NPDE), V(1), VD(1)
       C(1,1) = V(1)*V(1)
       R(1) = DUDX(1)
       Q(1) = -X*VD(1)*DUDX(1) * V(1)
      RETURN
      END
C
      SUBROUTINE BNDR( T, BETA, GAMMA, U, UX, NPDE, LEFT, NV,V,VD,IRES)
C SPECIFIES BOUNDARY CONDITIONS FOR JTH P.D.E. IN MASTER EQN (5.2) FORM
C                            .                  .
C     BETA(J,T)*R(X,T,U,U ,V,V) = GAMMA(J,T,U,V,V) AT X = A OR B,
C                     - -X - -              - - -
C The form of the flux function R() is specified in SPDEF1. For
C the moving boundary example:                  .
C     U  = - S(T) * EXP(T)  AT X=0  AND  U  = - S(T) * S(T) AT X = 1
C      X                           X
      INTEGER NPDE, NV
      DOUBLE PRECISION BETA(NPDE), GAMMA(NPDE), U(NPDE), UX(NPDE)
     -                  ,T, V(1), VD(1)
      LOGICAL LEFT
      BETA(1) = 1.0D0
      IF(LEFT)THEN
C known flux b.c. at X=0
          GAMMA(1) = -V(1)*DEXP(T)
      ELSE
C known flux b.c. at X=1, the moving boundary condition
          GAMMA(1) = -V(1)*VD(1)
      END IF
      RETURN
      END
C
      SUBROUTINE MYMNTR (NEQ,T,Y,H,IMON)
C Simple MONITOR (used to test valid solution)
      INTEGER NEQ, IMON
      DOUBLE PRECISION T,Y(NEQ),H
      IF(Y(NEQ).LT.0.0D0) THEN
        IMON = -2
        WRITE(6,91) Y(NEQ)
 91     FORMAT('  MOVING BOUNDARY TOO SMALL  ',D14.6)
      ENDIF
      RETURN
      END
C
      SUBROUTINE EVNRMF(TIME,NIP,NPDE,X,U,R,MAXNPT,FMON)
C  routine for remeshing (not used in this example)
      INTEGER NIP, NPDE, MAXNPT
      DOUBLE PRECISION TIME, U(NPDE,1),X(NIP),FMON(NIP),R(NPDE,1)
      RETURN
      END
C
      SUBROUTINE EXACT( TIME, NPDE, NPTS, X, U)
C Exact solution (for comparison purpose) - optional routine
      INTEGER NPDE, NPTS
      DOUBLE PRECISION X(NPTS), U(NPDE,NPTS), TIME
      DO 10 I = 1,NPTS
 10     U(1,I) = DEXP( TIME * (1.0D0 - X(I))) - 1.0D0
      RETURN
      END
