
      PARAMETER (NNPTS = 41)
      PARAMETER (NNEQ = NNPTS)
C  WORKSPACE REQUIRED FOR SPARSE MATRIX ALGEBRA ROUTINES
      PARAMETER (NRWK = 18*NNEQ+23 + 4*NNEQ + 11*NNEQ/2)
C  WORKSPACE FOR RES - SKEEL DISCRETISATION
      PARAMETER (NRESWK = NNPTS*6 + 100)
      PARAMETER (NMONWK = 1)
      PARAMETER (NRW    = NRWK + NRESWK + NMONWK)
C  INTEGER WORKSPACE
      PARAMETER (NIWK= 2*NNEQ + 14)
C
      INTEGER I, IBAND, IBK, ITRACE, IW(NIWK), M, MAXNPT, NEL, NEQ,
     1           NPDE, NPTS, NPTL, NT, NV, NXI, J, NIW(3)
      DOUBLE PRECISION ALPHA, BETA, DXP, EPS, GAMMA, T, TOUT,TINC,
     1           Y(NNEQ), X(NNPTS), RTOL(NNEQ), ATOL(NNEQ), RW(NRW),
     2           XI(1), XBK(11)
      LOGICAL REMESH
      CHARACTER*6  RESULT,SNORM,MATZ,STEP,SPACE
      COMMON/TPROPS/ALPHA,BETA,GAMMA,EPS
      EXTERNAL SKLRES,SGERES,EZMNTR
C
C P.D.E COEFFICIENTS ALPHA, BETA, GAMMA, EPS FOR USE IN SPDEFN
      ALPHA = 1.0D0
      BETA = 0.3D0
      GAMMA = 1.0D0
      EPS = 0.03D0
C
C ACTUAL PROBLEM SIZE - MAY BE SMALLER THAN PARAMETER STATEMENTS
      NPDE    = 1
      NPTS    = 31
C
C M = GEOMETRY (0 = PLANAR, 1 = CYLINDRICAL, 2 = SPHERICAL)
      M = 1
C DEFINE THE MESH POSITIONS IN ARRAY X(I)
      X(1)=0.0D0
      X(NPTS) = 1.0D0
      DXP = (X(NPTS)-X(1))/DFLOAT(NPTS-1)
      DO 31 I = 2,NPTS
31    X(I) = X(I-1) + DXP
C
C  SETUP AND CALL INITIALISATION OF THE SKEEL DISCRETISATION
C  ---------------------------------------------------------
      NV      = 0
      NXI     = 0
      REMESH  = .FALSE.
      MAXNPT  = NNPTS
      SPACE   = 'COLL'
      STEP    = 'GEAR'
C
C FOLLOWING NEEDED FOR COLLOCATION METHOD ONLY
      NEL     = 10
      NPTL    = 4
      NPTS    = NEL*(NPTL-1)+1
      IBK     = 11
      XBK(1)  =0.0D0
      XBK(IBK) = 1.0D0
      DXP = (XBK(IBK)-XBK(1))/DFLOAT(IBK-1)
      DO 41 I = 2,IBK
41    XBK(I) = XBK(I-1) + DXP
C
      T    = 0.0D0
      CALL SETPDE(NEQ,NPDE,NPTS,X,Y,SPACE,STEP,RW,NRESWK,M,T,
     1            IBAND,1,REMESH,MAXNPT,XBK,IBK,NEL,NPTL,NV,NXI,XI)
C
C  SETUP AND CALL SPRINT - VIA EASY INTERFACE SPRITE
C  -------------------------------------------------
C
      DO 52 I = 1,NEQ
       RTOL(I) = 1.D-3
52     ATOL(I) = 1.D-3
C
      ITRACE  = 1
      SNORM   = 'L2NORM'
      MATZ    = 'SPARSE'
      RESULT  = 'BRIEF'
      IW(1)   = 0
      IW(3)   = 0
      NIW(1)  = NIWK
      NIW(2)  = 0
      NIW(3)  = 0
      NT      = 1
C
      WRITE(8,4999)
C
      TINC = 0.2D0
      DO 53 I = 1,5
        TOUT = T + TINC
C
        CALL SPRITE(NEQ,T,TOUT,NT,RESULT,Y,RTOL,ATOL,ITRACE,
     1            SNORM,MATZ,STEP,SGERES,EZMNTR,RW,NRW,IW,NIW)
C
        WRITE(8,5000) T,(Y(J),J=1,6)
        WRITE(8,5001) IW(1),T
C TEST IF SPRINT INTEGRATION SUCCESSFUL
        IF (IW(1).NE.2) THEN
           GO TO 1000
        END IF
 53   CONTINUE
C
 4999 FORMAT('     TIME      TEMPERATURE PROFILE.....')
 5000 FORMAT(7F10.3)
 5001 FORMAT(2X,' SPRITE RETURNED IWK(1) = ',I5,' AT TIME T=',D11.3)
 1000 CONTINUE
      STOP
      END
C **********************************************************************
       SUBROUTINE UINIT( NPDE, NPTS, X, U)
C      ROUTINE FOR P.D.E. INITIAL VALUES.
       INTEGER NPDE, NPTS
       DOUBLE PRECISION X(NPTS), U(NPDE,NPTS)
       DO 10 I=1,NPTS
 10       U(1,I) = 0.0D0
       RETURN
       END
C
C **********************************************************************
C
      SUBROUTINE SVINIT(V,NV)
C  SET INITIAL VALUES OF O.D.E.S (NONE IN THIS CASE )
      INTEGER NV
      DOUBLE PRECISION V(1)
      RETURN
      END
C
C **********************************************************************
C
C  ROUTINE TO DESCRIBE THE BODY OF THE P.D.E. SEE THE COMMENTS AT THE TO
C  OF THE PROGRAM FOR THE FORM OF THE P.D.E.S
      SUBROUTINE SPDEFN(T, X, NPTL, NPDE, U, DUDX, UDOT, UTDX,
     *                  Q, R, NV, V, VD, IRES)
       INTEGER NPDE, NPTS, I, J, NV, IRES
       DOUBLE PRECISION T, X(1), U(NPDE,1), DUDX(NPDE,1),
     1         UDOT(NPDE,1),Q(NPDE,1), R(NPDE,1), V(1),VD(1),UTDX(NPDE),
     2         ALPHA,BETA,GAMMA,EPS
      COMMON/TPROPS/ALPHA,BETA,GAMMA,EPS
C
      DO 10 I = 1,NPTL
C        LOOP OVER ALL THE POINTS IN THE ELEMENT
          DO 9 J = 1,NPDE
             Q(J,I) = ALPHA*UDOT(J,I)-GAMMA*DEXP(U(J,I)/(1+EPS*U(J,I)) )
             R(J,I) = BETA*DUDX(J,I)
  9       CONTINUE
C
 10   CONTINUE
      RETURN
      END
C
      SUBROUTINE SBNDR( T, BETA, GAMMA, U, UX, UDOT, UTDX,
     `                  NPDE, LEFT, NV, V, VD, IRES)
C
C SPECIFIES BOUNDARY CONDITIONS OF THE FORM
C          BETA(I,T)*R(X,T,U,U ,V,VD) = GAMMA(I,T,U,V,VD)  AT X = A OR B
C                             X
C THE FORM OF THE FLUX FUNCTION IS SPECIFIED IN SPDEF1
      INTEGER NPDE, I, J, NV, IRES
      DOUBLE PRECISION T, BETA(NPDE), GAMMA(NPDE), U(NPDE), UX(NPDE),
     1       UDOT(NPDE),UTDX(NPDE),V(1), VD(1)
      LOGICAL LEFT
C FLUX B.C. AT X=0, KNOWN SOLUTION AT X=1
          BETA(1) = 1.0D0
       IF(LEFT) THEN
          GAMMA(1) = 0.0D0
       ELSE
          BETA(1) = 0.0D0
          GAMMA(1) = U(1) - 0.0D0
       END IF
      RETURN
      END
C
      SUBROUTINE MYMNTR (NEQ,T,Y,H,IMON)
      INTEGER NEQ, IMON
      DOUBLE PRECISION T,Y(NEQ),H
      IF(Y(1).GT.2.0D0) THEN
        IMON = -2
        WRITE(6,91)Y(1)
 91     FORMAT('  Y TOO BIG  ',D14.6)
      ENDIF
      RETURN
      END
C
      SUBROUTINE EVNRMF(TIME,NIP,NPDE,X,U,R,MAXNPT,FMON)
C  ROUTINE FOR REMESHING (NOT USED IN THIS EXAMPLE)
      INTEGER NIP, NPDE, MAXNPT
      DOUBLE PRECISION TIME,  U(NPDE,1),X(NIP),FMON(NIP),R(NPDE,1)
      RETURN
      END
      SUBROUTINE DUT (DUM1, DUM2, DUM3, IDUM)
      INTEGER IDUM
      DOUBLE PRECISION DUM1, DUM2, DUM3
      RETURN
      END
      SUBROUTINE UT (DUM1, DUM2, DUM3, IDUM)
      INTEGER IDUM
      DOUBLE PRECISION DUM1, DUM2, DUM3
      RETURN
      END
