C       PARAMETER DESCRIPTION
C      ***********************
C
C  NPDE : THE NUMBER OF PARABOLIC P.D.E.S
C  NPTS : THE NUMBER OF GRID POINTS IN THE SPACE DIRECTION
C  X(NPTS) : THE ARRAY OF GRID POINTS
C  M     : INTEGER PARAMETER SPECIFYING WHETHER THE P.D.E IS IN
C          CARTESIAN (M=0) OR POLAR (M > 0) CO-ORDINATES.
C  U(NPDE,NPTS) THE SOLUTION VALUES AT TIME TS .
C  TS : THE TIME AT WHICH INTEGRATION IS TO BE STARTED OR CONTINUED.
C  TOUT : THE NEXT OUTPUT TIME LEVEL
C  ABS : THE ABSOLUTE LOCAL ERROR TOLERANCE.
C  REL : THE RELATIVE LOCAL ERROR TOLERANCE.
C  LINALG ; INTEGER PARAMETER TO DEFINE THE TYPE OF LINEAR ALGEBRA
C           USED IUN THE SOLUTION OF THE O.D.E. SYSTEM. ALLOWED VALUES
C           ARE :  = 0 YALE SPARSE MATRIX ROUTINES.
C                  = 1 LINPACK BANDED MATRIX ROUTINES.
C                  = 2 LINPACK FULL MATRIX ROUTINES.
C                  = 3 NAG SPARSE MATRIX ROUTINES
C  IODE  =  0       STHETA METHOD
C        =  1       STHETB METHOD
C        =  2       SPGEAR METHOD
C        =  3       SPDASL METHOD
C***********************************************************************
C    ERROR MESSAGES ARE OUTPUT ON DEVICE IDEV WHERE IDEV IS SET UP
C    BY THE COMMON  STATEMENT  COMMON/SDEV2/ITRACE,IDEV
C    THE INITIALISATION FOR THE DISCRETISATION CODE IS DONE BY CALLING
C    THE SUBROUTINE INITSK - SEE THE SPDIFF MODULE FOR DETAILS.
C
      INTEGER NPTS, NPDE, LIW, IMESH,
     -        IBAND, IWORK(3220),IDEV, ITRACE, I, J, NWKMON,
     -        ITOL, NSTEPS, NEQN, IFUN, IJAC, M, IOVFLO
      INTEGER INFORM(213), NWKDRV, NWKJAC, IRET, N, NOP, IPMINF,
     1        JSINFO(4), NITER, NEL, ISET, IRES, NRWK, NV, NXI,
     2        IA(1), NIA, JA(1), NJA, NJCPVT, ISPLIT, ICALL, IGROW,
     3        LIWREQ, LIWUSD, LRWREQ, LRWUSD, NLU, NBLOCK, NNZ, NGP
      DOUBLE PRECISION  X(81), U(2,81), WORK(900), UROUND, XI,
     -        TS, TOUT, ABS, REL, RESWK, DUNFLO, WKMON(1),
     -        WKJAC(10000), YSAVE(161,15), YDOT(161), TTIME,
     -        CONST, STPRAT, DELX, DX, SFNOFC, SENS, UPIV, ETA
      LOGICAL REMESH, LBLOCK
      CHARACTER*6 SNORM
      CHARACTER*12 JCEVAL
      EXTERNAL SBLEND,PREPJB, SOLSB, SOLSS, PREPJS, STHETA, STHETB,
     1         RES, JAC, PREPJF, SOLSF, MVMESH, DERIV, SPGEAR, SKLRES,
     2         SPANMM, SPANNV, SPDASL
      COMMON /SDEV2/ ITRACE,IDEV
      COMMON /ST002A/ SFNOFC
      COMMON /SCONS1/ DUNFLO, UROUND, IOVFLO
      COMMON /RESIDZ/ RESWK(500)
C COMMON MESHIN USED BY SUBROUTINES INITSK AND MVMESH
      COMMON /MESHIN/ CONST, STPRAT, IPMINF, NOP
C COMMON MESHTI USED BY SUBROUTINE MVMESH FOR REMESHING IN TIME INFO
      COMMON /MESHTI/ TOUT, REMESH, NRMESH, ICOUNT
        NPDE = 2
        WRITE(6,1011)
C       CALL ERRSET ( 208, 256, -1, -1, 0) IBM ONLY TO DISABLE UNDERFLOW
        CALL ERRSET ( 208, 256, -1, -1, 0)
1011    FORMAT(' PLEASE INPUT IODE , LINALG AND IMESH')
        READ(5,*)IODE, LINALG, IMESH
        WRITE(6,1013)IODE, LINALG, IMESH
1013    FORMAT(' IODE = ',I3,' LINALG = ',I3,' IMESH =',I3)
        ITRACE = 1
        CALL TIMER(TTIME,1)
        IDEV   = 4
        WRITE(IDEV,1013)IODE, LINALG, IMESH
        NPTS = 41
C       NPTS = 15
        NEQN = NPDE*NPTS
        M = 0
        NWKMON = 1
        ITOL = 1
C       LINALG = 2
        ABS = 1.0D-4
        REL = 1.0D-4
       IF( IODE .EQ. 1)THEN
           WRITE(6,777)
777        FORMAT(' INPUT THE VALUE OF FN OVER FC, IN RANGE 1 TO 9 SAY')
           READ(5,*)SFNOFC
       END IF
C
C  INITIALISE THE DISCRETISATION WORKSPACE
C
C REMESH INFO (VARIABLE NO. POINTS OPTION THEN SET NOP=0 ELSE NOP=NPTS)
      REMESH = .FALSE.
      NOP=NPTS
      CONST=2.0D0 / ( NPTS - 1.0D0 )
      STPRAT=1.5D0
      IPMINF=0
C NRMESH DICTATES HOW OFTEN REMESH :
C =1 THEN REMESHES EVERY TIME STEP WHEN MVMESH ROUTINE CALLED
C =2                     2ND TIME STEP, ETC....
C =0 THEN REMESHES AT CURRENT TIME TOUT BY THE CALL TO MVMESH WITH
C    INFORM(2)=4 AND WORK(1) SET TO CURRENT TOUT. IF THE SOLUTION
C    PROFILE CHANGES RAPIDLY FOR CERTAIN T THEN SET TOUT ACCORDINGLY.
C
      NRMESH=5
C ICOUNT USED TO COUNT UP TO NRMESH SO JUST INITIALISE TO ZERO
      ICOUNT=0
C IF HMAX=WORK(6) IS LARGE THEN NRMESH*HMAX MAY BE TOO LARGE
C FOR REMESHING PURPOSES SO SET ACCORDINGLY
      WORK(6)=0.2D0
      WORK(5)=0.0D0
      WORK(7)=0.0D0
C
        NV = 0
        NXI = 0
        XI = 0.0D0
        IRES = 1
        NRWK = 500
        X(1) = 0.0D0
        X(NPTS) = 10.0D0
        DO 10 I = 2, NPTS-1
 10        X(I) = X(1) + (I-1)*(X(NPTS) - X(1)) / (NPTS-1)
        IF(IMESH.EQ.1)REMESH = .TRUE.
        CALL INITSK( NEQN, NPDE, NPTS, X, U, RESWK, NRWK, M, TS, IBAND,
     1               IRES, REMESH, NPTS, NV, NXI, XI)
        IF(IRES .LT. 0)GOTO 106
C
       IF(LINALG .EQ. 1)THEN
C        SET UP THE BAND INFORMATION NEEDED BY BANDED MATRIX ROUTINES
         IWORK(1) = IBAND
         IWORK(2) = IBAND
       END IF
C
C  PASS THE INTEGRATION PARAMETERS INTO THE ARRAY INFORM
C
      N = NEQN
      INFORM(1) = 0
      INFORM(2) = 1
      INFORM(3) = 1
      DO 50 I = 4,14
50       INFORM(I) = 0
C
C   SET UP THE TIME INTEGRATION  PARAMETERS
C
      IF(IODE .EQ. 0)THEN
         CALL THESET(8,IRET)
      ELSE IF(IODE .EQ. 1)THEN
         CALL THBSET(8, IRET, .FALSE.,.FALSE.,0.55D0)
C        CALL THBSET(8, IRET, .TRUE.,.TRUE.,0.55D0)
      ELSE IF(IODE .EQ. 2)THEN
         CALL BDFSET(8, IRET, 3, 2 , .TRUE.)
      ELSE
         CALL DASSET(8, IRET, 3, 2 )
      END IF
C
      IF(IRET .LT. 0)GOTO 1000
      NWKDRV = 900
      NYSAVE = 161
      NWKJAC = 10000
      LIW = 3220
C
C   SET UP THE PARAMETERS FOR THE LINEAR ALGEBRA INITIALISATION CALLS
C
      NEL = 3*N
      ISET = 0
      SENS = 0.0D0
      IF(LINALG .EQ. 0)THEN
          CALL SMTSET( NEQN, 2, SENS, NWKJAC, LIW, NEL, ISET, JSINFO)
      ELSE IF(LINALG .LE. 2)THEN
          CALL MATSET( LINALG, NEQN, IWORK, IWORK(2), NWKJAC, LIW, ISET)
      ELSE
          NIA = 1
          NJA = 1
          NJCPVT = 166
          ISPLIT = 73
          LBLOCK = .FALSE.
          ETA    = 10.0D0
          JCEVAL = 'NUMERICAL  '
          UPIV   = 0.1
          CALL SPANUF( NEQN, NEQN, JCEVAL, NWKJAC, IA, NIA, JA, NJA,
     1                 IWORK, LIW, SENS, UPIV, ETA, LBLOCK, ISPLIT,ISET)
      ENDIF
      IF(ISET .LT. 0)GOTO 1000
      IDEV = 4
C**********************************************************************
C    CALL MARK 0 OF THE SPRINT PACKAGE
C
      CALL TIMER(TTIME,2)
      WRITE(IDEV,2000)IFUN, IJAC, NITER, NSTEPS, TTIME
      TS = 0.0D0
      TOUT = 0.30D0
100   SNORM = 'AVERL2'
C
      IF(IODE .EQ. 0)THEN
C
C          STHETA METHOD WITH FULL MATRIX ROUTINES
C
        IF(LINALG .EQ. 0)THEN
C                                  SPARSE MATRIX ROUTINES USED.
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, STHETA,YSAVE, NYSAVE
     2                ,PREPJS, WKJAC, NWKJAC, IWORK, JAC, SOLSS,
     3                 MVMESH, WKMON, NWKMON)
        ELSE IF(LINALG .EQ. 1)THEN
C                                  BANDED MATRIX ROUTINES USED.
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, STHETA,YSAVE, NYSAVE
     2                ,PREPJB, WKJAC, NWKJAC, IWORK, JAC, SOLSB,
     3     MVMESH, WKMON, NWKMON)
        ELSE IF(LINALG .EQ. 2)THEN
C                                  FULL MATRIX ROUTINES USED.
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, STHETA,YSAVE, NYSAVE
     2                ,PREPJF, WKJAC, NWKJAC, IWORK, JAC, SOLSF,
     3     MVMESH, WKMON, NWKMON)
             ELSE
C                                  NAG SPARSE  MATRIX ROUTINES
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, STHETA,YSAVE, NYSAVE
     2                ,SPANMM, WKJAC, NWKJAC, IWORK, JAC, SPANNV,
     3                 MVMESH, WKMON, NWKMON)
             END IF
       ELSE IF(IODE .EQ. 1)THEN
C
C      SPRINT USED WITH STHETB INTEGRATOR
C      **********************************
        IF(LINALG .EQ. 0)THEN
C                                  SPARSE MATRIX ROUTINES USED.
           CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, STHETB,YSAVE, NYSAVE
     2                 ,PREPJS, WKJAC, NWKJAC, IWORK, JAC, SOLSS,
     3                  MVMESH, WKMON, NWKMON)
        ELSE IF(LINALG .EQ. 1)THEN
C                                  BANDED MATRIX ROUTINES USED.
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, STHETB,YSAVE, NYSAVE
     2                ,PREPJB, WKJAC, NWKJAC, IWORK, JAC, SOLSB,
     3                 MVMESH, WKMON, NWKMON)
        ELSE IF(LINALG .EQ. 2)THEN
C                                  FULL MATRIX ROUTINES USED.
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, STHETB,YSAVE, NYSAVE
     2                ,PREPJF, WKJAC, NWKJAC, IWORK, JAC, SOLSF,
     3                 MVMESH, WKMON, NWKMON)
             ELSE
C                                  NAG SPARSE MATRIX ROUTINES
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, STHETB,YSAVE, NYSAVE
     2                ,SPANMM, WKJAC, NWKJAC, IWORK, JAC, SPANNV,
     3                 MVMESH, WKMON, NWKMON)
             END IF
C
      ELSE IF(IODE .EQ. 2)THEN
C
C       SPRINT USED WITH ADAMS/B.D.F METHODS
C       ************************************
        IF(LINALG .EQ. 0)THEN
C                                  SPARSE MATRIX ROUTINES USED.
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, SPGEAR,YSAVE, NYSAVE
     2                ,PREPJS, WKJAC, NWKJAC, IWORK, JAC, SOLSS,
     3                 MVMESH, WKMON, NWKMON)
        ELSE IF(LINALG .EQ. 1)THEN
C                                  BANDED MATRIX ROUTINES USED.
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, SPGEAR,YSAVE, NYSAVE
     2                ,PREPJB, WKJAC, NWKJAC, IWORK, JAC, SOLSB,
     3                 MVMESH, WKMON, NWKMON)
        ELSE IF(LINALG .EQ. 2)THEN
C                                  FULL MATRIX ROUTINES USED.
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, SPGEAR,YSAVE, NYSAVE
     2                ,PREPJF, WKJAC, NWKJAC, IWORK, JAC, SOLSF,
     3                 MVMESH, WKMON, NWKMON)
             ELSE
C                                  NAG SPARSE MATRIX ROUTINES
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, SPGEAR,YSAVE, NYSAVE
     2                ,SPANMM, WKJAC, NWKJAC, IWORK, JAC, SPANNV,
     3                MVMESH, WKMON, NWKMON)
             END IF
      ELSE IF(IODE .EQ. 3)THEN
C
C       SPRINT USED WITH SPDASL
C       ************************
        IF(LINALG .EQ. 0)THEN
C                                  SPARSE MATRIX ROUTINES USED.
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, SPDASL,YSAVE, NYSAVE
     2                ,PREPJS, WKJAC, NWKJAC, IWORK, JAC, SOLSS,
     3                 MVMESH, WKMON, NWKMON)
        ELSE IF(LINALG .EQ. 1)THEN
C                                  BANDED MATRIX ROUTINES USED.
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, SPDASL,YSAVE, NYSAVE
     2                ,PREPJB, WKJAC, NWKJAC, IWORK, JAC, SOLSB,
     3                 MVMESH, WKMON, NWKMON)
        ELSE IF(LINALG .EQ. 2)THEN
C                                  FULL MATRIX ROUTINES USED.
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, SPDASL,YSAVE, NYSAVE
     2                ,PREPJF, WKJAC, NWKJAC, IWORK, JAC, SOLSF,
     3                 MVMESH, WKMON, NWKMON)
             ELSE
C                                  NAG SPARSE MATRIX ROUTINES
          CALL SPRINT( NEQN, TS, TOUT, U, YDOT, WORK, NWKDRV, REL, ABS,
     1    ITOL, INFORM, SNORM, SKLRES, RESWK, NRWK, SPDASL,YSAVE, NYSAVE
     2                ,SPANMM, WKJAC, NWKJAC, IWORK, JAC, SPANNV,
     3                MVMESH, WKMON, NWKMON)
             END IF
       END IF
C   PASS STATS BACK ACROSS.
C
       IF(LINALG .EQ. 3)THEN
          ICALL = 0
          IF(INFORM(1) .NE. 2)ICALL = 1
          CALL SPANXF(NEQN, ICALL, LIWREQ, LIWUSD, LRWREQ, LRWUSD, NLU,
     1                NNZ, NGP, ISPLIT, IGROW, LBLOCK, NBLOCK)
       END IF
C
C   ACCESS THE CURRENT MESH.
C
79     IRES = 2
       CALL INITSK( NEQN,NPDE, NPTS, X, U, RESWK, NRWK, M, TS, IBAND,
     1              IRES, .TRUE. ,NPTS, NV, NXI, XI)
        IFUN = INFORM(7)
        IJAC = INFORM(8)
        NSTEPS = INFORM(6)
        NITER = INFORM(11)
C
        DELX = 1000.0D0
        DO 677 I = 2, NPTS
          DX  = X(I) -X(I-1)
          IF(DX .LE. DELX)DELX = DX
677     CONTINUE
        WRITE(IDEV,81)TOUT,INFORM(1),DELX
        WRITE(6,81)TOUT,INFORM(1),DELX
81      FORMAT('  SOL AT',D12.4/' INFORM(1) =',I3,' MESH WIDTH =',D11.3)
        CALL TIMER(TTIME,2)
        WRITE(IDEV,2000)IFUN, IJAC, NITER, NSTEPS, TTIME
        IF((TOUT .GT. 0.7 .AND. TOUT.LT.0.9).OR. TOUT .GE. 2.7D0)THEN
          DO 70 I = 1,NPDE
           DO 70 J = 1,NPTS
70           WRITE(IDEV,80)X(J),U(I,J)
80           FORMAT(2E10.5)
        END IF
106     CONTINUE
        IF(TOUT .LT. 0.35D0)THEN
           CALL SPATEV
C          ITRACE = 3
        END IF
        IF(INFORM(1) .EQ. 2)THEN
           IF(TOUT .GE. 2.7D0)GOTO 1000
           TOUT = TOUT + 0.10D0
           GOTO 100
        END IF
 1000 CONTINUE
      CALL TIMER(TTIME,2)
      WRITE(IDEV,2000)IFUN,IJAC,NITER, NSTEPS, TTIME
 2000 FORMAT(' FUN=',I5,' IJAC=',I5,' NITER=',I5,' NSTEPS=',I5,' CPU=',
     1       D11.3)
      STOP
      END
C**********************************************************************
C        PROBLEM DESCRIPTION ROUTINES
C**********************************************************************
       SUBROUTINE UINIT( NPDE, NPTS, X, U)
C      ROUTINE FOR P.D.E. INITIAL VALUES.
       INTEGER NPDE, NPTS
       DOUBLE PRECISION X(NPTS), U(NPDE,NPTS)
       DO 10 I = 1,NPTS
          U(1,I) = 1.0D0
 10       U(2,I) = 0.0D0
       RETURN
       END
       SUBROUTINE SPDEF1(T, X, NPDE, U, DUDX, C, F, R, NV, V,VD,L)
C      ROUTINE TO DESCRIBE THE BODY OF THE P.D.E.
       INTEGER NPDE, J, NV, L
       DOUBLE PRECISION T, KT, X, U(NPDE), DUDX(NPDE),
     1            C(NPDE,NPDE), F(NPDE), R(NPDE), V, VD
          DO 9 J = 1,NPDE
             C(J,J) = 1.0D0
 9           R(J) = DUDX(J)
          KT = 14.6D0 * DEXP( 4.0D0 - 4.0D0/(U(2) + 0.01D0))
          F(1) =   KT * U(1)
          F(2) = - KT * U(1)
       RETURN
       END
       SUBROUTINE BNDR( T, BETA, GAMMA, U, UX, NPDE, LEFT, NV, V, VD,L)
C      BOUNDARY CONDITIONS ROUTINE
       INTEGER NPDE, I,NV
       DOUBLE PRECISION T, BETA(NPDE), GAMMA(NPDE), U(NPDE), HPI, V, VD
     1                    ,UX(NPDE)
       LOGICAL LEFT
       HPI = 3.14159265350D0 * 0.5D0 / 0.95D0
       DO 10 I = 1,NPDE
          BETA(I) = 1.0D0
          GAMMA(I) = 0.0D0
 10    CONTINUE
       IF(LEFT) THEN
          IF(T .LE. 0.05)THEN
             GAMMA(2) = -T/0.05D0
          ELSE IF(T .LE. 1.0)THEN
             GAMMA(2) = -DCOS(HPI*(T-0.05D0))
          END IF
       END IF
       RETURN
       END
C      DUMMY ROUTINES FOR NON-EXISTANT O.D.E. PART
       SUBROUTINE SVINIT
       RETURN
       END
       SUBROUTINE SODEFN
       RETURN
       END
       SUBROUTINE SET( A, N, B, M)
       INTEGER N, M, I
       DOUBLE PRECISION A(N),B(M)
       IF(N .LE. M)THEN
          DO 10 I = 1,N
             B(I) = A(I)
 10          A(I) = 0.0D0
          DO 20 I = N+1,M
 20          B(I) = 0.0D0
       ELSE
          WRITE(6,30)
 30       FORMAT(' INVALID CALL TO SET ROUTINE - NOTHING DONE')
       END IF
       RETURN
       END
C**********************************************************************
      SUBROUTINE EVNRMF( TIME, NIP, NPDE, X, U, R, MAXNPT, FMON)
C**********************************************************************
C     EXAMPLE MONITOR  FUNCTION ROUTINE FOR REMESHING.
C     R(J,I) CONTAINS THE FLUX FOR JTH P.D.E. AT POINT Y(I)
C        WHERE Y(1) = X(1) , Y(NIP+1) = X(NIP)
C              Y(I) =(X(I+1) - X(I)) * 0.5   I = 2,..., NIP
C     THE MONITOR FUNCTION IS RETURNED IN THE ARRAY FMON
C
      INTEGER NIP, NPDE, MAXNPT, I, J, K, L
      DOUBLE PRECISION U(NPDE,1), X(NIP), SUM,FMON(NIP), TIME,
     1                 R(NPDE,1),  DRDX, H
      IF(TIME .EQ. 0.0D0)GOTO 100
      DO 10 I=1,NIP
        K = MAX0(1,I-1)
        L = MIN0(NIP,I+1)
        H = (X(L) - X(K)) * 0.5D0
        SUM=0.0D0
        J = 2
C       DO 5 J=1,NPDE
C 1ST DERIV
C          DRDX = R(J,I)
C 2ND DERIV
           DRDX = (R(J,I+1) - R(J,I)) / H
    5      SUM = SUM + DRDX**2
        FMON(I)=DSQRT(SUM)
   10 CONTINUE
      RETURN
100   CONTINUE
      DO 200 I = 1, NIP
       FMON(I) = DEXP(-X(I))
200   CONTINUE
C
      RETURN
      END
