      PARAMETER (PIBY2 = 1.5707963D0)
      INTEGER NEQ, NV, NXI, M, MAXNPT, NPTS, NPDE, NEQMAX, NWKMON,
     1          NRW, IBAND, ITIME, I, NY2DIM, MAXORD, ISET, NWKJAC,
     2          JACPVT(160), K,ITOL, INFORM(174), IDEV, IPTS,IOPT, IFL
      DOUBLE PRECISION T, TOUT, Y(160), YDOT(160), RWORK(501), RTOL,
     1          ATOL, WKRES(674), YSAVE(160,6), WKJAC(2570), WKMON,
     2          X(80), XI, DSIN, ALPHA, HX, XOUT(6), UOUT(2,6),CPU
      LOGICAL REMESH
      CHARACTER*6 SNORM
C
C         DECLARE NAMES OF SPRINT ROUTINES USED.
C
      EXTERNAL SKLRES, SPGEAR, PREPJB, SOLSB, SPRMON, SPRJAC, ERRSET
C
C         COMMON BLOCK FOR MATERIAL PROPERTIES OF PROBLEM.
C
      COMMON /VBLE/ ALPHA
      COMMON /SDEV2/ITRACE, IDEV
      DATA XOUT(1)/0.0D+0/, XOUT(2)/0.4D+0/, XOUT(3)/0.8D+0/,
     * XOUT(4)/0.9D+0/, XOUT(5)/0.95D+0/, XOUT(6)/1.0D+0/
C     CALL ERRSET(208, 256, -1, -1, 0) IBM ONLY TO SWITCH OFF UNDEFLOW
      WRITE(6,9)
 9    FORMAT(' INPUT RTOL AND IFLITER (=1 FOR FILTER )')
      READ(5,*)RTOL,IFL
      ATOL = RTOL / 10000.0D0
      ITRACE = 1
      IDEV   = 6
      ALPHA  = 1.0D0
C
C     READ(5,*)RTOL, ATOL, ITRACE, IDEV, ALPHA
      WRITE(4,104)RTOL, ATOL, ITRACE, IDEV, ALPHA, IFL
      WRITE(IDEV,104)RTOL, ATOL, ITRACE, IDEV, ALPHA,IFL
104   FORMAT(//' RTOL=',D12.3,' ATOL=',D12.3,' ITRACE AND IDEV = ',I4,
     1       2X, I4,'  ALPHA IS ',D12.3,' IFL= ',I2/)
      CALL TIMER( CPU, 1)
      IOPT = 0
      ITOL = 1
      INFORM(1) = 0
      INFORM(2) = 1
      INFORM(3) = 1
      DO 19 I=4,13
         INFORM(I) = 0
   19 CONTINUE
      INFORM(14) = IFL + 1
C SPRINT WITH GEAR INTEGRATION AND SKEEL SPACE DISCR.
C
      NV = 0
      NXI = 0
      XI = 0.0D0
C SET M FOR SPACE CO-ORDINATE TYPE
C  M = 0 FOR CARTESIAN,  = 1 FOR CYLINDRICAL, = 2 FOR SPHERICAL
      M = 1
C PDE AND SPACE SIZES:
C MAXNPT ALSO USED FOR FIXED ARRAY DIMENSIONS IN MONITOR - MONITR
      MAXNPT= 80
      NPTS = 80
      NPDE = 2
      NEQ = NPDE * NPTS + NV
      NEQMAX = NPDE * MAXNPT + NV
C
C MONITOR WORKSPACE SIZE
      NWKMON = 1
C NRW IS SIZE OF RWORK INTEGRATOR WORKSPACE
      NRW = 21 + 3*NEQMAX
C
C SPACE MESH INFO.: MESH SPACING X(1)...X(NPTS)
      HX = PIBY2/(NPTS - 1)
      X(1) = 0.0D0
      X(NPTS) = 1.0D0
      DO 10 I = 2, NPTS-1
         X(I) = DSIN(HX*(I-1))
 10   CONTINUE
      HX = X(NPTS) - X(NPTS-1)
      IF(ITRACE .GE. 1)WRITE(IDEV,7711)HX
7711  FORMAT(' HX = ',D16.5)
C CALL THE SKEEL DISCRETISATION INITIALISATION ROUTINE
C WKRES IS THE WORKSPACE USED BY SKEEL ROUTINE HAS TO BE OF SIZE AT LEAS
C NPDE*(NPTS*2+NXI*6+17) + NXI + NV + 2*NPDE(MAXNPT-NPTS) + 4*MAXNPT
C
      NWKRES = 674
      IBAND = 0
C ITIME - SHOULD BE SET TO 1 ON THE 1ST CALL (=2 VALUE USED FOR REMESHIN
      ITIME = 1
C REMESH INFO ( IF TRUE EXTRA INFO. IS NEEDED SEE later SECTION   )
      REMESH = .FALSE.
      CALL INITSK( NEQ, NPDE, NPTS, X, Y, WKRES, NWKRES, M, T, IBAND,
     1             ITIME, REMESH, MAXNPT, NV, NXI, XI)
      IF(ITIME .LT. 0)THEN
         WRITE(IDEV,902)ITIME
902      FORMAT('0 SETUP FAILURE IN INITSK',I3)
         STOP
      ENDIF
C
      WRITE(IDEV,777)
      WRITE(IDEV,778)(Y(I), I = 1,NEQ)
777   FORMAT('  INITIAL SOLUTION  VALUES ')
778   FORMAT(1X,5D11.3)
C  O.D.E. INTEGRATOR INITIALISATION CALL
C
      NY2DIM = 6
      MAXORD = 5
      ISET = 0
      CALL BDFSET( NY2DIM, ISET, MAXORD, 2, .FALSE.)
      IF(ISET .LT. 0)GO TO 100
C
C LINEAR ALGEBRA INITIALISATION CALL
C
      ISET = 0
      NIWJAC = NEQMAX
      NWKJAC = 2570
      CALL MATSET( 1, NEQ , IBAND, IBAND, NWKJAC, NIWJAC, ISET)
      IF(ISET .LT. 0)GO TO 100
C
      SNORM = 'L2NORM'
      T    = 0.0D0
      WRITE (4,99) (XOUT(I), I=1,6)
99    FORMAT ('       T/X', 3X, 6F11.5/)
C TIME LOOP:
100   TOUT = 0.1D-4
      DO 13 K=1,5
        TOUT = TOUT*10
C       BANDED MATRIX ROUTINES USED.
        CALL SPRINT( NEQ, T, TOUT, Y, YDOT, RWORK, NRW, RTOL, ATOL,
     1        ITOL, INFORM, SNORM, SKLRES, WKRES, NWKRES, SPGEAR, YSAVE,
     2        NEQMAX, PREPJB, WKJAC, NWKJAC, JACPVT, SPRJAC, SOLSB,
     3        SPRMON, WKMON, NWKMON)
C
C      INTERPOLATE THE RESULTS
       IPTS = 6
             CALL INTERX(XOUT, UOUT,IPTS, X, Y, NPTS, NPDE, IFLAG, 1)
      J = 1
      WRITE (4,98) TOUT,J, (UOUT(1,I),I=1,6)
      J = 2
      WRITE (4,97) J, (UOUT(2,I),I=1,6)
   13 CONTINUE
      CALL TIMER(CPU,2)
      WRITE(4,101)INFORM(6),INFORM(7),INFORM(8),INFORM(11),CPU
 101  FORMAT(' NSTEPS=',I6,' NFCN=',I6,' NJAC=',I6,' NITER= ',I6,
     1       ' CPU= ',D13.5)
      STOP
98    FORMAT (1X, F6.4,' U(',I2,')', 6F11.6)
C   END OF INTEGRATION LOOP
97    FORMAT (7X, ' U(',I2,')', 6F11.6)
      END
C
      SUBROUTINE UINIT( NPDE, NPTS, X, U)
C Routine for p.d.e. initial values
      INTEGER NPDE, NPTS
      DOUBLE PRECISION X(NPTS), U(NPDE,NPTS), ALPHA
      COMMON /VBLE/ALPHA
      DO 10 I=1,NPTS
         U(2,I) = 1.0D0
 10      U(1,I) = 2.0D+0*ALPHA*X(I)
         U(1,NPTS) = U(1,NPTS-1) * X(NPTS-1)
         U(2,NPTS) = 0.0D0
      RETURN
      END
C
      SUBROUTINE SPDEF1( T, X,NPDE, U, DUDX, C, Q, R, NV, V, VD, IRES)
C Routine to describe the p.d.e. system in the Skeel eqn.form (4.1).
C SPDEF1 IS CALLED FOR EACH MESH POINT IN TURN BY SKLRES.
      INTEGER NPDE, I, J, NV, IRES
      DOUBLE PRECISION T, X, U(NPDE), DUDX(NPDE),
     1         C(NPDE,NPDE), Q(NPDE), R(NPDE), V(1), VD(1),
     2         ALPHA
      COMMON/VBLE/ALPHA
          C(1,1) = 0.0D+0
          C(1,2) = 0.0D0
          R(1) = X*DUDX(1)
          Q(1) = 4.D0*ALPHA*(U(2)+X*DUDX(2))
          C(2,1) = 0.0D+0
          C(2,2) = 1.0D0 - X**2
          R(2) = DUDX(2) - U(1)*U(2)
          Q(2) = 0.0D+0
      RETURN
      END
      SUBROUTINE BNDR( T, BETA, GAMMA,U,UX,NPDE, LEFT, NV, V, VD, IRES)
C Specifies the boundary conditions in master eqn. form (4.2); the form
C of the flux function R is specified in SPDEF1
      INTEGER NPDE, I, J, NV, IRES
      DOUBLE PRECISION T, BETA(NPDE), GAMMA(NPDE), U(NPDE), UX(NPDE),
     1       V(1), VD(1)
      LOGICAL LEFT
      IF(LEFT) THEN
          GAMMA(1) = U(1)
          BETA(1) = 0.0D+0
          GAMMA(2) = 0.0D0
          BETA(2) = 1.0D+0
      ELSE
          GAMMA(1) = -U(1)
          BETA(1) = 1.0D0
C         GAMMA(2) = U(2)- 1.0D0
          GAMMA(2) = U(2)
          BETA(2) = 0.0D+0
CXX       IF(T .GT. 1.0D-16)GAMMA(2) = U(2)
      END IF
      RETURN
      END
      SUBROUTINE SODEFN(T, NV, V, VDOT, NPDE, NXI, XI, UI, UXI, RI,
     1                  UTI, UTXI, VRES, IRES)
C Routine for auxiliary o.d.e.s (if any) in master eqn. form (4.3)
      INTEGER NPDE, NXI, NV, IRES
      DOUBLE PRECISION T, XI(NXI), UI(NPDE,NXI), UXI(NPDE,NXI),
     1        RI(NPDE,NXI), UTI(NPDE,NXI), UTXI(NPDE,NXI), VRES(NV),
     2        V(NV), VDOT(NV), TEM
      RETURN
      END
C
      SUBROUTINE SVINIT( V,NV)
C Routine for initial values of auxiliary o.d.e.s (if any)
      INTEGER NV
      DOUBLE PRECISION V(NV)
C SVINIT NOT USED IN THIS EXAMPLE
      RETURN
      END
