C***********************************************************************
C     EXAMPLE SIMPLE DRIVER ROUTINE FOR ODE PROBLEMS.
C     LEIMKUHLER PROBLEM 1
C
C***********************************************************************
       INTEGER NEQN, LRW, ITOL, INFORM(17), NRESWK, JACPVT(20),INFO(15),
     1          NWKMON, MAXORD, ISET, NYSAVE, JSINFO(4), NY2DIM, ISTAT,
     2          IEFAIL, IJAC, KZ
       INTEGER  LIW, ITRACE, IDEV,  I, NFCN, NOINV, NOSOLV, NOSTEP
       DOUBLE PRECISION T,TOUT, Y(2), RWORK(100), RESWK(1),PHI,
     1         YSAVE(2,14), WKJAC(400), WKMON(1), YDOT(2), TTIME, DPHI,
     2         ALPHA, BETA, PI, DDPHI, REL(2), ABS(2)
       CHARACTER*6 JNORM
       EXTERNAL RES, SPDASL, PREPJF, SOLSF, MONITR, JAC, SPGEAR,STHETA
     1         , RESDAS, JACDEF
       COMMON /SDEV2/ ITRACE, IDEV
       COMMON /EGS  / ALPHA, BETA, PI
       COMMON /PSTATS/ISTAT(4)
       COMMON /ERRCNT/ IEFAIL
C          SETUP THE PROBLEM INPUTS AND THE OPTIONAL OUTPUTS FOR SPRINT
       WRITE(6,10)
 10    FORMAT(' INPUT ITRACE IDEV IODE 0 1 2 3 IJAC')
       READ(5,*)ITRACE ,IDEV, IODE, IJAC
      DO 2000 KZ = 1,10
       NRESWK = 1
       PI = 3.141592653589793D0
       ALPHA = 1.0D0
       BETA  = 30.0D0
       NWKMON = 1
       NWKJAC = 400
       IEFAIL = 0
       LRW    = 100
       REL(1) = 0.1D0 * (0.5D0 ** (KZ-1))
       ABS(1) = REL(1)
       WRITE(IDEV,11)REL(1) ,ABS(1), IODE, IJAC
 11    FORMAT(' LEIMKUHLER PROBLEM 1'/' RTOL AND ATOL ARE ',2D11.3,
     1        ' IODE = ',I3,' IJAC  = ',I3)
       REL(2) = REL(1)
       ABS(2) = ABS(1)
       ITOL   = 4
       MAXORD = 11
       LIW    = 2
       JNORM = 'AVERL2'
       NY2DIM = 14
       NEQN = 2
       NYSAVE = 2
       T = 0.0D0
       TOUT = 3.0D0
       CALL TIMER(TTIME,1)
       Y(1) = PHI(T)
       Y(2) = DPHI(T)
       YDOT(1) = DPHI( T)
       YDOT(2) = DDPHI(T)
       IF(ITRACE .GE. 1)WRITE(IDEV,12)Y(1),Y(2),YDOT(1),YDOT(2)
 12    FORMAT(' INITIAL SOLUTION VALUES ARE ',2D11.3,/
     1        ' INITIAL DERIV    VALUES ARE ',2D11.3)
       RWORK(5) = 0.1D-2
       RWORK(6) = 1.0D0
       RWORK(7) = 0.1D-15
       INFORM(1) = 1
       IF(TOL .EQ. 0.0D0)INFORM(1) = 1
       INFORM(2) = 1
       INFORM(3) = 1
       INFORM(4) = 2500
       DO 19 I = 5,17
C        SET THE UNUSED PART OF INFORM TO 0
         INFORM(I) = 0
 19    CONTINUE
      INFORM(14) = 1
      IF(IJAC .EQ. 1)ISET = 1
C             CALL THE SETUP ROUTINES AND SPRINT IF THE SETUPS ARE O.K.
      CALL MATSET( 2, NEQN, JACPVT(1), JACPVT(2), NWKJAC, LIW, ISET)
      IF(ISET .LT. 0)THEN
         WRITE(IDEV,20)
 20      FORMAT(' SETUP FAILED IN MATSET')
         STOP
      END IF
      MAXORD = 5
      IF(IODE .EQ.0)THEN
         CALL THESET( NY2DIM, ISET)
      ELSE IF(IODE.EQ. 1)THEN
         CALL BDFSET( NY2DIM, ISET, MAXORD, 2,.TRUE.)
      ELSE IF(IODE.EQ. 2)THEN
         CALL DASSET( NY2DIM, ISET, MAXORD)
      ELSE
         DO 211 I =1,15
 211        INFO(I) = 0
      END IF
      IF(ISET .LT. 0)THEN
         WRITE(IDEV,21)
 21      FORMAT(' SETUP FAILED IN INTEGRATOR INITIALISATION')
         STOP
      END IF
      WRITE(IDEV,1000)
 1000 FORMAT(/'0',2X,'#STEPS',2X,'#FCN',2X,'#DECOMP',2X,'#SOLVE',2X,
     1       'CPU TIME',2X,'ISTATE',2X,'STOP AT TF LEFAIL'/)
      IF(IODE .EQ. 0)THEN
       CALL SPRINT( NEQN, T, TOUT, Y, YDOT, RWORK, LRW, REL, ABS, ITOL,
     1        INFORM, JNORM, RES, RESWK, NRESWK, STHETA,YSAVE, NYSAVE,
     2        PREPJF, WKJAC, NWKJAC, JACPVT, JAC, SOLSF, MONITR, WKMON,
     3        NWKMON)
      ELSE IF(IODE .EQ. 1)THEN
       CALL SPRINT( NEQN, T, TOUT, Y, YDOT, RWORK, LRW, REL, ABS, ITOL,
     1        INFORM, JNORM, RES, RESWK, NRESWK, SPGEAR,YSAVE, NYSAVE,
     2        PREPJF, WKJAC, NWKJAC, JACPVT, JAC, SOLSF, MONITR, WKMON,
     3        NWKMON)
      ELSE IF(IODE .EQ. 2)THEN
       CALL SPRINT( NEQN, T, TOUT, Y, YDOT, RWORK, LRW, REL, ABS, ITOL,
     1        INFORM, JNORM, RES, RESWK, NRESWK, SPDASL,YSAVE, NYSAVE,
     2        PREPJF, WKJAC, NWKJAC, JACPVT, JAC, SOLSF, MONITR, WKMON,
     3        NWKMON)
      ELSE IF(IODE.EQ. 3)THEN
           IWK = 40
           IK = 0
           IF(IJAC .EQ. 1)INFO(5) = 1
 1002      IR =  NEQN
           CALL DDASSL( RESDAS, NEQN, T, Y, YDOT, TOUT, INFO, REL, ABS,
     1          IDID, RWORK, LRW, JACPVT, IWK, RESWK, IR, JACDEF)
           I = IDID
           IF(IDID .EQ. -1)THEN
              IK = IK + 1
              INFO(1) = 1
              IF(IK.LT.5)GOTO 1002
           END IF
C
C          WRITE(IDEV,1003)IDID
C1003      FORMAT(' DASSL CODE RETURNED IDID = ',I5)
           NFCN = JACPVT(12)
           NOINV= JACPVT(13)
           NOSTEP = JACPVT(11)
           NOSOLV = ISTAT(4)
           IF(IDID .GT. 0)THEN
              INFORM(1) = 2
              KFLAG = 1
           END IF
      END IF
       IF(ITRACE .GE. 1)WRITE(IDEV,888)T,TOUT,INFORM(1)
 888   FORMAT(' T AND TOUT = ',2D13.5,'  ISTATE = ',I3)
C                        COLLECT THE INTEGRATION STATISTICS
       IF(IODE .LT. 3)THEN
          NFCN   = INFORM(7)
          NOSTEP = INFORM(6)
          NOINV  = INFORM(8)
          NOSOLV = INFORM(11)
       END IF
       CALL TIMER(TTIME,2)
   50  WRITE(IDEV,999) NOSTEP,NFCN,NOINV,NOSOLV,TTIME,INFORM(1),T,IEFAIL
  999  FORMAT('0',2X,I5,2X,I5,3X,I4,5X,I4,7X,D11.3,4X,I2,4X,D10.4,2X,I5)
2000  CONTINUE
      STOP
      END
      SUBROUTINE RES( N, T, Y, YDOT, R, IRES, RWORK, NR)
C**********************************************************************
C     EXAMPLE O.D.E. RESIDUAL ROUTINE
C**********************************************************************
      INTEGER I, N, IRES, NR
      DOUBLE PRECISION T, Y(2), YDOT(2), R(2), RWORK(1)
      DOUBLE PRECISION PHI
      IF(IRES .EQ. -1)THEN
         R(2) = 0.0D0
         R(1) = -YDOT(1)
      ELSE
         R(2) =  Y(1) - PHI(T)
         R(1) =  Y(2) - YDOT(1)
      END IF
      RETURN
      END
      SUBROUTINE RESDAS( T, Y, YDOT, R, IRES, RWORK, NR)
C**********************************************************************
C     EXAMPLE O.D.E. RESIDUAL ROUTINE
C**********************************************************************
      INTEGER I, N, IRES, NR
      DOUBLE PRECISION T, Y(2), YDOT(2), R(2), RWORK(1)
      DOUBLE PRECISION PHI
      R(1) =  Y(1) - PHI(T)
      R(2) =  Y(2) - YDOT(1)
      RETURN
      END
        SUBROUTINE MONITR( N, T,HOLD, H, Y, YDOT, YSAVE, NYH, R, ACOR,
     1       RESWK, NRESWK, WKMON, NWKMON, IMON, INLN, HMIN, HMXI)
C**********************************************************************
C SIMPLE EXAMPLE MONITOR TO PRINT INTERMEDIATE RESULTS WHEN ITRACE > 0
C**********************************************************************
        INTEGER N, NYH, NRESWK, NWKMON, IMON, INLN, ITRACE, IDEV
        DOUBLE PRECISION T, H, Y(2), YDOT(2), YSAVE(NYH,2), R(2), HOLD,
     1          ACOR(2), RESWK(NRESWK), WKMON(NWKMON), HMIN, HMXI, TEM,
     2          Z(4), ZDOT(2), PHI, DPHI, DDPHI
        COMMON /SDEV2/ ITRACE, IDEV
        Z(1) = PHI(T) - Y(1)
        Z(2) = DPHI(T) - Y(2)
        Z(3) = DPHI(T)  - YDOT(1)
        Z(4) = DDPHI(T) - YDOT(2)
        IF(ITRACE .GE. 2)WRITE(IDEV,9)T,Y(1),Y(2),Z(1),Z(2)
        IF(ITRACE .GE. 2)WRITE(IDEV,8)YDOT(1),YDOT(2),Z(3),Z(4)
  9     FORMAT(' AT T= ',D13.5,' SOL IS',2D11.3,' ERROR IS ',2D11.3)
  8     FORMAT(20X,' DERIVS',2D11.3,' ERROR IS ',2D11.3)
        RETURN
        END
        DOUBLE PRECISION FUNCTION PHI( T )
        DOUBLE PRECISION T, ALPHA, BETA, PI
        COMMON /EGS/ ALPHA, BETA, PI
C
        PHI = DSIN( 2 * PI * T ) + ALPHA * DTANH(BETA*(T-0.5D0))
        RETURN
        END
        DOUBLE PRECISION FUNCTION DPHI( T )
        DOUBLE PRECISION T, ALPHA, BETA, PI
        COMMON /EGS/ ALPHA, BETA, PI
C
        DPHI = 2.0D0 * PI *DCOS(2.D0*PI*T) +
     1         ALPHA*BETA/(DCOSH(BETA*(T-0.5D0)) **2)
        RETURN
        END
        DOUBLE PRECISION FUNCTION DDPHI( T )
        DOUBLE PRECISION T, ALPHA, BETA, PI
        COMMON /EGS/ ALPHA, BETA, PI
C
        DDPHI = -4.0D0 * PI * PI * DSIN(2.D0*PI*T) -
     1           2.D0*ALPHA*BETA**2 * DTANH(BETA*(T-0.5D0))  /
     2                             (DCOSH(BETA*(T-0.5D0))**2)
        RETURN
        END
C *******************************************************************
        SUBROUTINE JAC(NEQN,T,Y,YDOT,H,D,ML,MU,P,NROWP)
        INTEGER ML,MU,NROWP,NEQN
        DOUBLE PRECISION T,Y(NEQN),YDOT(NEQN),H,D,P(NROWP,NEQN)
           P(2,1)=   H*D
           P(2,2)=   0.0D0
           P(1,1)=  -1.0D0
           P(1,2)=   H*D
        RETURN
        END
C **********************************************************************
        SUBROUTINE JACDEF(T,Y,YDOT,P,CJ,RPAR,IPAR)
C       JAC ROUTINE FOR DASSLD
        INTEGER IPAR,I,J
        DOUBLE PRECISION T,Y(2),YDOT(2),CJ,P(2,2),RPAR
        DO 80 I=1,NEQN
            DO 80 J=1,NEQN
            P(I,J)=0.0D0
 80     CONTINUE
           P(1,1)=1.0D0
           P(1,2)=0.0D0
           P(2,1)=-CJ
           P(2,2)=1.0D0
        RETURN
        END
