C***********************************************************************
C     EXAMPLE SIMPLE DRIVER ROUTINE FOR ODE PROBLEMS.
C***********************************************************************
       INTEGER NEQN, LRW, ITOL, INFORM(17), NRESWK, JACPVT(3),
     1          NWKMON, MAXORD, ISET, NYSAVE, JSINFO(4), NY2DIM
       INTEGER  LIW, ITRACE, IDEV,  I, NFCN, NOINV, NOSOLV, NOSTEP
       DOUBLE PRECISION T,TOUT, Y(3), RWORK(100), REL,ABS, RESWK(1),
     1         YSAVE(3,14), WKJAC(400), WKMON(1), YDOT(3), TTIME
       CHARACTER*6 JNORM
       EXTERNAL RES, SBLEND, PREPJF, SOLSF, MONITR, JAC, SPGEAR,STHETA
       COMMON /SDEV2/ ITRACE, IDEV
C          SETUP THE PROBLEM INPUTS AND THE OPTIONAL OUTPUTS FOR SPRINT
       NRESWK = 1
       NWKMON = 1
       NWKJAC = 400
       LRW    = 100
       REL    = 0.1D-2
       ABS    = 0.1D-2
       IDEV = 4
       ITRACE = 1
       ITOL   = 1
       MAXORD = 11
       LIW    = 3
       JNORM = 'L2NORM'
       NY2DIM = 14
       NEQN = 3
       NYSAVE = 3
       T = 0.0D0
       TOUT = 20.0D0
       CALL TIMER(TTIME,1)
       Y(1) = 5.0D0
       Y(2) = 0.0D0
       Y(3) = 300.0D0
       RWORK(5) = 0.0
       RWORK(6) = 1.0D0
       RWORK(7) = 0.1D-15
       INFORM(1) = 0
       INFORM(2) = 1
       INFORM(3) = 1
       INFORM(4) = 1000
       DO 19 I = 5,17
C        SET THE UNUSED PART OF INFORM TO 0
         INFORM(I) = 0
 19    CONTINUE
C             CALL THE SETUP ROUTINES AND SPRINT IF THE SETUPS ARE O.K.
      CALL MATSET( 2, NEQN, JACPVT(1), JACPVT(2), NWKJAC, LIW, ISET)
      IF(ISET .LT. 0)THEN
         WRITE(IDEV,20)
 20      FORMAT(' SETUP FAILED IN MATSET')
         stop
      END IF
C     CALL THESET( NY2DIM, ISET)
      MAXORD = 6
      CALL BDFSET( NY2DIM, ISET, MAXORD, 1, .FALSE.)
C     MAXORD = 12
C     CALL BDFSET( NY2DIM, ISET, MAXORD, 2, .FALSE.)
C     MAXORD = 11
C     CALL BLDSET( NY2DIM, ISET, MAXORD)
      IF(ISET .LT. 0)THEN
         WRITE(IDEV,21)
 21      FORMAT(' SETUP FAILED IN INTEGRATOR INITIALISATION')
         stop
      END IF
      WRITE(IDEV,1002)
 1002 FORMAT(/'0',2X,'#STEPS',2X,'#FCN',2X,'#DECOMP',2X,'#SOLVE',2X,
     1       'CPU TIME',2X,'ISTATE',2X,'STOP AT TF'/)
      CALL SPRINT( NEQN, T, TOUT, Y, YDOT, RWORK, LRW, REL, ABS, ITOL,
     1        INFORM, JNORM, RES, RESWK, NRESWK, SPGEAR,YSAVE, NYSAVE,
     2        PREPJF, WKJAC, NWKJAC, JACPVT, JAC, SOLSF, MONITR, WKMON,
     3        NWKMON)
       WRITE(IDEV,888)T,TOUT,INFORM(1)
 888   FORMAT(' T AND TOUT = ',2D13.5,'  ISTATE = ',I3)
C                        COLLECT THE INTEGRATION STATISTICS
       NFCN   = INFORM(7)
       NOSTEP = INFORM(6)
       NOINV  = INFORM(8)
       NOSOLV = INFORM(11)
       CALL TIMER(TTIME,2)
   50  WRITE(IDEV,999) NOSTEP,NFCN,NOINV,NOSOLV,TTIME,INFORM(1),T
  999  FORMAT('0',2X,I5,2X,I5,3X,I4,5X,I4,7X,D11.3,4X,I2,4X,D10.4)
      STOP
      END
      SUBROUTINE RES( N, T, Y, YDOT, R, IRES, RWORK, NR)
C**********************************************************************
C     EXAMPLE O.D.E. RESIDUAL ROUTINE
C**********************************************************************
      INTEGER I, N, IRES, NR
      DOUBLE PRECISION T, Y(1), YDOT(1), R(1), RWORK(1)
      DOUBLE PRECISION DKF, DKB, AF, AB, EF, EB, S
      DATA AF,EF,AB,EB,S/1.0D+13, 83736.D0,1.D+19, 125604.D0 , 8.3143D0/
      IF(IRES .EQ. -1)THEN
         DO 10 I = 1,N
 10         R(I) = -YDOT(I)
      ELSE
         DKF= AF*DEXP( -EF / (S*Y(3)))
         DKB= AB*DEXP( -EB / (S*Y(3)))
         R(1) =  - DKF * Y(1) + DKB * Y(2)                 - YDOT(1)
         R(2) =    DKF * Y(1) - DKB * Y(2)                 - YDOT(2)
         R(3) =   (DKF * Y(1) - DKB * Y(2)) * 10.D0/1.09D0 - YDOT(3)
      END IF
      RETURN
      END
        SUBROUTINE MONITR( N, T,HOLD, H, Y, YDOT, YSAVE, NYH, R, ACOR,
     1       RESWK, NRESWK, WKMON, NWKMON, IMON, INLN, HMIN, HMXI)
C**********************************************************************
C SIMPLE EXAMPLE MONITOR TO PRINT INTERMEDIATE RESULTS WHEN ITRACE > 0
C**********************************************************************
        INTEGER N, NYH, NRESWK, NWKMON, IMON, INLN, ITRACE, IDEV
        DOUBLE PRECISION T, H, Y(1), YDOT(1), YSAVE(NYH,1), R(1), HOLD,
     1          ACOR(1), RESWK(NRESWK), WKMON(NWKMON), HMIN, HMXI, TEM
        COMMON /SDEV2/ ITRACE, IDEV
        IF(ITRACE .GE. 1)WRITE(IDEV,9)T,(Y(I),I = 1,N)
  9     FORMAT(' AT T= ',D13.5,' SOL IS',3D11.3)
C       IMON = -2
        RETURN
        END
        SUBROUTINE JAC
C       DUMMY ROUTINE FOR THE LOADER
        RETURN
        END
