        INTEGER NEQ, NV, NXI, M, MAXNPT, NPTS, NPDE, NEQMAX, NWKMON,
     1          NRW, IBAND, ITIME, I, NY2DIM,MAXORD,ISET,NWKJAC,ITRACE,
     2          LIW, NEL, JACPVT(50), JSINFO(4), ITOL, INFORM(50), IDEV
        DOUBLE PRECISION T, TOUT, Y(41), YDOT(41), RWORK(144), RTOL,
     1          ATOL, WKRES(300), YSAVE(41,8), WKJAC(600), WKMON,
     2          X(41), XI, TINC, TEND, ALPHA, BETA, GAMMA, EPS
        LOGICAL REMESH
        CHARACTER*6 SNORM
C
C         DECLARE NAMES OF SPRINT ROUTINES USED.
C
        EXTERNAL SKLRES, SPGEAR, PREPJS, SOLSS, SPRMON, SPRJAC
C
C         COMMON BLOCK FOR MATERIAL PROPERTIES OF PROBLEM.
C
        COMMON /TPROPS/ ALPHA, BETA, GAMMA, EPS
        COMMON /SDEV2/ ITRACE, IDEV
        ALPHA = 1.0D0
        BETA  = 0.1D0
        GAMMA = 1.0D0
        EPS   = 0.1D0
C SPRINT WITH GEAR INTEGRATION AND SKEEL SPACE DISCR.
        IDEV  = 4
C EXAMPLE PROGRAM BASED ON A SIMPLE CHEMICAL REACTOR MODEL (CYLINDER)
      NV = 0
      NXI = 0
      XI = 0.0D0
C SET M FOR SPACE CO-ORDINATE TYPE
C  M = 0 FOR CARTESIAN,  = 1 FOR CYLINDRICAL, = 2 FOR SPHERICAL
      M = 1
C PDE AND SPACE SIZES:
C MAXNPT ALSO USED FOR FIXED ARRAY DIMENSIONS IN MONITOR - MONITR
      MAXNPT=41
      NPTS = 31
      NPDE = 1
      NEQ = NPDE * NPTS + NV
      NEQMAX = NPDE * MAXNPT + NV
C
C MONITOR WORKSPACE SIZE
      NWKMON = 1
C NRW IS SIZE OF RWORK INTEGRATOR WORKSPACE
      NRW = 21 + 3*NEQMAX
C
C SPACE MESH INFO.: MESH SPACING X(1)...X(NPTS)
      X(1)=0.0D0
      X(NPTS) = 1.0D0
      DO 10 I = 2, NPTS-1
 10      X(I)=X(1)+(I-1)*(X(NPTS)-X(1))/(NPTS-1)
C
C CALL THE SKEEL DISCRETISATION INITIALISATION ROUTINE
C WKRES IS THE WORKSPACE USED BY SKEEL ROUTINE HAS TO BE OF SIZE AT LEAS
C NPDE*(NPTS*2+NXI*6+17) + NXI + NV + 2*NPDE(MAXNPT-NPTS) + 4*MAXNPT
C
      NWKRES = 300
      IBAND = 0
C ITIME - SHOULD BE SET TO 1 ON THE 1ST CALL (=2 VALUE USED FOR REMESHIN
      ITIME = 1
C REMESH INFO ( IF TRUE EXTRA INFO. IS NEEDED SEE later SECTION   )
      REMESH = .FALSE.
      CALL INITSK( NEQ, NPDE, NPTS, X, Y, WKRES, NWKRES, M, T, IBAND,
     1             ITIME, REMESH, MAXNPT, NV, NXI, XI)
      IF(ITIME .LT. 0)THEN
         WRITE(IDEV,902)ITIME
902      FORMAT('0 SETUP FAILURE IN INITSK',I3)
         STOP
      ENDIF
C
C  O.D.E. INTEGRATOR INITIALISATION CALL
C
      NY2DIM = 8
      MAXORD = 5
      ISET = 0
      CALL BDFSET( NY2DIM, ISET, MAXORD, 2, .TRUE.)
      IF(ISET .LT. 0)GO TO 100
C
C LINEAR ALGEBRA INITIALISATION CALL
C
      ISET = 0
      LIW = 50
      NEL = 125
      NWKJAC = 600
      CALL SMTSET( NEQ, 2, 0.0D0, NWKJAC, LIW, NEL, ISET, JSINFO)
      IF(ISET .LT. 0)GO TO 100
C
      SNORM = 'L2NORM'
      INFORM(1) = 0
      INFORM(2) = 1
      DO 50 I = 3,14
50       INFORM(I) = 0
      ITOL = 1
      RTOL = 0.1D-3
      ATOL = 0.1D-3
      TINC = 0.1D0
      T    = 0.0D0
      TEND = 1.0D0
C
C TIME LOOP:
100   TOUT = T + TINC
C       SPARSE MATRIX ROUTINES USED.
        CALL SPRINT( NEQ, T, TOUT, Y, YDOT, RWORK, NRW, RTOL, ATOL,
     1        ITOL, INFORM, SNORM, SKLRES, WKRES, NWKRES, SPGEAR, YSAVE,
     2        NEQMAX, PREPJS, WKJAC, NWKJAC, JACPVT, SPRJAC, SOLSS,
     3        SPRMON, WKMON, NWKMON)
       WRITE(IDEV,81)TOUT,INFORM(1)
81     FORMAT('  SOL AT',D12.4,'         INFORM(1) =',I3,/
     - '   X        U')
       WRITE(IDEV,85)(X(I),Y(I),I=1,NPTS)
85     FORMAT(1H ,2F10.5)
C
C CHECK IF INTEGRATION SUCCESSFUL AND WHETHER FURTHER TIME STEPS NEEDED
       IF(TOUT.LT.TEND.AND.INFORM(1).EQ.2)GO TO 100
      STOP
      END
C
      SUBROUTINE UINIT( NPDE, NPTS, X, U)
C Routine for p.d.e. initial values
      INTEGER NPDE, NPTS
      DOUBLE PRECISION X(NPTS), U(NPDE,NPTS)
      DO 10 I=1,NPTS
 10      U(1,I) = 0.0D0
      RETURN
      END
C
      SUBROUTINE SPDEF1( T, X,NPDE, U, DUDX, C, Q, R, NV, V, VD, IRES)
C ROUTINE TO DESCRIBE THE P.D.E. SYSTEM IN THE SKEEL EQN.FORM (5.1).
C SPDEF1 IS CALLED FOR EACH MESH POINT IN TURN BY SKLRES.
      INTEGER NPDE, I, J, NV, IRES
      DOUBLE PRECISION T, X, U(NPDE), DUDX(NPDE),
     1         C(NPDE,NPDE), Q(NPDE), R(NPDE), V(1), VD(1),
     2         ALPHA,BETA,GAMMA,EPS
      COMMON/TPROPS/ALPHA,BETA,GAMMA,EPS
      DO 9 J = 1,NPDE
          C(J,J) = ALPHA
          R(J) = BETA*DUDX(J)
          Q(J) = -GAMMA*DEXP(U(J)/(1+EPS*U(J)) )
  9   CONTINUE
      RETURN
      END
      SUBROUTINE BNDR( T, BETA, GAMMA,U,UX,NPDE, LEFT, NV, V, VD, IRES)
C SPECIFIES THE BOUNDARY CONDITIONS IN MASTER EQN. FORM (5.2); THE FORM
C of the flux function R is specified in SPDEF1
      INTEGER NPDE, I, J, NV, IRES
      DOUBLE PRECISION T, BETA(NPDE), GAMMA(NPDE), U(NPDE), UX(NPDE),
     1       V(1), VD(1)
      LOGICAL LEFT
C FLUX B.C.S AT BOTH ENDS, SYMMETRY CONDITION AT XLEFT = 0
C R() = RLAM*DU/DX = GAMMA()
          BETA(1) = 1.0D0
       IF(LEFT) THEN
          GAMMA(1) = 0.0D0
       ELSE
          BETA(1) = 0.0D0
          GAMMA(1) = U(1) - 0.0D0
       END IF
      RETURN
      END
      SUBROUTINE SODEFN(T, NV, V, VDOT, NPDE, NXI, XI, UI, UXI, RI,
     1                  UTI, UTXI, VRES, IRES)
C ROUTINE FOR AUXILIARY O.D.E.S (IF ANY) IN MASTER EQN. FORM (5.3)
      INTEGER NPDE, NXI, NV, IRES
      DOUBLE PRECISION T, XI(NXI), UI(NPDE,NXI), UXI(NPDE,NXI),
     1        RI(NPDE,NXI), UTI(NPDE,NXI), UTXI(NPDE,NXI), VRES(NV),
     2        V(NV), VDOT(NV), TEM
      RETURN
      END
C
      SUBROUTINE SVINIT( V,NV)
C Routine for initial values of auxiliary o.d.e.s (if any)
       INTEGER NV
       DOUBLE PRECISION V(NV)
C SVINIT NOT USED IN THIS EXAMPLE
       RETURN
       END
