      SUBROUTINE SVDJOB(A,B,D,E,HS,W,WH,W3,ZC,IPVT,IND1,IND2,
     +                   S,ES,U,V,NX,NU,NY,NA,NB,ND,P,IP,ITER,DW)
C---------------------------------------------------------------C
C***BEGIN PROLOGUE SVDJOB                                       C
C   AUTHOR : David Di Ruscio    ITK/NTH 30/11 1988              C
C                                                               C
C   PURPOSE                                                     C
C   SVDJOB computes transfer matrix H(jw)=D*((jw-A)inv))*B+E    C
C   and the singualar values of H(jw) for all specified         C
C   frequencies w.                                              C
C                                                               C
C   ON INPUT                                                    C
C   A    DOUBLE PRECISION(NA,NX) dimension (NX,NX).             C
C   B    DOUBLE PRECISION(NB,NU) dimension (NX,NU).             C
C   D    DOUBLE PRECISION(ND,NU) dimension (NY,NX).             C
C   E    DOUBLE PRECISION(ND,NU) dimension (NY,NU).             C
C   W    DOUBLE PRECISION scaler.                               C
C               Start computation at frequensy W.               C
C   DW   DOUBLE PRECISION scalar. Sample interval.              C
C   ITER INTEGER number of samples. (frequensy computations)    C
C                                                               C
C   ON OUTPUT                                                   C
C   P    REAL            (IP,NX). Array containing the computed C
C        singular values.                               -1      C
C   HS   COMPLEX*16 (ND,NU) contains the matrix D*(jw-A)  B+E   C
C        at the last computed frequensy.                        C
C                                                               C
C   ROUTINES CALLED : DFREQ, (EISPACK EXTENDED)                 C
C                     ZSVDC, (LINPACK)                          C
C***END PROLOGUE SVDJOB                                         C
C---------------------------------------------------------------C
      INTEGER NX,NU,NY,NA,NB,ND,IPVT(NX),IND1(*),IND2(*)
      INTEGER INFO1,INFO2,JOB
      INTEGER*4 ITER
      DOUBLE PRECISION A(NA,NX),B(NB,NU),D(ND,NX),E(ND,NU),W3(NB)
      COMPLEX*16 WI,HS(ND,NU),WH(NA,NX),ZC(NA)
      COMPLEX*16 S(NA),ES(NA),U(NA,NA),V(NA,NA)
      REAL P(IP,NX)              
      DOUBLE PRECISION W,DW,SVAL
      CHARACTER CFORM*12

C1.. Initialization                             .................
      CFORM = '(5X,A,1X,I3)'
      INFO1 = 1
      WT    = W

C2.. Go through all specified frequencies       .................
      DO 10 II = 1,ITER

        WI = CMPLX(0.0,WT)

C... Compute HS(jw)=D*(jw-A)inv*B+E             .................
        CALL DFREQ(INFO1,WI,NX,NU,NY,NA,NB,ND,ND,ND,NA,A,B,D,E,HS,
     +               WH,IPVT,W3,ZC,IND1,IND2)
        IF (INFO1.NE.0) THEN
         WRITE(*,CFORM)'* INFO DFREQ = ',INFO1
        ENDIF

C... Compute singular values of HS(jw)  .........................
        JOB = 11
        CALL ZSVDC(HS,ND,NY,NU,S,ES,U,NA,V,NA,ZC,JOB,INFO2)
        IF (INFO2.NE.0) THEN
         WRITE(*,CFORM)'* INFO SVD   = ',INFO2
        ENDIF

C... Store abs value of computed singular values        .........
        DO 20 I = 1,NU
           W3(I) = CDABS(S(I))
CUT        SVAL = W3(I)
CUT        P(II,I)= 20.0*ALOG10(SVAL)
           P(II,I) = W3(I)
20      CONTINUE

C... Uppdate frequency parameter w (WT)         .................
        WT = WT + DW

10    CONTINUE

      RETURN
      END
