function [h] = kov5(y,u,k,rm);
%        [h] = kov5(y,u,k,rm);
%
%  Compute h = E(y_(i+k) u_i')  for all  k=0,1,2,3,4,5, ....,k
%  rm = 1 --> mean removed       (cross-covariance)
%  rm = 0 --> mean not removed   (cross-correlation)
%
%  Return unbiased estimate
%
[Ny,ny] = size(y);
[Nu,nu] = size(u);
N = min([Ny,Nu]);

% Remove mean
if rm == 1
  for i=1:ny
    y(:,i) = y(:,i) - mean(y(:,i))*ones(N,1);
  end
  for i=1:nu
    u(:,i) = u(:,i) - mean(u(:,i))*ones(N,1);
  end
end

ip = 0;
for i=1:k
  h(ip+1:ip+ny,1:nu)= y(i:N,:)'*u(1:N-i+1,:)/(N-i);
% merk, slik gjores det o xcov
% h(ip+1:ip+ny,1:nu)= y(i:N,:)'*u(1:N-i+1,:)/(N-i+1);
  ip = ip+ny;
end
