      SUBROUTINE COMCHK(CSTR,CDAT,IDAT,IFLAG,IPOS)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE COMCHK                                       C
C   AUTHOR : David Di Ruscio            ITK/NTH 18/2 89         C
C                                                               C
C   PURPOSE                                                     C
C   COMCHK is used to check a input command CSTR against an     C
C   array of legal defined commands CDAT.                       C
C                                                               C
C   ON INPUT                                                    C
C   CSTR  CHARACTER*(*) specified command.                      C
C   CDAT  CHARACTER(IDAT)*N defined array of legal commands.    C
C   IDAT  INTEGER actual lenght of array CDAT.                  C
C   ON OUTPUT                                                   C
C   IFLAG INTEGER . IFLAG = 0 if legal command.                 C
C                   IFLAG = 1 if unlegal command.               C
C   IPOS  INTEGER. Determines the position of legal command     C
C         in command array CDAT. Ie. CDAT(IPOS) is legal comand C
C                                                               C
C   ROUTINES CALLED: LENS, CHCHNG                               C
C***END PROLOGUE COMCHK                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER IDAT,IFLAG,IPOS
      CHARACTER CSTR*(*),CDAT(IDAT)*(*)
C... Local parameters
      CHARACTER CW1*80,CW2*80
      INTEGER I,NSTR,JDAT

C1... Initialize and compute actual lenght of CSTR and CDAT ....
      IFLAG = 0
      IPOS  = 0
      NSTR  = LENS( CSTR )

C2... Change small letters in CSTR to large letters
      CW1(1:NSTR) = CSTR(1:NSTR)
      CALL CHCHNG(CW1)

C3... Check if CSTR is a legal command                  ........
      DO 10 I=1,IDAT
         JDAT = LENS( CDAT(I) )
         CW2(1:JDAT) = CDAT(I)(1:JDAT)
         CALL CHCHNG(CW2)
CUT      IF (CSTR(1:NSTR).EQ.CDAT(I)(1:JDAT)) THEN
         IF (CW1(1:NSTR).EQ.CW2(1:JDAT)) THEN
          IPOS = I
          RETURN
         ENDIF
10    CONTINUE

C4... Return error signal if unlegal cmmand             .........
      IFLAG = 1
      
      END


