      SUBROUTINE COMSTR(CSTR,CDAT,IDAT,COUT,IFLAG,INFO)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE COMSTR                                       C
C   AUTHOR   David Di Ruscio            NTH/ITK  18/2 - 1989    C
C                                                               C
C   PURPOSE                                                     C
C   COMSTR is used to check an input string CSTR of commands    C
C   or symbols separated by comma or space against an array     C
C   CDAT(IDAT) of defined legal symbols.                        C
C   EX. On input, CDAT(1)='A', CDAT(2)='B', CDAT(3)='C', IDAT=3.C
C       Then  CSTR = 'A,C' will result in COUT(1)='A',          C
C       COUT(2)=' ', COUT(3)='C' and IFLAG=0.                   C
C                                                               C
C   ON INPUT                                                    C
C     CSTR   Input character string of commands sepatated by    C
C            a comma or a space.                                C
C     CDAT   CHARACTER(IDAT)*(*) array of legal commands. The   C
C            array could be stored as a data-block in the       C
C            calling program.                                   C
C     IDAT   INTEGER size of array CDAT in calling program.     C
C     INFO(1)INTEGER parameter defining the position whitch the C
C            legal command shall be stored in output array COUT.C
C                                                               C
C     ON OUTPUT                                                 C
C     COUT   CHARACTER(*)*(*) array. The legal commands in CSTR C
C            will be stored from position COUT(JPOS) to         C
C            COUT(JPOS+IDAT) at the same position as the legal  C
C            symbols is stored in CDAT(1) to CDAT(IDAT).        C
C                                                               C
C     IFLAG  INTEGER. IFLAG = 1 on output means that an         C
C            unlegal symbol is detected in input string CSTR.   C
C            IFLAG = 0 if the string is a legal one.            C
C     INFO   INTEGER(3) array.                                  C
C            INFO(2) = actual lenght of CSTR*(*).               C
C            INFO(3) = actual lenght of COUT(1)*(*)             C
C                                                               C
C   ROUTINES CALLED : COMCHK, COMLIS, LENS                      C
C***END PROLOGUE COMSTR                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER IFLAG,IDAT,JPOS,INFO(4),NOUT,NSTR
      CHARACTER CSTR*(*),CDAT(IDAT)*(*),COUT(*)*(*)
      CHARACTER COMMA*1,SPACE*1,CF*11
      DATA COMMA/','/, SPACE/' '/
      CF = '(5X,A,2X,A)'

      IF (INFO(1).EQ.0) THEN
       JPOS = 1
      ELSE
       JPOS = INFO(1)
      ENDIF
C1... Compute actual lenght of input strings           ..........
      NOUT = LENS( COUT(1) )
      NSTR = LENS( CSTR    )
      INFO(2) = NSTR
      INFO(3) = NOUT

C2... Reset array COUT                                 ..........
      DO 10 I=1,IDAT
         N = I+JPOS-1
         NOUT = LENS( COUT(N) )
         COUT(N)(1:NOUT) = ' '
10    CONTINUE

C3.. Check set of commands defined in input string CSTR against
C    array of legal commands stored in CDAT(IDAT)................
      NC=1
      IS=1
      DO 30 K=NC,NSTR+1
         IF (CSTR(K:K).EQ.COMMA.OR.CSTR(K:K).EQ.SPACE) THEN
          NC = K
          CALL COMCHK(CSTR(IS:NC-1),CDAT,IDAT,IFLAG,IPOS)

          IF (IFLAG.EQ.0) THEN
           COUT(IPOS+JPOS-1) = CDAT(IPOS)
          ELSEIF (IFLAG.EQ.1) THEN
           WRITE(*,CF)'---> ERROR SYMBOL OR COMMAND :',CSTR(IS:NC-1)
           CALL COMLIS('ERROR, avaiable is :',CDAT,IDAT)
           GO TO 1000
          ENDIF

          IS = NC+1
         ENDIF
30    CONTINUE

1000  RETURN
      END

