       PROGRAM CPUT
C TEST PROGRAM FOR A MINI PARSE COMPILER
       INTEGER NSTR,ISYS,INFO(3)
       CHARACTER CPRO*25,CINP*17,COUT(10)*4,CEST(5)*2,CSYS(4)*1

       DATA CSYS(1)/'A'/, CSYS(2)/'B'/, CSYS(3)/'C'/,
     +      CSYS(4)/'D'/
       DATA ISYS/4/
       DATA CEST(1)/'AE'/, CEST(2)/'BE'/, CEST(3)/'CE'/,
     +      CEST(4)/'DE'/, CEST(5)/'KA'/
       DATA IEST/5/

       CINP = 'AE,BE,CE,DE,KA'
       CPRO = 'A,B,C,D'

100    CALL RCSTR('Specify PROCESS matrixes',CPRO,1,1,1)
       WRITE(*,*)'CPRO = ',CPRO
       INFO(1) = 1
       CALL COMSTR(CPRO,CSYS,ISYS,COUT,IFLAG,INFO)
       IF (IFLAG.NE.0) THEN
        CPRO = 'A,B,C,D'
        GO TO 100
       ENDIF

200    CALL RCSTR('Specify ESTIMATOR matrixes',CINP,1,1,1)
       INFO(1) = 5
       CALL COMSTR(CINP,CEST,IEST,COUT,IFLAG,INFO)
       IF (IFLAG.NE.0) THEN
        CINP = 'AE,BE,CE,DE,KA'
        GO TO 200
       ENDIF

       N = ISYS+IEST
       CALL COMLIS('SPECIFIED SYSTEM IS :',COUT,N)

       GO TO 100
       END

      SUBROUTINE COMSTR(CSTR,CDAT,IDAT,COUT,IFLAG,INFO)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE COMSTR                                       C
C   AUTHOR   David Di Ruscio            NTH/ITK  18/2 - 1989    C
C                                                               C
C   PURPOSE                                                     C
C   COMSTR is used to check an input string CSTR of commands    C
C   or symbols separated by comma or space against an array     C
C   CDAT(IDAT) of defined legal symbols.                        C
C   EX. On input, CDAT(1)='A', CDAT(2)='B', CDAT(3)='C', IDAT=3.C
C       Then  CSTR = 'A,C' will result in COUT(1)='A',          C
C       COUT(2)=' ', COUT(3)='C' and IFLAG=0.                   C
C                                                               C
C                                                               C
C   ON INPUT                                                    C
C     CSTR   Input character string of commands sepatated by    C
C            a comma or a space.                                C
C     CDAT   CHARACTER(IDAT)*(*) array of legal commands. The   C
C            array could be stored as a data-block in the       C
C            calling program.                                   C
C     IDAT   INTEGER size of array CDAT in calling program.     C
C     INFO(1)INTEGER parameter defining the position whitch the C
C            legal command shall be stored in output array COUT.C
C                                                               C
C     ON OUTPUT                                                 C
C     COUT   CHARACTER(*)*(*) array. The legal commands in CSTR C
C            will be stored from position COUT(JPOS) to         C
C            COUT(JPOS+IDAT) at the same position as the legal  C
C            symbols is stored in CDAT(1) to CDAT(IDAT).        C
C                                                               C
C     IFLAG  INTEGER. IFLAG = 1 on output means that an         C
C            unlegal symbol is detected in input string CSTR.   C
C            IFLAG = 0 if the string is a legal one.            C
C     INFO   INTEGER(3) array.                                  C
C            INFO(2) = actual lenght of CSTR*(*).               C
C            INFO(3) = actual lenght of COUT(1)*(*)             C
C                                                               C
C   ROUTINES CALLED : COMCHK, COMLIS, LENS                      C
C***END PROLOGUE COMSTR                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER IFLAG,IDAT,JPOS,INFO(4),NOUT,NSTR
      CHARACTER CSTR*(*),CDAT(IDAT)*(*),COUT(*)*(*)
      CHARACTER COMMA*1,SPACE*1,CF*11
      DATA COMMA/','/, SPACE/' '/
      CF = '(5X,A,2X,A)'

      IF (INFO(1).EQ.0) THEN
       JPOS = 1
      ELSE
       JPOS = INFO(1)
      ENDIF
C1... Compute actual lenght of input strings           ..........
      NOUT = LENS( COUT(1) )
      NSTR = LENS( CSTR    )
      INFO(2) = NSTR
      INFO(3) = NOUT

C2... Reset array COUT                                 ..........
      DO 10 I=1,IDAT
         N = I+JPOS-1
         NOUT = LENS( COUT(N) )
         COUT(N)(1:NOUT) = ' '
10    CONTINUE

C3.. Check set of commands defined in input string CSTR against
C    array of legal commands stored in CDAT(IDAT)................
      NC=1
      IS=1
      DO 30 K=NC,NSTR+1
         IF (CSTR(K:K).EQ.COMMA.OR.CSTR(K:K).EQ.SPACE) THEN
          NC = K
          CALL COMCHK(CSTR(IS:NC-1),CDAT,IDAT,IFLAG,IPOS)

          IF (IFLAG.EQ.0) THEN
           COUT(IPOS+JPOS-1) = CDAT(IPOS)
          ELSEIF (IFLAG.EQ.1) THEN
           WRITE(*,CF)'---> ERROR SYMBOL OR COMMAND :',CSTR(IS:NC-1)
           CALL COMLIS('ERROR, avaiable is :',CDAT,IDAT)
           GO TO 1000
          ENDIF

          IS = NC+1
         ENDIF
30    CONTINUE

1000  RETURN
      END

      SUBROUTINE RCSTR(TEXT,STR,IDUM1,IDUM2,IDUM3)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE RCSTR                                         C
C   AUTHOR   David Di Ruscio                   ITK/NTH 18/2-1989 C
C                                                                C
C   PURPOSE                                                      C
C   RCSTR is used to read a character string STR*(*) from term.. C
C   ROUTINES CALLED : LENS (integer function)                    C
C                                                                C
C   PARAMETERS                                                   C
C   TEXT    CHARACTER*(*) user specified text.                   C
C   STR     CHARACTER*(*) string to be readed from terminal.     C
C           Old string is keept whit carriage return.            C
C   IDUM    INTEGER dummy parameters for future use and for      C
C           concictensy whit the CYPROS CREAD routine.           C
C   ROUTINES CALLED :  LENS                                      C
C***END PROLOGUE RCSTR                                           C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER BLANK,MAXCHAR,NST,NSTR,NT
      PARAMETER ( BLANK=32 ,MAXCHAR=72 )
      CHARACTER TEXT*(*),STR*(*),CSIGN*72,CARCON*1,CF*12,CDUM*72

C... Carriage controll sign for VAX/VMS                 .........
      DATA CARCON /'0'/

C... Initialize parameters                              .........
      CF = '(5X,A,2X,I2)'
      MAX   = LEN(STR)
      NSTR  = LENS(STR)
      NT    = LENS(TEXT)
      CDUM(1:NSTR) = STR(1:NSTR)

C... Print old and read new character string            ........
5     PRINT 86, CARCON//TEXT(1:NT)//'  (',STR(1:NSTR+1),')  > '
      READ(5,88) CSIGN
      IF ( ICHAR(CSIGN(1:1)).NE.BLANK ) THEN
              READ(CSIGN,87,ERR=9 ) STR
      ENDIF

C... Test number of input characters not grather than MAX  .....
      NFIN = LENS(STR)
      IF (NFIN.GE.MAX) GO TO 8
      GOTO 1000

C... ERROR HANDLING                                     .........
C... If too many characters
8     WRITE(*,CF)'Dont type more character than :',MAX-1
      WRITE(*,'(5X,A)')'TRYE AGAIN !'
      STR(1:NFIN) = ' '
      STR(1:NSTR) = CDUM(1:NSTR)
      GO TO 5
C... If read error
9     PRINT *,' ---> READ ERROR'
      GOTO 5
        
C... Format specifications                              .........
86    FORMAT(A,A,A,A)
87    FORMAT(A)
88    FORMAT(A72)

1000  RETURN
      END

      SUBROUTINE COMCHK(CSTR,CDAT,IDAT,IFLAG,IPOS)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE COMCHK                                       C
C   AUTHOR : David Di Ruscio            ITK/NTH 18/2 89         C
C                                                               C
C   PURPOSE                                                     C
C   COMCHK is used to check a input command CSTR against an     C
C   array of legal defined commands CDAT.                       C
C                                                               C
C   ON INPUT                                                    C
C   CSTR  CHARACTER*(*) specified command.                      C
C   CDAT  CHARACTER(IDAT)*N defined array of legal commands.    C
C   IDAT  INTEGER actual lenght of array CDAT.                  C
C   ON OUTPUT                                                   C
C   IFLAG INTEGER . IFLAG = 0 if legal command.                 C
C                   IFLAG = 1 if unlegal command.               C
C   IPOS  INTEGER. Determines the position of legal command     C
C         in command array CDAT. Ie. CDAT(IPOS) is legal cooman C
C                                                               C
C***END PROLOGUE COMCHK                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER IDAT,IFLAG,IPOS
      CHARACTER CSTR*(*),CDAT(IDAT)*(*)
      INTEGER I,NSTR,JDAT

C1... Initialize and compute actual lenght of CSTR and CDAT ....
      IFLAG = 0
      IPOS  = 0
      NSTR  = LENS( CSTR )

C2... Check if CSTR is a legal command                  ........
      DO 10 I=1,IDAT
         JDAT = LENS( CDAT(I) )
         IF (CSTR(1:NSTR).EQ.CDAT(I)(1:JDAT)) THEN
          IPOS = I
          RETURN
         ENDIF
10    CONTINUE

C3... Return error signal if unlegal cmmand             .........
      IFLAG = 1
      
      END

      SUBROUTINE COMLIS(TEXT,CSYS,ISYS)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE COMLIS                                        C
C   AUTHOR David Di Ruscio                    NTH/ITK 19/2-1989  C
C                                                                C
C   PURPOSE                                                      C
C   COMLIS is used to write a character(*)*(*) array CSYS        C
C   on terminal. TEXT is a user specified text.                  C
C                                                                C
C   ROUTINES CALLED : LENS                                       C
C***END PROLOGUE COMLIS                                          C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER ISYS,K
      CHARACTER TEXT*(*),CSYS(*)*(*)

      WRITE(*,'(5X,A)') TEXT
      WRITE(*,2) ( CSYS(K)(1:LENS(CSYS(K))) , K=1,ISYS )
2     FORMAT(1(5X,6(A,4X)))

      RETURN
      END



      INTEGER FUNCTION LENS( STR )
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE LENS                                         C
C   AUTHOR : David Di Ruscio                                    C
C                                                               C
C   PURPOSE :  To comput actual lenght of a character*(*)       C
C              string STR.                                      C
C   ON INPUT : STR    CHARACTER*(*) string.                     C
C   ON OUTPUT:        Actual lenght of STR.                     C
C                                                               C
C   ROUTINES CALLED :  FORTRAN function LEN.                    C
C***END PROLOGUE LENS                                           C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER I
      INTEGER*4 NST
      CHARACTER STR*(*)

      NST  = LEN( STR )
      DO 10 I=NST,1,-1
         IF ( STR(I:I) .NE. ' ') THEN
            LENS = I
            RETURN
         ENDIF
10    CONTINUE
      LENS = 0

      END

