      SUBROUTINE DREMA(A,W,NI,NIM,NJ,NJM,NAME)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE DREMA                                        C
C                                                               C
C   PURPOSE                                                     C
C   DREMA reads a DOUBLE PRECISION matrix A from terminal.      C
C                                                               C
C   ON INPUT                                                    C
C   A     DOUBLE PRECISION matrix of dimension (NI,NJ)          C
C   NI    INTEGER row dimension on A                            C
C   NJ    INTEGER column dimension on A                         C
C   NIM   INTEGER leading dimension on A in calling program     C
C   NJM   INTEGER leading dimension on A in calling program     C
C   W     DOUBLE PRECISION(NIM) used as work vector             C
C   ON OUTPUT                                                   C
C   A   Matrix A                                                C
C                                                               C
C   ROUTINES CALLED : DREAD, CHARNO, LENS                       C
C   VERSION    : DOUBLE PRECISION                               C
C***END PROLOGUE DREMA                                          C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER I,J,NI,NJ,NIM,NJM,NSTR
       DOUBLE PRECISION A(NIM,NJM),W(NIM)
       CHARACTER TEXT1*5,TEXT2*12,NAME*(*),CNUM*5,CHARNO*5
       TEXT1 = 'Row ('
       TEXT2 = ') in matrix '

C...   Read matrix row for rows           .......................
       DO 10 I=1,NI
          DO 20 J=1,NJ
             W(J)=A(I,J)
20        CONTINUE
          CNUM = CHARNO(I)
          NSTR = LENS(CNUM)
          CALL DREAD(TEXT1//CNUM(1:NSTR)//TEXT2//NAME,W,NJ,NJM,IIII)
          DO 30 J=1,NJ
             A(I,J)=W(J)
             W(J) = 0.0
30        CONTINUE
10     CONTINUE

       RETURN
       END

