      INTEGER FUNCTION ICREAD(TEXT,COM,ICOM,IDEF)
Cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C***BEGIN PROLOGUE ICREAD                                              c
C   AUTHOR:  David Di Ruscio                                           c
C   PURPOSE                                                            c
C   ICREAD reads a command from tty and check this command against     c
C   an array COM(ICOM)*(*) of legal commands. The legal command is     c
C   returned as the position number in COM(ICOM) array.                c
C   ICREAD work identically to the CYPROS routine ICDREAD.             c
C                                                                      c
C   ON INPUT                                                           c
C   TEXT    CHARACTER*(*) leading text.                                c
C   COM     CHARACTER(ICOM)*(*) array of legal commands.               c
C   ICOM    INTEGER leading dimension on COM in calling program.       c
C   IDEF    INTEGER parameter defining which command who shuld be      c
C                   used as default.                                   c
C   ROUTINES CALLED : RCSTR  (read a character string. )               c
C***END PROLOGUE ICREAD                                                c
Cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER ICOM, IDEF
      CHARACTER TEXT*(*), COM(ICOM)*(*)

      INTEGER IPOS,IFLAG
      CHARACTER CJOB*72

C1... First handle default command
100   IF (IDEF.EQ.0) THEN
        CJOB = '0'
      ELSE
        CJOB = COM(IDEF)
      ENDIF

C2... Read possibly new command in CJOB
      CALL RCSTR(TEXT,CJOB,1,1,IIII)

C3... Handle command from number input
C.... Extract a IJOB number from a number command CJOB  
      IPOS = ICNUM(CJOB)
      IF (IPOS.EQ.0) THEN
       ICREAD = 0
       GO TO 1000
      ELSEIF (IPOS.GE.1 .AND. IPOS.LE.ICOM) THEN
       ICREAD = IPOS
       GO TO 1000
      ENDIF

C4... Handle command from character input
C.... Extraxt IJOB number from a character command CJOB 
      CALL COMCHK(CJOB,COM,ICOM,IFLAG,IPOS)
      IF (IFLAG.EQ.0) THEN
        ICREAD = IPOS
       GO TO 1000
      ELSEIF (IFLAG.EQ.1) THEN
       WRITE(*,'(1X,A,1X,A)')'ERROR SYMBOL OR COMMAND :',CJOB
       CALL COMLIS('Available is :',COM,ICOM)
       GO TO 100
      ENDIF

1000  RETURN
      END
