      INTEGER FUNCTION IYESANS(TEXT,IDEF)
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C****Begin prologue IYESANS                                     c
C    Written by  David Di Ruscio                ITK 20/5 -1989  c
C    Purpose                                                    c
C    IYESANS is used to read a Yes No answer from terminal.     c
C    This routine would perform identical to the CYPROS         c
C    roueine IYESREAD. This routine need less storage and are   c
C    constructed to be used on al machines with a FORTRAN       c
C    compiler.                                                  c
C    Example :    ISVAR = IYESANS('Stop program NN ?',2)        c
C                 Default answer is No (2). ISVAR=2 if Yes      c
C                 and ISVAR=1 if No on output.                  c
C    Routines called : RCSTR, COMCHK                            c
C****End prologue IYESANS                                       c
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER IDEF, IIII, ICOM, IOUT, IPOS
      PARAMETER ( ICOM = 16, IOUT = 6)
      CHARACTER TEXT*(*), CANS*4, COM(ICOM)*3
      DATA COM(1)/'yes'/, COM(2)/'Yes'/, COM(3)/'YEs'/, COM(4)/'YES'/,
     +     COM(5)/'yEs'/, COM(6)/'yES'/, COM(7)/'yeS'/, COM(8)/'YeS'/,
     +     COM(9)/'y'/, COM(10)/'Y'/, COM(11)/'N'/, COM(12)/'n'/,
     +     COM(13)/'no'/, COM(14)/'nO'/, COM(15)/'No'/, COM(16)/'NO'/

C1...Initialize default answer                          ............
100   IF (IDEF.EQ.1) THEN
       CANS = 'No'
       IYESANS = 1
      ELSEIF (IDEF.EQ.2) THEN
       CANS = 'Yes'
       IYESANS = 2
      ENDIF

C2...Read new answer from terminal                      ...........
      CALL RCSTR(TEXT,CANS,1,1,IIII)

C3...Check commands                                     ...........
      CALL COMCHK(CANS,COM,ICOM,IFLAG,IPOS)

C.. Legal command
      IF (IFLAG.EQ.0) THEN
C.. Yes
       IF (IPOS.GE.1 .AND. IPOS.LE.10) THEN
        IYESANS = 2 
        RETURN
       ENDIF
C.. No
       IF (IPOS.GE.11 .AND. IPOS.LE.16) THEN
        IYESANS = 1     
        RETURN
       ENDIF

C.. Unlegal symbol/comand
      ELSEIF (IFLAG.EQ.1) THEN
       WRITE(IOUT,'(1X,A)')'Error symbol or command :',CANS
       WRITE(IOUT,'(1X,A)')'Avaiable is             :  Yes or No )'
       GO TO 100
      ENDIF

      END
