      SUBROUTINE MATEDT(TEXT,A,DX,N,M,NA)      
Cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C   Purpose                                                      c
C   MATEDT is used to edit a matrix A(N,M).                      c
C   On input                                                     c
C   TEXT   CHARACTER*(*) leading text for matrix on terminal.    c
C   A      DOUBLE PRECISION(N,M) matrix.                         c
C   DX     DOUBLE PRECISION(N,M) work array.                     c
C   N,M    INTEGER actual row and column dimension for A(N,M).   c
C   NA     INTEGER Leading dimension for A and DX in calling     c
C          program.                                              c
C   Routines called: decod,lens                                  c
Cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER N,M,NA,IERR,IFLAG,I,J,K,IOUT
      PARAMETER (IOUT = 6)
      DOUBLE PRECISION A(NA,NA),DX(NA)
      CHARACTER TEXT*(*),TALL*80        

      K = 1
CUT   OPEN (UNIT=IOUT,STATUS='SCRATCH',FORM='FORMATTED')
100    WRITE(IOUT,1) TEXT                             
       DO 10 I=1,N
          WRITE(IOUT,2) (A(I,J),J=1,M)
10     CONTINUE

       DO 20 I=K,N
          DO 30 J=1,M
             DX(J) = A(I,J)
30        CONTINUE
          WRITE(IOUT,4) I              
C.. Read string of numbers separated with comma or space from tty
          READ (5,3) TALL

          CALL DECOD(TALL,DX,M,NA,IERR,IFLAG)
          IF (IERR.NE.0) GO TO 99
          IF (IFLAG.EQ.1) THEN
           DO 40 J=1,M
              A(I,J) = DX(J)
40         CONTINUE
          ENDIF
          K = K + 1
20     CONTINUE

CUT   CLOSE(UNIT = IOUT)

1     FORMAT(5X,A)
2     FORMAT(5G14.6)
3     FORMAT(A)
4     FORMAT(2X,'Line no. (',I3,' ) :')

      GO TO 1000
99    WRITE(IOUT,'(5X,A)')'Error in double precision syntax'
      GO TO 100

1000  RETURN
      END
