      SUBROUTINE PLTOUT(P,NSAMP,N,NL,NK,DT,IFIL,NAME)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE PLTOUT                                       C
C   AUTHOR : David Di Ruscio            ITK/NTH 11. mars 1989   C
C   PURPOSE                                                     C
C   Output facilities of an array P(NSAMP,N) based on CYPROS    C
C   output routines.                                            C
C   ON INPUT                                                    C
C   NAME   CHARACTER*(*) name of an TS-file (optionally)        C
C   IFIL   INTEGER file number                                  C
C   DT     DOUBLE PRECISION sample intervall (optionally) DT>0  C
C   P      DOUBLE PRECISION(NL,NK) array of numbers to be plotted. C
C   NL,NK  INTEGER leading dimensions for P in calling prog.    C
C   NSAMP  INTEGER number of rows in P(NSAMP,N) array.          C
C   N      INTEGER number of columns in P(NSAMP,N) array.       C
C   ROUTINES CALLED : PROUT1,PROUT2,PROUT3                      C
C***END PROLOGUE PLTOUT                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N,NL,NK,IFIL
      INTEGER *4 NSAMP
      DOUBLE PRECISION P(NL,NK),DT
      CHARACTER NAME*(*)

      INTEGER NCOM,ICOM
      CHARACTER COM(6)*11
      DATA COM(1)/'disp'/,   COM(2)/'keep'/,
     2     COM(3)/'plot'/,   COM(4)/'mat'/,
     3     COM(5)/'return'/, COM(6)/'0'/
      DATA NCOM/6/

      IF (NAME.EQ.' ') NAME = 'pltout.con'

C1... Checks for errors in input parameters             .........
      CALL PLTCHK(NL,NK,NSAMP,N,DT,IFLAG)
      IF (IFLAG.NE.0) GO TO 1000

C2... Choose command from above menu                    .........
      ICOM = 2
100   ICOM = ICREAD('Output command :',COM,NCOM,ICOM)

C3... Execute commands                                  .........
      IF     (ICOM.EQ.1) THEN
       CALL PROUT1(P,NSAMP,N,NL,NK)
       ICOM = 2
       GO TO 100
      ELSEIF (ICOM.EQ.2) THEN
       CALL PROUT2(P,NSAMP,N,NL,NK,DT,IFIL,NAME)
       ICOM = 3
       GO TO 100
      ELSEIF (ICOM.EQ.3) THEN
       CALL PROUT3(P,NSAMP,N,NL,NK,IFIL,NAME)
       ICOM = 5
       GO TO 100
      ELSEIF (ICOM.EQ.4) THEN
cut    CALL PROUT4(P,NSAMP,N,NL,NK,IFIL,NAME)
       CALL PROUT4b(P,NSAMP,N,NL,NK,IFIL,NAME)
       ICOM = 5
       GO TO 100
      ELSEIF (ICOM.EQ.5) THEN
       GO TO 1000
      ELSEIF (ICOM.EQ.6) THEN
       GO TO 1000
      ENDIF
CUT0  CALL SCLR

1000  RETURN
      END

      SUBROUTINE PROUT1(P,NSAMP,N,NL,NK)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE PROUT1                                       C
C   PURPOSE                                                     C
C   To plot columns versus rows of an array P(NSAMP,N) whit     C
C   CYPROS DISXY.                                               C
C   ROUTINES CALLED : NREAD, DISXY   (CYPROS routines)          C
C***END PROLOGUE PROUT1                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER NL,N,NK
      INTEGER*4 NSAMP
      DOUBLE PRECISION P(NL,NK)
      INTEGER IX(3),I1,I2,I3

100   IX(1) = 1
      IX(2) = 2
      IX(3) = 3
      CALL NREAD('Disp. column number ',IX,3,3,IIII)
      I1    = IX(1)
      I2    = IX(2)
      I3    = IX(3)
      IF (I1.EQ.0) GO TO 1000
      WRITE(IOUT,1) (I,P(I,I1), P(I,I2), P(I,I3), I=1,NSAMP)
1     FORMAT(1X,'sample ',I4,1X,3E16.6)
      GO TO 100

1000  RETURN
      END

      SUBROUTINE PROUT2(P,NSAMP,N,NL,NK,DT,IFIL,NAME)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE PROUT2                                       C
C   PURPOSE                                                     C
C   To store P(NSAMP,N) on a HX -file NAME.                     C
C   ROUTINES CALLED : RCSTR, FILHDR, CONPUT                     C
C***END PROLOGUE PROUT2                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N,NL,NK
      INTEGER *4 NSAMP
      INTEGER NR,NC,NM,NT,NX,LUNIT
      DOUBLE PRECISION P(NL,NK),DT
      CHARACTER NAME*(*)
      LOGICAL USED

C...  Store results on TS - file NAME                  ..........
      CALL RCSTR('Specify TS - file name :',NAME,1,1,IIII)
      IF (NAME.EQ.'0') GO TO 1000

C... Time varying vector (NR=1)
      NR = 1    
      NC = N
C... Mode time varying (NM=1)
      NM = 1
C... Store results in single precision (NT=1) on file NAME
      NT = 1
      NX = 0

CUT   INQUIRE(file='pltout.con',exist=used)
CUT   IF (USED) THEN
CUT    CALL SYSTEM('rm '//'pltout.con')
CUT   ENDIF
      LUNIT = 10
      CALL FILHDR(NAME,LUNIT,NR,NC,NM,NT,NX)
      CALL CONPUT(LUNIT,P,NL,NSAMP,NC,NT)
      CLOSE(LUNIT)

1000  RETURN
      END

      SUBROUTINE PROUT3(P,NSAMP,N,NL,NK,IFIL,NAME)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE PROUT2                                       C
C   PURPOSE                                                     C
C***END PROLOGUE PROUT2                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N,NL,NK,IFIL
      INTEGER *4 NSAMP
      INTEGER IT,ICOL(2),NCOL
      DOUBLE PRECISION P(NL,NK)
      CHARACTER NAME*(*), COMAND*72

      NSTR = LENS(NAME)
      IF (NAME(1:NSTR).EQ.'pltout.con') THEN
       IT   = 1
       ICOL(1) = 2
       ICOL(2) = 3
       CALL NREAD('X axis col. # :',IT,1,1,IIII)
       CALL NREAD('Y axis col. # :',ICOL,2,2,IIII)
       IF (ICOL(2).EQ.0) THEN
        NCOL = 1
       ELSE
        NCOL = 2
       ENDIF
       CALL DMAORD(P,NL,NK,NSAMP,N,IT,ICOL)
       CALL HXSTORE(P,NL,NK,NSAMP,NCOL,'pltout.con')
      ENDIF

C plt is a honeyx plot program for sun3
CUT   COMAND = 'plt '//NAME(1:NSTR)//' t r'
C plot is sun4 version of plt
      COMAND = 'plot '//NAME(1:NSTR)//' t r'

      WRITE(*,'(1X,A)') COMAND(1:LENS(COMAND))

      CALL RCSTR('Unix command',COMAND,1,1,1)
      IF (COMAND.EQ.'0') GO TO 1000
      CALL SYSTEM(COMAND)

1000  RETURN
      END

      SUBROUTINE HXSTORE(P,NL,NK,NSAMP,N,NAME)
C
      INTEGER NL,NK,NSAMP,N
      DOUBLE PRECISION P(NL,NK)
      CHARACTER NAME*(*)
      INTEGER NR,NC,NM,NT,NX
      LOGICAL USED

C... Erase old file
      INQUIRE(file=name,exist=used)
      IF (USED) THEN
       CALL SYSTEM('rm '//name)
      ENDIF

C...# rows NR and # col NC     
      NR = 1    
      NC = N
C... Mode time varying (NM=1)
      NM = 1
C... Store results in single precision (NT=1) on file NAME
      NT = 1
      NX = 0
      LUNIT = 10
      CALL FILHDR(NAME,LUNIT,NR,NC,NM,NT,NX)
      CALL CONPUT(LUNIT,P,NL,NSAMP,NC,NT)

      RETURN
      END

      SUBROUTINE DMAORD(P,NL,NK,NSAMP,N,IT,ICOL)
      INTEGER NL,NK,NSAMP,N,IT,IC1,IC2,ICOL(*)
      DOUBLE PRECISION P(NL,NK),W(6)

      IC1 = ICOL(1)
      IC2 = ICOL(2)

      DO 10 I=1,NSAMP
         W(1) = P(I,1)
         W(2) = P(I,IT)
         P(I,1)  = W(2)
         P(I,IT) = W(1)

         W(3) = P(I,2)
         W(4) = P(I,IC1)
         P(I,2)   = W(4)
         P(I,IC1) = W(3)

         IF (IC2.NE.0) THEN
          W(5) = P(I,3)
          W(6) = P(I,IC2)
          P(I,3)  = W(6)
          P(I,IC2) = W(5)
         ENDIF

10    CONTINUE
            

      RETURN
      END

      SUBROUTINE PROUT4(P,NSAMP,N,NL,NK,IFIL,NAME)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE PROUT4                                       C
C   PURPOSE                                                     C
C   To store P(NSAMP,N) on a .mat -file NAME (MATLAB FILE).     C
C   ROUTINES CALLED : RCSTR, SAVMAT, CONCAT                     C
C***END PROLOGUE PROUT4                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N,NL,NK
      INTEGER *4 NSAMP
      DOUBLE PRECISION P(NL,NK)
      CHARACTER NAME*(*), CNAM*128, C2NAM*128,CEXT*4
      INTEGER NR,NC,IN
C
      CHARACTER MATNAM*4
      INTEGER MATTYP,IMAGF,NAMLEN,LUNIT,IRECL

      CNAM = 'p'
      CEXT = '.mat'

C...  Store results on .mat - file NAME                ..........
      CALL RCSTR('Specify matlab - file name :',CNAM,1,1,IIII)
      IF (CNAM.EQ.'0') GO TO 1000

      C2NAM = CNAM(1:LENS(CNAM))//CEXT
      WRITE(*,'(80A)') C2NAM(1:LENS(C2NAM))

      NR = INT(NSAMP)
      NC = N+1

      LUNIT = 4
      IRECL = 4
      OPEN (UNIT=LUNIT,FILE=C2NAM,FORM='UNFORMATTED',
     +      STATUS='UNKNOWN',ACCESS='DIRECT',RECL=IRECL,ERR=89)

      MATTYP = 1010
      IMAGF  = 0
      NAMLEN = 4
      MATNAM = 'ode'
      MATNAM(4:4) = CHAR(0)

      WRITE(LUNIT,REC=1,ERR=90) MATTYP
      WRITE(LUNIT,REC=2,ERR=90) NR
      WRITE(LUNIT,REC=3,ERR=90) NC
      WRITE(LUNIT,REC=4,ERR=90) IMAGF
      WRITE(LUNIT,REC=5,ERR=90) NAMLEN
      WRITE(LUNIT,REC=6,ERR=90) MATNAM(1:3),MATNAM(4:4)

      ICNT = 1

      IST = 2
      IF (IST.EQ.1) THEN
       DO 10 J=1,NC
          DO 20 I=1,NR
             WRITE(LUNIT,REC=ICNT+6,ERR=90) SNGL(P(I,J))
             ICNT = ICNT + 1
20        CONTINUE
          WRITE(*,'(1X,A,I10)')' Columns stored : ',J
10     CONTINUE

      ELSE

       DO 30 I=1,NR
          DO 40 J=1,NC
             IN = I + (J-1)*NR
             WRITE(LUNIT,REC=IN+6,ERR=90) SNGL(P(I,J))
             ICNT = ICNT + 1
40        CONTINUE
          WRITE(*,'(1X,A,I10)')' Rows stored : ',I
30     CONTINUE

      ENDIF

      CLOSE(LUNIT)
      GO TO 1000

90    WRITE(6,'(1X,A)')'WRITE ERROR'
      CLOSE(LUNIT)
      GO TO 1000

89    WRITE(6,'(1X,A)')'ERROR'
      CLOSE(LUNIT)

1000  RETURN
      END


      SUBROUTINE PROUT4b(P,NSAMP,N,NL,NK,IFIL,NAME)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE PROUT4                                       C
C   PURPOSE                                                     C
C   To store P(NSAMP,N) on a .mat -file NAME (MATLAB FILE).     C
C   ROUTINES CALLED : RCSTR, SAVMAT, CONCAT                     C
C***END PROLOGUE PROUT4                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N,NL,NK
      INTEGER *4 NSAMP
      DOUBLE PRECISION P(NL,NK)
      CHARACTER NAME*(*), CNAM*128, C2NAM*128,CEXT*4
      INTEGER NR,NC,IN
C
      CHARACTER MATNAM*4
      INTEGER MATTYP,IMAGF,NAMLEN,LUNIT,IRECL

      CNAM = 'p'
      CEXT = '.mat'

C...  Store results on .mat - file NAME                ..........
      CALL RCSTR('Specify matlab - file name :',CNAM,1,1,IIII)
      IF (CNAM.EQ.'0') GO TO 1000

      C2NAM = CNAM(1:LENS(CNAM))//CEXT
      WRITE(*,'(80A)') C2NAM(1:LENS(C2NAM))

      NR = INT(NSAMP)
      NC = N+1

      LUNIT = 4
      IRECL = 8
      OPEN (UNIT=LUNIT,FILE=C2NAM,FORM='UNFORMATTED',
     +      STATUS='UNKNOWN',ACCESS='DIRECT',RECL=IRECL,ERR=89)

      MATTYP = 1000
      IMAGF  = 0
      NAMLEN = 4
      MATNAM = 'ode'
      MATNAM(4:4) = CHAR(0)

      WRITE(LUNIT,REC=1,ERR=90) MATTYP,NR
      WRITE(LUNIT,REC=2,ERR=90) NC,IMAGF
      WRITE(LUNIT,REC=3,ERR=90) NAMLEN,MATNAM(1:3),MATNAM(4:4)

      ICNT = 1

      IST = 2
      IF (IST.EQ.1) THEN
       DO 10 J=1,NC
          DO 20 I=1,NR
             WRITE(LUNIT,REC=ICNT+6,ERR=90) SNGL(P(I,J))
             ICNT = ICNT + 1
20        CONTINUE
          WRITE(*,'(1X,A,I10)')' Columns stored : ',J
10     CONTINUE

      ELSE

       DO 30 I=1,NR
          DO 40 J=1,NC
             IN = I + (J-1)*NR
             WRITE(LUNIT,REC=IN+3,ERR=90) P(I,J)
             ICNT = ICNT + 1
40        CONTINUE
          WRITE(*,'(1X,A,I10)')' Rows stored : ',I
30     CONTINUE

      ENDIF

      CLOSE(LUNIT)
      GO TO 1000

90    WRITE(6,'(1X,A)')'WRITE ERROR'
      CLOSE(LUNIT)
      GO TO 1000

89    WRITE(6,'(1X,A)')'ERROR'
      CLOSE(LUNIT)

1000  RETURN
      END

