      PROGRAM DEQSIM
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE PROGRAM DEQSIM                               C
C   PURPOSE                                                     C
C   DEQSIM is a sample program for the integration module       C
C   DEQSOL based on SPRINT/SPRITE.                              C
C                                                               C
C***END PROLOGUE PROGRAM DEQSIM                                 C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      CHARACTER COM(4)*6,CF*6
      INTEGER NRCMND, ICMND

      CF = '(5X,A)'
      WRITE(*,CF)'-------------------------------------------------'  
      WRITE(*,CF)'                                                 '
      WRITE(*,CF)'   S I M U L A T I O N   W I T H   S P R I T E   '  
      WRITE(*,CF)'                                                 '
      WRITE(*,CF)'-------------------------------------------------' 

      DATA COM(1)/'param'/, COM(2)/'solve'/, COM(3)/'exit'/,
     +     COM(4)/'0'/
      DATA NRCMND/4/

CUT   CALL CYPROS('DEQSIM')

      ICMND = 2
50    ICMND = ICREAD('Main command :',COM,NRCMND,ICMND)
      IF (ICMND .EQ .1) THEN
          CALL DIFPAR
          ICMND = 2
          GO TO 50
      ELSEIF (ICMND .eq. 2) THEN
          CALL SOLUTION
          ICMND = 3
          GO TO 50
      ENDIF
      IF (ICMND.EQ.3 .OR. ICMND.EQ.0) THEN
          IANSW = IYESANS('Are you sure ?',2)
          IF (IANSW .eq. 2 ) GO TO 1000
          ICMND = 3
          GO TO 50
      ENDIF

1000  END

      SUBROUTINE SOLUTION
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE SOLUTION                                        C
C   PURPOSE                                                        C
C   To specify set of ODE (defined in external subroutines)        C
C   and call to integration module DEQSOL(ODE,NEQ,Y,INFO,T,TFINAL) C
C***END PROLOGUE SOLUTION                                          C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INCLUDE 'DEQSOL.INC'
      INTEGER NEQ,INFO,NRCMND,ICMND
      DOUBLE PRECISION Y(NEQMAX),T,TFINAL
      CHARACTER SCOM(13)*9, CNAME*20

      EXTERNAL SD1,SD2,SD3,SD4,SD5,SD6,ND1,SD8,SD9,SD10,SD11,SD12

      DATA SCOM(1)/'d1 '/,       SCOM( 2)/'d2 '/,
     2     SCOM(3)/'d3 '/,       SCOM( 4)/'d4 '/,
     3     SCOM(5)/'d5 '/,       SCOM( 6)/'d6 '/,
     4     SCOM(7)/'non-stiff'/, SCOM( 8)/'sine'/,
     5     SCOM(9)/'destcol'/,   SCOM(10)/'d10'/,
     6     SCOM(11)/'d11'/,      SCOM(12)/'d12'/,
     7     SCOM(13)/'exit'/     
      DATA NRCMND/13/

      CNAME ='deq.con'

      ICMND = 1
50    ICMND = ICREAD('Specify equation :',SCOM,NRCMND,ICMND)

      IF (ICMND.EQ.0) THEN
       RETURN
      ELSEIF (ICMND.EQ.13) THEN
       RETURN    
      ELSE
       CALL INIT( NEQ,Y,T,TFINAL,ICMND )

       INFO = 0
       IF ( ICMND.EQ.1 ) THEN
         CALL DEQSOL(SD1,NEQ,Y,INFO,T,TFINAL,CNAME)
         ICMND = 2
         GO TO 50
       ELSEIF ( ICMND.EQ.2 ) THEN
         CALL DEQSOL(SD2,NEQ,Y,INFO,T,TFINAL,CNAME)
         ICMND = 3
         GO TO 50
       ELSEIF ( ICMND.EQ.3 ) THEN
         CALL DEQSOL(SD3,NEQ,Y,INFO,T,TFINAL,CNAME)
         ICMND = 4
         GO TO 50
       ELSEIF ( ICMND.EQ.4 ) THEN
         CALL DEQSOL(SD1,NEQ,Y,INFO,T,TFINAL,CNAME)
         ICMND = 5
         GO TO 50
       ELSEIF ( ICMND.EQ.5 ) THEN
         CALL DEQSOL(SD1,NEQ,Y,INFO,T,TFINAL,CNAME)
         ICMND = 6
         GO TO 50
       ELSEIF ( ICMND.EQ.6 ) THEN
         CALL DEQSOL(SD1,NEQ,Y,INFO,T,TFINAL,CNAME)
         ICMND = 13
         GO TO 50
       ELSEIF ( ICMND.EQ.7 ) THEN
         CALL DEQSOL(SD1,NEQ,Y,INFO,T,TFINAL,CNAME)
         ICMND = 8
         GO TO 50
       ELSEIF ( ICMND.EQ.8 ) THEN
         CALL DEQSOL(SD1,NEQ,Y,INFO,T,TFINAL,CNAME)
         ICMND = 9
         GO TO 50
       ELSEIF ( ICMND.EQ.9 ) THEN
         CALL DEQSOL(SD1,NEQ,Y,INFO,T,TFINAL,CNAME)
         ICMND = 9
         GO TO 50
       ELSEIF ( ICMND.EQ.10) THEN
         CALL DEQSOL(SD1,NEQ,Y,INFO,T,TFINAL,CNAME)
         ICMND = 10
         GO TO 50
       ELSEIF ( ICMND.EQ.11) THEN
         CALL DEQSOL(SD1,NEQ,Y,INFO,T,TFINAL,CNAME)
         ICMND = 11
         GO TO 50
       ELSEIF ( ICMND.EQ.12) THEN
         CALL DEQSOL(SD1,NEQ,Y,INFO,T,TFINAL,CNAME)
         ICMND = 12
         GO TO 50
       ENDIF

      ENDIF

      END



