      SUBROUTINE INIT( NEQ,Y0,T0,TEND,PROBLEM )
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C   PURPOSE                                                             c
C   To initialize initial conditions on OD Equations. This routine is   c
C   called from deqsim.                                                 c
C                                                                       c
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      include 'DEQSOL.INC'
      integer neq,problem
      double precision y0(neqmax),T0,TEND
C Local
      CHARACTER FNAM*80

C  Parameters for problem 1, 2 and 12 (SD1, SD2 and SD12)
      DOUBLE PRECISION XF(3),VF,TF,ALF,BET
      COMMON /SD12BLK/ XF,VF,TF,ALF,BET

C  Parameters for problem 3, SD3
      DOUBLE PRECISION XF2(1200),VF2,TF2,ALF2,BET2
      COMMON /SD3BLK/ XF2,VF2,TF2,ALF2,BET2

C  Initialiserer for SD1 
      IF (PROBLEM.EQ.1) THEN
         TF = 1.0
         VF = 1.0
         ALF= 1.0
         BET= 1.0

         NEQ   = 3
         CALL DRVEC('Initial values on x',Y0,NEQ,NEQMAX)
         CALL DRVEC('Initial values on xf',XF,NEQ,NEQMAX)
         CALL DREAD('Initial values on vf',VF,1,1,IIII)
         CALL DREAD('Initial values on tf',TF,1,1,IIII)
         CALL DREAD('1. reak. order alfa',ALF,1,1,IIII)
         CALL DREAD('2. reak. order beta',BET,1,1,IIII)
       
         T0    = 0.0
         TEND  = 10.0

C  Initialiserer for SD2
      ELSEIF (PROBLEM.EQ.2) THEN
           NEQ   = 3
           FNAM ='init.dat'
           CALL RCSTR('FILE NAME ',FNAM,1,1,IIII)
           NIN = 10
           OPEN (NIN,FILE=FNAM,STATUS='OLD',ERR=90)
            READ(NIN,*,ERR=91) (XF(I),I=1,NEQ)
           CLOSE(NIN)
           GO TO 1000
90         WRITE(*,'(1X,A)')'FILE DOES NOT EXIST'
           GO TO 1000
91         WRITE(*,'(1X,A)')'ERROR DURING READ'

1000       CALL DRVEC('Initial values on x ',Y0,NEQ,NEQMAX)
           CALL DRVEC('Initial values on xf',XF,NEQ,NEQMAX)
           CALL DREAD('Initial value  on vf',VF,1,1,IIII)
           CALL DREAD('Initial value  on tf',TF,1,1,IIII)
           CALL DREAD('1. reak. order alfa ',ALF,1,1,IIII)
           CALL DREAD('2. reak. order beta ',BET,1,1,IIII)
         
           T0    = 0.0
           TEND  = 10.0

C  Initialiserer for SD3
      ELSEIF (PROBLEM.EQ.3) THEN
         NEQ   = 3
         TF2   = 1.0
         VF2   = 1.0
         ALF2  = 1.0
         BET2  = 1.0

         CALL NREAD('NUMBER OF ODEs NEQ =',NEQ,1,1,IIII)

         IF (NEQ.EQ.3) THEN
          CALL DRVEC('Initial values on x ',Y0,NEQ,NEQMAX)
          CALL DRVEC('Initial values on xf',XF2,NEQ,NEQMAX)
         ELSE
          DO 190 I=1,NEQ
             Y0(I) = 1.0D0
             XF2(I) = 2.0D0
190       CONTINUE
         ENDIF

         CALL DREAD('Initial value on vf',VF2,1,1,IIII)
         CALL DREAD('Initial value on tf',TF2,1,1,IIII)
         CALL DREAD('1. reak. order alfa',ALF2,1,1,IIII)
         CALL DREAD('2. reak. order beta',BET2,1,1,IIII)
       
         T0    = 0.0
         TEND  = 10.0

C  Initialiserer for SD12
      ELSEIF (PROBLEM.EQ.12) THEN
        NEQ   = 3
        TF    = 1.0
        VF    = 1.0
        ALF   = 1.0
        BET   = 1.0

        CALL DRVEC('Initial values on x',Y0,NEQ,NEQMAX)
        CALL DRVEC('Initial values on xf',XF,NEQ,NEQMAX)
        CALL DREAD('Initial values on vf',VF,1,1,IIII)
        CALL DREAD('Initial values on tf',TF,1,1,IIII)
        CALL DREAD('1. reak. order alfa',ALF,1,1,IIII)
        CALL DREAD('2. reak. order beta',BET,1,1,IIII)

        T0    = 0.0
        TEND  = 10.0

      ELSE
       WRITE(*,'(1X,A)')'* WARNING initial values not defined'
      ENDIF

      RETURN
      END
