      SUBROUTINE RICERR(INFO)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C**BEGIN PROLOGUE RICERR                                         C
C  AUTHOR : David Di Ruscio             ITK/NTH 3 december 1988  C
C  PURPOSE                                                       C
C  RICERR is a error handler routine for the Riccati equation    C
C  solver routine RICSOL.                                        C
C                                                                C
C  ON INPUT                                                      C
C  INFO   INTEGER whit values corresponding to the following     C
C         messages. The messages are printed on terminal.        C
C  INFO = 1  the real Schur decomposition was not successful.    C
C  INFO = 2  the eigenspace reordering failed.                   C
C  INFO = 3  the linear equation is singular.                    C
C                                                                C
C  ROUTINES CALLED : (NONE)                                      C
C***END PROLOGUE RICERR                                          C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER INFO
      CHARACTER CFORM*6

      CFORM = '(5X,A)'

      IF (INFO.EQ.1) THEN
       WRITE(*,CFORM)'* Schur decomposition failed.               '
       WRITE(*,CFORM)'* Error occur in subroutine HQR4.           '
      ELSEIF (INFO.EQ.2) THEN
       WRITE(*,CFORM)'* Failed to reorder eigensystem.            '
       WRITE(*,CFORM)'* Error occur in subroutine eigord.         '
      ELSEIF (INFO.EQ.3) THEN
       WRITE(*,CFORM)'* Linear system is singular.                '
       WRITE(*,CFORM)'* Attemt to invert singular matrix in Ricsol'
       WRITE(*,CFORM)'* Error occur in subroutine DGEFA.          '
      ENDIF

      RETURN
      END
