
      SUBROUTINE MATFN7
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     AUTHOR : David Di Ruscio          ITK february 1989              C
C     PURPOSE                                                          C
C     To include other functions into MATLAB FORTRAN version.          C
C     The routines MATFN1 to MATFN(XX) is interface routines between   C
C     MATLAB and serious computation routines as EISPACK,LINPACK etc.  C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C... Global parameters (shuld be defined in a INCLUDE file, MATLAB.INC)
      DOUBLE PRECISION STKR(20020),STKI(20020)
      INTEGER IDSTK(4,48),LSTK(48),MSTK(48),NSTK(48),VSIZE,LSIZE,BOT,TOP
      INTEGER DDT,ERR,FMT,LCT(4),LIN(1024),LPT(6),HIO,RIO,WIO,RTE,WTE
      INTEGER SYM,SYN(4),BUF(256),CHAR,FLP(2),FIN,FUN,LHS,RHS,RAN(2)
      COMMON /VSTK/ STKR,STKI,IDSTK,LSTK,MSTK,NSTK,VSIZE,LSIZE,BOT,TOP  
      COMMON /IOP/ DDT,ERR,FMT,LCT,LIN,LPT,HIO,RIO,WIO,RTE,WTE  
      COMMON /COM/ SYM,SYN,BUF,CHAR,FLP,FIN,FUN,LHS,RHS,RAN 
C...  Lokal parameters
      INTEGER NITER,IERR
      DOUBLE PRECISION LARGE,EPS
      CHARACTER CFORM*6
      INTEGER IOUT,IPRT
      COMMON /IUTIL/ IOUT,IPRT

      CFORM = '(5X,A)'
      DATA LARGE/1.0E10/
C...  For debug purpose  (set DEBUG(1) --> DDT=1 in matlab)
      IF (DDT .EQ. 1) THEN               
       WRITE(WTE,100) FIN
100    FORMAT(1X,'MATFN7',I4)
       IPRT = 1
       IOUT = 6
       CALL NREAD('Output to unit',iout,1,1,iiii)
      ENDIF

C...  Initialize common stack pointers
      L  = LSTK(TOP)
      M  = MSTK(TOP)
      N  = NSTK(TOP)
      L2 = LSTK(TOP+1)
      M2 = MSTK(TOP+1)
      N2 = NSTK(TOP+1)

C... Compute machine epsilon
      CALL MACEPS(EPS)

C...  Execute functions defined by FIN (output from routine FUNS)
      GO TO (10,20,30,40,50,60),FIN

C************************************************************************
C1.. LIAP Solve Liapunov equation
10    IF (M.NE.N) CALL ERROR(20)
      IF (ERR.GT.0) RETURN
      NN = N*N
      NP = N*(N+1)/2
      IF (RHS.EQ.2) THEN
       IF (M2.NE.N2) CALL ERROR(20)
       IF (ERR.GT.0) RETURN
       TOP = TOP - (RHS-1)
       LA  = LSTK(TOP)
       LB  = LSTK(TOP+1)
       LAS = LB  + NN
       LBS = LAS + NN
       LAR = LBS + NN   
       LBT = LAR + NN
       LZ  = LBT + NP*NP
       ERR = LZ + LA - LSTK(BOT)
       IF (ERR.GT.0) CALL ERROR(17)
       IF (ERR.GT.0) RETURN
      ELSEIF (RHS.EQ.1) THEN
C... Only one RHS argument
       CALL ERROR(39)
       IF (ERR.GT.0) RETURN
      ENDIF
      IF (LHS .EQ. 2) THEN
       MATZ = 1
      ELSE
       MATZ = 0
      ENDIF
C... Store arguments
      CALL WCOPY (NN,STKR(LA),STKI(LA),1,STKR(LAS),STKI(LAS),1)
      CALL WCOPY (NN,STKR(LB),STKI(LB),1,STKR(LBS),STKI(LBS),1)
C... Compute generalized eigenvalues

      CALL DLYP(STKR(LAS),STKR(LBS),STKR(LAR),N,N,
     +            STKR(LBT),STKR(LZ),NP,BUF,IERR)
      IF (IERR.EQ.1) THEN
       WRITE(WTE,'(3X,A)')'System singular (no solution)'
      ELSEIF (IERR.EQ.2) THEN
       WRITE(WTE,'(3X,A)')'Work array to small'
      ENDIF

C.. Copy solution to top of stack
      DO 11 I=LAR,LAR+NN
         STKI(I) = 0.0
11    CONTINUE
      CALL WCOPY(NN,STKR(LAR),STKI(LAR),1,STKR(LA),STKI(LA),1)
      NSTK(TOP) = N
      GO TO 99

C************************************************************************
C2...RGA comutation
20    WRITE(WTE,CFORM)' Computation of RGA elements is not yet  '
      WRITE(WTE,CFORM)' implemented.                            '

      IF (M.NE.N) CALL ERROR(20)
      IF (ERR.GT.0) RETURN
      NN = N*N
      IF (RHS.EQ.1) THEN
       TOP = TOP - (RHS-1)
       LA  = LSTK(TOP)
       LB  = LSTK(TOP+1)
       LAS = LB  + NN
       LBS = LAS + NN
       LAR = LBS + NN
       LBT = LAR + N
       LZ  = LBT + N
       ERR = LZ + LA - LSTK(BOT)
       IF (ERR.GT.0) CALL ERROR(17)
       IF (ERR.GT.0) RETURN
      ELSEIF (RHS.EQ.2) THEN
C... Only one RHS argument
       CALL ERROR(39)
       IF (ERR.GT.0) RETURN
      ENDIF
      IF (LHS .EQ. 2) THEN
       MATZ = 1
      ELSE
       MATZ = 0
      ENDIF
C... Store arguments
      CALL WCOPY (NN,STKR(LA),STKI(LA),1,STKR(LAS),STKI(LAS),1)
      CALL WCOPY (NN,STKR(LB),STKI(LB),1,STKR(LBS),STKI(LBS),1)

C...Only for real matrixes implemented
      CALL DFROMIN(N,N,STKR(LAS),STKR(LAR),NITER)
C.. Copy solution to top of stack
      CALL WCOPY( N,STKR(LAR),STKI(LAR),1,STKR(LA),STKI(LA),1)
      NSTK(TOP) = 1
      GO TO 99

C************************************************************************
C3.. Function GEIG (Generalized eigenvalues)
30    IF (M.NE.N) CALL ERROR(20)
      IF (ERR.GT.0) RETURN
      NN = N*N
      IF (RHS.EQ.2) THEN
       IF (M2.NE.N2) CALL ERROR(20)
       IF (ERR.GT.0) RETURN
       TOP = TOP - (RHS-1)
       LA  = LSTK(TOP)
       LB  = LSTK(TOP+1)
       LAS = LB  + NN
       LBS = LAS + NN
       LAR = LBS + NN
       LBT = LAR + N
       LZ  = LBT + N
       ERR = LZ + LA - LSTK(BOT)
       IF (ERR.GT.0) CALL ERROR(17)
       IF (ERR.GT.0) RETURN
      ELSEIF (RHS.EQ.1) THEN
C... Only one RHS argument
       CALL ERROR(39)
       IF (ERR.GT.0) RETURN
      ENDIF
      IF (LHS .EQ. 2) THEN
       MATZ = 1
      ELSE
       MATZ = 0
      ENDIF
C... Store arguments
      CALL WCOPY (NN,STKR(LA),STKI(LA),1,STKR(LAS),STKI(LAS),1)
      CALL WCOPY (NN,STKR(LB),STKI(LB),1,STKR(LBS),STKI(LBS),1)
C... Compute generalized eigenvalues
      CALL DGEIGV(N,N,STKR(LAS),STKR(LBS),STKR(LAR),STKI(LAR),
     +             STKR(LBT),MATZ,STKR(LZ),IERR,LARGE)
C.. Copy solution to top of stack
      CALL WCOPY( N,STKR(LAR),STKI(LAR),1,STKR(LA),STKI(LA),1)
      NSTK(TOP) = 1
      CALL VECPRT2('GEN. EIGENVAL.','GEIG',STKR(LA),STKI(LA),N,N,WTE)
      IF (IERR.NE.0) THEN
       WRITE(WTE,'(3X,A,1X,I3)')'QZIT (EISPACK) ERROR',IERR
      ENDIF
      GO TO 99

C*************************************************************************
C4.. Exexute scale function (minimize frobenius norm of invD*A*D)
40    IF (M.NE.N) CALL ERROR(20)
      IF (ERR.GT.0) RETURN
      NN = N*N
      IF (RHS.EQ.1) THEN
       TOP = TOP - (RHS-1)
       LA  = LSTK(TOP)
       LB  = LSTK(TOP+1)
       LAS = LB  + NN
       LBS = LAS + NN
       LAR = LBS + NN
       LBT = LAR + N
       LZ  = LBT + N
       ERR = LZ + LA - LSTK(BOT)
       IF (ERR.GT.0) CALL ERROR(17)
       IF (ERR.GT.0) RETURN
      ELSEIF (RHS.EQ.2) THEN
C... Only one RHS argument
       CALL ERROR(39)
       IF (ERR.GT.0) RETURN
      ENDIF
      IF (LHS .EQ. 2) THEN
       MATZ = 1
      ELSE
       MATZ = 0
      ENDIF
C... Store arguments
      CALL WCOPY (NN,STKR(LA),STKI(LA),1,STKR(LAS),STKI(LAS),1)
      CALL WCOPY (NN,STKR(LB),STKI(LB),1,STKR(LBS),STKI(LBS),1)

C...Only for real matrixes implemented
      CALL DFROMIN(N,N,STKR(LAS),STKR(LAR),NITER)
      WRITE(WTE,'(1X,A,I3)')'NO. OF ITERATIONS =',NITER
      DO 41 I = 1,N
         J = I - 1
         IF (STKR(LAR+J).NE.0.0) THEN
          STKR(LAR+J) = 1.0D0/STKR(LAR+J)
         ENDIF
41    CONTINUE

C.. Copy solution to top of stack
      CALL WCOPY( N,STKR(LAR),STKI(LAR),1,STKR(LA),STKI(LA),1)
      NSTK(TOP) = 1
      GO TO 99

C********************************************************************
C5.. RICU  Solve Algebraic Riccati Equation (ARE)  neg. definit solution
60    IERR = 1
      GO TO 51
C5.. RICC  Solve Algebraic Riccati Equation (ARE)  pos. definit solution
50    IERR = 0
51    IF (RHS.LE.2 .OR. RHS.GE.4) THEN
       CALL ERROR(39)
       GO TO 99
      ENDIF

      IF (M .NE. N) CALL ERROR(20)
      IF (M2.NE.N2) CALL ERROR(20)
      IF (ERR.GT.0) RETURN

      NN  = N*N
      NP  = 4*NN
      TOP = TOP - (RHS-1)
C...Input matrix dimensions
      LA  = LSTK(TOP)
      LB  = LSTK(TOP+1)
      LC  = LSTK(TOP+2)

C...Pointers for A, B, C (argument matrixes)
      LAA = LC  + NN
      LAH = LAA + NN
      LAQ = LAH + NN

C...Ponters for F, U (arrays involving Hamiltonian)
      LAS = LAQ + NN
      LBS = LAS + NP

C...Pointer for eigenvalue array (er , ei)
      LCS = LBS + NP   
      LAR = LCS + N + N 

C...Work vector
      LZ  = LAR + N + N

C...Check memory
      ERR = LZ + LA - LSTK(BOT)
      IF (ERR.GT.0) CALL ERROR(17)
      IF (ERR.GT.0) RETURN

C... Store arguments
      CALL WCOPY (NN,STKR(LA),STKI(LA),1,STKR(LAA),STKI(LAA),1)
      CALL WCOPY (NN,STKR(LB),STKI(LB),1,STKR(LAH),STKI(LAH),1)
      CALL WCOPY (NN,STKR(LC),STKI(LC),1,STKR(LAQ),STKI(LAQ),1)

C... Solve Algebraic Riccati Equation
      IF (IPRT.EQ.1) THEN
       CALL DMAPRT('Call DRICSOL A =',STKR(LAA),N,N,N,N,IOUT)
       CALL DMAPRT('Call DRICSOL H =',STKR(LAH),N,N,N,N,IOUT)
       CALL DMAPRT('Call DRICSOL Q =',STKR(LAQ),N,N,N,N,IOUT)
      ENDIF
      CALL DRICSOL(STKR(LAA),STKR(LAH),STKR(LAQ),N,N,
     +             STKR(LAS),STKR(LBS),N+N,STKR(LCS),STKR(LAR),   
     +             STKR(LZ),BUF,EPS,IERR)                         

      IF (IERR.NE.0) THEN
       CALL DRICERR(IERR,WTE)
      ENDIF

C.. Copy solution to top of stack
      DO 52 I=LAQ,LAQ+NN
         STKI(I) = 0.0
52    CONTINUE
      CALL WCOPY(NN,STKR(LAH),STKI(LAH),1,STKR(LA),STKI(LA),1)
CUT   CALL WCOPY(N, STKR(LCS),STKR(LAR),1,STKR(LB),STKI(LB),1)
      NSTK(TOP) = N
CUT   NSTK(TOP+1) = 1

      CALL VECPRT2
     +    ('EIG(A-HR) =','s',STKR(LCS),STKR(LAR),N,N,WTE)
      GO TO 99


99    RETURN
      END

      SUBROUTINE RGGTST1(NA,N,A,B,ALFR,ALFI,BETA,MATZ,Z,IERR)
C.. TEST ROUTINE (used for implementations of new functions)
      INTEGER NA,N,MATZ,IERR
      DOUBLE PRECISION A(NA,N),B(NA,N),Z(NA,N)
      DOUBLE PRECISION ALFR(N),ALFI(N),BETA(N)

      CALL MATPRT('A=',A,NA,NA,N,N)
      CALL MATPRT('B=',B,NA,NA,N,N)
      DO 10 I=1,N
         DO 20 J=1,N
            Z(I,J) = A(I,J) + B(I,J)
20       CONTINUE
         ALFR(I) = Z(I,I)
         ALFI(I) = Z(I,I)
10    CONTINUE
      CALL MATPRT('Z=A+B',Z,NA,NA,N,N)

      RETURN
      END

