       SUBROUTINE ACPACK(A,C,AU,N,M,NA,NC,NAU)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE ACPACK                                     C
C   AUTHOR : David Di Ruscio         ITK/NTH AUTOMN 88        C
C                                                             C
C   PURPOSE                          -                        C
C   ACPACK makes the expanded matrix A.                       C
C                                                             C
C                    -  (A C)                                 C
C                    A =(0 0)                                 C
C                                                             C
C   ON INPUT                                                  C
C   A       DOUBLE PRECISION (N,N)                            C
C   C       DOUBLE PRECISION (N,M)                            C
C   AU      DOUBLE PRECISION (NAU,*)                          C
C   NA      INTEGER leading dimension on A in calling prog.   C
C   NC      INTEGER leading dimension on C in calling prog.   C
C   NAU     INTEGER leading dimension on AU in calling prog.  C
C   ON OUTPUT                                                 C
C   AU      The expanded matrix of dimension (N+M,N+M)        C
C                                                             C
C   ROUTINES CALLED : (NONE)                                  C
C***END PROLOGUE ACPACK                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER N,M,NI,I,J,NA,NC,NAU
       DOUBLE PRECISION A(NA,N),C(NC,M),AU(NAU,*)

C......A - part ....................................
       DO 10 I=1,N
          DO 20 J=1,N
             IF (I.LE.N.AND.J.LE.N) THEN
              AU(I,J)=A(I,J)
             ENDIF                             
20        CONTINUE
10     CONTINUE

C..... C - part ....................................
       DO 30 I=1,N   
          DO 40 J=1,M
             AU(I,N+J)=C(I,J)
40        CONTINUE
30     CONTINUE
 
C..... 0 - part ....................................
       DO 50 I=N+1,N+M
          DO 60 J=1,N+M
             AU(I,J)=0.0
60        CONTINUE
50     CONTINUE
       
       RETURN
       END
