       SUBROUTINE ADPACK(A,C,AU,N,M,NA,NC,NAU)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE ADPACK                                     C
C                                                             C
C   PURPOSE                          -                        C
C   ADPACK makes the expanded matrix A.                       C
C                                                             C
C                    -  (A 0)                                 C
C                    A =(C 0)                                 C
C                                                             C
C   ON INPUT                                                  C
C   A       DOUBLE PRECISION (N,N)                            C
C   C       DOUBLE PRECISION (M,N)                            C
C   AU      DOUBLE PRECISION (NAU,*)                          C
C   NA      INTEGER leading dimension on A in calling prog.   C
C   NC      INTEGER leading dimension on C in calling prog.   C
C   NAU     INTEGER leading dimension on AU in calling prog.  C
C   ON OUTPUT                                                 C
C   AU      The expanded matrix of dimension (N+M,N+M)        C
C                                                             C
C   ROUTINES CALLED : (NONE)                                  C
C***END PROLOGUE ADPACK                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER N,M,NI,I,J,NA,NC,NAU
       DOUBLE PRECISION A(NA,N),C(NC,N),AU(NAU,*)

C         -   ( A 0 )
C   Make  A = ( C 0 )   .......................................
C
       DO 10 I=1,N+M
C... Make A- part
          DO 20 J=1,N
              AU(I,J)=A(I,J)
20        CONTINUE

C... Make C- part
          DO 30 J=1,N
             IF (I.GT.N) THEN
              AU(I,J)=C(I-N,J)
             ENDIF
30        CONTINUE
C... Make 0- part
          DO 40 J=N+1,N+M
             AU(I,J)=0.0D0
40        CONTINUE
10     CONTINUE

       RETURN
       END
