       SUBROUTINE ASETUP(A,ABE,N,NA,ML,MU)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGINB PROLOGUE ASETUP                                       C
C   PURPOSE                                                      C
C   ASETUP sets up the matrix ABE used by DNBFS. DNBFS solves    C
C   linear systems of equations Ax = b whit band structure on A. C
C                                                                C
C   ON INPUT                                                     C
C   A      The band matrix DOUBLE PRECISION (N,N).               C
C   N      The dimension on A. INTEGER                           C
C   NA     Leading dimension on A in calling program.            C
C   ML     Lower band whidt (number of sub diagonals)            C
C   MU     Upper band whidt (number of super diagonals)          C
C                                                                C
C   ON OUTPUT                                                    C
C   ABE    Contains the setup matrix used by DNBFS band solver   C
C                                                                C
C***END PROLOGUE ASETUP                                          C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER N,MU,ML
       DOUBLE PRECISION A(NA,NA),ABE(NA,NA)

       DO 10 I=1,N
          J1=MAX0(1,I-ML)
          J2=MIN0(N,I+MU)
          DO 20 J=J1,J2
             K=J-I+ML+1
             ABE(I,K)=A(I,J)
20        CONTINUE
10     CONTINUE
       
       RETURN
       END
