       SUBROUTINE AUGPCK(A,B,AU,N,M,NA,NC,NAU,IAUG)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE AUGPCK                                     C
C   AUTHOR : David Di Ruscio         ITK/NTH AUTOMN 88        C
C                                                             C
C   PURPOSE                          -                        C
C   AUGPCK makes the expanded matrix A.                       C
C                                                             C
C                   AU = (A B)   ---> IAUG = 1                C
C                                                             C
C                   AU = ( A )   ---> IAUG = 2                C
C                        ( B )                                C
C                                                             C
C   ON INPUT                                                  C
C   A       DOUBLE PRECISION (N,N)                            C
C   B       DOUBLE PRECISION (N,M) or (M,N)                   C
C   AU      DOUBLE PRECISION (NAU,*)                          C
C   NA      INTEGER leading dimension on A in calling prog.   C
C   NC      INTEGER leading dimension on C in calling prog.   C
C   NAU     INTEGER leading dimension on AU in calling prog.  C
C   ON OUTPUT                                                 C
C   AU      The expanded matrix of dimension (N+M,N+M)        C
C                                                             C
C   ROUTINES CALLED : (NONE)                                  C
C***END PROLOGUE AUGPCK                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER N,M,I,J,NA,NC,NAU,IAUG
       DOUBLE PRECISION A(NA,*),B(NC,*),AU(NAU,*)

C         -    
C   Make  A = (A B)
C
       
       IF (IAUG.EQ.1) THEN
C......A - part ....................................
        DO 10 I=1,N
           DO 20 J=1,N
              IF (I.LE.N.AND.J.LE.N) THEN
               AU(I,J)=A(I,J)
              ENDIF                            
20         CONTINUE

C..... B - part ....................................
           DO 30 J=1,M
              AU(I,N+J)=B(I,J)
30         CONTINUE
10      CONTINUE
 
C         -   ( A )  
C   Make  A = ( C )     .......................................
C
       ELSEIF (IAUG.EQ.2) THEN
        DO 40 I=1,N+M
C... Make A- part
           DO 50 J=1,N
               AU(I,J)=A(I,J)
50         CONTINUE

C... Make B- part
           DO 60 J=1,N
              IF (I.GT.N) THEN
               AU(I,J)=B(I-N,J)
              ENDIF
60         CONTINUE
40      CONTINUE

       ENDIF

       RETURN
       END
