       SUBROUTINE AXBSOLV(A,B,DET,N,NA,II,III,IFLAG)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                               C
C      VERSJON 1 David Di Ruscio     12/10-88                   C
C      FORMAAL                                                  C
C      Rutine for loesning av Ax = b ved LU - dekomponering.    C
C      Rutinen beregner ogs} determinanten  det(A).             C
C      Benytter ikke pivaatsoekning. Dersom pivaatsoekning      C
C      oenskes boer AXBSOL2 benyttes.                           C
C      INPUT                                                    C
C      A   Matrise med dimensjon N x N                          C
C      B   Hoeyreside , vektor med dimensjon N                  C
C      NA  Dimensjonen p} A og B i det kallende program         C
C                                                               C
C      OUTPUT                                                   C
C      B   Loesningen X ligger i B ved utgangen fra rutinen     C
C      DET Determinanten til matrisen A                         C
C                                                               C
C      IFLAG=0   beregningen var vellykket                      C
C      IFLAG=3   det(A)=0.0  algoritmen havarerer. Uthopp !     C
C      II og III settes lik 1 dersom dekomponering |nskes       C
C                                                               C
C      KALLER : LUDEC1,LUSOL1                                   C
C                                                               C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER N,NA,II,III,IFLAG
       DOUBLE PRECISION A(NA,N),B(NA),DET

C1...  Dekompnerer A = L*U (L - lower, U - upper triangular) ....
       IF (II.EQ.1.AND.III.EQ.1) THEN
        CALL LUDEC1(A,N,NA,DET,IFLAG)
       ENDIF
       IF (IFLAG.EQ.3) GO TO 100
C2...  Loeser L*U*x = b                 .........................
       CALL LUSOL1(A,N,NA,B)

100    RETURN
       END
