       SUBROUTINE DINFNO(X,N,NX,DNORM)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE DINFNO                                        C
C   AUTHOR : David Di Ruscio            ITK/NTH 12 december 1988 C
C   PURPOSE                                                      C
C   DINFNO computes the infinity vector norm.                    C
C   DINFNO(X) = MAX(ABS(X(I)))                                   C
C   ON INPUT                                                     C
C   X     DOUBLE PRECISION (N)                                   C
C   N     Actual dimension on X. INTEGER                         C
C   NA    Leading dimension on X in calling program. INTEGER     C
C   ON OUTPUT
C   DNORM D.P. contains the infinity norm. The answer is exatct. C
C   ROUTINES CALLED : IDAMAX                                     C
C***END PROLOGUE DINFNO                                          C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER N,NX,INCH,IMAX
       DOUBLE PRECISION X(NX),DNORM,C,Z
       PARAMETER (INCH = 1)

       DNORM = 0.0D0
       IF (N.LE.0) GO TO 20
C... Find the position of the largest element in vector (abs.val)
       IMAX = IDAMAX(N,X,INCH)

C3... Compute the infinity norm (We dont want to use DABS because
C ... we want an exsact answer)
       IF (X(IMAX).LT. 0.0D0) THEN
        DNORM = -X(IMAX)
        GO TO 20
       ENDIF
       DNORM = X(IMAX)
       Z = DABS(X(IMAX))
       WRITE(*,*)'* ABS(X(IMAX))=',Z
20     RETURN
       END
