      SUBROUTINE DSCALE(A,DAD,D,NM,N)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE DSCALE                                       C
C   AUTHOR : David Di Ruscio            ITK/NTH 2/12 - 1988     C
C                                                               C
C   PURPOSE                                                     C
C   DSCALE performs the scaling D*A*Dinv of a matrix A where    C
C   D is a diagonal matrix.                                     C
C                                                               C
C   ON INPUT                                                    C
C   A      DOUBLE PRECISION (NM,N) matrix.                      C
C   D      DOUBLE PRECISION (NM) diagonal scaling matrix.       C
C   NM     INTEGER leading dimension of A and D in calling prog.C
C   ON OUTPUT                                                   C
C   DAD    DOUBLE PRECISION (NM,N) the matrix product D*A*Dinv. C
C                                                               C
C   ROUTINES CALLED : (NONE)                                    C
C***END PROLOGUE DSCALE                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N,NM
      DOUBLE PRECISION A(NM,N),DAD(NM,N),D(NM)

      DO 10 I=1,N
         DO 20 J=1,N
          IF (I.EQ.J) THEN
           DAD(I,J)=A(I,J)
          ELSE
           DAD(I,J)=D(I)*A(I,J)/D(J)
          ENDIF
20       CONTINUE
10    CONTINUE

      RETURN
      END
