      SUBROUTINE DUQUT(U,Q,WORK,N,NA,JOB)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   David Di Ruscio               ITK/NTH  23/10 1988           C
C                                                               C
C   DESCRIPTION                                                 C
C                                       T          T            C
C   UQUT computes products of the form U QU and UQU .           C
C                                                               C
C   ON INPUT                                                    C
C   U   a doubly subscripted array of dimension (N x N)         C
C       U are unchanged on output.                              C
C   Q   a doubly subscripted array of dimension (N x N)         C
C       Q are changed on output.                                C
C   WORK a doubly subscripted array of dimension (N x N)        C
C        Used as work space.                                    C
C   N   the actual dimensjon of U and Q                         C
C   NA  the leading dimensjon of U and Q in the calling program C
C   JOB a integer whit following options,                       C
C       JOB = 1  computes the product UT*Q*U                    C
C       JOB = 2  computes the product U *Q*UT                   C
C                (where UT is the transpose of U)               C
C   ON OUTPUT                                                   C
C   C     the product spesified by JOB.                         C
C   WORK  the product Q*U if JOB = 1                            C
C         the product Q*UT if JOB = 2                           C
C   ROUTINES CALLED : MATMULT,TRANSMULT                         C
C   VERSJON         : DOUBLE PRECISION                          C
C                                                               C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N,NA,JOB
      DOUBLE PRECISION U(NA,NA),Q(NA,NA),X,WORK(NA,NA)

C1... Computes the product UT*Q*U     ...........................
      IF (JOB.EQ.1) THEN

C...  Computes the product Q*U = WORK
       CALL MATMULT(Q,U,WORK,N,N,N,NA)

C...  Computes the product UT*WORK = UT*Q*U = Q
       CALL TRANSMULT(U,WORK,Q,N,N,N,10,2)

C2... Computes the product U*Q*UT     ...........................
      ELSEIF (JOB.EQ.2) THEN
       
C...  Computes the product Q*UT = WORK
       CALL TRANSMULT(Q,U,WORK,N,N,N,NA,1)

C...  Computes the product U*WORK      
       CALL MATMULT(U,WORK,Q,N,N,N,NA)

      ENDIF

      RETURN
      END
