       SUBROUTINE INVERS(A,P,W,DET,N,NA)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE INVERS                                       C
C   PURPOSE                                                     C
C   INVERS computes the invers inv(A) of a square matrix A.     C
C   This routine does not work if the diagonal of A contains    C
C   any zero elements.                                          C
C   ON INPUT                                                    C
C   A       A general square matrix of dimension (N,N).         C
C   W       Work vector of dimension (N). Contents destroyed.   C
C   N       Actual dimension on A.                              C
C   NA      Leading dimension on A in calling program.          C
C   ON OUTPUT                                                   C
C   P       Contains the inverse of A.                          C
C   A       Contains the LU factorisation                       C
C   W       Zero vector                                         C
C   DET     Contains the determinant of A.                      C
C   IFLAG   INTEGER whit the following options                  C
C    IFLAG = 0   Sucsessfull coputation                         C
C    IFLAG = 3   Diagonal elements in A equal zero. ERROR       C
C                                                               C
C   ROUTINES CALLED : AXBSOLV (LUDEC1,LUSOL1)                   C
C                                                               C
C***END PROLOGUE INVERS                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER I,II,J,N,NA,IFLAG
       DOUBLE PRECISION A(NA,NA),W(NA)
       DOUBLE PRECISION P(NA,NA),DET

       DO 30 II=1,N
C1... Make identy vectors equivalent to identy matrix ...........
          DO 40 I=1,N
             IF (I.EQ.II) THEN
              W(I) = 1.0
             ELSE
              W(I) = 0.0
             ENDIF
40        CONTINUE
          
C2... Solve linear systems of equations Axi = bi   ..............
          CALL AXBSOLV(A,W,DET,N,NA,II,1,IFLAG)
          IF (IFLAG.EQ.3) THEN
           WRITE(*,'(3X,A,1X,I3)')'* IFLAG = ',IFLAG
           GO TO 100
          ENDIF

C3... Store solutions                             ...............
          DO 50 I=1,N
             P(I,II)=W(I)
50        CONTINUE
          W(II) = 0.0
30     CONTINUE
100    RETURN
       END

