       SUBROUTINE IVSORT(A,N,NA)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE IVSORT                                      C
C   AUTHOR : David Di Ruscio            ITK/NTH sept 1988      C
C                                                              C
C   PURPOSE                                                    C
C   IVSORT sort the vector A(I). The largest vector element    C
C   stored in A(1) on output. The smallest in X(N) etc.        C
C   ON INPUT                                                   C
C   A    INTEGER (N) vector. A is destroyed on output.         C
C   N    INTEGER dimension on A                                C
C   NA   INTEGER leading dimension on A in calling program.    C
C   ON OUTPUT                                                  C
C   A(1) The first element in the vector A(I) contains the     C
C        largest element in the input vector A.                C
C   A(I+1) The elements in A in descending order.              C
C   ROUTINES CALLED : (NONE)                                   C
C***END PROLOGUE IVSORT                                        C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER I,J,JJ,N,NN,NA,A(NA),C

       NN=N-1
       DO 10 I=1,N-1
          JJ=I+1
          DO 20 J=JJ,N
             IF (A(I).GE.A(J)) GO TO 20
             C = A(I)
             A(I) = A(J)
             A(J) = C
20        CONTINUE
10     CONTINUE

       RETURN
       END

