       SUBROUTINE LUDEC1(A,N,NA,DET,IFLAG)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***START PROLOGUE LUDEC1                                       C
C   AUTHOR : David Di Ruscio          ITK/NTH 24 november 88    C
C                                       (new version)           C
C     PURPOSE                                                   C
C   - LUDEC1 factor a sqare matrix A = L*U where L - lower and  C
C     U - upper triangular matrixes. The diagonal elements in U C
C     are 1.0. The factorisation are done whitout pivot search. C
C     If pivot search is recomanded use SUBROUTINE LUDEC2.      C
C   - LUDEC1 computes the determinant of A and store it in DET. C
C                                                               C
C     ON INPUT                                                  C
C     A     : DOUBLE PRECISION double subscripted array of      C
C             actual dimension (N,N).                           C
C     N     : INTEGER actual dimension on A.                    C
C     NA    : INTEGER leading dimension on A in calling program.C
C     DET   : DOUBLE PRECISION containing any scalar.           C
C     ON OUTPUT                                                 C
C     A     : Containes the factorisation L*U. L are stored in  C
C             the lower part of A. U are stored in the upper    C
C             part of A.                                        C
C     DET   : Contains the determinant of A.                    C
C     IFLAG : INTEGER                                           C
C      IFLAG = 0  Sucsessfull factorisation                     C
C      IFLAG = 1  if diagonal elements in L .LT. 0.0 is detectedC
C      IFLAG = 2  The determinant of A is zero but the          C
C                 factorisation of A=L*U exist.                 C
C      IFLAG = 3  Diagonal elements in A equal zero is detected C
C                 The determinant of A is set to zero.          C
C                 WARNING the factorisation cant be done.       C
C                 (LUDEC2 shold be used)                        C
C     ROUTINES CALLED : (NONE)                                  C
C                                                               C
C***END PROLOGUE LUDEC1                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER NM1,N,I,KP1,J,IM1,IB,IP1,II,III,IFLAG
       DOUBLE PRECISION A(NA,NA),T,DET
C1... Initialisation                   ..........................
       DET=1.0
       IFLAG=0
C2...  Factorisation of A into L*U     ..........................
       NM1=N-1
       DO 10 K=1,NM1
          KP1=k+1
          DO 20 I=KP1,N
C... Test diagonal elements in A for zero elements  (IFLAG = 3)...
             IF (A(K,K).EQ.0) THEN      
              IFLAG=3.0
              DET=0.0
              GO TO 100
             ENDIF
             T=A(I,K)/A(K,K)
             IF (T.EQ.0.0) GO TO 20
             A(I,K)=T

             DO 30 J=KP1,N
                A(I,J)=A(I,J)-T*A(K,J)
30           CONTINUE
20        CONTINUE
10     CONTINUE
       
C3....Comput determinant of A det(A) = DET    ..(IFLAG = 1) .....
       DO 80 I=1,N
          DET=DET*A(I,I)
          IF (A(I,I).LT.0.0) IFLAG = 1
80     CONTINUE
C... Set IFLAG = 2 if DET is zero       ........(IFLAG = 2) .....
       IF (DET.EQ.0.0d0) THEN
        IFLAG=2
       ENDIF

100    RETURN
       END
