       SUBROUTINE LUSOL1(A,N,NA,B)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***START PROLOGUE LUSOL1                                       C
C   AUTHOR : David Di Ruscio    ITK/NTH  november 88            C
C                       (first version in diploma work 86)      C
C   PURPOSE                                                     C
C   LUSOL1 solves the linear system of equations L*U*x = b      C
C   The factor L*U = A from LUDEC could be used.                C
C   ON INPUT                                                    C
C   A   : DOUBLE PRECISION double subscripted array of dimensionC
C         (N,N) containing the LU factorisation. L should be    C
C         stored in the lower part of A and U in the upper part.C
C   B   : DOUBLE PRECISION single subscripted array of dimensionC
C         (N) containing the right hand side in L*U*x = b.      C
C   N   : INTEGER actual dimension on A.                        C
C   NA  : INTEGER leading dimension on A in calling program.    C
C   ON OUTPUT                                                   C
C   B   : DOUBLE PRECISION single subscripted array of dimensionC
C         (N) containing the solution vector x.                 C
C   ROUTINES CALLED  : (NONE)                                   C
C                                                               C
C***END PROLOGUE LUSOL1                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER N,NA
       DOUBLE PRECISION A(NA,N),B(NA)
       INTEGER I,IM1,K,IB,IP1

C......Loeser Ly=b...............................................
       DO 40 I=2,N
          IM1=I-1
          DO 50 K=1,IM1
             IF(A(I,K).NE.0) THEN
             B(I)=B(I)-A(I,K)*B(K)
             ENDIF
50        CONTINUE
40     CONTINUE

C......Loeser Lx = y ............................................
       B(N)=B(N)/A(N,N)
       DO 60 IB=2,N
          I=N-IB+1
          IP1=I+1
          DO 70 K=IP1,N
             IF (A(I,K).NE.0) THEN
              B(I)=B(I)-A(I,K)*B(K)
             ENDIF
70        CONTINUE
          B(I)=B(I)/A(I,I)
60     CONTINUE

       RETURN
       END
