       SUBROUTINE MABAT1(A,B,C,N,M,NA,NB,W)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE MABAT1                                       C
C   AUTHOR : David Di Ruscio            ITK/NTH DECEMBER 1988   C
C                                                               C
C   PURPOSE                                                T    C
C   MABAT1 computes the symmetric matrix product  C = A*B*A .   C
C                                                               C
C   ON INPUT                                                    C
C   A       DOUBLE PRECISION (N,M) any matrix. Unchanged on     C
C           output.                                             C
C   B       DOUBLE PRECISION (M,M) any symmetric matrix.        C
C           Unchanged on output.                                C
C   W       DOUBLE PRECISION (M) dimensional work array.        C
C   NA      INTEGER leading dimension for A and C.              C
C   NB      INTEGER leading dimension for B and W.              C
C   ON OUTPUT                                                   C
C   C       DOUBLE PRECISION (N,N) contains the symmetric       C
C           matrix produkt described above. C is forced to      C
C           be symmetric on output.                             C
C                                                               C
C   HISTORY :This routine is a modification of the Scandinavian C
C             Control library routine MCON.                     C
C                                                               C
C   ROUTINES CALLED : (NONE)                                    C
C***END PROLOGUE MABAT1                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER J,K,L,N,M,NA,NB
       DOUBLE PRECISION A(NA,M),B(NB,M),C(NA,N),W(NB),HELP

       DO 40 K=1,N
          DO 20 L=1,M
             HELP=0.0D0
             DO 10 J=1,M
                HELP=HELP+B(L,J)*A(K,J)
10           CONTINUE
             W(L)=HELP
20        CONTINUE

          DO 40 L=K,N
             HELP=0.0D0
             DO 30 J=1,M
                HELP=HELP+A(L,J)*W(J)
30           CONTINUE
             C(L,K)=HELP
             C(K,L)=HELP
40     CONTINUE

       RETURN
       END
