      SUBROUTINE MACEPS(EPS)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***START PROLUGUE MACEPS                                         C
C   David Di Ruscio                ITK/NTH 21 november 1988       C
C                                                                 C
C   PURPOSE                                                       C
C   MACEPS computes the machine epsilon EPS. EPS = the smallest   C
C   number such that EPS + 1 are grather than 1.                  C 
C                                                                 C
C   ON INPUT                                                      C 
C   EPS    Any double precision number                            C 
C   ON OUTPUT                                                     C
C   EPS    Contains the machine epsilon. The smallest no. such    C
C          that EPS+1.GT.1. Double precision EPS.                 C
C   ROUTINES CALLED  (None)                                       C
C***END PROLOGUE MACEPS                                           C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N
      DOUBLE PRECISION EPS,DPAR
      PARAMETER (DPAR = 2.0D0)
C1... Initial value on EPS (Small as possible for fast convergence)
C     EPS = 1.0D-16
      EPS = 1.0D0
C2... Computing machine epsilon for double precision argument .....
5     EPS = EPS/DPAR
      IF (EPS + 1.0D0 . GT. 1.0D0) GO TO 5
      EPS = DPAR*EPS
C3... Last line of MACEPS                           ...............
      RETURN
      END

