      SUBROUTINE RMACEPS(EPS)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***START PROLUGUE MACEPS                                         C
C   David Di Ruscio                ITK/NTH 21 november 1988       C
C                                                                 C
C   PURPOSE                                                       C
C   MACEPS computes the machine epsilon EPS. EPS = the smallest   C
C   number such that EPS + 1 are grather than 1.                  C 
C                                                                 C
C   ON INPUT                                                      C 
C   EPS    Any real precision number                              C 
C   ON OUTPUT                                                     C
C   EPS    Contains the machine epsilon. The smallest no. such    C
C          that EPS+1.GT.1. Real EPS.                             C
C   ROUTINES CALLED  (None)                                       C
C***END PROLOGUE MACEPS                                           C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N
      real EPS,DPAR
      PARAMETER (DPAR = 2.0E0)
C1... Initial value on EPS (Small as possible for fast convergence)
C     EPS = 1.0E-8
      EPS = 1.0E0
C2... Computing machine epsilon for double precision argument .....
5     EPS = EPS/2.0
      IF (EPS + 1.0E0 . GT. 1.0E0) GO TO 5
      EPS = 2.0*EPS
C3... Last line of MACEPS                           ...............
      RETURN
      END
