       SUBROUTINE SYPACK(A,B,D,E,AU,NX,NU,NY,NA,NB,ND,NE,NAU)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE SYPACK                                     C
C   AUTHOR : David Di Ruscio         ITK/NTH AUTOMN 88        C
C                                                             C
C   PURPOSE                          -                        C
C   SYPACK makes the expanded matrix A.                       C
C                                                             C
C                    -  (A B)                                 C
C                    A =(D E)                                 C
C                                                             C
C   ON INPUT                                                  C
C   A       DOUBLE PRECISION (NX,NX)                          C
C   B       DOUBLE PRECISION (NX,NU)                          C
C   D       DOUBLE PRECISION (NY,NX)                          C
C   E       DOUBLE PRECISION (NY,NU)                          C
C   AU      DOUBLE PRECISION (NAU,*)                          C
C   NA      INTEGER leading dimension on A in calling prog.   C
C   NB      INTEGER leading dimension on B in calling prog.   C
C   ND      INTEGER leading dimension on D in calling prog.   C
C   NE      INTEGER leading dimension on E in calling prog.   C
C   NAU     INTEGER leading dimension on AU in calling prog.  C
C   ON OUTPUT                                                 C
C   AU      The expanded matrix of dimension (NX+NU,NX+NY)    C
C                                                             C
C   ROUTINES CALLED : (NONE)                                  C
C***END PROLOGUE SYPACK                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER NX,NU,NY,NA,NB,ND,NE,NAU
       INTEGER I,J
       DOUBLE PRECISION A(NA,NX),B(NB,NU),D(ND,NY),E(NE,NU)
       DOUBLE PRECISION AU(NAU,NAU)

C......A - part                                 ................
       DO 10 I=1,NX
          DO 20 J=1,NX
             IF (I.LE.NX.AND.J.LE.NX) THEN
              AU(I,J)=A(I,J)
             ENDIF                             
20        CONTINUE
C..... B - part                                 ................
          DO 40 J=1,NU
             AU(I,NX+J)=B(I,J)
40        CONTINUE
10     CONTINUE
 
C..... D - part                                 ................
       DO 50 I=1,NX+NY
          DO 60 J=1,NX
             IF (I.GT.NX) THEN
              AU(I,J)=D(I-NX,J)
             ENDIF
60        CONTINUE
C...   E- part                                  .................
          DO 70 J=NX+1,NX+NU
             IF (I.GT.NX) THEN
              AU(I,J)=E(I-NX,J-NX)
             ENDIF
70        CONTINUE

50     CONTINUE

       RETURN
       END
