       SUBROUTINE VECMAX(A,MAX,N,NA)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE VECMAX                                      C
C   AUTHOR : David Di Ruscio            ITK/NTH sept 1988      C
C                                                              C
C   PURPOSE                                                    C
C   VECMAX finds the largest positive element in the vector A. C
C   The largest element in A are stored in MAX on output.      C
C   ON INPUT                                                   C
C   A    DOUBLE PRECISION (N) vector. Unchanged on output.     C
C   N    INTEGER dimension on A                                C
C   NA   INTEGER leading dimension on A in calling program.    C
C   ON OUTPUT                                                  C
C   MAX  Contains the largest element in the vector A.         C
C   ROUTINES CALLED : (NONE)                                   C
C***END PROLOGUE VECMAX                                        C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER I,J,JJ,N,NN,NA
       DOUBLE PRECISION A(NA),C,MAX,SAM

       MAX=A(1)
       DO 10 I=2,N
          SAM=A(I)
          IF (MAX.GE.SAM) GO TO 10
          C = MAX
          MAX = A(I)
          SAM = C
10     CONTINUE

       RETURN
       END

