      SUBROUTINE VECPRT(TEXT,ARG,A,NN,N)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***START PROLOGUE VECPRT                                       C
C   AUTHOR : David Di Ruscio            ITK/NTH 18/11 - 1988    C
C                                                               C
C   PURPOSE                                                     C
C   VECPRT prints a vector A(N) on terminal. An eksample is,    C
C   INTEGER N                                                   C
C   DOUBLE PRECISION X(10)                                      C
C   CALL VECPRT('Vector X =','X',X,10,N)                        C
C         Vector X =                                            C
C         X( 1) = ...                                           C
C         X( 2) = ...                                           C
C            .     .                                            C
C         X( N) = ...                                           C
C                                                               C
C   ON INPUT                                                    C
C   NN     The first dimension on A (NN) in calling program.    C
C   N      INTEGER dimensions for A(N).                         C
C   A      Single subscripted array of dimension (N)            C
C          DOUBLE PRECISION (N)                                 C
C   TEXT   Any leading TEXT.                                    C
C   ARG    The vector name.                                     C
C   ON OUTPUT                                                   C
C   Printout format are G16.9                                   C
C   The variables are unchanged on output                       C
C***END PROLOGUE VECPRT                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER I,NN,N
      DOUBLE PRECISION A(NN)
      CHARACTER TEXT*(*),AFORM*22,CFORM*6,ARG*(*)
C1... Initialize printout format                .................
      AFORM='(3X,A,A,I3,A,1X,G16.9)'
      CFORM='(3X,A)'
C2... Print vector ARG whit TEXT on terminal    .................
      WRITE(*,CFORM) TEXT
      DO 10 I=1,N
         WRITE(*,AFORM) ARG,'(',I,') = ',A(I)
10    CONTINUE
C3... Last line of VECPRT                       .................
      RETURN
      END


