      SUBROUTINE DSDETI(A,N,NA,IW,NI,DW,ND,DETA,JOB)
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C   Purpose                                                         c
C   Compute the determinant, invers or inertia of a symmetrix       c
C   matrix A                                                        c
C                                                                   c
C   ON INPUT                                                        c
C   A    DOUBLE PRECISION(NA,N)                                     c
C   DW   DOUBLE PRECISION(ND) ND = N*(N+1)/2+N  work space.         c
C   IW   INTEGER(NI) NI = N+3  work space.                          c
C   JOB  INTEGER  JOB = 010 -> determinant                          c
C   ON OUTPUT                                                       c
C   DETA DOUBLE PRECISION determinant of A.                         c
C                                                                   c
C   ROUTINES CALLED: DSET                                           c
C                    DSPFA, DSPDI (LINPACK routines)                c
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER N,NA,JOB,IW(NI)
      DOUBLE PRECISION A(NA,N),DW(ND),DETA
      DOUBLE PRECISION DET(2)
      INTEGER IAP,IWO,IKP,IIN

C... Pointers for double prec. work array DW
      IAP = 1
      IWO = IAP + N*(N+1)/2

C... Pointers for integer work array IW
      IKP = 1
      IIN = IKP + N

      IF (ND.LT.IWO .OR. NI.LT.IIN) THEN
       WRITE(*,'(1X,A)')'To less work space'
       GO TO 1000
      ENDIF

      CALL DSETA(A,DW,N,NA)
      CALL DSPFA(DW,N,IW,INFO)
      IF (INFO.NE.0) THEN
       WRITE(*,'(1X,A,I5)')'DSPFA INFO =',INFO
      ENDIF
      CALL DSPDI(DW(IAP),N,IW(IKP),DET,IW(IIN),DW(IWO),JOB)

      IF (DET(2).EQ.0.0) THEN
       DETA = DET(1)
      ELSE
       DETA = DET(1)*10.0D0**DET(2)
      ENDIF

1000  RETURN
      END

      SUBROUTINE DSETA(A,AP,N,NA)
      INTEGER N,NA
      DOUBLE PRECISION A(NA,N),AP(*)
      K = 0                                
      DO 20 J = 1, N                       
         DO 10 I = 1, J                    
             K = K + 1                     
            AP(K) = A(I,J)                 
10       CONTINUE                          
20    CONTINUE                             

      RETURN
      END

