      SUBROUTINE INACCH(F,X,N,FX)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C    PURPOSE                                                     C
C    To estimate the optimal perturbation at X. Useful for       C
C    estimating the gradient vectors during optimization.        C
C    It is hoped that this computation only is done initialy.    C
C                                                                C
C    ROUTINES CALLED : VECPRT                                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N
      DOUBLE PRECISION F,X(N)

      INTEGER MAX
      PARAMETER (MAX = 50)
      INTEGER HFAIL(MAX),IO          
      DOUBLE PRECISION PERT(MAX),GRAD(MAX),HESSDIAG(MAX)
      DOUBLE PRECISION STEP,EPSA,EPSR           
      PARAMETER (STEP = 1.0D-5)
      INTEGER NC,IGRAD
      COMMON /IDB/ NC,IGRAD
      EXTERNAL FX

      CALL ACCFUNC(FX,X,F,N,STEP,EPSA,EPSR)
      WRITE(*,'(5X,A,D30.23)')'Initial stepsice     STEP :',STEP
      WRITE(*,'(5X,A,D30.23)')'Calculated accuracy  EPSA :',EPSA
      WRITE(*,'(5X,A,D30.23)')'Calculated rel. acc. EPSR :',EPSR
      WRITE(*,'(5X,A,I20   )')'# of function calls  NC   :',NC   

      CALL ESTINT (FX,X,F,EPSA,N,PERT,GRAD,HESSDIAG,HFAIL)

      WRITE(*,'(5X,A,I20   )')'# of function calls  NC   :',NC   
      CALL VECPRT('Estimated perturbation :','PERT',PERT,MAX,N)
      CALL VECPRT('Estimated gradient     :','GRAD',PERT,MAX,N)

C... Write result to fort.4 file
      IO = 4
      CALL INACCRES(STEP,EPSA,EPSR,PERT,GRAD,MAX,N,NC,IO)


      RETURN
      END


      SUBROUTINE INACCRES(STEP,EPSA,EPSR,PERT,GRAD,MAX,N,NC,IO)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  PURPOSE                                                      C
C  Write result to file fort.IO (unix) or FOR0IO.DAT (VMS).     C
C  Output routine called from INACCH.                           C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N,MAX,NC
      DOUBLE PRECISION PERT(MAX),GRAD(MAX)                
      DOUBLE PRECISION STEP,EPSA,EPSR           

      WRITE(IO,'(5X,A,D30.23)')'Initial stepsice     STEP :',STEP
      WRITE(IO,'(5X,A,D30.23)')'Calculated accuracy  EPSA :',EPSA
      WRITE(IO,'(5X,A,D30.23)')'Calculated rel. acc. EPSR :',EPSR
      WRITE(IO,'(5X,A,I20   )')'# of function calls  NC   :',NC  

      WRITE(IO,'(5X,A)')'Estimated perturbations :'              
      WRITE(IO,1) (I,PERT(I),I=1,N)
1     FORMAT(2X,'PERT(',I3,' ) = ',D30.23)

      WRITE(IO,'(5X,A)')'Estimated gradient :'
      WRITE(IO,2) (I,GRAD(I),I=1,N)
2     FORMAT(2X,'GRAD(',I3,' ) = ',D30.23)

      RETURN
      END
