
      subroutine accfunc( fvalue,x,fx,xdim,step,epsa,epsr )
      double precision x(xdim),fx,epsa,epsr,step
      integer xdim

c/****************************************************************/
c/*                                                              */
c/*   This function estimates the accuracy with which a problem  */
c/*   function is evaluated. The procedure is described in       */
c/*   sections 8.5.2.3 and 8.5.2.4 in Practical Optimization     */
c/*   by Gill,Murray and Wrigth. It is assumed that derivatives  */
c/*   are not available, but the function may as well be used    */
c/*   even though they are. The call to the problem function     */
c/*   routine is similar to the calls from other library         */
c/*   routines.                                                  */
c/*                                                              */
c/*   Calling Parameters:                                Status: */
c/*                                                              */
c/*   fvalue  :Subroutine calculating function value
c/*            DESCR:                                            */
c/*            subroutine fvalue( fx,x,xdim )
c/*                                                              */
c/*   x       :Array holding parameter vector.
c/*                                                              */
c/*   fx      :Function value. Content by
c/*            entrance doesn't matter, by exit the              */
c/*            location holds the function value                 */
c/*            corresponding to the given parameter vector.      */
c/*                                                              */
c/*   xdim    :Dimension of parameter vector.               I    */
c/*                                                              */
c/*   step    :Corresponds to the h in the book.Decides     I    */
c/*            first stepsize.                                   */
c/*                                                              */
c/*   epsa    :The calculated accuracy.
c/*                                                              */
c/*   epsr    :Calculated relative accuracy. 
c/*                                                              */
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      double precision npoint(100),values(200)
      double precision stepsize,betak,kladd,minepsa,epsm
      integer i,j,k,l,numval
      integer*4 lfak,kfak
      external fvalue

      call machpres(epsm)
        numval = 10
        epsa = 0.0
        stepsize = step/sqrt( real(xdim) )
        do 10 i=1,numval
            do 5 j=1,xdim
5               npoint(j) = x(j) + real(i-1)*stepsize
            call fvalue( values(i),npoint,xdim )
10      continue
        fx = values(1)
        minepsa = epsm*(1.0+dabs( values(1) ))
        do 20 i=2,numval
            do 15 j=1,numval-i
                values((i-1)*numval+j) = values((i-2)*numval+j+1)
     +                              - values((i-2)*numval+j)
15          continue
20      continue
        do 100 i=4,6
            kfak = 1
            lfak = 1
            do 50 k=1,i
50             kfak = kfak*k
            do 60 l=1,2*i
60             lfak = lfak*l
            kladd = real(lfak)/real(kfak*kfak)
            betak = sqrt( kladd )
            values(i+1) = 0.0
            do 70 j=1,numval-i
                kladd = dabs( values((i+1)*numval+j) )
                if (kladd .ge. values(i+1))values(i+1) = kladd
70          continue            

            values(i+1) = values(i+1)/betak
            epsa = epsa + values(i+1)
100     continue
        epsa = epsa/3.0

        epsr = dmax1( epsm,epsa*epsm/minepsa )
        if (minepsa .gt. epsa)epsa = minepsa

        return
        end

