        subroutine conput(lunit,p,np,nr,nc,nt)
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C***begin prologue conput                                               c
C   Author : David Di Ruscio                            ITK             c
C   purpose                                                             c
C   To store a time varying matrix P(nr,nc) on file lunit               c
C   in system dependent binary format.                                  c
C   Time is stored in p(nr,1), states in p(nr,j+1),j=1,nc)              c
C                                                                       c
C   on input                                                            c
C   lunit integer logical file number.                                  c
C   p     real(nr,nc) matrix. Must be declared at least (nr,nc+1).      c
C   np    integer leading dimension on p in calling program.            c
C   nr    integer # of rows in p.                                       c
C   nc    integer # of columns in p.                                    c
C   nt    integer storing format.   nt = 1 --> single precision         c
C                                        file format.                   c
C                                   nt = 2 --> double precision         c
C         remark: time t is always stored as real.                      c
C                                                                       c
C   routines called : (none)                                            c
C***end prologue conput                                                 c
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer lunit,np,nr,nc,nm,nt
      double precision p(np,*),t

c...  nm = 1 (time varying) nt = 1 (real precision)
      nm    = 1

c... write single precision  nt = 1
      if (nt.eq.1) then
       do 10 i=1,nr
          t = p(i,1)
          write (lunit) sngl(t), ( sngl(p(i,j+1)) ,j=1,nc)
10     continue

c... write double precision file nt = 2
      elseif (nt.eq.2) then
       do 20 i=1,nr
          t = p(i,1)
          write (lunit) sngl(t), (p(i,j+1),j=1,nc)
20     continue
      endif

      return
      end
