
      subroutine filhdr(name,lunit,nr,nc,nm,nt,nx)
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C***begin prologue filhdr                                               c
C   purpose                                                             c
C   To open file name and write system header info equivalent to        c
C   honeyx format files. See further documentation in honeyx manual.    c
C                                                                       c
C   on input                                                            c
C   name character*(*) file name to be opened.                          c
C   nr  integer # of rows.                                              c
C   nc  integer # of columns.                                           c
C   nm  integer mode    nm = 0 constant.                                c
C                       nm = 1 time varying.                            c
C   nt  integer         nt = 1 real                                     c
C                       nt = 2 double precision                         c
C                       nt = 3 complex                                  c
C                       nt = 4 complex*16                               c
C   nx  integer number of states. nx=0 exept for system matrixes        c
C       in A B C D packed form.                                         c
C   on output                                                           c
C   lunit integer logical file number.                                  c
C   routines called : (none)                                            c
C***end prologue filhdr                                                 c
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer lunit,nr,nc,nm,nt,nx
      character*(*) name

C... open file 
      open (unit = lunit, file = name, status = 'new',
     +      form = 'unformatted', err=99)
      GO TO 110
99    open (unit = lunit, file = name, status = 'old',
     +      form = 'unformatted', err=100)

C... write header variables if legal ones
110   if (nr.ge.0 .and. nc.ge.0 .and. nm.ge.0 .and. nm.le.1
     +                          .and. nt.ge.1 .and. nt.le.4) then

        if (nx.eq.0) then
         write (lunit) nr,nc,nm,nt
        else
         write (lunit) nr,nc,nm,nt,nx
        endif

      else
        write(*,'(1X,A,5I9)')'error ---> Attempt to write invalid     
     +  header (nr nc nm nt nx ) :',nr,nc,nm,nt,nx
      endif
      return
100   write(*,'(1x,a)')'error ---> unable to open file'

      return
      end
