      SUBROUTINE PLTOUT(P,NSAMP,N,NL,NK,DT,IFIL,NAME)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE PLTOUT                                       C
C   AUTHOR : David Di Ruscio            ITK/NTH 11. mars 1989   C
C   PURPOSE                                                     C
C   Output facilities of an array P(NSAMP,N) based on CYPROS    C
C   output routines.                                            C
C   ON INPUT                                                    C
C   NAME   CHARACTER*(*) name of an TS-file (optionally)        C
C   IFIL   INTEGER file number                                  C
C   DT     REAL sample intervall (optionally) DT>0              C
C   P      REAL(NL,NK) array of numbers to be plotted.          C
C   NL,NK  INTEGER leading dimensions for P in calling prog.    C
C   NSAMP  INTEGER number of rows in P(NSAMP,N) array.          C
C   N      INTEGER number of columns in P(NSAMP,N) array.       C
C   ROUTINES CALLED : PROUT1,PROUT2,PROUT3                      C
C***END PROLOGUE PLTOUT                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N,NL,NK,IFIL
      INTEGER *4 NSAMP
      DOUBLE PRECISION P(NL,NK),DT
      CHARACTER NAME*(*)

      INTEGER NCOM,ICOM
      CHARACTER COM(5)*11
      DATA COM(1)/'disp'/, COM(2)/'keep'/,
     2     COM(3)/'plot'/, COM(4)/'Return'/,
     3     COM(5)/'0'/
      DATA NCOM/5/

      IF (NAME.EQ.' ') NAME = 'pltout.con'

C1... Checks for errors in input parameters             .........
      CALL PLTCHK(NL,NK,NSAMP,N,DT,IFLAG)
      IF (IFLAG.NE.0) GO TO 1000

C2... Choose command from above menu                    .........
      ICOM = 2
100   ICOM = ICREAD('Output command :',COM,NCOM,ICOM)

C3... Execute commands                                  .........
      IF     (ICOM.EQ.1) THEN
       CALL PROUT1(P,NSAMP,N,NL,NK)
       ICOM = 2
       GO TO 100
      ELSEIF (ICOM.EQ.2) THEN
       CALL PROUT2(P,NSAMP,N,NL,NK,DT,IFIL,NAME)
       ICOM = 3
       GO TO 100
      ELSEIF (ICOM.EQ.3) THEN
cut    CALL PROUT3(NAME)
       CALL PROUT3(P,NSAMP,N,NL,NK,IFIL,NAME)
       ICOM = 4
       GO TO 100
      ELSEIF (ICOM.EQ.4) THEN
       GO TO 1000
      ELSEIF (ICOM.EQ.5) THEN
       GO TO 1000
      ENDIF
CUT0  CALL SCLR

1000  RETURN
      END

      SUBROUTINE PROUT1(P,NSAMP,N,NL,NK)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE PROUT1                                       C
C   PURPOSE                                                     C
C   To plot columns versus rows of an array P(NSAMP,N) whit     C
C   CYPROS DISXY.                                               C
C   ROUTINES CALLED : NREAD, DISXY   (CYPROS routines)          C
C***END PROLOGUE PROUT1                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER NL,N,NK
      INTEGER*4 NSAMP
      DOUBLE PRECISION P(NL,NK)
      INTEGER IX(3),I1,I2,I3

100   IX(1) = 1
      IX(2) = 2
      IX(3) = 3
      CALL NREAD('Disp. column number ',IX,3,3,IIII)
      I1    = IX(1)
      I2    = IX(2)
      I3    = IX(3)
      IF (I1.EQ.0) GO TO 1000
      WRITE(IOUT,1) (I,P(I,I1), P(I,I2), P(I,I3), I=1,NSAMP)
1     FORMAT(1X,'sample ',I4,1X,3E16.6)
      GO TO 100

1000  RETURN
      END

      SUBROUTINE PROUT2(P,NSAMP,N,NL,NK,DT,IFIL,NAME)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE PROUT2                                       C
C   PURPOSE                                                     C
C   To store P(NSAMP,N) on a HX -file NAME.                     C
C   ROUTINES CALLED : RCSTR, FILHDR, CONPUT                     C
C***END PROLOGUE PROUT2                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N,NL,NK
      INTEGER *4 NSAMP
      INTEGER NR,NC,NM,NT,NX,LUNIT
      DOUBLE PRECISION P(NL,NK),DT
      CHARACTER NAME*(*)
      LOGICAL USED

C...  Store results on TS - file NAME                  ..........
      CALL RCSTR('Specify TS - file name :',NAME,1,1,IIII)
      IF (NAME.EQ.'0') GO TO 1000

C... Time varying vector (NR=1)
      NR = 1    
      NC = N
C... Mode time varying (NM=1)
      NM = 1
C... Store results in single precision (NT=1) on file NAME
      NT = 1
      NX = 0

      INQUIRE(file='pltout.con',exist=used)
      IF (USED) THEN
       CALL SYSTEM('rm '//'pltout.con')
      ENDIF
      LUNIT = 10
      CALL FILHDR(NAME,LUNIT,NR,NC,NM,NT,NX)
      CALL CONPUT(LUNIT,P,NL,NSAMP,NC,NT)

1000  RETURN
      END

      SUBROUTINE PROUT3(P,NSAMP,N,NL,NK,IFIL,NAME)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE PROUT2                                       C
C   PURPOSE                                                     C
C***END PROLOGUE PROUT2                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N,NL,NK,IFIL
      INTEGER *4 NSAMP
      INTEGER IT,ICOL(2),NCOL
      DOUBLE PRECISION P(NL,NK)
      CHARACTER NAME*(*), COMAND*72

      NSTR = LENS(NAME)
      IF (NAME(1:NSTR).EQ.'pltout.con') THEN
       IT   = 1
       ICOL(1) = 2
       ICOL(2) = 3
       CALL NREAD('X axis col. # :',IT,1,1,IIII)
       CALL NREAD('Y axis col. # :',ICOL,2,2,IIII)
       IF (ICOL(2).EQ.0) THEN
        NCOL = 1
       ELSE
        NCOL = 2
       ENDIF
       CALL DMAORD(P,NL,NK,NSAMP,N,IT,ICOL)
       CALL HXSTORE(P,NL,NK,NSAMP,NCOL,'pltout.con')
      ENDIF

      COMAND = 'plt '//NAME(1:NSTR)//' t r'
      CALL RCSTR('Unix command',COMAND,1,1,1)
      IF (COMAND.EQ.'0') GO TO 1000
      CALL SYSTEM(COMAND)

1000  RETURN
      END

      SUBROUTINE HXSTORE(P,NL,NK,NSAMP,N,NAME)
C
      INTEGER NL,NK,NSAMP,N
      DOUBLE PRECISION P(NL,NK)
      CHARACTER NAME*(*)
      INTEGER NR,NC,NM,NT,NX
      LOGICAL USED

C... Erase old file
      INQUIRE(file=name,exist=used)
      IF (USED) THEN
       CALL SYSTEM('rm '//name)
      ENDIF

C... Time varying vector (NR=1)
      NR = 1    
      NC = N
C... Mode time varying (NM=1)
      NM = 1
C... Store results in single precision (NT=1) on file NAME
      NT = 1
      NX = 0
      LUNIT = 10
      CALL FILHDR(NAME,LUNIT,NR,NC,NM,NT,NX)
      CALL CONPUT(LUNIT,P,NL,NSAMP,NC,NT)

      RETURN
      END

      SUBROUTINE DMAORD(P,NL,NK,NSAMP,N,IT,ICOL)
      INTEGER NL,NK,NSAMP,N,IT,IC1,IC2,ICOL(*)
      DOUBLE PRECISION P(NL,NK),W(6)

      IC1 = ICOL(1)
      IC2 = ICOL(2)

      DO 10 I=1,NSAMP
         W(1) = P(I,1)
         W(2) = P(I,IT)
         P(I,1)  = W(2)
         P(I,IT) = W(1)

         W(3) = P(I,2)
         W(4) = P(I,IC1)
         P(I,2)   = W(4)
         P(I,IC1) = W(3)

         IF (IC2.NE.0) THEN
          W(5) = P(I,3)
          W(6) = P(I,IC2)
          P(I,3)  = W(6)
          P(I,IC2) = W(5)
         ENDIF

10    CONTINUE
            

      RETURN
      END
