      SUBROUTINE DHAMC (A,H,Q,F,N,NA,NH,NQ,NF)
Cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C***begin prologue DHAMC                                             c
C   purpose                                                          c
C   DHAMC sets up the hamiltonian matrix F corresponding to the      c
C   continnuous Algebraic Riccati Equation (ARE). Note that only the c
C   stationary solution to the ARE can be found from F.              c
C                                                                    c
C     T                                   |  A -H  |                 c
C    A R + RA - RHR + Q = 0  --->     F = |      T |                 c
C                                         | -Q -A  |                 c
C                                                                    c
C   on input                                                         c
C   A,H,Q  double precision matrixes.                                c
C   n      integer actual dimension on A,H and Q.                    c
C   on output                                                        c
C   F      double precision Hamiltonian matrix with dim. (2n,2n)     c
C   routines called : (none)                                         c
C***end prologue DHAMC                                               c
Cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER N,NA,NH,NQ,NF
      DOUBLE PRECISION A(NA,N),H(NH,N),Q(NQ,N),F(NF,*)
      INTEGER I,J,NPI,NPJ

      DO 20 J=1,N
         NPJ = N+J
         DO 10 I=1,N
            NPI = N+I
            F(I,J)     =  A(I,J)
            F(NPI,J)   = -Q(I,J)
            F(I,NPJ)   = -H(I,J)
            F(NPI,NPJ) = -A(J,I)
   10    CONTINUE
   20 CONTINUE

      RETURN
      END
