
      SUBROUTINE SDCOPZ(Z,ZD,N,JOB)
Cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C***BEGIN PROLOGUE SDCOPZ                                              c
C   AUTHOR:  DAVID DI RUSCIO                    ITK/NTH november 1989  c
C   PURPOSE                                                            c
C   SDCOPZ perform transformations between REAL vector Z and           c
C   DOUBLE PRECISION vector ZD according to parameter JOB. Se          c
C   description below.                                                 c
C                                                                      c
C   ON INPUT                                                           c
C   Z    REAL(*) array                                                 c
C   ZD   DOUBLE PRECISION(*) array                                     c
C   N    INTEGER dimension on Z and ZD                                 c
C   JOB  INTEGER.  JOB = 1 ---> copy REAL Z to DOUBLE PRECISION ZD     c
C                  JOB = 2 ---> copy DOUBLE PRECISION ZD to REAL Z     c
C   ON OUTPUT                                                          c
C   Z,ZD as described above.                                           c
C                                                                      c
C   ROUTINES CALLED : (none)                                           c
C***END PROLOGUE SDCOPZ                                                c
Cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER N
      REAL Z(*)
      DOUBLE PRECISION ZD(*)

      IF (JOB.EQ.1) THEN
       DO 10 I=1,N
          ZD(I) = DBLE(Z(I))
10     CONTINUE
      ELSEIF (JOB.EQ.2) THEN
       DO 20 I=1,N
          Z(I) = SNGL(ZD(I))
20     CONTINUE
      ENDIF
      RETURN
      END
