
      SUBROUTINE STRMUL(A,B,C,N,M,P,NA,NB,NC,JOB)
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
C***BEGIN PROLOGUE STRMUL                                       c
C      AUTHOR                                                   c
C      David Di Ruscio       NTH october 1986                   c
C      Versjon 2:             17 october 1988                   c
C                                                               c
C      PURPOUSE                                                 c
C      STRMUL performs multiplication of a matrix whit the      c
C      transpose of another matrix. Bouf pre and post-          c
C      multipilication could be done. A and B are unchanged on  c
C      output                                                   c
C      A=(N x M),B=(M x P), C=(N x P)                           c
C                                                               c
C      ON INPUT                                                 c
C      A   REAL(NA,M) argument matrix.                          c
C      B   REAL(NB,P) argument matrix.                          c
C      NA  INTEGER leading dimensjon of A in calling program.   c
C      NB  INTEGER leading dimensjon of B in calling program.   c
C      NC  INTEGER leading dimensjon of C in calling program.   c
C      N,M INTEGER actual row and column dimension of A.        c
C      N,P INTEGER actual row and column dimension of B.        c
C      JOB INTEGER.  JOB = 1 ---> C = A*Btr.                    c
C                    JOB = 2 ---> C = Atr*B.                    c
C                                                               c
C      ON OUTPUT                                                c
C      C   REAL(NC,P) containing the product                    c
c          C = A*Btr (JOB=1) or C = Atr*B (JOB=2).              c
C      N,P INTEGER actual row and column dimension of C.        c
C                                                               c
C      ROUTINES CALLED : (none)                                 c
C***END PROLOGUE STRMUL                                         c
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER I,J,K,N,M,P,NA,JOB
      REAL A(NA,*),B(NB,*),C(NC,*),X

C....JOB=1 then postmult C = A*BT ...............................
      IF (JOB.EQ.1) THEN
       DO 10 I=1,N
          DO 20 J=1,P
             X=0.0
             DO 30 K=1,M
                X=X+A(I,K)*B(J,K)
30           CONTINUE
             C(I,J)=X
20        CONTINUE
10     CONTINUE

C...  JOB=2 then premult C = AT*B ...............................
      ELSEIF (JOB.EQ.2) THEN
       DO 11 I=1,N
          DO 21 J=1,P
             X=0.0
             DO 31 K=1,M
                X=X+A(K,I)*B(K,J)
31           CONTINUE
             C(I,J)=X
21        CONTINUE
11     CONTINUE
      ENDIF

      RETURN
      END
