      SUBROUTINE PQMAT(Q,P,WV,W1,W2,NX,NU,NA,NB,CJOB)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE PQMAT                                        C
C                                                               C
C   PURPOSE                                                     C
C   PQMAT is used to read the state weight matrix Q and         C
C   control weight matrix P from terminal. It is possible       C
C   to read only the matrix diagonal elements                   C
C                                                               C
C   W1  DUMMY ARRAY !                                           C
C                                                               C
C   ROUTINES CALLED : DREMA,RVEC ,DREAD  ,RCSTR                 C
C                     DIAGM                                     C
C***END PROLOGUE PQMAT                                          C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER NX,NU,NA,NB,ISVAR,IS
      DOUBLE PRECISION Q(NA,NX),P(NB,NU),WV(NA)
      DOUBLE PRECISION W1(NA,NA),W2(NA),DK
      CHARACTER CFORM*6,CJOB*(*),CMAT*4,CF*16

C1...Initialize                         .........................
      CFORM = '(5X,A)'
      CMAT  = CJOB(1:1)
      CF    = '(5X,A,I3,A,I3,A)'

C2... Specify which matrix to edit              .................
90    CALL RCSTR('Edit matrix ',CMAT,1,1,IIII)
      IF (CMAT.EQ.'Q'.AND.CJOB(1:1).EQ.'Q') THEN
       IF (CJOB(2:2).EQ.'P') THEN
        CMAT = 'P'
       ELSE
        CMAT = 'No'
       ENDIF
       GO TO 100
      ELSEIF (CMAT.EQ.'P'.AND.CJOB(2:2).EQ.'P') THEN
       CMAT = 'No'
       GO TO 200
      ELSEIF (CMAT.EQ.'N'.OR.CMAT.EQ.'No'.OR.CMAT.EQ.'0') THEN
       GO TO 1000
      ELSE
       DO 10 I=1,LEN( CJOB )
          IF (CJOB(I:I).NE.'0') THEN
           WRITE(*,'(5X,A,1X,A)')'* Avaiable ',CJOB(I:I)
          ENDIF
10     CONTINUE
       WRITE(*,CFORM)'* Type No or 0 to exit'
       CMAT = 'No'
       GO TO 90
      ENDIF

C3...Read Q                             .........................
100   IF (CJOB(1:1).EQ.'Q') THEN
       ISVAR = IYESANS('Diagonal state weight matrix ?',2)
       WRITE(*,CF)'* State weight matrix Q(',NX,',',NX,')'
       IF (ISVAR.EQ.1) THEN
        CALL DREMA(Q,W2,NX,NA,NX,NA,'Q')
       ELSEIF (ISVAR.EQ.2) THEN
        IS = IYESANS('Equal diagonal elements ?',2)
        IF (IS.EQ.1) THEN
         DO 20 I=1,NX
            WV(I) = Q(I,I)
20       CONTINUE
         CALL DRVEC('Diagonal element Q',WV,NX,NA)
        ELSEIF (IS.EQ.2) THEN
         DK = Q(1,1)
         CALL DREAD('Value on diagonal',DK,1,1,IIII)
         DO 21 I=1,NX
            WV(I) = DK
21       CONTINUE
        ENDIF
        CALL DIAGM(Q,WV,NX,NX,NA,NA)
       ENDIF
       GO TO 90
      ENDIF

C4...Read P                             .........................
200   IF (CJOB(2:2).EQ.'P') THEN
       ISVAR = IYESANS('Diagonal control weight matrix ?',2)
       WRITE(*,CF)'* Control weight matrix P(',NU,',',NU,')'
       IF (ISVAR.EQ.1) THEN
        CALL DREMA(P,W2,NU,NB,NU,NB,'P')
       ELSEIF (ISVAR.EQ.2) THEN
        IS = IYESANS('Equal diagonal elements ?',2)
        IF (IS.EQ.1) THEN
         DO 30 I=1,NU
            WV(I) = P(I,I)
30       CONTINUE
         CALL DRVEC('Diagonal element P',WV,NU,NA)
        ELSEIF (IS.EQ.2) THEN
         DK = P(1,1)
         CALL DREAD('Value on diagonal',DK,1,1,IIII)
         DO 31 I=1,NU
            WV(I) = DK
31       CONTINUE
        ENDIF
        CALL DIAGM(P,WV,NU,NU,NB,NA)
       ENDIF
       GO TO 90
      ENDIF

C... Reset work vector WV                      ..................
      DO 40 I=1,NX
         WV(I)= 0.0D0
40    CONTINUE
1000  RETURN
      END
