      SUBROUTINE DATCOM(A,B,C,D,G,KA,NX,NU,NV,NY,NA,NB,NC,ND,IF)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE DATCOM                                        C
C   AUTHOR : DAVID DI RUSCIO            ITK/NTH 26/1-1989        C
C   PURPOSE                                                      C
C   DATCOM  is used to exequte the commands SAVE, LOAD, and LIST C
C                                                                C
C   ON INPUT                                                     C
C   IF  INTEGER         IF = 1  Default is SAVE                  C
C                       IF = 2  Default is LOAD                  C
C                       IF = 3  Default is LIST                  C
C                                                                C
C   ROUTINES CALLED : SAVLOD2, RCSTR                             C
C***END PROLOGUE DATCOM                                          C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER NX,NU,NV,NY,NA,NB,NC,ND,IF
      DOUBLE PRECISION A(NA,NA),B(NB,NB),C(NC,NC),D(ND,ND)
      DOUBLE PRECISION G(NB,NA),KA(NA,ND)
      INTEGER IERR,IFLAG
      CHARACTER NAME*20,OP*6,CFORM*6,MAT*4

C... Initialization                                     .........
      CFORM = '(5X,A)'
      NAME  = 'A.DAT'
      MAT   = 'A'
      IF (IF.EQ.1) THEN
       OP = 'SAVE'
      ELSEIF (IF.EQ.2) THEN
       OP = 'LOAD'
      ELSEIF (IF.EQ.3) THEN
       OP = 'LIST'
      ENDIF
      GO TO 300

C... Specify operation  (not for first call)            .........
100   CALL RCSTR('Specify operation ',OP,1,1,IIII)
300   IF (OP.EQ.'LOAD'.OR.OP.EQ.'load') THEN
       IFLAG = 1
      ELSEIF (OP.EQ.'SAVE'.OR.OP.EQ.'save') THEN
       IFLAG = 2
      ELSEIF (OP.EQ.'LIST'.OR.OP.EQ.'list') THEN
       IFLAG = 3
       GO TO 200
      ELSEIF (OP.EQ.'EXIT'.OR.OP.EQ.'exit'.OR.OP.EQ.'0') THEN
       GO TO 1000
      ELSE
       WRITE(*,CFORM)'*         AVAIABLE IS                     '
       WRITE(*,CFORM)'*  SAVE       Save matrix on data file    '
       WRITE(*,CFORM)'*  LOAD       Load matrix from data file  '
       WRITE(*,CFORM)'*  LIST       List matrix on terminal     '
       WRITE(*,CFORM)'*  EXIT or 0  Exit to main modus          '
       OP = 'EXIT'
       GO TO 100
      ENDIF

C... Specify file name                                  .........
      CALL RCSTR('Data file name',NAME,1,1,IIII)
      IF (NAME.EQ.'0') THEN
       WRITE(*,CFORM)'* EXIT'
       GO TO 100
      ENDIF

C... Specify matrix name                                .........
200   CALL RCSTR('Matrix name',MAT,1,1,IIII)

C... Exequte command                                    .........
      IF (MAT.EQ.'A') THEN
       CALL SAVLOD2(A,NX,NX,NA,NAME,MAT,IERR,IFLAG)
       MAT = 'B'
       GO TO 100
      ELSEIF (MAT.EQ.'B') THEN
       CALL SAVLOD2(B,NX,NU,NB,NAME,MAT,IERR,IFLAG)
       MAT = 'C'
       GO TO 100
      ELSEIF (MAT.EQ.'C') THEN
       CALL SAVLOD2(C,NX,NV,NC,NAME,MAT,IERR,IFLAG)
       MAT = 'D'
       GO TO 100
      ELSEIF (MAT.EQ.'D') THEN
       CALL SAVLOD2(D,NY,NX,ND,NAME,MAT,IERR,IFLAG)
       MAT = 'G'
       GO TO 100
      ELSEIF (MAT.EQ.'G') THEN
       CALL SAVLOD2(G,NU,NX,NB,NAME,MAT,IERR,IFLAG)
       MAT = 'K'
       GO TO 100
      ELSEIF (MAT.EQ.'K') THEN
       CALL SAVLOD2(KA,NX,NY,NA,NAME,MAT,IERR,IFLAG)
       MAT = 'A'
       GO TO 100
      ELSEIF (MAT.EQ.'0') THEN
       GO TO 1000
      ELSE
       WRITE(*,CFORM)'*   AVAIABLE IS   '
       WRITE(*,CFORM)'* A B C D G K     '
       WRITE(*,CFORM)'* 0 - EXIT        '
       MAT = 'A'
       GO TO 100
      ENDIF

1000  RETURN
      END
