      SUBROUTINE MENU(IJOB,NJOB,IDEF)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE MENU                                         C
C                                                               C
C   PURPOSE                                                     C
C   MENU is used for listing of the utilities of                C
C   PROGRAM CONLAB on terminal.                                 C
C                                                               C
C   ON INPUT                                                    C
C   NJOB    INTEGER number of avaiable utilities declared in    C
C           the calling program                                 C
C   IJOB    INTEGER array of dimension (NJOB).                  C
C   IDEF    INTEGER number corresponding to default question.   C
C           Eks. IDEF = 3 on input. The default job to do is    C
C                IJOB(3)=3 ---> system matrix definitions       C
C   ON OUTPUT                                                   C
C   IJOB    Is set to the user specified job to be done.        C
C           IJOB(1)=1 --> read system from file                 C
C           IJOB(2)=2 --> system definitions.                   C
C             .             .                                   C
C                                                               C
C   ROUTINES CALLED : RCSTR  (read a character string. )        C
C***END PROLOGUE MENU                                           C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER IJOB(NJOB),NJOB,IDEF,ICOM,IPOS
      PARAMETER ( ICOM = 18 )
      CHARACTER CFORM*6,TEXT*26,CJOB*8,COM(ICOM)*(6)

      DATA COM( 1)/'SREAD'/,  COM( 2)/'SDEF'/,   COM( 3)/'SMAT'/,
     +     COM( 4)/'OPTIM'/,  COM( 5)/'SVD'/,    COM( 6)/'STORE'/,
     +     COM( 7)/'TSDIS'/,  COM( 8)/'MATLAB'/, COM( 9)/'ESTIM'/,
     +     COM(10)/'TDSIM'/,  COM(11)/'USER'/,   COM(12)/'SAVE'/,
     +     COM(13)/'LOAD'/,   COM(14)/'LIST'/,   COM(15)/'HELP'/,
     +     COM(16)/'ZEROES'/, COM(17)/'MODOPT'/, COM(18)/'EXIT'/

C1...Initialisation                     .........................
      CFORM = '(8X,A)'
      DO 10 I = 1,NJOB
         IJOB(I) = 101
10    CONTINUE

C ...Initialize default                         .................
      IF (    IDEF.EQ.1) THEN
       CJOB = 'SREAD '
      ELSEIF (IDEF.EQ.2) THEN
       CJOB = 'SDEF  '
      ELSEIF (IDEF.EQ.3) THEN
       CJOB = 'SMAT  '
      ELSEIF (IDEF.EQ.4) THEN
       CJOB = 'OPTIM '
      ELSEIF (IDEF.EQ.5) THEN
       CJOB = 'SVD   '
      ELSEIF (IDEF.EQ.6) THEN
       CJOB = 'STORE '
      ELSEIF (IDEF.EQ.7) THEN
       CJOB = 'TSDIS '
      ELSEIF (IDEF.EQ.0) THEN
       CJOB = 'EXIT  '
      ELSE
       CJOB = 'SDEF  '
      ENDIF

C3... Read CONLAB command operation from terminal         .......
      WRITE(*,CFORM)'                                           '
      TEXT = 'Main CONLAB operation :'
100   CALL RCSTR(TEXT,CJOB,1,1,IIII)
      WRITE(*,CFORM)'                                           '

C4... Extract a IJOB number from a number command CJOB    .......
      NUM = ICNUM(CJOB)
      IF (NUM.EQ.0) THEN
       IJOB(NJOB) = 0
       GO TO 1000
      ELSEIF (NUM.GE.1.AND.NUM.LE.NJOB-1) THEN
       IJOB(NUM) = NUM
       GO TO 1000
      ENDIF

C5... Extraxt IJOB number from a character command CJOB   .......
      CALL COMCHK(CJOB,COM,ICOM,IFLAG,IPOS)
      IF (IFLAG.EQ.0) THEN
       IF (IPOS.EQ.NJOB) THEN
        IJOB(IPOS) = 0
       ELSE
        IJOB(IPOS) = IPOS
       ENDIF
       GO TO 1000
      ELSEIF (IFLAG.EQ.1) THEN
       WRITE(*,'(5X,A,1X,A)')'ERROR SYMBOL OR COMMAND :',CJOB
       CALL COMLIS('Avaiable is :',COM,ICOM)
       CJOB = 'SDEF'
       GO TO 100
      ENDIF

1000  RETURN
      END
