
      SUBROUTINE SAVLOD2(A,N,M,NA,NAME,MAT,IERR,IFLAG)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE SAVLOD2                                      C
C   AUTHOR : DAVID DI RUSCIO                                    C
C   PURPOSE :                                                   C
C   SAVLOD2 exequte the following commands                      C
C      IFLAG = 1  LOAD matrix from file                         C
C      IFLAG = 2  SAVE matrix on file                           C
C      IFLAG = 3  LIST matrix on terminal                       C
C                                                               C
C   ROUTINES CALLED : MATPRT                                    C
C***END PROLOGUE SAVLOD2                                        C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER N,M,NA,IERR,NIN,IFLAG,IW(2)
      DOUBLE PRECISION A(NA,NA)
      CHARACTER NAME*(*),MAT*(*),CFORM*6

C... Format statements                                   ........
      CFORM = '(5X,A)'

C... Specify matrix dimension                            ........
      IF (IFLAG.EQ.1.OR.IFLAG.EQ.2) THEN
       IW(1) = N
       IW(2) = M
       CALL NREAD('Matrix dimension (N,M) ',IW,2,2,IIII)
       N = IW(1)
       M = IW(2)
      ENDIF

C... DATA file operation                                 ........

      NIN = 10
      IF (IFLAG.EQ.1) THEN
       OPEN(NIN,FILE=NAME,STATUS='OLD',ERR=98)
       DO 10 I=1,N
CUT       READ (NIN,99900,ERR=100) (A(I,J),J=1,M)
          READ (NIN,*    ,ERR=100) (A(I,J),J=1,M)
10     CONTINUE
      ELSEIF (IFLAG.EQ.2) THEN
       OPEN(NIN,FILE=NAME,STATUS='UNKNOWN',ERR=99)
       DO 20 I=1,N
          WRITE(NIN,99900) (A(I,J),J=1,M)
20     CONTINUE
      ELSEIF (IFLAG.EQ.3) THEN
       CALL MATPRT(MAT,A,NA,NA,N,M)
       IERR = 0
       GO TO 1000
      ENDIF
      CLOSE (NIN)

99900 FORMAT(100(3E23.15,/))
      IERR = 0
      WRITE(*,CFORM)'* Done'
      GO TO 1000

C... Error handling                                      ........
98    WRITE(*,CFORM)'* ---> FILE DOES NOT EXIST'
      IERR = 1
      GO TO 1000
99    WRITE(*,CFORM)'* ---> FILE ERROR'
      IERR = 2
      GO TO 1000

100   WRITE(*,CFORM)'* ---> READ ERROR'
      IERR = 3

1000  RETURN
      END
