      SUBROUTINE TDLSIM(AE,BE,CE,DE,GE,KE,NDIM,INFO)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE TDLSIM                                      C
C   AUTHOR : David Di Ruscio            26/9 - 1988            C
C                                                              C
C   PURPOSE                                                    C
C   TDLSIM is a program for numeric simulation of differential C
C   equations. External matrixes could pass into TDLSIM trough C
C   the subroutine head. This is not nessesarry ie. matrixes   C
C   could be defined in TDLSIM.                                C
C   ON INPUT                                                   C
C   INFO    - a dummy integer.                                 C
C   NDIM(1) - actual dimension on x , NX                       C
C   NDIM(2) - actual dimension on u , NU                       C
C   NDIM(3) - actual dimension on v , NV                       C
C   NDIM(4) - actual dimension on y , NY                       C
C                                                              C
C - TDLSIM is the PART I of the simulation program.            C
C   TDSIM is the PART II. TDSIM solves the diferential         C
C   equations defined in PART I TDLSIM.                        C
C - Dependent include files is TDSIM.INC and MAXDIM.INC.       C
C   MAXDIM.INC is called (nested) in TDSIM.INC.                C
C                                                              C
C**END PROLOGUE TDLSIM                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER NDIM(*),INFO,ICOM
      INCLUDE 'TDSIM.INC'
      DOUBLE PRECISION AE(NA,NA),BE(NB,NB),CE(NC,NC),DE(ND,ND)
      DOUBLE PRECISION A(NA,NA),B(NB,NB),C(NC,NC),D(ND,ND)
      DOUBLE PRECISION G(NB,NA),KA(NA,ND),GE(NB,NA),KE(NA,ND)
      CHARACTER COM(7)*7,CFORM*6

      COMMON /MAT1/ A,B,C,D,G,KA

      DATA COM(1)/'SYS-DEF'/, COM(2)/'DIM-DEF'/, COM(3)/'MAT-DEF'/,
     2     COM(4)/'SOLVE  '/, COM(5)/'HELP   '/, COM(6)/'RETURN '/,
     7     COM(7)/'0      '/
      DATA ICOM/7/

C...  INITIALIZATION                                        .....
      CFORM = '(5X,A)'

C...  Copy matrix information from "WORLD" at first call    .....
      CALL DIMCOP(NDIM,NX,NU,NV,NY,1)
      CALL SYSCOP1(AE,BE,CE,DE,A,B,C,D,NX,NU,NV,NY,NA,NB,NC,ND)
      CALL SYSCOP2(GE,KE,G,KA,NX,NU,NY,NA,NB,ND)

C... Now copy common blok /MAT1/ into common block /MAT2/   .....
      CALL COMCOP(NX,NU,NV,NY)

C.... Print user info on terminal                           .....
      CALL TDLHLP

C.... Start main work                                       .....
      IMAIN = 1
100   IMAIN = ICREAD('TDLSIM main command :',COM,ICOM,IMAIN)

      IF (IMAIN.EQ.1) THEN
C1..  Specify system to be simulated an initialize dimensions ..
       CALL INITSYS(IERR)
       WRITE(*,CFORM)'* Done !'
       IMAIN = 2
       GO TO 100
      ELSEIF (IMAIN.EQ.2) THEN
       CALL INITDIM(IERR)
       IMAIN = 3
       GO TO 100
      ELSEIF (IMAIN.EQ.3) THEN
C2..  Specify system matrixes                            ........
       CALL INITMAT(IERR)
       WRITE(*,CFORM)'* Done !'
       IMAIN = 4
       GO TO 100
      ELSEIF (IMAIN.EQ.4) THEN
C3..   Simulate system                                   ........
       CALL TDSIM(IERR)
       WRITE(*,CFORM)'* Done !'
       IMAIN = 5
       GO TO 100
      ELSEIF (IMAIN.EQ.5) THEN
C4..   List help info on terminal                        ........
       CALL TDLHLP
       WRITE(*,CFORM)'* Done !'
       IMAIN = 1
       GO TO 100
      ENDIF
      IF (IMAIN.EQ.0 .OR. IMAIN.EQ.6 .OR. IMAIN.EQ.7) THEN
C5..   Copy matrix data into output arrrays              ........
       CALL DIMCOP(NDIM,NX,NU,NV,NY,2)
       CALL SYSCOP1(A,B,C,D,AE,BE,CE,DE,NX,NU,NV,NY,NA,NB,NC,ND)
       CALL SYSCOP2(G,KA,GE,KE,NX,NU,NY,NA,NB,ND)

       RETURN
      ENDIF

      END

      SUBROUTINE TEXT
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE                                              C
C   PURPOSE                                                     C
C   TEXT display user information on screen.                    C
C   ROUTINES CALLED : (NONE)                                    C
C***END PROLOGUE TEXT                                           C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      CHARACTER CFORM*6

      CFORM = '(5X,A)'
      WRITE(*,CFORM)'-------------------------------------------'
      WRITE(*,CFORM)'<             PROGRAM TDLSIM              >'
      WRITE(*,CFORM)'<     TIME DOMAIN LINEAR SIMULATION       >'
      WRITE(*,CFORM)'<               SOLVER                    >'
      WRITE(*,CFORM)'<                         DDiR/ITK-1/2-89 >'
      WRITE(*,CFORM)'------------------------------------------>'

      RETURN
      END

      SUBROUTINE INITDIM(IERR)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                     C
C   To initialize system matrix dimensions.                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER IERR
      INCLUDE 'TDSIM.INC'
      CHARACTER CC*2

C... Dimensions in process equations                   ..........
      IF (ISYS(1).EQ.1) THEN
       CC = CSYS(1)
       CALL DIMVCK(NX,NA,CC,'A','X')
       CC = CSYS(2)
       CALL DIMVCK(NU,NB,CC,'B','U')
       CC = CSYS(3)
       CALL DIMVCK(NV,NC,CC,'C','V')
       CC = CSYS(4)
       CALL DIMVCK(NY,ND,CC,'D','Y')
      ENDIF

C... Dimensions in estimator equations                 ..........
      IF (ISYS(2).EQ.1.AND.ISYS(1).NE.1) THEN
       CC = CSYS(6)
       CALL DIMVCK(NX,NA,CC,'AE','XE')
       CC = CSYS(7)
       CALL DIMVCK(NU,NB,CC,'BE','UE')
       CC = CSYS(8)
       CALL DIMVCK(NV,NC,CC,'CE','VE')
       CC = CSYS(9)
       CALL DIMVCK(NY,ND,CC,'DE','YE')
      ENDIF

      RETURN
      END

      SUBROUTINE DIMVCK(NX,MAX,CSY,CMAT,CVEC)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                     C 
C   To read single dimension on vector CVEC corresponding to    C 
C   matrix CMAT only if CSY equal CMAT.                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER NX,MAX,NI
CUT   CHARACTER CSY*(*),CMAT*(*),CVEC*(*)
      CHARACTER CSY*(*),CMAT*(*),CVEC*2

      IF (CSY.EQ.CMAT) THEN
       NI = NX
100    CALL NREAD('Dimension on '//CVEC,NX,1,1,IIII)
       IF (NX.LT.0.OR.NX.GT.MAX) THEN
        WRITE(*,'(5X,A,A,A,I4)')
     + 'Error ---> Specify 0 < dim(',CVEC,') < ',MAX
        NX = NI
        GO TO 100
       ENDIF
      ELSE
       NX = 0
      ENDIF

      RETURN
      END

       SUBROUTINE DIMXUV(NX,NU,NV,NY,CSYS)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                     C
C   To read actual dimensions NX, NU, NV and NY                 C
C   Dummy routine (not used, not called from TDLSIM)            C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER NX,NU,NV,NY
       CHARACTER CSYS(*)*(*)

       IF (CSYS(1).EQ.'A') THEN
        CALL NREAD('Dimension on x',NX,1,1,IIII)
       ELSE
        NX = 0
        WRITE(*,'(5X,A)')'* ---> Warning ( NX = 0 )'
       ENDIF
       IF (CSYS(2).EQ.'B') THEN
        CALL NREAD('Dimension on u',NU,1,1,IIII)
       ELSE
        NU = 0
       ENDIF
       IF (CSYS(3).EQ.'C') THEN
        CALL NREAD('Dimension on v',NV,1,1,IIII)
       ELSE
        NV = 0
       ENDIF
       IF (CSYS(4).EQ.'D') THEN
        CALL NREAD('Dimension on y',NY,1,1,IIII)
       ELSE
        NY = 0
       ENDIF

       RETURN
       END

       SUBROUTINE TDLHLP
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                       C
C   To list help info on terminal.                                C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       CHARACTER CF*6

       CF = '(5X,A)'
       WRITE(*,CF)'                                               '
       WRITE(*,CF)'     <  T D L S I M   U T I L I T I E S  >     '
       WRITE(*,CF)'-----------------------------------------------'
       WRITE(*,CF)' Specify system to be simulated         SYS-DEF'
       WRITE(*,CF)' Specify system dimensions              DIM-DEF'
       WRITE(*,CF)' Edit matrixes in specified system      MAT-DEF'
       WRITE(*,CF)' Time Domain Linear Simulation          SOLVE  '
       WRITE(*,CF)' This help listning                     HELP   '
       WRITE(*,CF)' Leave TDLSIM                     0 or  RETURN '
       WRITE(*,CF)'-----------------------------------------------'
       WRITE(*,CF)'                                               '

       RETURN
       END

       SUBROUTINE INITSYS(IERR)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                      C
C   To initialize system to be simulated.                        C
C                                                                C
C   ON OUTPUT                                                    C
C   The defined matrixes in system to be simulated is stored in  C
C   the character array CSYS(NSYS)*4.                            C
C   PROCESS : CSYS(1)='A', CSYS(2)='B', CSYS(3)='C', CSYS(4)='D' C
C   CONTROLER : CSYS(5)='G'                                      C
C   ESTIMATOR : CSYS(6)='AE', CSYS(7)='BE', CSYS(8)='CE'         C
C               CSYS(9)='DE', CSYS(10)='KA'                      C
C   If process is defined ISYS(1)=1 else ISYS(1)=0               C
C   If estimator is defined ISYS(2)=1 else ISYS(2)=0             C
C   Data is transfered trough the common block defined in        C
C   TDSIM.INC.                                                   C
C                                                                C
C***END PROLOGUE INITSYS                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER INFO(3),IERR,NCOM,IPRO,IEST,IFLAG
       INCLUDE 'TDSIM.INC'
       CHARACTER CJOB*20,COM(5)*4,CPRO(5)*1,CRES(5)*4,CDUM(3)*4
       CHARACTER CEST(5)*2

       DATA COM(1)/'PRO'/, COM(2)/'EST'/, COM(3)/'CON'/,
     +      COM(4)/'NO '/, COM(5)/'0  '/
       DATA NCOM/5/

       DATA CPRO(1)/'A'/, CPRO(2)/'B'/, CPRO(3)/'C'/, CPRO(4)/'D'/

       DATA CEST(1)/'AE'/, CEST(2)/'BE'/, CEST(3)/'CE'/, CEST(4)/'DE'/,
     +      CEST(5)/'KA'/ 

C... Reset system arrays                                .........
       DO 10 I=1,3
          ISYS(I) = 0
          CDUM(I)(1:4) = ' '
10     CONTINUE
       DO 20 I=1,10
          CSYS(I)(1:LEN( CSYS(I) )) = ' '
20     CONTINUE

C1... Read commands from terminal                       .........
       CJOB = 'PRO,EST,CON'
100    CALL RCSTR('Define SYSTEM :',CJOB,1,1,IIII)
       INFO(1) = 1
       CALL COMSTR(CJOB,COM,NCOM,CRES,IFLAG,INFO)
       IF (IFLAG.NE.0) THEN
        CJOB = 'PRO,EST,CON'
        GO TO 100
       ENDIF

C2... Specify PROCESS structure (matrixes)              .........
       IF (CRES(1).EQ.'PRO') THEN
        ISYS(1) = 1
        IPRO    = 4
        CJOB    = 'A,B,C,D'
200     CALL RCSTR('Specify PROCESS matrixes',CJOB,1,1,IIII)
        INFO(1) = 1
        CALL COMSTR(CJOB,CPRO,IPRO,CSYS,IFLAG,INFO)
        IF (IFLAG.NE.0) THEN
         CJOB = 'A,B,C,D'
         GO TO 200
        ENDIF
        IN   = 5
        CDUM(1) = CRES(1)
       ENDIF

C3.. Specify estimator structure                      ..........
       IF (CRES(2).EQ.'EST') THEN
        ISYS(2) = 1
        CJOB    = 'AE,BE,CE,DE,KA'
        IEST    = 5
300     CALL RCSTR('Specify ESTIMATOR structure',CJOB,1,1,IIII)
        INFO(1) = 6
        CALL COMSTR(CJOB,CEST,IEST,CSYS,IFLAG,INFO)
        IF (IFLAG.NE.0) THEN
         CJOB = 'AE,BE,CE,DE,KA'
         GO TO 300
        ENDIF
        IN = 10
        CDUM(2) = CRES(2)
       ENDIF

C4.. Specify controller structure                       .........
       IF (CRES(3).EQ.'CON') THEN
        ISYS(3) = 1
        CJOB    = 'G'
400     CALL RCSTR('Specify CONTROLLER structure',CJOB,1,1,IIII)
        IF (CJOB.EQ.'G') THEN
         CSYS(5) = 'G'
        ELSE
         WRITE(*,'(5X,A,1X,A)')'Avaiable is : ',CSYS(5)
         ISYS(3) = 0
         GO TO 400
        ENDIF
        CDUM(3) = CRES(3)
       ENDIF

C5..  Excequte legal exit symbols                       .........
       IF (CRES(4).EQ.'NO'.OR.CRES(5).EQ.'0') THEN
        GO TO 1000
       ENDIF
       CJOB = 'NO'
       GO TO 100

C6.. List specified SYSTEM on terminal                  .........
1000   CALL COMLIS('Specified SYSTEM is:',CDUM,3)
       CALL COMLIS('Specified matrixes :',CSYS,IN)

       RETURN
       END

       SUBROUTINE DIMCOP(NDIM,NX,NU,NV,NY,IFLAG)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                     C
C   To copy dimensions from NDIM(4) to NX, NU, NV, and NY       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER NDIM(*),NX,NU,NV,NY,IFLAG

       IF (IFLAG.EQ.1) THEN
        NX = NDIM(1)
        NU = NDIM(2)
        NV = NDIM(3)
        NY = NDIM(4)
       ELSEIF (IFLAG.EQ.2) THEN
        NDIM(1) = NX
        NDIM(2) = NU
        NDIM(3) = NV
        NDIM(4) = NY
       ENDIF

       RETURN
       END

       SUBROUTINE INITMAT(IERR)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                      C
C   To read specified system, controller and estimator           C
C   matrixes.                                                    C
C                                                                C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER IERR
       INCLUDE 'TDSIM.INC'
       DOUBLE PRECISION A(NA,NA),B(NB,NB),C(ND,ND),D(ND,ND),G(NB,NA)
       DOUBLE PRECISION AE(NA,NA),BE(NB,NB),CE(ND,ND),DE(ND,ND)
       DOUBLE PRECISION KA(NA,ND),W1(NA,NA),W2(NA)
       CHARACTER COM(6)*(2)

       COMMON /MAT1/ A,B,C,D,G,KA
       COMMON /MAT2/ AE,BE,CE,DE

C1... Edit PROCESS and CONTROLLER matrixes A, B, C, D, and G .....
       IF (ISYS(1).EQ.1.OR.ISYS(3).EQ.1) THEN
        WRITE(*,'(5X,A)')'Edit process + controller matrixes'
        CALL SYSMAT(A,B,C,D,G,KA,W1,W2,NX,NU,NV,NY,NA,NB,NC,ND,CSYS,
     +              5,IERR)
       ENDIF

C2... Edit ESTIMATOR matrixes AE,BE,CE,DE,G and KA       .........
       IF (ISYS(2).EQ.1) THEN

CUT     CALL SYSCOP1(A,B,C,D,AE,BE,CE,DE,NX,NU,NV,NY,NA,NB,NC,ND)
        DO 10 I=1,4
           COM(I) = CSYS(I+5)
10      CONTINUE
        COM(5) = CSYS(5)
        COM(6) = CSYS(10)
        WRITE(*,'(5X,A)')'Edit estimator + controller matrixes'
        CALL SYSMAT(AE,BE,CE,DE,G,KA,W1,W2,NX,NU,NV,NY,NA,NB,NC,ND,
     +             COM,6,IERR)

       ENDIF

       RETURN
       END

       SUBROUTINE SYSCOP1(A,B,C,D,AE,BE,CE,DE,NX,NU,NV,NY,NA,NB,NC,ND)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                      C
C   To copy system matrixes A,B,C,D,G and KA on AE,BE,CE,DE,GE,KEC
C   ROUTINES CALLED : MATCOP                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER NX,NU,NV,NY,NA,NB,NC,ND
       DOUBLE PRECISION A(NA,NA),B(NB,NB),C(ND,ND),D(ND,ND)
       DOUBLE PRECISION AE(NA,NA),BE(NB,NB),CE(ND,ND),DE(ND,ND)

       CALL MATCOP(A,AE,NX,NX,NA,NA)
       CALL MATCOP(B,BE,NX,NU,NB,NB)
       CALL MATCOP(C,CE,NX,NV,NC,NC)
       CALL MATCOP(D,DE,NY,NX,ND,ND)


       RETURN
       END

       SUBROUTINE SYSCOP2(GE,KE,G,KA,NX,NU,NY,NA,NB,ND)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                     C
C   To copy GE,KE into G,KA                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER NX,NU,NY,NA,NB,ND
       DOUBLE PRECISION G(NB,NA),KA(NA,ND),GE(NB,NA),KE(NA,ND)

C... Copy GE to G and KE to KA
       CALL MATCOP(GE,G,NU,NX,NB,ND)
       CALL MATCOP(KE,KA,NX,NY,NA,ND)
       RETURN
       END

       SUBROUTINE COMCOP(NX,NU,NV,NY)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                      C
C   To copy matrixes in common block /MAT1/ into common block    C
C   /MAT2/.                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER NX,NU,NV,NY,NA,NB,NC,ND
       INCLUDE 'MAXDIM.INC'
       DOUBLE PRECISION A(NA,NA),B(NB,NB),C(ND,ND),D(ND,ND)
       DOUBLE PRECISION G(NB,NA),KA(NA,ND)
       DOUBLE PRECISION AE(NA,NA),BE(NB,NB),CE(ND,ND),DE(ND,ND)
CUT    DOUBLE PRECISION GE(NB,NA),KE(NA,ND)
       COMMON /MAT1/ A,B,C,D,G,KA
       COMMON /MAT2/ AE,BE,CE,DE

       CALL MATCOP(A,AE,NX,NX,NA,NA)
       CALL MATCOP(B,BE,NX,NU,NB,NB)
       CALL MATCOP(C,CE,NX,NV,NC,NC)
       CALL MATCOP(D,DE,NY,NX,ND,ND)

       RETURN
       END

       SUBROUTINE RESMAT(A,N,M,W1,W2,NA,NB,CNAME)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                     C
C   To read single matrix from terminal.                        C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       INTEGER N,M,NA,NB
       DOUBLE PRECISION A(NA,NB), W2(NA), W1(NA,NA)
       CHARACTER CNAME*(*),CDUM*6,CFORM*16

       CDUM = CNAME
90     CALL RCSTR('Edit matrix :',CDUM,1,1,IIII)
       IF (CDUM.EQ.CNAME) THEN
        CALL DREMA(A,W2,N,NA,M,NB,CNAME)
        CDUM = 'NO'
        GO TO 90
       ELSEIF (CDUM.EQ.'NO'.OR.CDUM.EQ.'0') THEN
        GO TO 100
       ELSE
        CFORM = '(5X,A,2X,A,3X,A)'
        WRITE(*,CFORM)'Aaiable is :',CNAME,'NO   0'
        CDUM = CNAME
        GO TO 90
       ENDIF

100    RETURN
       END

      SUBROUTINE TDSIM(IFLAG)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC  
C***BEGIN PROLOGUE TDSIM                                        C
C     PURPOSE                                                   C
C     TDSIM is a Time Domain linear simulation routine.         C
C     Linear system shuld be initialized before call of         C
C     TDSIM. System matrixes are load into TDSIM throug         C
C     the common block specified in include file TDSIM.INC.     C
C                                                               C
C     CALLED FROM : TDLSIM.                                     C
C                                                               C
C***END PROLOGUE TDSIM                                          C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER IFLAG,NST,NEQ
      INCLUDE 'TDSIM.INC'
      DOUBLE PRECISION F(NA+NA),X(NA+NA)
      DOUBLE PRECISION W1(NA),W2(NA),W3(NA),W4(NA),W5(NA)
      DOUBLE PRECISION P(IP,NK),DT,DDT
      CHARACTER COM(7)*7,CFORM*6,CNAME*10

      INTEGER NSAMP
      INTEGER IFIL,ICOM

      EXTERNAL LISYFX
                             
      DATA COM(1)/'INITVAL'/, COM(2)/'EULER  '/, COM(3)/'STIFF '/,
     2     COM(4)/'OUTPUT '/, COM(5)/'HELP   '/, COM(6)/'RETURN'/,
     3     COM(7)/'0      '/

      DATA NCOM/7/

C... Initialization                                     .........
      CNAME = 'tdsim.con'
      CFORM = '(5X,A)'

C... Find number of differential equations NEQ          .........
      CALL ININEQ(ISYS,NEQ,NX)
      IF (NEQ.EQ.0) WRITE(*,CFORM)'Warning ---> NEQ = 0'
      IF (NEQ.GE.1000) WRITE(*,CFORM)'Warning ---> NEQ > 1000'

C...  Print avaiable commands once at first call        .........
      CALL SUBHLP

C...  Choose command                                    .........
      ICOM = 1
100   ICOM = ICREAD('TDLSIM sub command :',COM,NCOM,ICOM)

      IF (ICOM.EQ.0) THEN
       GO TO 1000
      ELSEIF (ICOM.EQ.1) THEN
C1..   Define start values on X, U and V                .........
       CALL INITVAL(W1,W2,W3,W4,W5,IFLAG)
       CALL INITCOP(X,W1,W2,W3,W4,W5)
       WRITE(*,CFORM)'* Done !'
       ICOM = 3
       GO TO 100

      ELSEIF (ICOM.EQ.2) THEN
C2..  Simulate linear system with forward Euler         .........
       WRITE(*,CFORM) 'Initial values on X and XE'
       WRITE(*,'(2X,4E12.4)') (X(I),I=1,NEQ)

C... Include automatic step lenght DT from eigenvalues (DT<2/max(eig))
       IF (DT.EQ.0.0) DT = 0.1

       CALL ITPAR(NSAMP,ISTEP,DT,IFLAG)
       WRITE(*,CFORM)'* Integrating !'
       CALL DSIM(NEQ,F,X,NSAMP,ISTEP,DT,P)
       WRITE(*,CFORM)'* Done !'
       ICOM = 4
       GO TO 100

      ELSEIF (ICOM.EQ.3) THEN
C3... Integrate with SPRITE  (implisit methods)         .........
       WRITE(*,CFORM) 'Initial values on X and XE'
       WRITE(*,'(2X,4E12.4)') (X(I),I=1,NEQ)

       CALL DEQSOL(LISYFX,NEQ,X,INFO)
       ICOM = 1
       GO TO 100

      ELSEIF (ICOM.EQ.4) THEN
C4..  Output handling                                  ..........
       NS = NX+NU+NY+1
       IF (ISYS(2).EQ.1) THEN
        NS = NS+NX
       ENDIF
       IF (ISTEP.LE.0) ISTEP = 1
       NST = NSAMP/ISTEP
       DDT = DT*DBLE(ISTEP)
       WRITE(*,'(5X,A,I4,A,I5)')'Output ',NST,' samples of total ',
     + NSAMP

       CALL PLTOUT(P,NST,NS,IP,NK,DDT,IFIL,CNAME)
       WRITE(*,CFORM)'* Done !'
       ICOM = 1
       GO TO 100

      ELSEIF (ICOM.EQ.5) THEN
C5..  Print help on terminal                            .........
       CALL SUBHLP
       WRITE(*,CFORM)'* Done !'
       ICOM = 1
       GO TO 100

      ELSEIF (ICOM.EQ.6) THEN
       GO TO 1000
      ELSEIF (ICOM.EQ.7) THEN
       GO TO 1000
      ENDIF

1000  RETURN
      END

      SUBROUTINE ITPAR(NSAMP,ISTEP,DT,IFLAG)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C    PURPOSE                                                     C
C    To define time intervall, step size and number of samples   C
C    for use in methods with fixed stepsize h = DT.              C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER IFLAG,ISTEP,MAXSTEP
      PARAMETER (MAXSTEP = 100)
      INTEGER NSAMP
      DOUBLE PRECISION DT,WR(2),TS,TF,DDT,RNOS

      WR(1) = TS
      WR(2) = TF
100   CALL DREAD('Time intervall (Ts,Tf)',WR,2,2,IIII)
      TS = WR(1)
      TF = WR(2)
      IF (TS.EQ.TF.OR.TF.EQ.0.0E0) THEN
       WRITE(*,'(5X,A)')'Error ---> TS = TF or TF = 0'
       GO TO 100
      ENDIF
      DDT = DT
200   CALL DREAD('Step size h           ',DDT,1,1,IIII)
      DT = DDT
      IF (DT.LE.0.0E0) THEN
       WRITE(*,'(5X,A)')'Error ---> h < 0'
       GO TO 200
      ENDIF
C... Compute number of samples                  .................
      RNOS  = (TF-TS)/DT
      NSAMP =  IFIX(RNOS) 

C... Compute storing intervall                  .................
      ISTEP = NSAMP/MAXSTEP 
      IF (ISTEP.EQ.0) ISTEP = 1

      RETURN
      END

      SUBROUTINE INITVAL(W1,W2,W3,W4,W5,IFLAG)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE :                                                   C
C   This routine is used to user specification of the initial   C
C   values on states X, initial values on control signals U     C
C   and initial values on disturbances V.                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER IFLAG,ILEG,IPO,IPOS
      INCLUDE 'TDSIM.INC'
      DOUBLE PRECISION W1(NA),W2(NA),W3(NA),W4(NA),W5(NA)
      CHARACTER CDIM(6)*2,CFORM*6,CJOB*5,CLEG(6)*2

      DATA CLEG(1)/'X '/, CLEG(2)/'U '/, CLEG(3)/'V '/,
     +     CLEG(4)/'XE'/, CLEG(5)/'UE'/, CLEG(6)/'VE'/
      CFORM = '(5X,A)'

C... Compare system against references CLEG            ..........
      DO 1 I=1,6
         CDIM(I)(1:LENS(CDIM(I))) = ' '
1     CONTINUE
      DO 2 I=1,3
         IF (CSYS(I)   .NE. ' ') CDIM(I) = CLEG(I)
         IF (CSYS(I+5) .NE. ' ') CDIM(I+3) = CLEG(I+3)
2     CONTINUE

C... Find witch symbol (CLEG) to start with (statement 100) ....
      IDIM = 6
      IPO = ILEG(CDIM,1,IDIM)
      IF (IPO.NE.0) THEN
       CJOB = CLEG(IPO)
       GO TO 100
      ELSE
       WRITE(*,CFORM)'System not initialized !'
       RETURN
      ENDIF

C... Read symbol from terminal (start with legal default)  ......
100   CALL RCSTR('Specify initial values on ',CJOB,1,1,IIII)
      IF (CJOB.EQ.'0'.OR.CJOB.EQ.'EX'.OR.CJOB.EQ.'EXIT') GO TO 1000
      CALL COMCHK(CJOB,CDIM,IDIM,IFLAG,IPOS)
      IF (IFLAG.EQ.0) THEN
       GO TO 200
      ELSEIF (IFLAG.EQ.1) THEN
       WRITE(*,CFORM)'Error symbol or command !'
       CALL COMLIS('Avaiable is :',CDIM,IDIM)
       CJOB = CLEG( ILEG(CDIM,1,IDIM) )
       GO TO 100
      ENDIF

C... Initial values on states                           .........
200   IF (IPOS.EQ.1) THEN
       CALL INRVEC(W1,NX,NA,'X',CJOB,CDIM,IDIM,2)
       GO TO 100

C... Initial values on controller input u               .........
      ELSEIF (IPOS.EQ.2) THEN
       CALL INRVEC(W2,NU,NB,'U',CJOB,CDIM,IDIM,3)
       GO TO 100

C... Initial values on disturbances v                   .........
      ELSEIF (IPOS.EQ.3) THEN
       CALL INRVEC(W3,NV,NC,'V',CJOB,CDIM,IDIM,4)
       GO TO 100

C... Initial values on estimator states XE             ..........
      ELSEIF (IPOS.EQ.4) THEN
       CALL INRVEC(W4,NX,NA,'XE',CJOB,CDIM,IDIM,5)
       GO TO 100

C... Inintial values on estimator controller inputs U  ..........
      ELSEIF (IPOS.EQ.5) THEN
       CALL INRVEC(W2,NU,NB,'U',CJOB,CDIM,IDIM,6)
       GO TO 100

C... Initial values on estimator disturbances XE       ..........
      ELSEIF (IPOS.EQ.6) THEN
       CALL INRVEC(W5,NV,NC,'VE',CJOB,CDIM,IDIM,7)
       GO TO 100
      ENDIF

1000  RETURN
      END

      SUBROUTINE SUBHLP
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                      C
C   Short help table.                                            C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      CHARACTER CF*6
      CF = '(5X,A)'
      WRITE(*,CF)'                                                 '
      WRITE(*,CF)'         <  TDLSIM SUB COMMANDS  >               '
      WRITE(*,CF)'-------------------------------------------------'
      WRITE(*,CF)' Specify initial values                   INITVAL'
      WRITE(*,CF)' Integrate system with forward Euler      EULER  '
      WRITE(*,CF)' Integrate system with implisit methods   STIFF  '
      WRITE(*,CF)' Result handling, display,store etc.      OUTPUT '
      WRITE(*,CF)' This help listing                        HELP   '
      WRITE(*,CF)' Return to calling modus         0  or    RETURN '
      WRITE(*,CF)'-------------------------------------------------'
      WRITE(*,CF)'                                                 '

      RETURN
      END

      SUBROUTINE DSIM(NEQ,F,X,NSAMP,ISTEP,DT,P)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE DSIM                                          C
C   PURPOSE                                                      C
C   To integrate system dx/dt = F(X) with forward Euler.         C
C   (fixed step integration)                                     C
C***END PROLOGUE DSIM                                            C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER NEQ
      INCLUDE 'TDSIM.INC'
CUT   INTEGER*4 NSAMP
      INTEGER NSAMP
      INTEGER II,ISTEP,III,ITEL
      DOUBLE PRECISION F(NA+NA),X(NA+NA),T
      DOUBLE PRECISION P(IP,NK),DT

      ITEL  = 0
      III   = 1
      T     = 0.0D0

      DO 10 II=1,NSAMP+2
C1... Store variables                                   .........
         CALL PSTORE(P,X,II,T,DT,ISTEP,III,ITEL)

         IF (IPRT.EQ.1) THEN
          WRITE(*,'(1X,A,E16.6)') 'TIME ',T
          WRITE(*,11) (X(I),I=1,NEQ)
11        FORMAT(1X,'X(i)',4E12.4)
         ENDIF

C2... Compute right hand side of LQG or LQ equations    .........
         CALL FSYS(F,X,T,NEQ)

C3... Integrate with Euler                              .........
C.... Store states in array X(1) to X(NX)               .........
C.... Store estimates in array X(NX+1) to X(NEQ). NEQ=NX+NX .....
         DO 30 I=1,NEQ
            X(I) = X(I) + DT*F(I)
30       CONTINUE

         T = T + DT

10    CONTINUE

      RETURN
      END

      SUBROUTINE FSYS(F,X,T,NEQ)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     PURPOSE                                                   C
C     To compute right hand side of the LQG equations.          C
C                                                               C
C 1)  U       = G*X or U = G*XE                                 C
C 2)  F(I)    = A*X + B*U + C*V                     I = 1, NX   C
C 3)  Y       = D*X               -                             C
C 4)  F(I+NX) = AE*XE + BE*U + CE*V + KA*(Y - D*X), I = 1, NX   C
C                                                               C
C     NEQ  INTEGER actual number of diferential equations       C
C          on output.                                           C
C                                                               C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER NEQ
      INCLUDE 'TDSIM.INC'
      DOUBLE PRECISION F(NA+NA),X(NA+NA),W1(NA),W2(NA),W3(NA)
      DOUBLE PRECISION A(NA,NA),B(NB,NB),C(NC,NC),D(ND,ND),G(NB,NA)
      DOUBLE PRECISION AE(NA,NA),BE(NB,NB),CE(NC,NC),DE(ND,ND)
      DOUBLE PRECISION KA(NA,ND),XE(NA),XP(NA),T

      COMMON /MAT1/ A,B,C,D,G,KA
      COMMON /MAT2/ AE,BE,CE,DE

C1... Copy states X at t=T into XP (process) and XE (estimator)..
      DO 10 I=1,NX
         XP(I) = 0.0D0
         XP(I) = X(I)
         XE(I) = 0.0D0
         XE(I) = X(I+NX)
10    CONTINUE

C2... Compute controller input signal    u = G*x or u = G*XE ....
      IF (CSYS(5).EQ.'G') THEN
       IF (ISYS(2).EQ.1) THEN
        CALL MATMULT(G,XE,U,NU,NX,1,NA)
       ELSE
        CALL MATMULT(G,XP,U,NU,NX,1,NA)
       ENDIF
      ENDIF

C3... Compute right hand side of process equations F = A*x+B*u+C*v
C...  Store result in array F(1) to F(NX)
      IF (ISYS(1).EQ.1) THEN
       CALL FXTDL(F,XP,U,V,A,B,C,NX,NU,NV,NA,NB,NC,W1,W2,W3,CSYS,IFLAG)
      ENDIF

C4... Compute measurement signal         y = D*x          .......
      IF (CSYS(4).EQ.'D') THEN
       CALL MATMULT(D,XP,Y,NY,NX,1,NA)
      ENDIF

C5... Compute right hand side in estimator equations      .......
C...  Store result in array F(NX) to F(NX+NX)
      IF (ISYS(2).EQ.1) THEN
       CALL FETDL(F,XE,U,VE,Y,AE,BE,CE,DE,KA,NX,NU,NV,NY,NA,NB,NC,ND,
     +            W1,W2,W3,CSYS,IFLAG)
      ENDIF

      RETURN
      END

      SUBROUTINE FXTDL(F,X,U,V,A,B,C,NX,NU,NV,NA,NB,NC,W1,W2,W3,CSYS,
     +                 IFLAG)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE FX                                           C
C                                                               C
C   PURPOSE                                                     C
C   FX is used to compute the right hand side in the following  C
C   set of linear diferential equations.                        C
C                                                               C
C   dx/dt = F = A*x + B*u + C*v                                 C
C                                                               C
C***END PROLOGUE FX                                             C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER NX,NU,NV,NA,NB,NC,IFLAG
      DOUBLE PRECISION A(NA,NA),B(NB,NB),C(NC,NC),X(NA),U(NB),V(NC)
      DOUBLE PRECISION W1(NA),W2(NA),W3(NA),F(NA+NA)
      CHARACTER CSYS(*)*(*)

C... Reset work arrays                                  .........
      DO 10 I=1,NX
         F(I)  = 0.0D0
         W1(I) = 0.0D0
         W2(I) = 0.0D0
         W3(I) = 0.0D0
10    CONTINUE

C1... Compute dx/dt = F = A*x + B*u + C*v               .........
      IF (CSYS(3).EQ.'C') THEN
       IF (NV.NE.0) THEN
        CALL MATMULT(C,V,W1,NX,NV,1,NA)
       ELSE
        WRITE(*,*)'ILLEGAL DIMENSION IN MODULE FX  NV = ',NV
       ENDIF
      ENDIF

      IF (CSYS(2).EQ.'B') THEN
       IF (NU.NE.0) THEN
        CALL MATMULT(B,U,W2,NX,NU,1,NA)
       ELSE
        WRITE(*,*)'ILLEGAL DIMENSION IN MODULE FX NU = ',NU
       ENDIF
      ENDIF

      IF (CSYS(1).EQ.'A') THEN
       IF (NX.NE.0) THEN
        CALL MATMULT(A,X,W3,NX,NX,1,NA)
       ELSE
        WRITE(*,*)'ILLEGAL DIMENSION IN MODULE FX NX = ',NX
       ENDIF
      ENDIF

      DO 20 I=1,NX
         F(I) = W1(I) + W2(I) + W3(I)
20    CONTINUE

      RETURN
      END

      SUBROUTINE INITCOP(X,W1,W2,W3,W4,W5)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                     C
C   Copy initial values W1,W2,W3,W4 and W5 to X,U,V and VE      C
C   X,U,V,XE are transfered in COMMON block defined in INC-file C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INCLUDE 'TDSIM.INC'
      DOUBLE PRECISION X(NA+NA),W1(NA),W2(NA),W3(NA),W4(NA),W5(NA)

      IF (CSYS(1).EQ.'A') THEN
       CALL VECCOP(W1,X,NX,NA,NA)
      ENDIF
      IF (CSYS(2).EQ.'B'.OR.CSYS(7).EQ.'BE') THEN
       CALL VECCOP(W2,U,NU,NA,NB)
      ENDIF
      IF (CSYS(3).EQ.'C') THEN
       CALL VECCOP(W3,V,NV,NA,NC)
      ENDIF
      IF (CSYS(6).EQ.'AE') THEN
       DO 10 I=1,NX
          X(I+NX) = W4(I)
10     CONTINUE
      ENDIF
      IF (CSYS(8).EQ.'CE') THEN
       CALL VECCOP(W5,VE,NV,NA,NC)
      ENDIF
      RETURN
      END

      SUBROUTINE VECCOP(VI,VU,N,NI,NU)
C... Copy VI on VU                      ..................
      INTEGER N,NI,NU
      DOUBLE PRECISION VI(NI),VU(NU)

      DO 10 I=1,N
         VU(I) = VI(I)
10    CONTINUE
      RETURN
      END

      SUBROUTINE FETDL(F,X,U,V,Y,AE,BE,CE,DE,KA,NX,NU,NV,NY,
     +                 NA,NB,NC,ND,W1,W2,W3,CSYS,IFLAG)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE FE                                           C
C                                                               C
C   PURPOSE                                                     C
C   FE is used to compute the right hand side in the following  C
C   set of linear diferential equations.                        C
C                                                               C
C   dx/dt = F = AE*x + BE*u + CE*v + KA*(y - ye)                C
C                                                               C
C***END PROLOGUE FE                                             C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER NX,NU,NV,NY,NA,NB,NC,ND,IFLAG
      DOUBLE PRECISION AE(NA,NA),BE(NB,NB),CE(NC,NC),DE(ND,NA)
      DOUBLE PRECISION F(NA+NA),X(NA),U(NB),V(NC),Y(ND),KA(NA,ND)  
      DOUBLE PRECISION W1(NA),W2(NA),W3(NA)
      CHARACTER CSYS(*)*(*)

C... Reset work arrays                                  .........
      DO 10 I=1,NX
         F(I+NX) = 0.0D0
         W1(I)   = 0.0D0
         W2(I)   = 0.0D0
         W3(I)   = 0.0D0
10    CONTINUE

C1... Compute dx/dt = F = AE*x + BE*u + CE*v + KA( Y - D*x)......
      IF (CSYS(8).EQ.'CE') THEN
       IF (NV.NE.0) THEN
        CALL MATMULT(CE,V,W1,NX,NV,1,NA)
       ELSE
        WRITE(*,*)'ILLEGAL DIMENSION IN MODULE FE  NV = ',NV
       ENDIF
      ENDIF

      IF (CSYS(7).EQ.'BE') THEN
       IF (NU.NE.0) THEN
        CALL MATMULT(BE,U,W2,NX,NU,1,NA)
       ELSE
        WRITE(*,*)'ILLEGAL DIMENSION IN MODULE FE NU = ',NU
       ENDIF
      ENDIF

      IF (CSYS(6).EQ.'AE') THEN
       IF (NX.NE.0) THEN
        CALL MATMULT(AE,X,W3,NX,NX,1,NA)
       ELSE
        WRITE(*,*)'ILLEGAL DIMENSION IN MODULE FE NX = ',NX
       ENDIF
      ENDIF

C... Store AE*X + BE*U + CE*V                           .........
      DO 20 I=1,NX
         F(I+NX) = W1(I) + W2(I) + W3(I)
         W1(I)   = 0.0D0
         W2(I)   = 0.0D0
         W3(I)   = 0.0D0
20    CONTINUE

C... Compute KA(Y - YE) = W3                            .........
      IF (CSYS(10).EQ.'KA') THEN
       CALL MATMULT(DE,X,W1,NY,NX,1,NA)
       DO 30 I=1,NY
          W2(I) = Y(I) - W1(I)
30     CONTINUE
       CALL MATMULT(KA,W2,W3,NX,NY,1,NA)
      ENDIF

      DO 40 I=1,NX
         F(I+NX) = F(I+NX) + W3(I)
40    CONTINUE

      RETURN
      END

      SUBROUTINE PSTORE(P,X,II,T,DT,ISTEP,III,ITEL)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                     C
C   To store variables as a function of time.                   C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER II,ISTEP,III,ITEL
      INCLUDE 'TDSIM.INC'
      DOUBLE PRECISION X(NA+NA),T
      DOUBLE PRECISION P(IP,NK),DT

C1... Store variables                                   .........
      IF (II.EQ.1.OR.ITEL.EQ.0) THEN
         P(III,1) = T
         IF (CSYS(1).EQ.'A') THEN
          DO 20 I=1,NX
             P(III,I+1)    = X(I)
20        CONTINUE
         ENDIF
         IF (CSYS(2).EQ.'B') THEN
          DO 21 I=1,NU
             P(III,I+NX+1) = U(I)
21        CONTINUE
         ENDIF
         IF (CSYS(4).EQ.'D') THEN
          DO 22 I=1,NY
             P(III,I+NX+NU+1) = Y(I)
22        CONTINUE
         ENDIF
         IF (ISYS(2).EQ.1) THEN
          DO 23 I=1,NX
             P(III,I+NX+NU+NY+1) = X(I+NX)
23        CONTINUE
          P(III,NX+NX+NU+NY+1) = DT
         ELSE
          P(III,NX+NU+NY+2) = DT
         ENDIF
      ENDIF

      IF (IPRT.EQ.1) THEN
       WRITE(*,'(2X,A,3E12.4)')'X   *',(X(I),I=1,NX)
       WRITE(*,'(2X,A,3E12.4)')'P   *',P(III,1), P(III,2), P(III,3)
       WRITE(*,'(2X,A,4I3   )')'II III ITEL ISTEP',
     +                           II,III,ITEL,ISTEP 
       CALL COMLIS('System ',CSYS,4)
      ENDIF

C... Uppdata storing counter                            .........
      ITEL  = ITEL + 1
      IF (ITEL.EQ.ISTEP) THEN
       III  = III + 1
       ITEL = 0
      ENDIF

      RETURN
      END

      SUBROUTINE ININEQ(ISYS,NEQ,NX)
C. Initialize number of differential equations NEQ to be solved
      INTEGER ISYS(*),NEQ,NX,NEQ1,NEQ2

      NEQ  = 0
      NEQ1 = 0
      NEQ2 = 0
      IF (ISYS(1).EQ.1) THEN
       NEQ1 = NX
      ELSE
       NEQ1 = 0
      ENDIF
      IF (ISYS(2).EQ.1) THEN
       NEQ2 = NX
      ELSE
       NEQ2 = 0
      ENDIF
      NEQ = NEQ1 + NEQ2

      RETURN
      END

      SUBROUTINE LISYFX(NEQ,T,XD,XDOT,R,IRES,WKRES,NWKRES)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE LISYFX                                      C
C   PURPOSE                                                    C
C   This routine computes right hand side equations in         C
C   total system ODE. LISYFX is called be SPRITE               C
C   integeration package.                                      C
C   The array WKRES(NWKRES) is not used by LISYFX. Se SPRINT   C
C   manual for usage. (Could be used to transport parameters   C
C   to this routine).                                          C
C   ON INPUT                                                   C
C   NEQ - Number of differential equations.                    C
C   T   - time                                                 C
C   XD  - solution at X(T)                                     C
C   XDOT- dx/dt                                                C
C   IRES- IRES=-1 at first kall                                C
C   ON OUTPUT                                                  C
C   R   - residual r = f(x) - dx/dt                            C
C                                                              C
C***END PROLOGUE LISYFX                                        C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER NEQ, NWKRES, IRES
      DOUBLE PRECISION T,XD(NEQ),XDOT(NEQ),R(NEQ),WKRES(NWKRES)
      INCLUDE 'TDSIM.INC'
      DOUBLE PRECISION F(NA+NA), X(NA+NA)

C... First- must tell SPRINT that ODE is ODE            ........
      IF (IRES .EQ. -1 ) THEN
       DO 10 I=1,NEQ
          R(I) = -XDOT(I)
10     CONTINUE
      ELSE

C... Compute right hand side F(I) = f(X(I)) =dX/dt      ........
       DO 20 I=1,NEQ
          X(I) = 0.0D0
          X(I) = XD(I)
20     CONTINUE
       CALL FSYS(F,X,T,NEQ)

C... Compute residuals  r = f(x) - dx/dt                ........
       DO 30 I=1,NEQ
          R(I) = F(I) - XDOT(I)
30     CONTINUE

      ENDIF

      RETURN
      END

      INTEGER FUNCTION ILEG(CSYS,IP,IDIM)
C...CALLED FROM : INITVAL
      INTEGER IDIM,I,IP
      CHARACTER CSYS(*)*(*)

      DO 10 I=IP,IDIM
         IF (CSYS(I).NE.' ') THEN
          ILEG = I
          GO TO 1000
         ENDIF
10    CONTINUE
      ILEG = 0

1000  RETURN
      END

      SUBROUTINE INRVEC(X,NX,NA,CX,CJOB,CDIM,IDIM,NSTART)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   PURPOSE                                                     C
C   To read a vector X with name CX and return next vector      C
C   to read in CJOB.                                            C
C   ROUTINES CALLED : RVEC,ILEG,CLEG                            C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      INTEGER NX,NA,IDIM,IPO,NSTART
      DOUBLE PRECISION X(NA)
CUT   CHARACTER CX*(*),CJOB*(*),CDIM(*)*(*)
      CHARACTER CX*2,CJOB*(*),CDIM(*)*(*)

C... Read vector
      IF (NX.NE.0) THEN
       CALL DRVEC('Initial value on '//CX,X,NX,NA)
      ELSE
       WRITE(*,'(5X,A)')'Dimension is zero !'
       GO TO 1000
      ENDIF

C... Find next symbol CJOB to return
      IF (NSTART.LE.IDIM) THEN
       IPO = ILEG(CDIM,NSTART,IDIM)
       IF (IPO.NE.0) THEN
        CJOB = CDIM(IPO)
       ELSE
        CJOB = 'EXIT'
       ENDIF
       GO TO 1000
      ELSE
       CJOB = 'EXIT'
      ENDIF

1000  RETURN
      END
