Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C      TRANSF is a program for computing the transfer matrix    c
C      H(s) = D(sI - A)**(-1)B = { p(s)/q(s) } of a state       c
C      space model (A,B,D).                                     c
C      Main work routine is : DTRANS                            c
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       PROGRAM TRANSF

       INTEGER ISVAR,IFLAG,MAX,NMAX
       PARAMETER (MAX = 10, NMAX = 12)
       DOUBLE PRECISION A(MAX,MAX),B(MAX,MAX),D(MAX,MAX)
       DOUBLE PRECISION P(NMAX,MAX,MAX),Q(NMAX),PW(NMAX)
       INTEGER NA,ND,NB,NPI,NPJ,NNA
       CHARACTER CNAME*72,CNAM2*72
C... Work arrays   
       DOUBLE PRECISION WC(MAX,MAX),WG(MAX,MAX),WK(MAX,MAX)

C... System parameters in DATA block 1
      INTEGER ISYS
      PARAMETER (ISYS = 10)
      CHARACTER CSYS(ISYS)*2
C... Main commmand parameters in DATA block 2
      INTEGER ICOM,IMAIN
      PARAMETER (ICOM = 9)
      CHARACTER COM(ICOM)*6

C.DATA block 1  System matrix names  A,B,D,G,P,Q and R
      DATA  CSYS(1)/'A'/, CSYS(2)/'B'/, CSYS(3)/' '/, CSYS(4)/'D'/,
     +      CSYS(5)/' '/, CSYS(6)/' '/, CSYS(7)/' '/, CSYS(8)/' '/,
     +      CSYS(9)/' '/, CSYS(10)/' '/

C.DATA block 2 Main commmands
      DATA  COM(1)/'DIM'/,  COM(2)/'SYS'/,  COM(3)/'SOLV'/,
     +      COM(4)/'LOAD'/, COM(5)/'SAVE'/, COM(6)/'RES'/,
     +      COM(7)/'HELP'/, COM(8)/'EXIT'/, COM(9)/'0'/

C1....Initialize default parameters             .................
      IOUT = 6
      IPRT = 0
      CNAME = 'TRANSF.DAT'
      CNAM2 = 'RESULT.DAT'

C ... Print program description on terminal     .................
      CALL TRHEAD


C.. MAIN INPUT COMMANDS
      IMAIN = 1
100   WRITE(*,*)'  '
      IMAIN = ICREAD('TRANSF main command :',COM,ICOM,IMAIN)

C.EXIT
      IF (IMAIN.EQ.0) THEN
       GO TO 1000
C.DIM
      ELSEIF (IMAIN.EQ.1) THEN

C... Specify dimensions
101   CALL NREAD('Dimension on x  NX = ',NA,1,1,IIII)
      CALL NREAD('Dimension on u, NU = ',NB,1,1,IIII)
      CALL NREAD('Dimension on y, NY = ',ND,1,1,IIII)

      CALL DIMCHK(NA,NB,ND,MAX,IERR)
      IF (IERR.NE.0) THEN
       WRITE(*,'(1X,A,I4)')'Maximum dimensions on (x u y) is :',MAX
       GO TO 101
      ENDIF

      IMAIN = 2
      GO TO 100
C.SYS
      ELSEIF (IMAIN.EQ.2) THEN

C3....  Interactiv reading    ....................................
       CALL DSYSMAT(A,B,WC,D,WG,WK,PW,NA,NB,1,ND,
     +               MAX,MAX,MAX,MAX,CSYS,ISYS,IERR)

       IMAIN = 3
       GO TO 100

C.SOLVE
      ELSEIF (IMAIN.EQ.3) THEN
C... Compute transfer matrix
       NPI = NA
       NPJ = NA
       CALL DTRANS(A,B,D,NA,NB,ND,P,Q,PW,NPI,NPJ,MAX,NMAX)
       IMAIN = 8
       GO TO 100
C.LOAD
      ELSEIF (IMAIN.EQ.4) THEN

C2....  Read matrices from file CNAME         ....................
       CALL RCSTR('Specify file name',CNAME,1,1,IIII)
       IF (CNAME.EQ.'0') THEN
        CNAME = 'TRANSF.DAT'
        GO TO 100
       ENDIF
       CALL MATRISER(A,B,D,NA,NB,ND,2,CNAME)
C      CALL SYSDAT(A,B,WC,P,WG,WK,K,D,DG,GD,NA,NB,NA,ND,MAX,1,
C    +             CNAME,IERR)
       IF (IERR.NE.0) THEN
        CNAME = 'TRANSF.DAT'
       ENDIF
       IMAIN = 3
       GO TO 100

C.SAVE
      ELSEIF (IMAIN.EQ.5) THEN

C2....  Save matrices on file CNAME         ....................
       CALL RCSTR('Specify file name',CNAME,1,1,IIII)
       IF (CNAME.EQ.'0') THEN
        CNAME = 'DESREG.DAT'
        GO TO 100
       ENDIF
       CALL MATRISER(A,B,D,NA,NB,ND,1,CNAME)
C      CALL SYSDAT(A,B,R,P,Q,G,K,D,DG,GD,NA,NB,NA,ND,MAX,2,CNAME,
C    +             IERR)

       IF (IERR.NE.0) THEN
        CNAME = 'TRANSF.DAT'
       ENDIF
       IMAIN = 4
       GO TO 100

C. RES 
      ELSEIF (IMAIN.EQ.6) THEN
       CALL RCSTR('Specify file name',CNAM2,1,1,IIII)
       IF (CNAM2.EQ.'0') THEN
        CNAM2 = 'RESULT.DAT'
        GO TO 100
       ENDIF
       CALL RESULT(P,Q,NA,NB,ND,NNA,CNAM2)
       IMAIN = 8
       GO TO 100
C.HELP
      ELSEIF (IMAIN.EQ.7) THEN
       CALL TRAHLP
       IMAIN = 1
       GO TO 100
C. EXIT
      ELSEIF (IMAIN.EQ.8) THEN
       GO TO 1000
C. 0 = EXIT
      ELSEIF (IMAIN.EQ.9) THEN
       GO TO 1000
      ENDIF

1000   ISVAR=IYESANS('Terminate program ?',2)
       IF (ISVAR.EQ.1) GO TO 100
       STOP '<   E X I T  T R A N S F   >'

       END
C*****************************************************

       SUBROUTINE SKRIV(STRING,PO,N)
       INTEGER N,J
       DOUBLE PRECISION PO(N)
       CHARACTER STRING*8,CR,LF
       CR=CHAR(13)
       LF=CHAR(10)
10     FORMAT('$',A1)
15     FORMAT('$',A2)
17     FORMAT('$',14X)
20     FORMAT('$',A8)
30     FORMAT('$',6X,I1)
40     FORMAT('$',1X,F4.1,'s',1X)
       WRITE(1,15) LF,LF
       WRITE(1,10) CR
       WRITE(1,20) '        '

       DO 70 J=0,NINT(PO(1))-1
         WRITE(1,30) J
70     CONTINUE

       WRITE(1,10) LF
       WRITE(1,10) CR
       WRITE(1,20) STRING

       DO 80 J=2,NINT(PO(1))+1
         WRITE(1,40) PO(J)
80     CONTINUE

       RETURN
       END
C******************************************************************

       SUBROUTINE TRAMUL(G,NGI,NGIM,NGJ,NGJM,P,NPM,NPI,NPIM,NPJ,NPJM,
     > R,NRM,NRI,NRIM,NRJ,NRJM,PREM)

C  TRAMUL PRE- OR POSTMULTIPLIES A TRANSFER MATRIX P/Q WITH A SCALAR
C  MATRIX G . THE RESULT IS A NEW TRANSFER MATRIX R/Q. THE MATRIX
C  R MAY BE P ITSELF. ORIGINAL VALUES IN P ARE THEN LOST.

       INTEGER NGI,NGIM,NGJ,NGJM,NPM,NPI,NPIM,NPJ,NPJM
       INTEGER NRM,NRI,NRIM,NRJ,NRJM,PREM,I,J,K,JW
       DOUBLE PRECISION G(NGIM,NGJM)
       DOUBLE PRECISION P(NPM,NPIM,NPJM),R(NRM,NRIM,NRJM)
       DOUBLE PRECISION PW(12,10),PW1(12)

C      WRITE(1,*)'NGI,NGJ,NPI,NPJ',NGI,NGJ,NPI,NPJ
       IF(PREM.EQ.1) THEN

C  PREM .EQ. 1 IMPLIES PREMULTIPLICATION :

         DO 10 J=1,NPJ
           DO 20 I=1,NGI
             JW=IDNINT(P(1,I,J))+1
             CALL POLZER(PW(1,I),JW)
             DO 30 K=1,NGJ
               CALL POLCON(G(I,K),PW1,P(1,K,J))
               CALL POLSUM(PW(1,I),PW(1,I),1,PW1)
30           CONTINUE
20         CONTINUE
           DO 40 I=1,NGI
             CALL POLEQ(R(1,I,J),PW(1,I))
40         CONTINUE
10       CONTINUE
         NRI=NGI
         NRJ=NPJ
       ELSE

C  PREM .NE. 1 IMPLIES POSTMULTIPLICATION :

         DO 50 I=1,NPI
           DO 60 J=1,NGJ
             JW=IDNINT(P(1,I,J))+1
             CALL POLZER(PW(1,J),JW)
             DO 70 K=1,NGI
C              WRITE(1,*) 'I,J,K,G(K,J),NGI',I,J,K,G(K,J),NGI
C              WRITE(1,*)
               CALL POLCON(G(K,J),PW1,P(1,I,K))
C      CALL SJEKK(PW1,'POLCON-POLS. PW1')
               CALL POLSUM(PW(1,J),PW(1,J),1,PW1)
C      CALL SJEKK(PW(1,J),'ETTER PS.PW(1,J)')
70           CONTINUE
60         CONTINUE
           DO 80 J=1,NGJ
             CALL POLEQ(R(1,I,J),PW(1,J))
80         CONTINUE
50       CONTINUE

         NRI=NPI
         NRJ=NGJ
       ENDIF
       RETURN
       END
C****************************************************************

       SUBROUTINE TRASTA(A,NA,NAM,Q,P,NPM,NPIM,NPJM,NEC)

C TRASTA COMPUTES THE COEFFICIENTS IN THE NOMINATOR POLYNOMIALS P AND
C THE DENOMINATOR POLYNOMIAL Q IN A TRANSFER MATRIX. THE TRANSFER MATRIX
C IS (sI-A)**-1 WITH ELEMENTS P(I,J)/Q WHERE I AND J = 1,....,NA.

       INTEGER NA,NAM,NPM,NPIM,NPJM,NEC(NPIM,NPJM)
       DOUBLE PRECISION A(NAM,NAM)
       DOUBLE PRECISION Q(12),P(NPM,NPIM,NPJM),DE(12,10),NO(12,10)
CUT    DOUBLE PRECISION CY(12),CU(12)
       INTEGER NPI,NPJ

       NPI=1
       NPJ=1

C INITIALIZATION; FIRST BLOCK IS 1.0/(S-A(1,1)) :

       CALL POLONE(P(1,1,1))
       Q(1)=2.0
       Q(2)=-A(1,1)
       Q(3)=1.0

C DENOMINATOR IN TRANSFER FUNCTIONS TO BE ADDED IS ALWAYS 1.0 :

       DO 10 I=1,NA-1
         CALL POLONE(DE(1,I))

C NOMINATOR IN TRANSFER FUNCTION TO BE ADDED IS ALWAYS S :

         NO(1,I)=2.0
         NO(2,I)=0.0
         NO(3,I)=1.0
10     CONTINUE
       CALL TRATRA(A,Q,P,NPM,NPI,NAM,NPJ,NAM,NA-1,DE,NO,12,10,NEC)
       RETURN
       END
C*******************************************************************

       SUBROUTINE TRATRA(C,Q,P,NPM,NPI,NPIM,NPJ,NPJM,
     >  NK,DE,NO,NNOM,NNOKM,NEC)

C TRATRA COMPUTES THE COEFFICIENTS IN THE NOMINATOR POLYNOMIALS P AND
C THE DENOMINATOR POLYNOMIAL Q IN A TRANSFER MATRIX. THE TRANSFER MATRIX
C RESULTS FROM THE INTERCONNECTION OF NC TRANSFER FUNCTIONS THROUGH A
C COEFFICIENT MATRIX C; DIM (C)=NPJ*NPI. THE TRANSFER MATRIX HAS NPJ INPUTS
C AND NPI OUTPUTS.

       INTEGER NPM,NPI,NPJ,NPIM,NPJM,NNOM,NNOKM,NK,K,JW,NEC(NPIM,NPJM)
       DOUBLE PRECISION C(NPJM,NPIM)
       DOUBLE PRECISION Q(12),P(NPM,NPIM,NPJM)
       DOUBLE PRECISION DE(NNOM,NNOKM),NO(NNOM,NNOKM)
       DOUBLE PRECISION CY(12),CU(12)

C REDUCING COMPUTATIONAL WORK :

       CALL REDUC(C,NEC,NPI,NPIM,NPJ,NPJM,NK)

C CALCULATION OF SUCCESSIVELY LARGER K*K SUB-TRANSFER-MATRICES :

       DO 10 K=1,NK
         NPI=NPI+1
         NPJ=NPJ+1
         DO 20 JW=1,NPI-1
           CY(JW)=C(NPJ,JW)
20       CONTINUE
         DO 30 IW=1,NPJ-1
           CU(IW)=C(IW,NPI)
30       CONTINUE
  
C SUBROUTINE TRADD CONNECTS A NEW TRANSFER FUNCTION TO THE (NPI-1)*(NPJ-1)
C SUB-TRANSFER-MATRIX :

         CALL TRADD(C(NPJ,NPI),CU,CY,Q,P,NPM,NPI,NPIM,
     >    NPJ,NPJM,NEC,K,DE(1,K),NO(1,K))

C END OF SUB-TRANSFER-MATRIX CALCULATION
 
10     CONTINUE

CUT    CALL REIMA(NEC,NPI,NPIM,NPJ,NPJM,'NE')                             #TEST#
       RETURN
       END
C***********************************************************************

       SUBROUTINE REMA(A,NI,NIM,NJ,NJM,NAME)

       DOUBLE PRECISION A(NIM,NJM)
       INTEGER I,J,NI,NIM,NJ,NJM
       DOUBLE PRECISION AW(10)
       CHARACTER TEKST*16,NAME*2
       TEKST(1:14)='RAD I MATRISE '
       TEKST(15:16)=NAME
       WRITE(*,*)'*** INNLESING MATRISE ',NAME,'******'

       DO 10 I=1,NI
         DO 20 J=1,NJ
           AW(J)=A(I,J)
20       CONTINUE
         CALL DREAD(TEKST,AW,NJ,NJ,J)
         DO 30 J=1,NJ
           A(I,J)=AW(J)
30       CONTINUE
10     CONTINUE
       RETURN
       END

C **************************************************************

       SUBROUTINE REIMA(A,NI,NIM,NJ,NJM,NAME)

       INTEGER A(NIM,NJM)
       INTEGER I,J,NI,NIM,NJ,NJM
       INTEGER AW(10)
       CHARACTER TEKST*16,NAME*2
       TEKST(1:14)='RAD I MATRISE '
       TEKST(15:16)=NAME
       WRITE(*,*)'*** VERDIER MATRISE ',NAME,'******'

       DO 10 I=1,NI
         DO 20 J=1,NJ
           AW(J)=A(I,J)
20       CONTINUE
         CALL NREAD(TEKST,AW,NJ,NJ,J)
         DO 30 J=1,NJ
           A(I,J)=AW(J)
30       CONTINUE
10     CONTINUE
       RETURN
       END

C ******************************************************************

       SUBROUTINE REDUC(C,LOOK,NPI,NPIM,NPJ,NPJM,NK)

       INTEGER NK,NPI,NPJ,NPIM,NPJM,LOOK(NPIM,NPJM)
       DOUBLE PRECISION C(NPJM,NPIM)
       INTEGER IK,JK,IK1,JK1,I,J,K,K1
       INTEGER IDUMMY

C THIS VERSION DATED DECEMBER 15., 1984.

C SUBROUTINE REDUC DECIDES WHICH TRANSFER FUNCTIONS IN THE MATRIX
C P/Q ARE TO BE COMPUTED. BECAUSE OF ZERO ENTRIES IN THE CONNECTION MATRIX
C C AND AMONGST THE INITIAL VALUES IN THE MATRIX "LOOK", IT IS NOT
C NECCESSARY TO CALCULATE ALL TRANSFER MATRIX ELEMENTS  P/Q FOR EACH
C STAGE K IN THE RECURSIVE TRANSFER MATRIX CALCULATION PROCESS.
C LOOK(I,J) EQ M AFTER EXECUTION OF REDUC IMPLIES THAT IT IS
C NECCESSARY TO CALCULATE ELEMENT P(I,J) FOR K LEQ M.
C THE ELEMENTS LOOK(I,J) MUST INITIALLY BE EQ 0 EXCEPT FOR PAIRS I,J FOR
C WHICH TRANSFER FUNCTIONS ARE TO BE FOUND: FOR THESE I,J-VALUES 
C LOOK(I,J) MUST BE EQ NC.
CUT    WRITE(*,*)'NPI,NPIM,NPJ,NPJM',NPI,NPIM,NPJ,NPJM
       IK=NPI+NK+1
       JK=NPJ+NK+1
       K=NK+1

C      DO WHILE (K.GT.1)

       DO 80 IDUMMY=1,9999
          IF (.NOT. K.GT.1) THEN
            GOTO 100
          ENDIF

         K=K-1
         K1=K-1
         IK=IK-1
         IK1=IK-1
         JK=JK-1
         JK1=JK-1
CUT    WRITE(*,*)'K,K1,IK,IK1,JK,JK1',K,K1,IK,IK1,JK,JK1
C CALCULATING WHICH ELEMENTS P(-,JK) AND P(IK,-) IN STAGE K ARE NECCESSARY
C TO FIND WANTED ELEMENTS P(I,J) IN STAGE K; I,J LE IK1,JK1 :

         DO 10 I=1,IK1
           DO 20 J=1,JK1
             IF (LOOK(I,J).GE.K) THEN
               IF (LOOK(I,JK).LT.K) LOOK(I,JK)=K
               IF (LOOK(IK,J).LT.K) LOOK(IK,J)=K
             ENDIF
20         CONTINUE
10       CONTINUE
         
C CALCULATING WHICH ELEMENTS P(I,J) ARE NECCESSARY IN STAGE K-1 TO CLOSE
C NEW LOOP CREATED BY THE CONNECTION OF THE K'TH TRANSFER FUNCTION :

         DO 30 J=1,JK1
           IF (C(J,IK).NE.0.0.AND.LOOK(IK,J).LT.K) LOOK(IK,J)=K
30       CONTINUE

C CALCULATING WHICH ELEMENTS P(I,J) ARE NECCESSARY IN STAGE K-1 TO FIND
C SPECIFIED ELEMENTS P(-,JK) IN NEXT STAGE K :

         DO 40 I=1,IK1
           IF (LOOK(I,JK).GE.K) THEN
             DO 50 J=1,JK1
               IF (C(J,IK).NE.0.0.AND.LOOK(I,J).LT.K1) LOOK(I,J)=K1
50           CONTINUE
           ENDIF
40       CONTINUE

C CALCULATING WHICH ELEMENTS P(I,J) ARE NECCESSARY IN STAGE K-1 TO FIND
C SPECIFIED ELEMENTS P(IK,-) IN NEXT STAGE K :

         DO 60 J=1,JK1
           IF (LOOK(IK,J).GE.K) THEN
             DO 70 I=1,IK1
               IF (C(JK,I).NE.0.0.AND.LOOK(I,J).LT.K1) LOOK(I,J)=K1
70           CONTINUE
           ENDIF
60       CONTINUE
80     CONTINUE
100    RETURN
       END
C*********************************************************************

       SUBROUTINE TRADD(CKK,CU,CY,Q,P,NPM,NPI,NPIM,NPJ,NPJM,NEC,INEC,
     > DE,NO)

C TRADD COMPUTES THE NEW COEFFICIENTS IN THE NOMINATOR POLYNOMIALS P AND
C THE DENOMINATOR POLYNOMIAL Q IN A TRANSFER MATRIX WHEN A TRANSFER FUNCTION
C DE/NO IS CONNECTED TO THE SYSTEM VIA COEFFICIENT VECTORS CU AND CY.

       INTEGER NPM,NPI,NPIM,NPJ,NPJM,NEC(NPIM,NPJM),INEC
       DOUBLE PRECISION CU(1),CY(1),CKK
       DOUBLE PRECISION Q(1),P(NPM,NPIM,NPJM),DE(1),NO(1)

       INTEGER I,J,IW,JW,NICOMP,NJCOMP,JC(10),IC(10)
       DOUBLE PRECISION PW1(12),PW2(12),SUMP(12),QOLD(12) 
       DOUBLE PRECISION PWL1(22),PWL2(22),NOH(12)
       LOGICAL TNBLK,FNBLK

C INCORPORATING LOCAL FEEDBACK GIVEN BY CKK TO GET A NEW EQUIVALENT
C TRANSFER FUNCTION DE/NOH :

       CALL POLCON(CKK,PW1,DE)
       CALL POLSUM(NOH,NO,-1,PW1)

C COMPRESSION OF NONZERO ELEMENTS IN COEFFICIENT VECTORS CU AND CY :

       NICOMP=0
       NJCOMP=0

       DO 10 IW=1,NPI-1
         IF (CY(IW).NE.0.0) THEN
           NICOMP=NICOMP+1
           IC(NICOMP)=IW
         ENDIF
10     CONTINUE
       DO 20 JW=1,NPJ-1
         IF (CU(JW).NE.0.0) THEN
           NJCOMP=NJCOMP+1
           JC(NJCOMP)=JW
         ENDIF
20     CONTINUE
       FNBLK=(NJCOMP.GT.0)
       TNBLK=(NICOMP.GT.0)

C CALCULATE NOMINATOR POLYNOMIAL P(-,NPI,NPJ) ;I.E. LOWER RIGHT ELEMENT :

       IF (NEC(NPI,NPJ).GE.INEC) CALL POLPOL(P(1,NPI,NPJ),DE,Q)

C CALCULATE NOMINATOR POLYNOMIALS P(-,NPI,J) ; I.E LOWER ROW EXCEPT 
C LOWER RIGHT ELEMENT:

       IF(TNBLK) THEN
         DO 30 JW=1,NPJ-1
           IF (NEC(NPI,JW).GE.INEC) THEN
             CALL POLZER(PW1,1)
             DO 40 IW=1,NICOMP
               I=IC(IW)
      IF (CY(I).NE.0.0.AND.NEC(I,JW).LT.INEC-1) WRITE(*,*)'##I,J,INEC'
     >,I,JW,INEC
               CALL POLCON(CY(I),PW2,P(1,I,JW))
               CALL POLSUM(PW1,PW1,1,PW2)
40           CONTINUE
             CALL POLPOL(P(1,NPI,JW),DE,PW1)
           ENDIF
30       CONTINUE
       ELSE
         DO 50 JW=1,NPJ-1
            IF (NEC(NPI,JW).GE.INEC) CALL POLZER(P(1,NPI,JW),1)
50       CONTINUE
       ENDIF

C CALCULATE DENOMINATOR Q FOR K*K SUB-TRANSFER-MATRIX :
       
       CALL POLEQ(QOLD,Q)
       CALL POLZER(SUMP,1)
       IF (FNBLK.AND.TNBLK) THEN
         DO 60 JW=1,NJCOMP
           J=JC(JW)
C          IF (NEC(NPI,J).GE.INEC-1) THEN
             CALL POLCON(CU(J),PW2,P(1,NPI,J))
             CALL POLSUM(SUMP,SUMP,1,PW2)
C          ENDIF
60       CONTINUE
         CALL POLPOL(PW1,Q,NOH)
C        CALL POLPOL(PW2,DE,SUMP)
         CALL POLSUM(Q,PW1,-1,SUMP)
       ELSE
         CALL POLPOL(Q,QOLD,NOH)
       ENDIF

C CALCULATE NOMINATOR POLYNOMIALS P(-,I,NPJ) (RIGHT COLUMN EXCEPT LOWER
C RIGHT ELEMENT), EXCEPT FROM A MULTIPLICATIVE FACTOR DE.

       IF(FNBLK) THEN
         DO 70 IW=1,NPI-1
           IF (NEC(IW,NPJ).GE.INEC) THEN
             CALL POLZER(PW1,1)
             DO 80 JW=1,NJCOMP
               J=JC(JW)
      IF (CU(J).NE.0.0.AND.NEC(IW,J).LT.INEC-1) WRITE(*,*)'##I,J,INEC'
     >,IW,J,INEC
               CALL POLCON(CU(J),PW2,P(1,IW,J))
               CALL POLSUM(PW1,PW1,1,PW2)
80           CONTINUE
             CALL POLEQ(P(1,IW,NPJ),PW1)
           ENDIF
70       CONTINUE
       ELSE
         DO 90 IW=1,NPI-1
           IF (NEC(IW,NPJ).GE.INEC) CALL POLZER(P(1,IW,NPJ),1)
90       CONTINUE
       ENDIF
 
C CALCULATE NOMINATOR POLYNOMIALS P(-,I,J) ; I < NPI, J < NPJ :

       IF(FNBLK.AND.TNBLK) THEN
         DO 91 JW=1,NPJ-1
           DO 92 IW=1,NPI-1
             IF (NEC(IW,JW).GE.INEC) THEN
               CALL POLPOL(PWL1,P(1,IW,NPJ),P(1,NPI,JW))
               CALL POLPOL(PWL2,P(1,IW,JW),Q)
               CALL POLSUM(PWL1,PWL1,1,PWL2)
               CALL POLDIV(PW1,PWL1,QOLD)
               CALL POLEQ(P(1,IW,JW),PW1)
             ENDIF
92         CONTINUE
91       CONTINUE
       ELSE
         DO 93 JW=1,NPJ-1
           DO 94 IW=1,NPI-1
             IF (NEC(IW,JW).GE.INEC) THEN
               CALL POLPOL(PW1,P(1,IW,JW),NOH)
               CALL POLEQ(P(1,IW,JW),PW1)
             ENDIF
94         CONTINUE
93       CONTINUE
       ENDIF
  
C MULTIPLY ELEMENTS P(-,I,NPJ) WITH DE TO GET CORRECT VALUES:

       IF (FNBLK) THEN
         DO 95 IW=1,NPI-1
           IF (NEC(IW,NPJ).GE.INEC) THEN
             CALL POLPOL(PW1,DE,P(1,IW,NPJ))
             CALL POLEQ(P(1,IW,NPJ),PW1)
           ENDIF
95       CONTINUE
       ENDIF
       RETURN
       END
C********************************************************************

       SUBROUTINE POLONE(PO)

C POLONE RETURNS A POLYNOMIAL = 1.0

       DOUBLE PRECISION PO(12)
       PO(1)=1.0
       PO(2)=1.0
       RETURN
       END

C **********************************************************************

       SUBROUTINE POLZER(PO,N)

C POLZER RETURNS A POLYNOMIAL = 0.0

       DOUBLE PRECISION PO(12)
       INTEGER N
       DO 10 J=1,N
         PO(J)=0.0
10     CONTINUE
       RETURN
       END

C **********************************************************************

       SUBROUTINE POLEQ(PO,PI)

C POLEQ PERFORMS PO=PI

       INTEGER I,J
       DOUBLE PRECISION PO(12),PI(1)
       J=IDNINT(PI(1))+1
       DO 10 I=1,J
         PO(I)=PI(I)
10     CONTINUE
       RETURN
       END

C **********************************************************************

       SUBROUTINE POLPOL(PO,PI1,PI2)

C POLPOL PERFORMS MULTIPLICATION OF POLYNOMIALS; PO = PI1*PI2 :

       INTEGER N1,N2,NO,J1,J2,JO
       DOUBLE PRECISION PO(12),PI1(1),PI2(1)
       DOUBLE PRECISION PW(22)

       IF(PI1(1).EQ.0.0.OR.PI2(1).EQ.0.0) THEN
         CALL POLZER(PO,1)
         RETURN
       ENDIF

       N1=IDNINT(PI1(1))+1
       N2=IDNINT(PI2(1))+1
       NO=N1+N2-3

       DO 10 J1=2,NO+1
         PW(J1)=0.0
10     CONTINUE
       PO(1)=NO
       DO 20 J1=2,N1
         IF (PI1(J1).NE.0.0) THEN
         DO 30 J2=2,N2
           IF (PI2(J2).NE.0.0) THEN
             JO=J1+J2-2
             PW(JO)=PW(JO)+PI1(J1)*PI2(J2)
            ENDIF
30       CONTINUE
         ENDIF
20     CONTINUE
       DO 40 JO=2,NO+1
         PO(JO)=PW(JO)
40     CONTINUE
       RETURN
       END

C **********************************************************************

       SUBROUTINE POLSUM(PO,PI1,ISIGN,PI2)

C POLSUM ADDS/SUBTRACTS TWO POLYNOMIALS: PO = PI1 + ISIGN * PI2

       INTEGER ISIGN,N1,N2,NLOW
       INTEGER IDUMMY
       DOUBLE PRECISION PO(1),PI1(1),PI2(1)
C     CALL SJEKK(PI1,'ST.POLS. PI1    ')
C     CALL SJEKK(PI2,'ST.POLS. PI2    ')
C     CALL SJEKK(PO,'ST.POLS. PO     ')

       IF (PI1(1).EQ.0.0) THEN
         CALL POLEQ(PO,PI2)
         RETURN
       ENDIF
       IF (PI2(1).EQ.0.0) THEN
         CALL POLEQ(PO,PI1)
         RETURN
       ENDIF
       N1=IDNINT(PI1(1))+1
       N2=IDNINT(PI2(1))+1
       NLOW=MIN0(N1,N2)
       PO(1)=DMAX1(PI1(1),PI2(1))
       IF(ISIGN.NE.-1) THEN
         DO 10 J=2,NLOW
           PO(J)=PI1(J)+PI2(J)
10       CONTINUE
         IF(N2.GT.N1) THEN
           DO 20 J=N1+1,N2
             PO(J)=PI2(J)
20         CONTINUE
           RETURN
         ENDIF
       ELSE
         DO 30 J=2,NLOW
           PO(J)=PI1(J)-PI2(J)
30       CONTINUE
         IF(N2.GT.N1) THEN
           DO 40 J=N1+1,N2
             PO(J)=-PI2(J)
40         CONTINUE
           RETURN
         ENDIF
       ENDIF
       IF(N1.GT.N2) THEN
         DO 50 J=N2+1,N1
           PO(J)=PI1(J)
50       CONTINUE
         RETURN
       ENDIF

       J=IDNINT(PO(1))+1
C      DO WHILE (PO(J).EQ.0.0.AND.J.GT.2)
C        J=J-1
C      ENDDO
C..Skriver om WHILE setningen ........................
       DO 60 IDUMMY=1,9999
          IF (.NOT. PO(J).EQ.0.0.AND.J.GT.2) THEN
             GOTO 100
          ENDIF
          J=J-1
60     CONTINUE
100    PO(1)=J-1

       IF(PO(1).EQ.1) THEN
         IF(PO(2).EQ.0.0) PO(1)=0.0
       ENDIF
C     CALL SJEKK(PO,'ET.POLS. PO     ')
       RETURN
       END

C **********************************************************************

       SUBROUTINE POLCON(A,PO,PI)

C POLCON MULTIPLIES A POLYNOMIAL WITH A SCALAR: PO = A * PI

       DOUBLE PRECISION PO(12),PI(1)
       DOUBLE PRECISION A
C     CALL SJEKK(PI,'ST.POLC. PI     ')
C     CALL SJEKK(PO,'ST.POLC. PO     ')

       IF (A.EQ.0.0.OR.PI(1).EQ.0.0) THEN
         CALL POLZER(PO,1)
         RETURN
       ENDIF
       I=IDNINT(PI(1))+1
       PO(1)=PI(1)
       DO 10 J=2,I
         IF (PI(J).EQ.0.0) THEN
           PO(J)=0.0
         ELSE
           PO(J)=A*PI(J)
         ENDIF
10     CONTINUE
C     CALL SJEKK(PO,'ET.POLC. PO     ')
       RETURN
       END

C **********************************************************************

       SUBROUTINE POLDIV(PO,PT,PN)

C POLDIV PERFORMS PO = PT / PN . IT IS ASSUMED THAT PT IS DIVISIBLE
C WITH PN, AND THAT PN NEQ ZERO.

       DOUBLE PRECISION PO(12),PT(1),PN(1)
       DOUBLE PRECISION WORK,W
       LOGICAL WLOG1,WLOG2
       INTEGER NO,NT,NN,IO,IO2,IT,IN,IN2
       INTEGER IDUMMY

       IF (PT(1).EQ.0.0) THEN
         CALL POLZER(PO,1)
         RETURN
       ENDIF
       PO(1)=PT(1)-PN(1)+1.0
       NO=IDNINT(PO(1))+1
       NN=IDNINT(PN(1))+1
       NT=IDNINT(PT(1))+1
       IT=2
       IN=2

C      DO WHILE (PN(IN).EQ.0.0)
C       IN=IN+1
C       IT=IT+1
C      ENDDO
C ..Skriver om WHILE setningen ............
       DO 60 IDUMMY =1,9999
          IF (.NOT.PN(IN).EQ.0.0) THEN
           GOTO 300
          ENDIF
          IN=IN+1
          IT=IT+1
60     CONTINUE

300    IN0=IN
       PO(2)=PT(IT)/PN(IN)
       WLOG1=.FALSE.

       DO 30 IO=3,NO/2+2
         WLOG1=.TRUE.
         IT=IT+1
         WORK=PT(IT)
         IN=IN+1
         IN2=IN+1
         DO 10 IO2=2,IO-1
           IN2=IN2-1
           IF(IN2.GT.NN) GOTO 10
           IF(IN2.LT.IN0) GOTO 200
             IF(PN(IN2).NE.0.0.AND.PO(IO2).NE.0.0) THEN
               WORK=WORK-PN(IN2)*PO(IO2)
             ENDIF
10       CONTINUE
200      WORK=WORK/PN(IN0)
         PO(IO)=WORK
30     CONTINUE
       W=PO(NO/2+2)
C     WRITE(*,*) 'BEREGN.PO(N),PO(N),1/2',PO(NO),W,PO(NO)/W
C     IN=INCH(1)
C      RETURN
C      END

C POLDIV PERFORMS PO = PT / PN . IT IS ASSUMED THAT PT IS DIVISIBLE
C WITH PN, AND THAT PN NEQ ZERO.

C      DOUBLE PRECISION PO(1),PT(1),PN(1)
C      DOUBLE PRECISION WORK,WORK2
C      INTEGER NO,NT,NN,IO,IO2,IT,IN,ICOUNT
C      IF (PT(1).EQ.0.0) THEN
C        CALL POLZER(PO,1)
C        RETURN
C      ENDIF
C      PO(1)=PT(1)-PN(1)+1.0
C      NO=IDNINT(PO(1))+1
C      NN=IDNINT(PN(1))+1

       IT=IDNINT(PT(1))+1
       PO(NO)=PT(IT)/PN(NN)
       ICOUNT=1
       WLOG2=.FALSE.
       DO 40 IO=NO-1,NO/2+2,-1
        WLOG2=.TRUE.
         IT=IT-1
         ICOUNT=ICOUNT+1
         IN=NN-ICOUNT
         WORK=PT(IT)
         DO 50 IO2=NO,IO+1,-1
           IN=IN+1
      IF(IN.GT.NN) GOTO 100
           IF(IN.GT.1) THEN
             IF(PN(IN).NE.0.0.AND.PO(IO2).NE.0.0) THEN
               WORK=WORK-PN(IN)*PO(IO2)
             ENDIF
           ENDIF
50       CONTINUE
100      WORK=WORK/PN(NN)
         PO(IO)=WORK
40     CONTINUE
C     W=PT(2)/PN(2)
C     IF (WLOG1.AND.WLOG2) THEN
C       WRITE(*,*) 'PO(IO)/PO(IO)',PO(NO/2+2)/W
C       IN=INCH(1)
C      ENDIF
       RETURN
       END
***************************************************************
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                      C
C      Rutinen beregner all r|ttene i polynomet f(s).  C
C      Benytter NAG ,C02AEF,X02AAF                     C
C                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C      SUBROUTINE PROT(KOEFF1,N1,KOEFF2,N2)
C
C      DOUBLE PRECISION KOEFF1(13),SRE(13),SIM(13),TOL
C      DOUBLE PRECISION KOEFF2(13),PRE(13),PIM(13),FOL
C      DOUBLE PRECISION X02AAF
C      INTEGER I,IFAIL,N1,N2,NN1,NN2
C
C      TOL=X02AAF(0.1E0)
C      SRE(1)=0.15
C      SIM(1)=0
C      IFAIL=1
C      NN1=N1-1
C
C      CALL C02AEF(KOEFF1,N1,SRE,SIM,TOL,IFAIL)
C      FOL=X02AAF(0.1E0)
C      PRE(1)=0.1
C      PIM(1)=0.1
C      IFAIL=1
CC     NN2=N2-1
C
C      CALL C02AEF(KOEFF2,N2,PRE,PIM,FOL,IFAIL)
C
C      WRITE(*,*)'  '
C      WRITE(*,*)'.....Poler...........        ....Nullpunkter.......'
C      WRITE(*,*)'  '
C      PRINT 1,(I,SRE(I),SIM(I),I,PRE(I),PIM(I),I=1,NN1)
C1     FORMAT(4X,'s(',I2,')=',2X,E12.5,1X,'i',1X,E12.5,4X,
C    + 'p(',I2,')=',2X,E12.5,1X,'i',1X,E12.5)
C      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                      C
C      Rutinen beregner all r|ttene i polynomet f(s).  C
C      Benytter NAG ,C02AEF,X02AAF                     C
C                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C      SUBROUTINE SROT(RE,N)
C
C      DOUBLE PRECISION RE(10),SRE(10),SIM(10),TOL
C      DOUBLE PRECISION X02AAF
C      INTEGER I,IFAIL,N,NN
C
CUT    TOL=X02AAF(0.1E0)
C      SRE(1)=0.15
C      SIM(1)=0
C      IFAIL=1
C      NN=N-1
C
CUT    CALL C02AEF(RE,N,SRE,SIM,TOL,IFAIL)
C      WRITE(*,*)'  '
C      WRITE(*,*)'.......Polynomets r|tter er......'
C      WRITE(*,*)'  '
C      PRINT 1,(I,SRE(I),SIM(I),I=1,NN)
C1     FORMAT(4X,'s(',I2,')=',2X,E12.5,1X,'i',1X,E12.5)
C
C      END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                           C
C    RUTINE FOR LAGRING AV MATRISENE P] DATA-FIL            C
C                                                           C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       SUBROUTINE MATRISER(A,B,D,NA,NB,ND,IFLAG,CNAME)

       INTEGER I,J,NA,NB,ND,IFLAG,NIN
       DOUBLE PRECISION A(10,10),B(10,10),D(10,10)
       CHARACTER CNAME*(*)

       NIN = 10
       IF (IFLAG.EQ.1) THEN
        OPEN (NIN,FILE=CNAME,STATUS='UNKNOWN',ERR=70)
        WRITE(NIN,99989) NA,NB,ND
        WRITE(NIN,99990) ((A(I,J),J=1,NA),I=1,NA)
        WRITE(NIN,99991) ((B(I,J),J=1,NB),I=1,NA)
        WRITE(NIN,99992) ((D(I,J),J=1,NA),I=1,ND)
        CLOSE (NIN)
       ELSEIF (IFLAG.EQ.2) THEN
        OPEN (NIN,FILE=CNAME,STATUS='OLD',ERR=80)
        READ (NIN,99989,ERR=81) NA,NB,ND
        READ (NIN,99990,ERR=81) ((A(I,J),J=1,NA),I=1,NA)
        READ (NIN,99991,ERR=81) ((B(I,J),J=1,NB),I=1,NA)
        READ (NIN,99992,ERR=81) ((D(I,J),J=1,NA),I=1,ND)
        CLOSE (NIN)
       ENDIF

99989  FORMAT(3I8)
99990  FORMAT(8E16.9)
99991  FORMAT(2E16.9)
99992  FORMAT(2E16.9)
       GO TO 1000
70     WRITE(*,'(1X,A)')'ERROR --> Error in opening file'
       GO TO 1000
80     WRITE(*,'(1X,A)')'ERROR --> File does not exist'
       GO TO 1000
81     WRITE(*,'(1X,A)')'ERROR --> Read error'


1000   RETURN
       END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       SUBROUTINE RESULT(P,Q,NA,NB,ND,NNA,CNAME)

       INTEGER NA,ND,NB,NNA,K,NIN
       DOUBLE PRECISION P(12,10,10),Q(12)
       CHARACTER CNAME*(*)

       NIN = 11
       WRITE(*,*)'NNA,NA,NB,ND',NNA,NA,NB,ND
       OPEN (NIN,FILE=CNAME,STATUS='UNKNOWN')
       WRITE(NIN,99979)
       WRITE(NIN,99980) (((P(K,I,J),J=1,NB),I=1,ND),K=1,NA+1)
       WRITE(NIN,99981) (I,Q(I),I=1,NA+2)
       CLOSE (NIN)

99979  FORMAT(1X,'H(I,J)(S)')
99980  FORMAT(1X,4E18.6)
99981  FORMAT(1X,'Q(',I3,')=',E18.6)

       RETURN
       END

       SUBROUTINE TRHEAD
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C***BEGIN PROLOGUE TRHEAD                                       C
C   PURPOSE                                                     C
C   TRHEAD print program description on terminal when the       C
C   program is exequted. Else no function.                      C
C***END PROLOGUE TRHEAD                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      CHARACTER CF*6

C... Initialize format statement                .................
      CF = '(8X,A)'

      WRITE(*,CF)'-----------------------------------------------'
      WRITE(*,CF)'.                                             .'
      WRITE(*,CF)'.            <  T R A N S F  >                .'
      WRITE(*,CF)'.                                             .'
      WRITE(*,CF)'.  Program for computing the transfer matrix  .'
      WRITE(*,CF)'.  H(s) = D*inv(sI - A)*B of a  state  space  .'
      WRITE(*,CF)'.  model (A,B,D).                             .'
      WRITE(*,CF)'.                                Version 1.1  .'
      WRITE(*,CF)'-----------------------------------------------'
      WRITE(*,CF)'  '

      RETURN
      END

       SUBROUTINE DTRANS(A1,B,D,NA,NB,ND,P,Q,PW,NPI,NPJ,MAX,NMAX)
C
       INTEGER NA,ND,NB,NPI,NPJ,MAX,NMAX
       DOUBLE PRECISION A1(MAX,MAX),B(MAX,MAX),D(MAX,MAX)
       DOUBLE PRECISION P(NMAX,MAX,MAX),Q(NMAX),PW(NMAX)
C... Local parameters
       INTEGER ISVAR,NNA,IW(2),I,J,NEC(10,10)
       DOUBLE PRECISION KOEF(13),NULL(13)
       CHARACTER STRING*8,IC,JC

C... Check dimensions
       CALL DIMCHK(NA,NB,ND,MAX,IERR)
       IF (IERR.NE.0) GO TO 1000

C... Set up 
       DO 50 I=1,NA
         DO 60 J=1,NA
           NEC(I,J) = NA
60       CONTINUE
50     CONTINUE

C... Compute transfer matrix H(s) 
       CALL TRASTA(A1,NA,MAX,Q,P,NMAX,MAX,MAX,NEC)
       CALL TRAMUL(B,NA,MAX,NB,MAX,P,NMAX,NA,MAX,NA,MAX,
     > P,NMAX,NPI,MAX,NPJ,MAX,0)
       CALL TRAMUL(D,ND,MAX,NA,MAX,P,NMAX,NPI,MAX,NPJ,MAX,
     > P,NMAX,NPI,MAX,NPJ,MAX,1)

C... Output modus
       IW(1) = 1
       IW(2) = 1
30     WRITE(*,*)' '
       CALL NREAD('Transfer matrix element (0 = exit) :',IW,2,2,I)
       IF(IW(1).LT.0 .OR. IW(1).GT.ND) THEN
         IW(1) = 1
         WRITE(*,'(1X,A)')'* ERROR -> element out of bounds'
         GO TO 30
       ENDIF
       IF(IW(2).LT.0 .OR. IW(2).GT.NB) THEN
        IW(2) = 1
        WRITE(*,'(1X,A)')'* ERROR -> element out of bounds'
        GO TO 30
       ENDIF

       IF(IW(1).EQ.0) GOTO 1000
       STRING='h( , )  '
       I=IW(1)
       J=IW(2)
       IC=CHAR(IW(1)+48)
       JC=CHAR(IW(2)+48)
       STRING(3:3)=IC
       STRING(5:5)=JC
       CALL POLEQ(PW(1),P(1,I,J))
       NNA = FLOAT(PW(1))

       CALL TRNEXT(IW,ND,NB)

C......Skriver ut transfer funksjonens data ................
       WRITE(*,*)'   '
       WRITE(*,'(1X,A,A,A)')'The transfer matrix element ',STRING,
     + '= p(s)/q(s) is given by :'
c      WRITE(*,'(1X,A)')'the denominator polynominal q(s) is given by'
c      WRITE(*,'(1X,A)')'q(1) + ... + q(n+1)*s^n'
c      WRITE(*,'(1X,A)')'and the nominator polynominal p(s) is given by'
c      WRITE(*,'(1X,A)')'p(1) + ... + p(m+2)*s^m'
       WRITE(*,*)'  '

C.. Noter at Q(1) = n+1 og at P(1) = m+1 der m = grad av teller polynom i h(s)
       WRITE(*,'(1X,A,2X,A)')
     + '* Coefficients in denominator polynomial',
     + 'q(s) = q(1) + ... + q(n+1)*s^n'
       PRINT 1,(I-1,Q(I),I=2,NA+2)
1      FORMAT(6X,'q(',I2,') =',2X,G16.6)
       WRITE(*,*)'  '

       WRITE(*,'(1X,A,2X,A)')
     + '* Coefficients in nominator polynomial',
     + 'p(s) = p(1) + ... + p(m+1)*s^m'
       PRINT 2,(I-1,PW(I),I=2,NNA+1)
2      FORMAT(6X,'p(',I2,') =',2X,G16.6)

C......R|ttene av polynomene bestemmes...........................
C 1,..Poler...........
       DO 70 I=2,NA+2
          KOEF(NA+3-I)=Q(I)
70     CONTINUE
CUT    ISVAR=IYESANS('..Beregning av poler. ?    ',2)
       IF (ISVAR.EQ.2) THEN
CUT    CALL SROT(KOEF,NA+1)
       ENDIF
C 2,..Nullpunkter.........

       DO 80 I=2,NNA+1
          NULL(NNA+2-I)=PW(I)
80     CONTINUE

CUT    ISVAR=IYESANS('..Beregning av nullpunkter ?   ',2)
       IF (PW(1).EQ.1) WRITE(*,*)'...Ingen nullpunkter....'
       IF (PW(1).EQ.0) THEN
       WRITE(*,*)'.....',STRING,' = 0'
       ENDIF
       IF (PW(1).NE.0.AND.PW(1).NE.1.AND.ISVAR.EQ.2) THEN
CUT    CALL SROT(NULL,NNA)
       ENDIF

C      CALL PROT(KOEF,NA+1,NULL,NNA)

       GOTO 30
20     CONTINUE

1000   RETURN
       END

       SUBROUTINE TRNEXT(IW,ND,NB)
       INTEGER IW(2),ND,NB

       IW(2) = IW(2) + 1
       IF (IW(2).EQ.NB+1) THEN
          IW(1) = IW(1) + 1
          IW(2) = 1
       ENDIF
       IF (IW(1).EQ.ND+1) THEN
        IW(1) = 0
        IW(2) = 0
       ENDIF

       RETURN
       END

       SUBROUTINE DIMCHK(NA,NB,ND,MAX,IERR)
       INTEGER NA,NB,ND,MAX,IERR

       IERR = 0
       IF (NA.GT.MAX) THEN
        WRITE(*,'(1X,A,1X,I4)')'* ERROR --> NX > MAX =',MAX
        IERR = 1
       ENDIF
       IF (NB.GT.MAX) THEN
        WRITE(*,'(1X,A,1X,I4)')'* ERROR --> NU > MAX =',MAX
        IERR = 2
       ENDIF
       IF (ND.GT.MAX) THEN
        WRITE(*,'(1X,A,1X,I4)')'* ERROR --> NY > MAX =',MAX
        IERR = 1
       ENDIF

       RETURN
       END

      SUBROUTINE TRAHLP
C--------------------------------------------------------------------c
C     Print help info on terminal                                    c
C--------------------------------------------------------------------c
      CHARACTER CF*6
      CF = '(1X,A)'

      WRITE(*,CF)'                < TRANSF HELP >'
      WRITE(*,CF)'----------------------------------------------------'
      WRITE(*,CF)'1.  Specify system dimensions ( NX NU NY )     DIM  '
      WRITE(*,CF)'    NX = # of states                                '
      WRITE(*,CF)'    NU = # of inputs                                '
      WRITE(*,CF)'    NY = # of outputs                               '
      WRITE(*,CF)'2.  Read system matrices from terminal         SYS  '
      WRITE(*,CF)'3.  Solve problem                              SOLV '
      WRITE(*,CF)'4.  Load system matrices from data file        LOAD '
      WRITE(*,CF)'5.  Save system matrices on data file          SAVE '
      WRITE(*,CF)'6.  Save transfer matrix polynomial elements   RES  '
      WRITE(*,CF)'7.  Help                                       HELP '
      WRITE(*,CF)'8.  Terminate program with                0 or EXIT '
      WRITE(*,CF)'----------------------------------------------------'
      WRITE(*,CF)'    '

      RETURN
      END
